<? 
include("includes/environment.php");
include("functions/accounts.php");

if($arr = loadRecord("SELECT account FROM system_accounts WHERE code='PAY_24NONSTOP'")){
	$nonstop_account = $arr['account'];
}

function xml_header(){
	return "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
}

function response_error($code){
	return xml_header().sprintf("<pay-response>\n<status_code>%s</status_code>\n<time_stamp>%s</time_stamp>\n</pay-response>",
		$code, date("d.m.Y H:i:s"));
}

function response_client_state($client){
	return xml_header()."<pay-response>
<balance>".($client['deposit']/100)."</balance>
<name>".iconv('windows-1251', 'utf-8', $client['last_name'].' '.$client['first_name'])."</name>
<account>".$client['contract']."</account>
<abonplata>".($client['abon']/100)."</abonplata>
<min_amount>0.01</min_amount>
<max_amount>20000</max_amount>
<status_code>".('21')."</status_code>
<time_stamp>".date("d.m.Y H:i:s")."</time_stamp>
</pay-response>";
}

function response_success_pay($pay_id, $amount, $time){
	return xml_header()."<pay-response>
<pay_id>".$pay_id."</pay_id >
<amount>".($amount/100)."</amount>
<status_code>22</status_code>
<time_stamp>".date("d.m.Y H:i:s", $time)."</time_stamp>
</pay-response>";
}

function response_pay_state($pay){
	return xml_header()."<pay-response>
<status_code>11</status_code>
<time_stamp>".date("d.m.Y H:i:s")."</time_stamp>
<transaction>
<pay_id>".$pay['pay_id']."</pay_id>
<amount>".($pay['amount']/100)."</amount>
<status>".$pay['status']."</status>
<time_stamp>".date("d.m.Y H:i:s", $pay['date'])."</time_stamp>
</transaction>
</pay-response>";
}

function getClientByContract($contract){
	return loadRecord(sprintf("SELECT id, login, contract, account, connection_type, first_name, last_name FROM clients WHERE contract='%s'", addslashes($contract)));
}

if($nonstop_account){
	$key = getTrimOption('NONSTOP24_KEY');
	$check_hash = strtoupper(md5($_GET['ACT'].'_'.$_GET['PAY_ACCOUNT'].'_'.$_GET['PAY_ID'].'_'.$key));
	if(strtoupper($_GET['SIGN']) == $check_hash){
		switch($_GET['ACT']){
			case 1: //    ,    
				if($client = getClientByContract($_GET['PAY_ACCOUNT'])){
					$next_con_type = loadRecord(sprintf("select ct.abon_amount + IFNULL(x.use_plan,0) as abon
						from connection_types ct
						left join (
						  select sum(use_plan) use_plan, connection_type from connection_type_resources group by connection_type
						) x on x.connection_type=ct.id
						where ct.id='%s'", $client['connection_type']));
					$client['abon'] = $next_con_type['abon'];
					$charges = loadRecord(sprintf("SELECT sum(s.amount * t.price / t.unit_size) as amount
						FROM charge_subscriptions s
						LEFT JOIN charge_types t ON s.type=t.id
						WHERE s.client=%s", $client['id']));
					$client['abon'] += $charges['amount'];
					$state = getAccountState(getCurrentCalendarPeriod(), $client['account']);
					$client['deposit'] = $state['state_end'];
					echo response_client_state($client);
				}else{
					echo response_error(-40);
				}
				break;
			case 4: //    
				if($client = getClientByContract($_GET['PAY_ACCOUNT'])){
					$amount = floor($_GET['PAY_AMOUNT'] * 100);
					if($amount > 0){
						$db->Begin();
						$time = time();
						$mid = move($nonstop_account, $client['account'], $amount);
						$db->Execute(sprintf("INSERT INTO nonstop24_pays (client, movement, pay_id, receipt_num, trade_point, amount, date)
							VALUES (%s, %s, '%s', '%s', '%s', %s, FROM_UNIXTIME('%s'))",
							$client['id'], $mid,
							addslashes($_GET['PAY_ID']),
							addslashes($_GET['RECEIPT_NUM']),
							addslashes($_GET['TRADE_POINT']),
							$amount,
							$time));
						if($db->hasErrors()){
							$db->Rollback();
							// pay duplicate
							echo response_error(-100);
						}else{
							$db->Commit();
							echo response_success_pay($_GET['PAY_ID'], $amount, $time);
						}
					}else{
						// wrong amount
						echo response_error(-42);
					}
				}else{
					echo response_error(-40);
				}
				break;
			case 7: //   
				$pay = loadRecord(sprintf("SELECT UNIX_TIMESTAMP(p.date) as date, p.pay_id, p.amount, m.id as mid
					FROM nonstop24_pays p
					LEFT JOIN movements m ON m.id=p.movement
					WHERE p.pay_id='%s'", addslashes($_GET['PAY_ID'])));
				if($pay){
					$pay['status'] = $pay['mid'] ? 111 : 130;
					echo response_pay_state($pay);
				}else{
					echo response_error(-10);
				}
				break;
			default:
				// wrong action;
				echo response_error(-101);
		}
	}else{
		// wrong hash;
		echo response_error(-101);
//		echo $check_hash;
	}
}else{
	// service unavailable
	echo response_error(-90);
}
?>