<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:08:50 $
$Revision: 1.20 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
loadStrings(BOOT.'asterisk_calls/strings.txt');

$doc->title .= ' :: '.getResource('asterisk.calls.title');

required_access('support_asterisk');

//$db->debug = 1;

class StatusCellRenderer {
	var $style_map = array('1'=>'green_lighted', '2'=>'red_lighted');
	function render($column, $record){
		return sprintf("<td class='%s' align='center'>%s</td>", $this->style_map[$record['status']], $record[$column->name]);
	}
}
$status_cell = new StatusCellRenderer();

class StatusCellRenderer2 {
	var $style_map = array('1'=>'green_lighted', '2'=>'red_lighted');
	function render($column, $record){
		return sprintf("<td class='%s' align='center'>%s</td>", $record['complete'] ? $this->style_map[$record['status']] : '', $record[$column->name]);
	}
}
$status_cell2 = new StatusCellRenderer2();


$period = new PPeriod($nil,BOOT.'stats_asterisk/period-form.php');
$period->commented = false;

$filters = array();
$filters['has_caller'] = 'c.caller > ""';
$filters['has_callie'] = 'c.callie > ""';
if($period->active){
	if($from = $period->getFrom()){
		$filters['from'] = sprintf("c.start >= '%s'", $from);
	}
	if($to = $period->getTo()){
		$filters['to'] = sprintf("c.start <= '%s'", $to);
	}
}

function prepare_calls(){
	global $filters, $db;
//	unset($filters['has_code']);
	$where = empty($filters) ? "" : " WHERE ".implode(" AND ", $filters);
	$db->Execute("CREATE TEMPORARY TABLE stats_calls (
		id			BIGINT NOT NULL PRIMARY KEY,
		start		DATETIME,
		s_count		INT NOT NULL,
		wait_duration INT NOT NULL
	) ENGINE=Memory");

	insertSelectOverFile('stats_calls', sprintf("
		SELECT max(id) as id,
		min(start),
		count(*) as s_count,
		TIME_TO_SEC(max(c.answer)) - TIME_TO_SEC(min(c.start)) as wait_duration
		FROM cdr c
		%s GROUP BY c.uniqueid", $where));
}

$menu = new PNamedMenu($nil,BOOT.'asterisk_calls/menu.php');
$doc->page->contents['menu'] = $menu;
switch($menu->selected){
	case 'gr':
		prepare_calls();
		$db->Execute("CREATE TEMPORARY TABLE stats_calls_grouped (
			last		BIGINT NOT NULL PRIMARY KEY,
			c_count		INT NOT NULL,
			wait_duration INT NOT NULL,
			billsec INT NOT NULL
		) ENGINE=Memory");
	//	$db->debug = 1;
		$where = empty($filters) ? "" : " WHERE ".implode(" AND ", $filters);
		insertSelectOverFile('stats_calls_grouped', sprintf("
			SELECT max(c.id) as last,
			count(*),
			SUM(c.duration - c.billsec),
			sum(c.billsec)
			FROM cdr c
			$where
			GROUP BY date_format(c.start, '%%Y-%%m-%%d'), c.caller"));
		$grouped = new PTable($db,BOOT.'asterisk_calls/grouped/table.php');
		$doc->page->contents['grouped'] = new PMyAccess($grouped,array(
			'title'=>getResource('asterisk.calls.title.grouped'),
			'help'=>HELP_PATH.'//Asterisk',
			'icon'=>HREF.'images/log.gif',
			'grid_boot'=>BOOT.'asterisk_calls/grouped/grid.php',
			'tool'=>$period,
		));
		if($grouped->isOn()){
			$g = $grouped->active_record;
			$stats_calls = new PTable($db,BOOT.'asterisk_calls/plain/table.php');
			$from = date("Y-m-d", $g['start_t']);
			$to = date("Y-m-d", $g['start_t'] + 60*60*24);
			$stats_calls->filters['caller'] = sprintf('c.caller="%s" AND c.start BETWEEN "%s" AND "%s"', $g['src'], $from, $to);
			$doc->page->contents['stats_calls'] = new PMyAccess($stats_calls,array(
				'title'=>getResource('asterisk.calls.title.plain'),
				'help'=>HELP_PATH.'//Asterisk',
				'icon'=>HREF.'images/log.gif',
				'grid_boot'=>BOOT.'asterisk_calls/plain/grid_alt.php',
			));
			include 'includes/asterisk_under_call.php';
		}
		break;
	case 'pl':
//		prepare_calls();
//		$db->debug = 1;
		$stats_calls = new PTable($db,BOOT.'asterisk_calls/plain/table.php');
		$stats_calls->filters = $filters;
		$doc->page->contents['stats_calls'] = new PMyAccess($stats_calls,array(
			'title'=>getResource('asterisk.calls.title.plain'),
			'help'=>HELP_PATH.'//Asterisk',
			'icon'=>HREF.'images/log.gif',
			'grid_boot'=>BOOT.'asterisk_calls/plain/grid.php',
			'tool'=>$period,
		));
//		$doc->page->contents['period'] = $period;
		include 'includes/asterisk_under_call.php';
		break;
}

//$db->debug = 1;

echo $doc->Paint();
?>
