<?
$obj = array(
	'name'=>'stats_calls_grouped',
	'nick'=>'sacsg',
	'readonly'=>1,
	'source'=>'stats_calls_grouped g
	LEFT JOIN cdr c ON c.id=g.last
	LEFT JOIN clients cl ON cl.id=c.billid',
	'fields'=>array(
		'id'=>array(
			'selector'=>'c.id',
			'key'=>1,
		),
		'wait_duration'=>array(
			'selector'=>'SEC_TO_TIME(g.wait_duration)',
			'aggregate'=>'CONCAT(SUM(g.wait_duration) DIV 86400, " ", SEC_TO_TIME(SUM(g.wait_duration) MOD 86400))',
		),
		'billsec'=>array(
			'selector'=>'SEC_TO_TIME(g.billsec)',
			'aggregate'=>'CONCAT(SUM(g.billsec) DIV 86400, " ", SEC_TO_TIME(SUM(g.billsec) MOD 86400))',
		),
		'c_count'=>array(
			'selector'=>'g.c_count',
			'aggregate'=>'sum',
		),
		'src'=>array(
			'selector'=>'c.caller',
		),
		'dst'=>array(
			'selector'=>'c.callie',
		),
		'client'=>array(
			'selector'=>'c.billid',
		),
		'client_name'=>array(
			'selector'=>'CONCAT(cl.last_name, " ", cl.first_name, " (", cl.login,")")',
		),
		'disposition'=>array(
			'selector'=>'CASE c.disposition
				WHEN "ANSWERED" THEN "'.getResource('asterisk.calls.ANSWERED').'"
				WHEN "FAILED" THEN "'.getResource('asterisk.calls.FAILED').'"
				WHEN "NO ANSWER" THEN "'.getResource('asterisk.calls.NOANSWER').'"
				WHEN "BUSY" THEN "'.getResource('asterisk.calls.BUSY').'"
				ELSE c.disposition END',
			'aggregate'=>'CONCAT("+", SUM(IF(c.disposition="ANSWERED", 1, 0)), " -", SUM(IF(c.disposition="ANSWERED", 0, 1)))',
		),
		'start'=>array(
			'selector'=>'DATE_FORMAT(c.start, "%Y-%m-%d")',
			'order_by'=>'c.start',
		),
		'start_t'=>array(
			'selector'=>'UNIX_TIMESTAMP(c.start)',
		),
	),
);
?>