<?
$obj = array(
	'name'=>'cdr',
	'nick'=>'sacs2',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'cdr c
	LEFT JOIN staff s ON s.asterisk_agent IS NOT NULL AND s.asterisk_agent=c.dstchannel
	LEFT JOIN staff ss ON ss.sip_id=c.caller
	LEFT JOIN staff sd ON sd.sip_id=c.callie
	LEFT JOIN asterisk_trunks it ON c.intrunk=it.id
	LEFT JOIN asterisk_trunks ot ON c.outtrunk=ot.id
	LEFT JOIN clients cl ON cl.id=c.billid
	LEFT JOIN stamps st ON st.id=c.stamp
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'c.id',
			'key'=>1,
			'nosort'=>1,
		),
		'wait_duration'=>array(
			'selector'=>'SEC_TO_TIME(c.duration - c.billsec)',
			'aggregate'=>'CONCAT(SUM(c.duration) DIV 86400, " ", SEC_TO_TIME(SUM(c.duration) MOD 86400))',
		),
		'uniqueid'=>array(
			'selector'=>'c.uniqueid',
		),
		'billsec'=>array(
			'selector'=>'SEC_TO_TIME(c.billsec)',
			'aggregate'=>'CONCAT(SUM(c.billsec) DIV 86400, " ", SEC_TO_TIME(SUM(c.billsec) MOD 86400))',
		),
		'src'=>array(
			'selector'=>'c.caller',
		),
		'src_name'=>array(
			'selector'=>'IFNULL(CONCAT(ss.name," (", c.caller,")"), c.caller)',
		),
		'dst'=>array(
			'selector'=>'c.callie',
		),
		'dst_name'=>array(
			'selector'=>'IFNULL(CONCAT(s.name ," (",c.callie,")"), IFNULL(CONCAT(sd.name," (", c.callie,")"), c.callie))',
		),
		'intrunk'=>array(
			'selector'=>'c.intrunk',
		),
		'intrunk_name'=>array(
			'selector'=>'it.name',
		),
		'outtrunk'=>array(
			'selector'=>'c.outtrunk',
		),
		'outtrunk_name'=>array(
			'selector'=>'ot.name',
		),
		'dstchannel'=>array(
			'selector'=>'IFNULL(s.name, c.dstchannel)',
		),
		'client'=>array(
			'selector'=>'c.billid',
		),
		'client_name'=>array(
			'selector'=>'CONCAT(cl.last_name, " ", cl.first_name, " (", cl.login,")")',
		),
		'disposition'=>array(
			'selector'=>'CASE c.disposition
				WHEN "ANSWERED" THEN "'.getResource('asterisk.calls.ANSWERED').'"
				WHEN "FAILED" THEN "'.getResource('asterisk.calls.FAILED').'"
				WHEN "NO ANSWER" THEN "'.getResource('asterisk.calls.NOANSWER').'"
				WHEN "BUSY" THEN "'.getResource('asterisk.calls.BUSY').'"
				ELSE c.disposition END',
			'aggregate'=>'CONCAT("+", SUM(IF(c.disposition="ANSWERED", 1, 0)), " -", SUM(IF(c.disposition="ANSWERED", 0, 1)))',
		),
		'start'=>array(
			'selector'=>'c.start',
		),
		'start_time'=>array(
			'selector'=>'DATE_FORMAT(c.start, "%H:%i:%s")',
		),
		'record'=>array(
			'selector'=>'IF(c.disposition="ANSWERED" AND c.billsec>0, c.record, "")',
			//'selector'=>'c.record',
		),
		'record_sign'=>array(
			'selector'=>'IF(c.disposition="ANSWERED" AND c.billsec>0 AND c.record>"", "+", "-")',
		),
		'notes'=>array(
			'selector'=>'c.notes',
		),
		'rating'=>array(
			'selector'=>'c.rating',
		),
		'stamp'=>array(
			'selector'=>'c.stamp',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
	'filters'=>array(
		'noempty'=>'(c.caller > "" AND c.callie > "")',
	),
);

?>