<?
$obj = array(
	'name'=>'faxes',
	'nick'=>'fxs',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, delete_fax_file',
	'source'=>'faxes s
	LEFT JOIN clients c ON c.id=s.client
	LEFT JOIN cities ci ON ci.id=c.city
	LEFT JOIN billing_storage.files f ON f.id=s.file
	LEFT JOIN stamps st ON st.id=s.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'s.id',
		),
		'city'=>array(
			'selector'=>'c.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'number'=>array(
			'bin'=>1,
			'desc'=>1,
			'selector'=>'s.number',
		),
		'client'=>array(
			'selector'=>'s.client',
			'desc'=>1,
			'log_by'=>'client_name',
			'nullable'=>1,
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'type'=>array(
			'selector'=>'s.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'CASE s.type
				WHEN 1 THEN "'.getResource('fax.type.1').'"
				WHEN 2 THEN "'.getResource('fax.type.2').'"
				ELSE "" END',
		),
		'status'=>array(
			'selector'=>'s.status',
			'log_by'=>'status_sign',
		),
		'status_sign'=>array(
			'selector'=>'CASE s.status
				WHEN 0 THEN "'.getResource('fax.status.0').'"
				WHEN 1 THEN "'.getResource('fax.status.1').'"
				ELSE s.status END',
		),
		'file'=>array(
			'selector'=>'s.file',
		),
		'file_name'=>array(
			'selector'=>'f.name',
		),
		'file_size'=>array(
			'selector'=>'f.size',
		),
		'file_type'=>array(
			'selector'=>'f.type',
		),
		'notes'=>array(
			'selector'=>'s.notes',
		),
		'stamp'=>array(
			'selector'=>'s.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_person'=>array(
			'selector'=>'md.person',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>