<?
$obj = array(
	'name'=>'asterisk_queues',
	'nick'=>'askqs',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'BeforeDelete'=>'before_street_delete',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'asterisk_queues s
	LEFT JOIN asterisk_queues_active a ON a.code=s.code
	LEFT JOIN queries q ON q.id=s.query
	LEFT JOIN operators ls ON ls.id = s.last_sender
	LEFT JOIN staff lss ON lss.id=ls.person
	LEFT JOIN stamps st ON st.id=s.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'s.id',
		),
		'code'=>array(
			'selector'=>'s.code',
			'nullable'=>1,
		),
		'active_sign'=>array(
			'selector'=>'IF(a.code IS NULL, "-", "+")',
		),
		'name'=>array(
			'selector'=>'s.name',
			'desc'=>1,
		),
		'query'=>array(
			'selector'=>'s.query',
			'log_by'=>'query_name',
			'nullable'=>1,
		),
		'query_name'=>array(
			'selector'=>'q.name',
		),
		'target_cmd'=>array(
			'selector'=>'s.target_cmd',
		),
		'stop_cmd'=>array(
			'selector'=>'s.stop_cmd',
		),
		'notes'=>array(
			'selector'=>'s.notes',
		),
		'actual'=>array(
			'selector'=>'s.actual',
		),
		'actual_sign'=>array(
			'selector'=>'IF(s.actual, "+", "-")',
		),
		'last_sent'=>array(
			'selector'=>'s.last_sent',
			'nullable'=>1,
		),
		'last_sender'=>array(
			'selector'=>'s.last_sender',
		),
		'last_sender_person'=>array(
			'selector'=>'ls.person',
		),
		'last_sender_name'=>array(
			'selector'=>'lss.name',
		),
		
		'stamp'=>array(
			'selector'=>'s.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>