<?
$obj = array(
	'name'=>'asterisk_schedule_details',
	'nick'=>'aslab',
	'masters'=>array(
		'periods'=>array(
			'table'=>$GLOBALS['schedule'],
			'on'=>'id',
			'by'=>'schedule',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'asterisk_schedule_details asp
	LEFT JOIN asterisk_schedule s ON s.id=asp.schedule
	LEFT JOIN asterisk_schedule_objects aho ON aho.id=asp.object
	LEFT JOIN stamps st ON st.id=asp.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'asp.id',
		),
		'schedule'=>array(
			'selector'=>'asp.schedule',
			'desc'=>1,
			'log_by'=>'schedule_day',
		),
		'schedule_day'=>array(
			'selector'=>'s.day',
		),
		'object'=>array(
			'selector'=>'asp.object',
			'desc'=>1,
			'log_by'=>'object_name',
		),
		'object_name'=>array(
			'selector'=>'aho.name',
		),
		'time_begin'=>array(
			'selector'=>'asp.time_begin',
		),
		'time_end'=>array(
			'selector'=>'asp.time_end',
		),
		'period'=>array(
			'selector'=>'CONCAT(DATE_FORMAT(asp.time_begin, "%H:%i"), " - ", DATE_FORMAT(asp.time_end, "%H:%i"))',
		),
		'stamp'=>array(
			'selector'=>'asp.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>