<?
$beans = array(
	'classLoader'=>array(
		'class'=>'FileClassLoader',
		'properties'=>array(
			'root'=>'classes',
			'registry'=>array(
				'/.+/'=>'cli/$0.php',
			),
		),
	),
	'hostsIpListCLI'=>array(
		'class'=>'CommandLineInterface',
		'properties'=>array(
			'info'=>"Hosts IP lister.\nAuthor: Ponomarev Denis <ponomarev@gmail.com>\n\nusage:\n%s [OPTIONS]\n",
			'options'=>array(
				'criteriaOption:ref'=>'criteriaOption',
			),
		),
	),
	'criteriaOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'shortKey'=>'-c',
			'longKey'=>'--criteria',
			'example'=>'criteria',
			'description'=>'which hosts to use: connected|disconnected',
		),
	),
	'cabanCLI'=>array(
		'class'=>'CommandLineInterface',
		'properties'=>array(
			'info'=>"Firewall accounting system.\nAuthor: Ponomarev Denis <ponomarev@gmail.com>\n\nusage:\n%s [OPTIONS]\n",
			'options'=>array(
				'actionOption:ref'=>'actionOption',
				'workDirOption:ref'=>'workDirOption',
			),
		),
	),
	'actionOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'shortKey'=>'-a',
			'example'=>'action',
			'value'=>'help',
			'description'=>"Specify what you want to do: help|make|fetch|pak\n".
				"fetch - read counters, produce accounting iteration and run make\n".
				"make  - build caban-chains using diff-method, no accounting\n".
				"pak   - reduce size of ip-log by replacing several detail records with one summary\n".
				"track - rebuild modem profiles for abonents which states has being changed\n".
				"help  - this help"
		),
	),
	'logToStdoutLevelOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'longKey'=>'--log-stdout-level',
			'example'=>'level',
			'value'=>'INFO',
			'description'=>"Log level for stdout: ERROR|WARNING|INFO|DEBUG, default is INFO",
		),
	),
	'logFileNameOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'longKey'=>'--log-stdout-level',
			'example'=>'level',
			'value'=>'WARNING',
			'description'=>"Log level for stdout: ERROR|WARNING|INFO|DEBUG, default is WARNING",
		),
	),
	'logToFileLevelOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'longKey'=>'--log-file-name',
			'example'=>'file',
			'value'=>'/var/log/caban',
			'description'=>"Log file name",
		),
	),
	'workDirOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'shortKey'=>'-w',
			'example'=>'dir',
			'value'=>TMP_DIR.'/caban',
			'description'=>"Work directory for dump files, default is ".TMP_DIR."/caban/",
			'target:ref'=>'configurer',
			'targetProperty'=>'workdir',
		),
	),
	'chainerCLI'=>array(
		'class'=>'CommandLineInterface',
		'properties'=>array(
			'info'=>"Iptables chain builder.\nAuthor: Ponomarev Denis <ponomarev@gmail.com>\n\nusage:\n%s [OPTIONS]\n",
			'options'=>array(
				'tableOption:ref'=>'tableOption',
				'chainOption:ref'=>'chainOption',
				'locationOption:ref'=>'locationOption',
				'targetOption:ref'=>'targetOption',
				'keepFirstOption:ref'=>'keepFirstOption',
				'keepLastOption:ref'=>'keepLastOption',
				'workDirOption:ref'=>'workDirOption',
			),
		),
	),
	'tableOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'shortKey'=>'-t',
			'longKey'=>'--table',
			'example'=>'table',
			'value'=>'filter',
			'description'=>'target table, default is filter',
		),
	),
	'chainOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'shortKey'=>'-c',
			'longKey'=>'--chain',
			'example'=>'chain',
			'description'=>'target chain',
		),
	),
	'locationOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'longKey'=>'--location',
			'example'=>'loc',
			'description'=>'identidy of data to generate rules from: src|dst',
		),
	),
	'targetOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'shortKey'=>'-j',
			'longKey'=>'--jump',
			'example'=>'target',
			'description'=>'iptables target for generated rules',
		),
	),
	'keepFirstOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'shortKey'=>'-f',
			'longKey'=>'--keep-first',
			'example'=>'number',
			'value'=>'0',
			'description'=>'keep N first rules untouchable, default is 0',
		),
	),
	'keepLastOption'=>array(
		'class'=>'ValueOption',
		'properties'=>array(
			'shortKey'=>'-l',
			'longKey'=>'--keep-last',
			'example'=>'number',
			'value'=>'0',
			'description'=>'keep N last rules untouchable, default is 0',
		),
	),
);
?>