<?
$beans = array(
	'classLoader'=>array(
		'class'=>'FileClassLoader',
		'properties'=>array(
			'root'=>'classes',
			'registry'=>array(
				'Profiler'=>'tools/Profiler.php',
				'PhpTemplate'=>'tools/PhpTemplate.php',
				'LinkBuilder'=>'tools/LinkBuilder.php',
				'/.+/'=>'calendar/$0.php',
			),
		),
	),
	'profiler'=>array(
		'class'=>'Profiler',
	),
	'linkBuilder'=>array(
		'class'=>'LinkBuilder',
	),
	'calendarTemplate'=>array(
		'class'=>'PhpTemplate',
		'properties'=>array(
			'filename'=>'boot/calendar/template.php',
		),
	),

	'jobsCalendar'=>array(
		'class'=>'Calendar',
		'properties'=>array(
			'model:ref'=>'jobsShortCalendarModel',
			'template:ref'=>'calendarTemplate',
			'linkBuilder:ref'=>'linkBuilder',
			'monthKey'=>'cmonth',
			'yearKey'=>'cyear',
			'dateKey'=>'cdate',
			'activeKey'=>'cactive',
			'briefKey'=>'clnbrf',
			'placeHolders'=>4,
		),
	),

	'jobShortTemplate'=>array(
		'class'=>'PhpTemplate',
		'properties'=>array(
			'filename'=>'boot/calendar/job-short-template.php',
		),
	),
	'jobsShortCalendarModel'=>array(
		'class'=>'JobsShortCalendarModel',
		'properties'=>array(
			'jobTemplate:ref'=>'jobShortTemplate',
		),
	),

	'jobTemplate'=>array(
		'class'=>'PhpTemplate',
		'properties'=>array(
			'filename'=>'boot/calendar/job-template.php',
		),
	),
	'jobsCalendarModel'=>array(
		'class'=>'JobsCalendarModel',
		'properties'=>array(
			'jobTemplate:ref'=>'jobTemplate',
		),
	),

	'tasksCalendar'=>array(
		'class'=>'Calendar',
		'properties'=>array(
			'model:ref'=>'tasksCalendarModel',
			'template:ref'=>'calendarTemplate',
			'linkBuilder:ref'=>'linkBuilder',
			'monthKey'=>'cmonth',
			'yearKey'=>'cyear',
			'dateKey'=>'cdate',
			'activeKey'=>'cactive',
			'briefKey'=>'tclnbrf',
			'placeHolders'=>4,
		),
	),
	'taskTemplate'=>array(
		'class'=>'PhpTemplate',
		'properties'=>array(
			'filename'=>'boot/calendar/task-template.php',
		),
	),
	'tasksCalendarModel'=>array(
		'class'=>'TasksCalendarModel',
		'properties'=>array(
			'template:ref'=>'taskTemplate',
		),
	),

	'scheduleCalendar'=>array(
		'class'=>'Calendar',
		'properties'=>array(
			'model:ref'=>'scheduleCalendarModel',
			'template:ref'=>'calendarTemplate',
			'linkBuilder:ref'=>'linkBuilder',
			'monthKey'=>'cmonth',
			'yearKey'=>'cyear',
			'dateKey'=>'as_day',
			'activeKey'=>'cactive',
			'briefKey'=>'sclnbrf',
			'placeHolders'=>2,
		),
	),
	'scheduleTemplate'=>array(
		'class'=>'PhpTemplate',
		'properties'=>array(
			'filename'=>'boot/calendar/schedule-template.php',
		),
	),
	'scheduleCalendarModel'=>array(
		'class'=>'ScheduleCalendarModel',
		'properties'=>array(
			'template:ref'=>'scheduleTemplate',
		),
	),

	'reportCalendar'=>array(
		'class'=>'Calendar',
		'properties'=>array(
			'model:ref'=>'reportCalendarModel',
			'template:ref'=>'calendarTemplate',
			'linkBuilder:ref'=>'linkBuilder',
			'monthKey'=>'cmonth',
			'yearKey'=>'cyear',
			'dateKey'=>'cdate',
			'activeKey'=>'cactive',
			'briefKey'=>'rclnbrf',
			'placeHolders'=>4,
		),
	),
	'reportTemplate'=>array(
		'class'=>'PhpTemplate',
		'properties'=>array(
			'filename'=>'boot/calendar/report-template.php',
		),
	),
	'reportCalendarModel'=>array(
		'class'=>'ReportCalendarModel',
		'properties'=>array(
			'template:ref'=>'reportTemplate',
		),
	),

);
?>