<?
$obj = array(
	'name'=>'jobs_extras',
	'nick'=>'jes',
	'masters'=>array(
		'jobs'=>array(
		'table'=>$GLOBALS['jobs'],
		'on'=>'id',
		'by'=>'job',
	 ),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'jobs_extras je
	
	LEFT JOIN jobs_extra_types jet ON jet.id=je.type
	LEFT JOIN charge_types ct ON ct.id=jet.charge_type
	LEFT JOIN stamps st ON st.id=je.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'je.id',
		),
		'ticket_state'=>array(
			'selector'=>'je.ticket_state',
			'log_by'=>'ticket_state_name',
		),
		'ticket_state_name'=>array(
			'selector'=>'case je.ticket_state '.
				"when 1 then '".getResource('je.ticket.state.1')."' ".
				"when 2 then '".getResource('je.ticket.state.2')."' ".
				"ELSE '' end",
		),
		'pay_state'=>array(
			'selector'=>'je.pay_state',
			'log_by'=>'pay_state_name',
		),
		'pay_state_name'=>array(
			'selector'=>'case je.pay_state '.
				"when 1 then '".getResource('je.pay.state.1')."' ".
				"when 2 then '".getResource('je.pay.state.2')."' ".
				"ELSE '' end",
		),
		'pay_state_sign'=>array(
			'selector'=>'case je.pay_state '.
				"when 1 then '+' ".
				"when 2 then '-' ".
				"ELSE '' end",
		),
		'job'=>array(
			'selector'=>'je.job',
		),
		'type' => array(
			'selector'=>'je.type',
		),
		'type_name' => array(
			'selector'=>'jet.name',
		),
		'amount' => array(
			'selector' => 'je.amount',
			'aggregate'=>'sum',
		),
		'notes' => array(
			'selector' => 'je.notes',
		),
		'cost'=>array(
			'selector'=>'IF(ct.id IS NULL, 0.00, floor(je.amount * ct.price / ct.unit_size)/100)',
			'aggregate'=>'sum',
		),
		'worker_fee'=>array(
			'selector'=>'je.amount * jet.worker_fee/100',
			'aggregate'=>'sum',
		),
		'resource_use'=>array(
			'selector'=>'je.resource_use',
		),
		'stamp'=>array(
			'selector'=>'je.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>