<?
$obj = array(
	'name'=>'calendar_account_states',
	'nick'=>'cas',
	'masters'=>array(
		'periods'=>array(
			'table'=>$GLOBALS['periods'],
			'on'=>'id',
			'by'=>'calendar_period',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'calendar_account_states cas
	LEFT JOIN accounts an ON an.id=cas.account
	LEFT JOIN calendar_periods cp ON cp.id=cas.calendar_period
	LEFT JOIN stamps st ON st.id=cas.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'account'=>array(
			'key'=>1,
			'selector'=>'cas.account',
			'log_by'=>'account_name',
			'desc'=>1,
		),
		'account_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT("[", an.type ,"] ",an.name)',
		),
		'account_type'=>array(
			'bin'=>1,
			'selector'=>'an.type',
		),
		'calendar_period'=>array(
			'key'=>1,
		),
		'period_begin'=>array(
			'selector'=>'cp.period_begin',
			'desc'=>1,
		),
		'period_end'=>array(
			'selector'=>'cp.period_end',
			'desc'=>1,
		),
		'state_begin'=>array(
			'selector'=>'cas.state_begin',
			'log_by'=>'state_begin_cur',
		),
		'state_begin_cur'=>array(
			'selector'=>'cas.state_begin/100',
			'aggregate'=>'sum',
		),
		'state_end'=>array(
			'selector'=>'cas.state_end',
			'log_by'=>'state_end_cur',
		),
		'state_end_cur'=>array(
			'selector'=>'cas.state_end/100',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'cas.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>