<?
$obj = array(
	'name'=>'movements',
	'nick'=>'ms',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'masters'=>array(
		'periods'=>array(
			'table'=>$GLOBALS['periods'],
			'on'=>'id',
			'by'=>'calendar_period',
		),
	),
	'source'=>'movements m
	LEFT JOIN accounts s ON s.id=m.src
	LEFT JOIN accounts d ON d.id=m.dst
	LEFT JOIN stamps st ON st.id=m.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'m.id',
		),
		'calendar_period'=>array(
			'selector'=>'m.calendar_period',
		),
		'src'=>array(
			'selector'=>'m.src',
			'log_by'=>'src_name',
			'desc'=>1,
		),
		'src_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'src_type'=>array(
			'bin'=>1,
			'selector'=>'s.type',
		),
		'dst'=>array(
			'selector'=>'m.dst',
			'log_by'=>'dst_name',
			'desc'=>1,
		),
		'dst_name'=>array(
			'bin'=>1,
			'selector'=>'d.name',
		),
		'dst_type'=>array(
			'bin'=>1,
			'selector'=>'d.type',
		),
		'amount'=>array(
			'selector'=>'m.amount',
			'log_by'=>'amount_cur',
			'desc'=>1,
		),
		'amount_cur'=>array(
			'selector'=>'m.amount/100',
			'aggregate'=>'sum',
		),
		'date'=>array(
			'selector'=>'m.date',
		),
		'note'=>array(
			'nullable'=>1,
			'selector'=>'m.note',
		),
		'stamp'=>array(
			'selector'=>'m.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>