<?
$obj = array(
	'name'=>'resource_uses',
	'nick'=>'rus',
	'masters'=>array(
		'periods'=>array(
			'table'=>$GLOBALS['periods'],
			'on'=>'id',
			'by'=>'calendar_period',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert, after_resource_use_insert',
	'AfterPost'=>'after_logged_post, after_resource_use_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, after_resource_use_delete',
	'source'=>'resource_uses ru
	LEFT JOIN calendar_periods cp ON cp.id=ru.calendar_period
	LEFT JOIN clients c ON c.id=ru.client
	LEFT JOIN resource_types rt ON rt.id=ru.resource_type
	LEFT JOIN accounts s ON s.id=ru.src
	LEFT JOIN accounts d ON d.id=ru.dst
	LEFT JOIN movements m ON m.id=ru.movement
	LEFT JOIN stamps st ON st.id=ru.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'ru.id',
		),
		'calendar_period'=>array(
			'selector'=>'ru.calendar_period',
			'desc'=>1,
		),
		'calendar_period_begin'=>array(
			'bin'=>1,
			'selector'=>'cp.period_begin',
		),
		'calendar_period_end'=>array(
			'bin'=>1,
			'selector'=>'cp.period_end',
		),
		'client'=>array(
			'selector'=>'ru.client',
			'desc'=>1,
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login, ")")',
		),
		'resource_type'=>array(
			'selector'=>'ru.resource_type',
			'desc'=>1,
			'log_by'=>'resource_type_name',
		),
		'resource_type_name'=>array(
			'bin'=>1,
			'selector'=>'rt.name',
		),
		'amount'=>array(
			'selector'=>'ru.amount',
			'aggregate'=>'sum',
		),
		'unit_size'=>array(
			'selector'=>'ru.unit_size',
			'desc'=>1,
		),
		'price'=>array(
			'selector'=>'ru.price',
			'desc'=>1,
			'log_by'=>'price_cur',
		),
		'price_cur'=>array(
			'selector'=>'ru.price/100',
		),
		'cost'=>array(
			'selector'=>'floor(ru.amount * ru.price / ru.unit_size)',
		),
		'cost_cur'=>array(
			'selector'=>'floor(ru.amount * ru.price / ru.unit_size)/100',
			'aggregate'=>'sum',
		),
		'src'=>array(
			'selector'=>'ru.src',
			'nullable'=>1,
			'desc'=>1,
			'log_by'=>'src_name',
		),
		'src_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT("[", s.type, "] ", s.name)',
		),
		'src_type'=>array(
			'bin'=>1,
			'selector'=>'s.type',
		),
		'dst'=>array(
			'selector'=>'ru.dst',
			'nullable'=>1,
			'desc'=>1,
			'log_by'=>'dst_name',
		),
		'dst_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT("[", d.type, "] ", d.name)',
		),
		'dst_type'=>array(
			'bin'=>1,
			'selector'=>'d.type',
		),
		'movement'=>array(
			'selector'=>'ru.movement',
			'nullable'=>1,
		),
		'moved'=>array(
			'bin'=>1,
			'selector'=>'m.date',
		),
		'stamp'=>array(
			'selector'=>'ru.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>