<?
$obj = array(
	'name'=>'client_expenses',
	'nick'=>'clx',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'client_expenses e
	LEFT JOIN jobs j ON j.id=e.job
	LEFT JOIN cities ci ON ci.id=j.city
	LEFT JOIN job_types jt ON jt.id = j.type
	LEFT JOIN clients jc ON jc.id = j.client_id
	LEFT JOIN clients c ON c.id = e.client
	LEFT JOIN cable_state cs ON cs.client=j.client_id
	LEFT JOIN modems m ON m.id=cs.modem
	LEFT JOIN houses h ON h.id=j.house_id
	LEFT JOIN districts d ON d.id=h.district
	LEFT JOIN admin_districts ad ON ad.id=d.admin
	LEFT JOIN streets s ON h.street = s.id
	LEFT JOIN stamps st ON st.id=e.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person
	LEFT JOIN stamps cst ON cst.id=jc.stamp
	LEFT JOIN operators ccr ON ccr.id = cst.created_by
	LEFT JOIN staff ccs ON ccs.id = ccr.person
	LEFT JOIN cable_uses cu ON cu.expense=e.id',
	'fields'=>array(
		'id'=>array(
			'selector'=>'e.id',
			'key'=>1,
		),
		'work_type'=>array(
			'selector'=>'j.type',
		),
		'work_type_name'=>array(
			'selector'=>'jt.name',
		),
		'job'=>array(
			'selector'=>'e.job',
		),
		'job_name'=>array(
			'selector'=>'CONCAT(j.id, " - ", IFNULL(s.name,""), " ", IFNULL(h.house,""), ", ", IFNULL(j.apartment, ""))',
			'desc'=>1,
		),
		'job_client'=>array(
			'selector'=>'j.client_id',
		),
		'job_client_name'=>array(
			'selector'=>'CONCAT(jc.last_name, " ", jc.first_name, " (", jc.login,")")',
		),
		'city'=>array(
			'selector'=>'j.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'client'=>array(
			'selector'=>'e.client',
			'desc'=>1,
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'house_id'=>array(
			'selector'=>'jc.house_id',
		),
		'house'=>array(
			'selector'=>'h.house',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'district_name'=>array(
			'selector'=>'d.name',
		),
		'admin_district_name'=>array(
			'selector'=>'ad.name',
		),
		'entrance'=>array(
			'selector'=>'j.entrance',
		),
		'floor'=>array(
			'selector'=>'j.floor',
		),
		'floors'=>array(
			'selector'=>'h.floors',
		),
		'apartment'=>array(
			'selector'=>'j.apartment',
		),
		'cable'=>array(
			'selector'=>'IFNULL(cu.cable, e.cable)',
			'aggregate'=>'sum',
		),
		'cable_in'=>array(
			'selector'=>'IFNULL(cu.cable_in, e.cable_in)',
			'aggregate'=>'sum',
		),
		'cable_out'=>array(
			'selector'=>'IFNULL(cu.cable, e.cable) - IFNULL(cu.cable_in, e.cable_in)',
			'aggregate'=>'sum',
		),
		'cable_reported'=>array(
			'selector'=>'cs.amount',
			'aggregate'=>'sum',
		),
		'cable_diff'=>array(
			'selector'=>'IF(e.connection=3,0,-(cs.amount - IFNULL(cu.cable, e.cable)))',
			'aggregate'=>'sum',
		),
		'cable_type'=>array(
			'selector'=>'IFNULL(cu.cable_type, e.cable_type)',
		),
		'no_materials'=>array(
			'selector'=>'e.no_materials',
		),
		'connection'=>array(
			'selector'=>'e.connection',
		),
		'connection_name'=>array(
			'selector'=>'case
				when e.connection=1 then "'.getResource('client.expenses.connection.short.1').'"
				when e.connection=2 then "'.getResource('client.expenses.connection.short.2').'"
				when e.connection=3 then "'.getResource('client.expenses.connection.short.3').'"
				else "" end',
		),
		'connection_port'=>array(
			'selector'=>'e.connection_port',
			'nullable'=>1,
		),
		'modem_name'=>array(
			'selector'=>'m.name',
		),
		'modem_entrance'=>array(
			'selector'=>'m.entrance',
		),
		'modem_floor'=>array(
			'selector'=>'m.floor',
		),
		'stamp'=>array(
			'selector'=>'e.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
		'client_stamp'=>array(
			'selector'=>'jc.stamp',
		),
		'client_created'=>array(
			'selector'=>'cst.created',
		),
		'client_created_by'=>array(
			'selector'=>'cst.created_by',
		),
		'client_created_name'=>array(
			'selector'=>'ccs.name',
		),
	),
);
$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "jc.department='$d'";
}
if(isset($GLOBALS['oper']->system_access['worker_features'])){
//	$obj['filters']['by_oper'] = "st.created_by='".$GLOBALS['oper']->id."'";
}

foreach($GLOBALS['mat_types'] as $type){
	$obj['source'] .= ' LEFT JOIN client_expenses_details d'.$type['id'].' ON d'.$type['id'].'.expense=e.id AND d'.$type['id'].'.material='.$type['id'];
	$obj['fields']['m'.$type['id']] = array(
		'selector'=>'IFNULL(d'.$type['id'].'.amount, 0)',
		'aggregate'=>'sum',
	);
}

?>