<?
$obj = array(
	'name'=>'block_schedule',
	'nick'=>'bschs',
	'masters'=>array(
		'hosts'=>array(
			'table'=>$GLOBALS['stats_hosts'],
			'on'=>'id',
			'by'=>'host',
		),
	),
	'BeforeInsert'=>'before_stamped_insert, before_schedule_apply',
	'BeforePost'=>'before_stamped_post, before_schedule_apply',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'block_schedule b
	LEFT JOIN hosts h ON h.id = b.host
	LEFT JOIN clients c ON c.id = h.client
	LEFT JOIN stamps st ON st.id=b.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'b.id',
		),
		'host'=>array(
			'selector'=>'b.host',
			'desc'=>1,
			'log_by'=>'host_name',
		),
		'host_name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,") - ", h.ip)',
		),
		'type'=>array(
			'selector'=>'b.type',
			'log_by'=>'type_name',
			'desc'=>1,
		),
		'type_name'=>array(
			'selector'=>'CASE b.type
				WHEN 0 THEN "'.getResource('block.schedule.type.0').'"
				WHEN 1 THEN "'.getResource('block.schedule.type.1').'"
				ELSE "" END',
		),
		'date'=>array(
			'selector'=>'b.date',
			'nullable'=>1,
			'desc'=>1,
		),
		'day_bits'=>array(
			'selector'=>'b.day_bits',
			'desc'=>1,
		),
		'date_name'=>array(
			'selector'=>'CASE b.type
				WHEN 1 THEN b.date
				WHEN 0 THEN CONCAT(
					IF(b.day_bits &  1, "'.getResource('block.schedule.day.bits.1').' ", ""),
					IF(b.day_bits &  2, "'.getResource('block.schedule.day.bits.2').' ", ""),
					IF(b.day_bits &  4, "'.getResource('block.schedule.day.bits.3').' ", ""),
					IF(b.day_bits &  8, "'.getResource('block.schedule.day.bits.4').' ", ""),
					IF(b.day_bits & 16, "'.getResource('block.schedule.day.bits.5').' ", ""),
					IF(b.day_bits & 32, "'.getResource('block.schedule.day.bits.6').' ", ""),
					IF(b.day_bits & 64, "'.getResource('block.schedule.day.bits.7').' ", "")
				)
				ELSE "" END',
		),
		'from_time'=>array(
			'selector'=>'b.from_time',
			'desc'=>1,
		),
		'to_time'=>array(
			'selector'=>'b.to_time',
			'desc'=>1,
		),
		'period'=>array(
			'selector'=>'CONCAT(DATE_FORMAT(b.from_time, "%H:%i"), " - ", DATE_FORMAT(b.to_time, "%H:%i"))',
		),
		'stamp'=>array(
			'selector'=>'b.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>