<?
$obj = array(
	'name'=>'client_shaper_patches',
	'nick'=>'csp',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'client_shaper_patches csp
	LEFT JOIN clients c ON c.id = csp.client
	LEFT JOIN stamps st ON st.id=csp.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'csp.id',
		),
		'active'=>array(
			'selector'=>'IF((from_time IS NULL || now()>=from_time) AND (to_time IS NULL || now() < to_time), "#", "")',
		),
		'client'=>array(
			'desc'=>1,
			'selector'=>'csp.client',
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'resource_use'=>array(
			'selector'=>'csp.resource_use',
			'nullable'=>1,
		),
		'from_time'=>array(
			'selector'=>'csp.from_time',
			'nullable'=>1,
		),
		'to_time'=>array(
			'selector'=>'csp.to_time',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'csp.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
?>