<?
$obj = array(
	'name'=>'blocks',
	'nick'=>'bks',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'blocks b
	LEFT JOIN clients c ON c.id = b.client
	LEFT JOIN resource_types rt ON rt.id = b.resource_type
	LEFT JOIN stamps st ON st.id=b.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'b.id',
		),
		'active'=>array(
			'selector'=>'IF((actual_from IS NULL || now()>=actual_from) AND (actual_to IS NULL || now() < actual_to), "#", "")',
		),
		'client'=>array(
			'selector'=>'b.client',
			'desc'=>1,
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'resource_type'=>array(
			'selector'=>'b.resource_type',
			'nullable'=>1,
			'desc'=>1,
			'log_by'=>'resource_type_name',
		),
		'resource_type_name'=>array(
			'bin'=>1,
			'selector'=>'rt.name',
		),
		'actual_from'=>array(
			'selector'=>'b.actual_from',
			'nullable'=>1,
		),
		'actual_to'=>array(
			'selector'=>'b.actual_to',
			'nullable'=>1,
		),
		'type'=>array(
			'selector'=>'b.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'CASE b.type
				WHEN 1 THEN "'.getResource('blocks.type.1').'"
				WHEN 2 THEN "'.getResource('blocks.type.2').'"
				WHEN 3 THEN "'.getResource('blocks.type.3').'"
				ELSE "" END',
		),
		'note'=>array(
			'selector'=>'b.note',
			'nullable'=>1,
		),
		'client_note'=>array(
			'selector'=>'b.client_note',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'b.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
?>