<?
$obj = array(
	'name'=>'credits',
	'nick'=>'cdts',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'credits cd
	LEFT JOIN clients c ON c.id = cd.client
	LEFT JOIN stamps st ON st.id=cd.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'cd.id',
		),
		'active'=>array(
			'selector'=>'IF((actual_from IS NULL || now()>=actual_from) AND (actual_to IS NULL || now() < actual_to), "#", "")',
		),
		'client'=>array(
			'selector'=>'cd.client',
			'desc'=>1,
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'amount'=>array(
			'selector'=>'cd.amount',
			'log_by'=>'amount_cur',
		),
		'amount_cur'=>array(
			'selector'=>'cd.amount/100',
			'aggregate'=>'sum',
		),
		'type'=>array(
			'selector'=>'cd.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'CASE cd.type
				WHEN 1 THEN "'.getResource('credits.type.1').'"
				WHEN 2 THEN "'.getResource('credits.type.2').'"
				WHEN 3 THEN "'.getResource('credits.type.3').'"
				WHEN 4 THEN "'.getResource('credits.type.4').'"
				WHEN 5 THEN "'.getResource('credits.type.5').'"
				ELSE "" END
			',
		),
		'actual_from'=>array(
			'selector'=>'cd.actual_from',
			'nullable'=>1,
		),
		'actual_to'=>array(
			'selector'=>'cd.actual_to',
			'nullable'=>1,
		),
		'note'=>array(
			'selector'=>'cd.note',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'cd.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>