<?
$obj = array(
	'name'=>'hosts',
	'nick'=>'chts',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client',
		),
	),
	'BeforeInsert'=>'before_computer_apply, before_stamped_insert,verify_restricted_names',
	'BeforePost'=>'before_computer_apply, before_stamped_post,verify_restricted_names',
	'AfterInsert'=>'after_computer_post, add_auto_firewall, after_logged_insert',
	'AfterPost'=>'after_computer_post, after_logged_post',
	'AfterDelete'=>'after_computer_delete, after_stamped_delete, after_logged_delete',
	'source'=>'hosts h
	LEFT JOIN domains d ON d.id = h.domain
	LEFT JOIN clients c ON c.id = h.client
	LEFT JOIN modems m ON m.id = h.modem
	LEFT JOIN domains msd ON msd.id = m.domain
	LEFT JOIN modems_nest n ON n.id=m.id
	LEFT JOIN modems l3 ON l3.id=n.l3
	LEFT JOIN modems_states x ON x.id = m.state_id
	LEFT JOIN modems_states l3x ON l3x.id = l3.state_id
	LEFT JOIN mac_vendors v ON v.code=SUBSTRING(h.mac, 1, 8)
	LEFT JOIN pair_status_names pan ON pan.id=h.pair_a_status
	LEFT JOIN pair_status_names pbn ON pbn.id=h.pair_b_status
	LEFT JOIN stamps st ON st.id=h.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'h.id',
		),
		'ip'=>array(
			'desc'=>1,
			'selector'=>'h.ip',
			'order_by'=>'INET_ATON(h.ip)',
		),
		'mac'=>array(
			'selector'=>'h.mac',
			'nullable'=>1,
		),
		'vendor'=>array(
			'selector'=>'v.id',
			'nullable'=>1,
			'log_by'=>'vendor_name',
		),
		'vendor_name'=>array(
			'selector'=>'v.name',
			'nullable'=>1,
		),
		'name'=>array(
			'selector'=>'h.name',
		),
		'login'=>array(
			'selector'=>'h.login',
			'nullable'=>1,
		),
		'password'=>array(
			'selector'=>'h.password',
			'nullable'=>1,
		),
		'domain'=>array(
			'selector'=>'h.domain',
			'nullable'=>1,
			'log_by'=>'domain_name',
		),
		'domain_name'=>array(
			'bin'=>1,
			'selector'=>'d.name',
		),
		'client'=>array(
			'selector'=>'h.client',
			'log_by'=>'client_name',
			'desc'=>1,
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'client_login'=>array(
			'selector'=>'c.login',
		),
		'client_department'=>array(
			'bin'=>1,
			'selector'=>'c.department',
		),
		'connection_type'=>array(
			'selector'=>'c.connection_type',
		),
		'modem'=>array(
			'selector'=>'h.modem',
			'log_by'=>'modem_name',
		),
		'modem_name'=>array(
			'bin'=>1,
			'selector'=>"CONCAT(IFNULL(CONCAT(msd.name, '.'), ''), m.name)",
		),
		'modem_ip'=>array(
			'selector'=>'m.ip',
		),
		'modem_state'=>array(
			'selector'=>'x.state',
		),
		'modem_state_sign'=>array(
			'selector'=>'IF((m.audit=0) || (x.state IS NULL), "", IF(x.state, "+", "-"))',
		),
		'l3'=>array(
			'selector'=>'l3.id',
		),
		'l3_name'=>array(
			'bin'=>1,
			'selector'=>'l3.name',
		),
		'l3_ip'=>array(
			'selector'=>'l3.ip',
		),
		'l3_state'=>array(
			'selector'=>'l3x.state',
		),
		'l3_state_sign'=>array(
			'selector'=>'IF((l3.audit=0) || (l3x.state IS NULL), "", IF(l3x.state, "+", "-"))',
		),
		'port'=>array(
			'selector'=>'h.port',
		),
		'vlan'=>array(
			'selector'=>'h.vlan',
		),
		'notes'=>array(
			'selector'=>'h.notes',
		),
		'countable'=>array(
			'aggregate'=>'sum',
		),
		'pair_a_status'=>array(
			'selector'=>'h.pair_a_status',
		),
		'pair_a_status_name'=>array(
			'selector'=>'pan.name',
		),
		'pair_b_status'=>array(
			'selector'=>'h.pair_b_status',
		),
		'pair_b_status_name'=>array(
			'selector'=>'pbn.name',
		),
		'pair_a_distance'=>array(
			'selector'=>'h.pair_a_distance',
		),
		'pair_b_distance'=>array(
			'selector'=>'h.pair_b_distance',
		),
		'stamp'=>array(
			'selector'=>'h.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>