<?
$obj = array(
	'name'=>'jobs',
	'nick'=>'jbs',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client_id',
		),
	),
	'BeforeInsert'=>'before_stamped_insert,subst_client_contacts',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert,check_job_unconfigured_modems',
	'AfterPost'=>'after_logged_post,check_job_unconfigured_modems',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'jobs j
	LEFT JOIN job_types jt ON jt.id = j.type
	LEFT JOIN clients cl ON cl.id=j.client_id
	LEFT JOIN streets s ON s.id=j.street
	LEFT JOIN houses h ON h.street=j.street AND h.house=j.house
	LEFT JOIN districts d ON d.id=h.district
	LEFT JOIN staff sf ON sf.id=j.worker
	LEFT JOIN clients c ON c.id=j.found_by_client
	LEFT JOIN stamps st ON st.id=j.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'j.id',
		),
		'street'=>array(
			'selector'=>'j.street',
			'nullable'=>1,
		),
		'street_name'=>array(
			'selector'=>'s.name',
			'desc'=>1,
		),
		'district_name'=>array(
			'selector'=>'d.name',
		),
		'house'=>array(
			'selector'=>'j.house',
			'desc'=>1,
			'nullable'=>1,
		),
		'entrance'=>array(
			'selector'=>'j.entrance',
			'nullable'=>1,
		),
		'floor'=>array(
			'selector'=>'j.floor',
			'nullable'=>1,
		),
		'apartment'=>array(
			'selector'=>'j.apartment',
			'nullable'=>1,
		),
		'client'=>array(
			'selector'=>'j.client',
		),
		'client_id'=>array(
			'selector'=>'j.client_id',
			'nullable'=>1,
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(cl.last_name, " ", cl.first_name, " (", cl.login,")")',
		),
		'phone'=>array(
			'selector'=>'j.phone',
		),
		'type'=>array(
			'selector'=>'j.type',
			'nullable'=>1,
		),
		'alarm'=>array(
			'selector'=>'j.alarm',
		),
		/*'type_name'=>array(
			'desc'=>1,
			'selector'=>'case j.type '.
				'when 1 then "'.getResource('jobs.type.1').'" '.
				'when 2 then "'.getResource('jobs.type.2').'" '.
				'when 3 then "'.getResource('jobs.type.3').'" '.
				'when 4 then "'.getResource('jobs.type.4').'" '.
				'end',
		
		),*/
		
		'type_name'=>array(
			'desc'=>1,
			'selector'=>'jt.name',
		),
		
		'worker'=>array(
			'selector'=>'j.worker',
			'nullable'=>1,
		),
		'worker_name'=>array(
			'selector'=>'sf.name',
		),
		'date'=>array(
			'selector'=>'j.date',
			'desc'=>1,
		),
		'time'=>array(
			'selector'=>'date_format(date, "%H:%i")',
		),
		'notes'=>array(
			'selector'=>'j.notes',
		),
		'state'=>array(
			'selector'=>'j.state',
		),
		'state_name'=>array(
			'selector'=>'case j.state '.
				"when 1 then '".getResource('jobs.state.1')."' ".
				"when 2 then '".getResource('jobs.state.2')."' ".
				"when 3 then '".getResource('jobs.state.3')."' ".
				"when 4 then '".getResource('jobs.state.4')."' ".
				"when 5 then '".getResource('jobs.state.5')."' ".
				"end",
		),
		'found_by'=>array(
			'selector'=>'j.found_by',
		),
		'found_by_name'=>array(
			'selector'=>'case j.found_by '.
				"when 1 then '".getResource('jobs.found.by.1')."' ".
				"when 2 then '".getResource('jobs.found.by.2')."' ".
				"when 3 then '".getResource('jobs.found.by.3')."' ".
				"when 4 then '".getResource('jobs.found.by.4')."' ".
				"when 5 then '".getResource('jobs.found.by.5')."' ".
				"when 6 then '".getResource('jobs.found.by.6')."' ".
				"when 7 then '".getResource('jobs.found.by.7')."' ".
				"when 8 then '".getResource('jobs.found.by.8')."' ".
				"end",
		),
		'found_by_client'=>array(
			'selector'=>'j.found_by_client',
			'nullable'=>1,
		),
		'found_by_client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'found_by_memo'=>array(
			'selector'=>'j.found_by_memo',
		),
		'stamp'=>array(
			'selector'=>'j.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>