<?
$obj = array(
	'name'=>'client_notes',
	'nick'=>'cns',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'client_notes cn
	LEFT JOIN clients c ON cn.client = c.id
	LEFT JOIN stamps st ON st.id=cn.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'cn.id',
			'key'=>1,
		),
		'client'=>array(
			'selector'=>'cn.client',
			'desc'=>1,
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(last_name, " ", first_name)',
		),
		'type'=>array(
			'selector'=>'cn.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'case
				when cn.type=1 then "'.getResource('client.notes.type.1').'"
				when cn.type=2 then "'.getResource('client.notes.type.2').'"
				when cn.type=3 then "'.getResource('client.notes.type.3').'"
				when cn.type=4 then "'.getResource('client.notes.type.4').'"
				when cn.type=5 then "'.getResource('client.notes.type.5').'"
				when cn.type=6 then "'.getResource('client.notes.type.6').'"
				when cn.type=7 then "'.getResource('client.notes.type.7').'"
				else "" end',
		),
		'active'=>array(
			'selector'=>'cn.active',
			'log_by'=>'active_char',
		),
		'active_char'=>array(
			'selector'=>'if(cn.active, "+", "-")',
		),
		'note'=>array(
			'bin'=>1,
			'selector'=>'cn.note',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'cn.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>