<?
$obj = array(
	'name'=>'self_limitations',
	'nick'=>'sls',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'self_limitations sl
	LEFT JOIN clients c ON c.id = sl.client
	LEFT JOIN resource_types rt ON rt.id = sl.resource_type
	LEFT JOIN personal_periods pp ON pp.client=sl.client AND pp.state=1
	LEFT JOIN personal_period_plans ppp ON ppp.personal_period=pp.id AND ppp.resource_type=sl.resource_type
	LEFT JOIN stamps st ON st.id=sl.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'client'=>array(
			'desc'=>1,
			'selector'=>'sl.client',
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(last_name, " ", first_name)',
		),
		'resource_type'=>array(
			'selector'=>'sl.resource_type',
			'key'=>1,
			'log_by'=>'resource_type_name',
		),
		'resource_type_name'=>array(
			'bin'=>1,
			'selector'=>'rt.name',
		),
		'amount'=>array(
			'selector'=>'sl.amount',
			'log_by'=>'amount_cur',
		),
		'amount_cur'=>array(
			'selector'=>'sl.amount/100',
		),
		'use_actual_cur'=>array(
			'selector'=>'IFNULL(ppp.use_actual,0)/100',
		),
		'stamp'=>array(
			'selector'=>'sl.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>