<?
$obj = array(
	'name'=>'troubles',
	'nick'=>'trbs',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['clients'],
			'on'=>'id',
			'by'=>'client',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'BeforeDelete'=>'before_trouble_delete',
	'AfterInsert'=>'after_logged_insert,after_trouble_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_trouble_delete,after_stamped_delete, after_logged_delete',
	'source'=>'troubles t
	LEFT JOIN clients c ON c.id = t.client
	LEFT JOIN stamps st ON st.id=t.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'t.id',
		),
		'client'=>array(
			'desc'=>1,
			'selector'=>'t.client',
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'code'=>array(
			'selector'=>'0 + t.code',
		),
		'type'=>array(
			'selector'=>'t.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'case
				when t.type=1 then "'.getResource('troubles.type.1').'"
				when t.type=2 then "'.getResource('troubles.type.2').'"
				when t.type=3 then "'.getResource('troubles.type.3').'"
				when t.type=4 then "'.getResource('troubles.type.4').'"
				when t.type=5 then "'.getResource('troubles.type.5').'"
				else "" end',
		),
		'title'=>array(
			'selector'=>'t.title',
			'desc'=>1,
		),
		'body'=>array(
			'selector'=>'t.body',
		),
		'state'=>array(
			'selector'=>'t.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'case
				when t.state=1 then "'.getResource('troubles.state.1').'"
				when t.state=2 then "'.getResource('troubles.state.2').'"
				when t.state=3 then "'.getResource('troubles.state.3').'"
				else "" end',
		),
		'callback'=>array(
			'selector'=>'t.callback',
		),
		'callback_sign'=>array(
			'selector'=>'IF(t.callback, "+", "-")',
		),
		'callback_phone'=>array(
			'selector'=>'t.callback_phone',
		),
		'stamp'=>array(
			'selector'=>'t.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>