<?
$obj = array(
	'name'=>'coil_supplies',
	'nick'=>'cs',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_config_post, before_stamped_post',
	'AfterInsert'=>'after_logged_insert,AICoilSupplies',
	'AfterPost'=>'after_config_post, after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'coil_supplies c
	LEFT JOIN cities ci ON ci.id=c.city
	LEFT JOIN coil_rests r ON r.supply=c.id
	LEFT JOIN tech_zones tz ON tz.id = c.tech_zone
	LEFT JOIN stamps st ON st.id=c.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'c.id',
		),
		'city'=>array(
			'selector'=>'c.city',
			'nullable'=>1,
			'log_by'=>'city_name',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'date'=>array(
			'selector'=>'c.date',
			'desc'=>1,
		),
        'code_from'=>array(
			'selector'=>'c.code_from',
			'desc'=>1,
		),
        //'code_to'=>array(
		//	'selector'=>'c.code_to',
		//),
        'tech_zone'=>array(
			'selector'=>'c.tech_zone',
			'log_by'=>'tech_zone_name',
			'desc'=>1,
		),
        'tech_zone_name'=>array(
			'selector'=>'tz.name',
		),
        'cable_type'=>array(
            'selector' => 'c.cable_type',
			'log_by'=>'cable_type_n',
			'desc'=>1,
		),
        'cable_type_n' => array(
			'selector'=>'case
				when c.cable_type=1 then "'.getResource('cs.cable_type.1').'"
				when c.cable_type=2 then "'.getResource('cs.cable_type.2').'"
				when c.cable_type=4 then "'.getResource('cs.cable_type.4').'"
				else "" end',
        ),
        'amount'=>array(
			'selector'=>'c.amount',
            'aggregate'=>'sum',
		),
        'length'=>array(
			'selector'=>'c.length',
		),
        'sum_length'=>array(
			'selector'=>'c.length * IFNULL(r.amount,0)',
			'aggregate'=>'sum',
		),
		'rest'=>array(
			'selector'=>'IFNULL(r.rest, 0)',
			'aggregate'=>'sum',
		),
		'ramount'=>array(
			'selector'=>'IFNULL(r.amount,0)',
		),
		'stamp'=>array(
			'selector'=>'c.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>