<?
$obj = array(
	'name'=>'con_requests',
	'nick'=>'crqs',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'con_requests r
	LEFT JOIN houses h ON h.id=r.house_id
	LEFT JOIN districts ds ON ds.id=h.district
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN cities ci ON ci.id=r.city
	LEFT JOIN stamps st ON st.id=r.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person
	LEFT JOIN answers_count ac ON ac.order_id=r.id',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'r.id',
		),
		'source'=>array(
			'selector'=>'r.source',
			'log_by'=>'source_name',
		),
		'source_name'=>array(
			'selector'=>'CASE r.source
				WHEN 1 THEN "'.getResource('con.requests.source.1').'"
				WHEN 2 THEN "'.getResource('con.requests.source.2').'"
				WHEN 3 THEN "'.getResource('con.requests.source.3').'"
				WHEN 4 THEN "'.getResource('con.requests.source.4').'"
				ELSE "" END',
		),
		'house_id'=>array(
			'nullable'=>1,
			'selector'=>'r.house_id',
			'log_by'=>'house_name',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'house_internet'=>array(
			'selector'=>'case h.internet
				when 2 then "*"
				when 1 then "+"
				when 0 then "-"
				else "" end',
		),
		'house_tv'=>array(
			'selector'=>'case h.tv
				when 2 then "*"
				when 1 then "+"
				when 0 then "-"
				else "" end',
		),
		'house_coords'=>array(
			'selector'=>'h.coords',
		),
		'district'=>array(
			'selector'=>'h.district',
		),
		'district_name'=>array(
			'selector'=>'ds.name',
		),
		'city'=>array(
			'selector'=>'r.city',
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'client'=>array(
			'desc'=>1,
			'selector'=>'r.client',
		),
		'email'=>array(
			'selector'=>'r.email',
		),
		'street_name_grid'=>array(
			'desc'=>1,
			'selector'=>'IF(h.street IS NULL, r.street_name, s.name)',
		),
		'street_name'=>array(
			'desc'=>1,
			'selector'=>'r.street_name',
		),
		'house_grid'=>array(
			'selector'=>'IF(r.house_id IS NULL, r.house, h.house)',
		),
		'house'=>array(
			'desc'=>1,
			'selector'=>'r.house',
		),
		'entrance'=>array(
			'selector'=>'r.entrance',
		),
		'floor'=>array(
			'selector'=>'r.floor',
		),
		'appartment'=>array(
			'selector'=>'r.appartment',
		),
		'phone'=>array(
			'selector'=>'r.phone',
		),
		'notes'=>array(
			'selector'=>'r.notes',
		),
		'inzone'=>array(
			'selector'=>'r.inzone',
		),
		'inzone_sign'=>array(
			'selector'=>'if(r.inzone, "+", "-")',
		),
		'state'=>array(
			'selector'=>'r.state',
			'log_by'=>'state_name',
		),
		'state_sign'=>array(
			'selector'=>'IF(r.state, "+", "-")',
		),
		'state_name'=>array(
			'selector'=>'CASE r.state
				WHEN 1 THEN CONCAT("'.getResource('con.requests.state.1').'", IFNULL(DATE_FORMAT(r.accept_date, " - %Y-%m-%d"), ""))
				WHEN 2 THEN "'.getResource('con.requests.state.2').'"
				WHEN 3 THEN CONCAT("'.getResource('con.requests.state.3').'", IFNULL(DATE_FORMAT(r.recall_date, " - %Y-%m-%d"), ""))
				WHEN 4 THEN "'.getResource('con.requests.state.4').'"
				WHEN 5 THEN "'.getResource('con.requests.state.5').'"
				WHEN 6 THEN "'.getResource('con.requests.state.6').'"
				ELSE "" END',
		),
		'type'=>array(
			'selector'=>'r.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'CASE r.type
				WHEN 1 THEN "'.getResource('con.requests.type.1').'"
				WHEN 2 THEN "'.getResource('con.requests.type.2').'"
				WHEN 3 THEN "'.getResource('con.requests.type.3').'"
				ELSE "" END',
		),
		'accept_date'=>array(
			'selector'=>'r.accept_date',
			'nullable'=>1,
		),
		'recall_date'=>array(
			'selector'=>'r.recall_date',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'r.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
		'answers' => array(
			'selector'=>'IFNULL(ac.cnt, 0)',
			'aggregate'=>'sum',
			)
		),
);
?>