<?
$obj = array(
	'name'=>'connection_type_bonuses',
	'nick'=>'hpbs',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'BeforeDelete'=>'',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'masters'=>array(
		'connection_types'=>array(
			'table'=>$GLOBALS['connection_types'],
			'on'=>'id',
			'by'=>'connection_type',
		),
	),
	'source'=>'connection_type_bonuses ctr
	LEFT JOIN connection_types ct ON ct.id=ctr.connection_type
	LEFT JOIN account_types r ON r.id=ctr.account_type
	LEFT JOIN accounts s ON s.id=ctr.start_src
	LEFT JOIN accounts d ON d.id=ctr.end_dst
	LEFT JOIN stamps st ON st.id=ctr.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'ctr.id',
			'desc'=>1,
		),
		'connection_type'=>array(
			'desc'=>1,
			'log_by'=>'connection_type_name',
			'selector'=>'ctr.connection_type',
		),
		'connection_type_name'=>array(
			'bin'=>1,
			'selector'=>'ct.name',
		),
		'account_type'=>array(
			'selector'=>'ctr.account_type',
			'key'=>1,
			'log_by'=>'account_type_name',
		),
		'account_type_name'=>array(
			'selector'=>'r.name',
		),
		'start_src'=>array(
			'selector'=>'ctr.start_src',
			'log_by'=>'start_src_name',
			'nullable'=>1,
		),
		'start_src_name'=>array(
			'selector'=>'s.name',
		),
		'end_dst'=>array(
			'selector'=>'ctr.end_dst',
			'log_by'=>'end_dst_name',
			'nullable'=>1,
		),
		'end_dst_name'=>array(
			'selector'=>'d.name',
		),
		'start_amount'=>array(
			'selector'=>'ctr.start_amount',
		),
		'start_amount_cur'=>array(
			'selector'=>'ctr.start_amount / 100',
			'desc'=>1,
		),
		'end_amount'=>array(
			'selector'=>'ctr.end_amount',
		),
		'end_amount_cur'=>array(
			'selector'=>'ctr.end_amount / 100',
		),
		'stamp'=>array(
			'selector'=>'ctr.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>