<?
$obj = array(
	'name'=>'connection_types',
	'nick'=>'hps',
	'BeforeInsert'=>'check_connection_type, before_stamped_insert,check_credit_connection_type,before_copy_connection_type',
	'BeforePost'=>'check_connection_type, before_stamped_post,check_credit_connection_type',
	'BeforeDelete'=>'before_connection_type_delete',
	'AfterInsert'=>'after_logged_insert,after_copy_connection_type',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_connection_type_delete, after_stamped_delete, after_logged_delete',
	'source'=>'connection_types ct
	LEFT JOIN cities c ON c.id=ct.city
	LEFT JOIN actions a ON a.id=ct.action
	LEFT JOIN connection_types o ON o.id=ct.offline_type
	LEFT JOIN connection_types r ON r.id=ct.replace_by
	LEFT JOIN connection_types cct ON cct.id=ct.credit_con_type
	LEFT JOIN resource_types rt ON rt.id=ct.abon_resource_type
	LEFT JOIN system_accounts ad ON ad.account=ct.abon_dst
	LEFT JOIN charge_types cht ON cht.id=ct.unshape_charge_type
	LEFT JOIN stamps st ON st.id=ct.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'ct.id',
		),
		'gigabit'=>array(
			'selector'=>'ct.gigabit',
			'log_by'=>'gigabit_name',
		),
		'gigabit_sign'=>array(
			'selector'=>'IF(ct.gigabit, "+", "-")',
		),
		'city'=>array(
			'selector'=>'ct.city',
			'log_by'=>'city_name',
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'action'=>array(
			'selector'=>'ct.action',
			'log_by'=>'action_name',
			'nullable'=>1,
		),
		'service_type'=>array(
			'selector'=>'ct.service_type',
			'log_by'=>'service_type_name',
		),
		'service_type_name' => array(
			'selector'=>'case ct.service_type
				when 1 then "'.getResource('connection.types.service.type.1').'"
				when 2 then "'.getResource('connection.types.service.type.2').'"
				when 3 then "'.getResource('connection.types.service.type.3').'"
				else "" end',
		),
		'action_name'=>array(
			'selector'=>'a.name',
		),
		'period_months'=>array(
			'selector'=>'ct.period_months',
		),
		'period_days'=>array(
			'selector'=>'ct.period_days',
		),
		'name'=>array(
			'bin'=>1,
			'desc'=>1,
			'selector'=>'ct.name',
		),
		'offline_type'=>array(
			'selector'=>'ct.offline_type',
			'nullable'=>1,
			'log_by'=>'offline_type_name',
		),
		'offline_type_name'=>array(
			'selector'=>'o.name',
		),
		'replace_by'=>array(
			'selector'=>'ct.replace_by',
			'nullable'=>1,
			'log_by'=>'replace_by_name',
		),
		'replace_by_name'=>array(
			'selector'=>'r.name',
		),
		'replace_after'=>array(
			'selector'=>'ct.replace_after',
			'nullable'=>1,
		),
		'replace_date'=>array(
			'selector'=>'ct.replace_date',
			'nullable'=>1,
		),
		'credit_con_type'=>array(
			'selector'=>'ct.credit_con_type',
			'nullable'=>1,
			'log_by'=>'credit_con_type_name',
		),
		'credit_con_type_name'=>array(
			'selector'=>'cct.name',
		),
		'abon_resource_type'=>array(
			'selector'=>'ct.abon_resource_type',
			'nullable'=>1,
			'log_by'=>'abon_resource_type_name',
		),
		'abon_resource_type_name'=>array(
			'bin'=>1,
			'selector'=>'rt.name',
		),
		'abon_dst'=>array(
			'nullable'=>1,
			'selector'=>'ct.abon_dst',
			'log_by'=>'abon_dst_name',
		),
		'abon_dst_name'=>array(
			'bin'=>1,
			'selector'=>'ad.name',
		),
		'abon_amount'=>array(
			'selector'=>'ct.abon_amount',
			'log_by'=>'abon_amount_cur',
		),
		'abon_amount_cur'=>array(
			'selector'=>'ct.abon_amount/100',
		),
		'unshape_charge_type'=>array(
			'selector'=>'ct.unshape_charge_type',
			'nullable'=>1,
			'log_by'=>'unshape_charge_type_name',
		),
		'unshape_charge_type_name'=>array(
			'selector'=>'cht.name',
		),
		'allow_enter'=>array(
			'selector'=>'ct.allow_enter',
		),
		'enter_cost'=>array(
			'selector'=>'ct.enter_cost',
		),
		'enter_cost_cur'=>array(
			'selector'=>'ct.enter_cost/100',
		),
		'allow_leave'=>array(
			'selector'=>'ct.allow_leave',
		),
		'allow_credits'=>array(
			'selector'=>'ct.allow_credits',
		),
		'allow_credits_sign'=>array(
			'selector'=>'IF(ct.allow_credits, "+", "-")',
		),
		'max_hosts'=>array(
			'selector'=>'ct.max_hosts',
		),
		'start_always'=>array(
			'selector'=>'ct.start_always',
		),
		'port_speed'=>array(
			'selector'=>'ct.port_speed',
			'nullable'=>1,
		),
		'public'=>array(
			'selector'=>'ct.public',
		),
		'first_charge_amount'=>array(
			'selector'=>'ct.first_charge_amount',
		),
		'first_free_amount'=>array(
			'selector'=>'ct.first_free_amount',
		),
		'first_free_limit'=>array(
			'selector'=>'ct.first_free_limit',
		),
		'igmp_profile'=>array(
			'selector'=>'ct.igmp_profile',
		),
		'igmp_max_groups'=>array(
			'selector'=>'ct.igmp_max_groups',
		),
		'igmp_block'=>array(
			'selector'=>'ct.igmp_block',
			'log_by'=>'igmp_block_sign',
		),
		'igmp_block_sign'=>array(
			'selector'=>'IF(ct.igmp_block, "+", "-")',
		),
		'check_offline'=>array(
			'selector'=>'ct.check_offline',
		),
		'check_offline_sign'=>array(
			'selector'=>'IF(ct.check_offline, "+", "-")',
		),
		'stamp'=>array(
			'selector'=>'ct.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>