<?
$obj = array(
	'name'=>'documents_access',
	'nick'=>'dacc',
	'masters'=>array(
		'documents'=>array(
			'table'=>$GLOBALS['documents'],
			'on'=>'id',
			'by'=>'document',
		),
	),
	'BeforeInsert'=>'before_stamped_insert, before_doc_access_apply',
	'BeforePost'=>'before_stamped_post, before_doc_access_apply',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'documents_access da
	LEFT JOIN cities c ON c.id=da.city
	LEFT JOIN ranks r ON r.id=da.rank
	LEFT JOIN groups g ON g.id=da.group_id
	LEFT JOIN staff s ON s.id = da.person
	LEFT JOIN stamps st ON st.id=da.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'da.id',
		),
		'city'=>array(
			'selector'=>'da.city',
			'log_by'=>'city_name',
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'document'=>array(
			'selector'=>'da.document',
			'desc'=>1,
		),
		'access_to'=>array(
			'selector'=>'da.access_to',
			'desc'=>1,
			'log_by'=>'access_to_name',
		),
		'access_to_name'=>array(
			'selector'=>'case da.access_to
				when 1 then "'.getResource('documents.access.to.1').'"
				when 2 then "'.getResource('documents.access.to.2').'"
				when 3 then "'.getResource('documents.access.to.3').'"
				when 4 then "'.getResource('documents.access.to.4').'"
				when 5 then "'.getResource('documents.access.to.5').'"
				else "" end',
		),
		'access_level'=>array(
			'selector'=>'da.access_level',
			'log_by'=>'access_level_name',
		),
		'access_level_name'=>array(
			'selector'=>'case da.access_level
				when 1 then "'.getResource('documents.access.level.1').'"
				when 2 then "'.getResource('documents.access.level.2').'"
				else "" end',
		),
		'access_who'=>array(
			'selector'=>'case da.access_to
				when 1 then ""
				when 2 then IFNULL(g.name, "")
				when 3 then IFNULL(r.name, "")
				when 4 then (case da.section
					when 1 then "'.getResource('staff.section.1').'"
					when 2 then "'.getResource('staff.section.2').'"
					when 3 then "'.getResource('staff.section.3').'"
					when 4 then "'.getResource('staff.section.4').'"
					when 5 then "'.getResource('staff.section.5').'"
					else "" end)
				when 5 then IFNULL(s.name, "")
				else "" end',
		),
		'rank'=>array(
			'selector'=>'da.rank',
			'log_by'=>'rank_name',
			'nullable'=>1,
		),
		'rank_name'=>array(
			'selector'=>'r.name',
		),
		'group_id'=>array(
			'selector'=>'da.group_id',
			'log_by'=>'group_name',
			'nullable'=>1,
		),
		'group_name'=>array(
			'selector'=>'g.name',
		),
		'section'=>array(
			'selector'=>'da.section',
			'log_by'=>'section_name',
			'nullable'=>1,
		),
		'section_name'=>array(
			'selector'=>'case da.section
				when 1 then "'.getResource('staff.section.1').'"
				when 2 then "'.getResource('staff.section.2').'"
				when 3 then "'.getResource('staff.section.3').'"
				when 4 then "'.getResource('staff.section.4').'"
				when 5 then "'.getResource('staff.section.5').'"
				else "" end',
		),
		'person'=>array(
			'selector'=>'da.person',
			'log_by'=>'person_name',
			'nullable'=>1,
		),
		'person_name'=>array(
			'selector'=>'s.name',
		),
		'stamp'=>array(
			'selector'=>'da.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>