<?
$obj = array(
	'name'=>'ecalls_back',
	'nick'=>'eclsb',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert, after_back_apply',
	'AfterPost'=>'after_logged_post, after_back_apply',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'masters'=>array(
		'ecals'=>array(
			'table'=>$GLOBALS['ecalls'],
			'on'=>'id',
			'by'=>'ecall',
		),
	),
	'source'=>'ecalls_back eb
	LEFT JOIN ecalls e ON eb.ecall = e.id
	LEFT JOIN stamps st ON st.id=eb.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'eb.id',
			'key'=>1,
		),
		'ecall'=>array(
			'selector'=>'eb.ecall',
			'desc'=>1,
		),
		'state'=>array(
			'selector'=>'eb.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'CASE eb.state
				WHEN 0 THEN "'.getResource('ecalls.state.0').'"
				WHEN 1 THEN "'.getResource('ecalls.state.1').'"
				WHEN 2 THEN CONCAT("'.getResource('ecalls.state.2').'", " ", IFNULL(DATE_FORMAT(eb.recall_date, "%Y-%m-%d %H:%i"), ""))
				WHEN 3 THEN "'.getResource('ecalls.state.3').'"
				WHEN 4 THEN "'.getResource('ecalls.state.4').'"
				ELSE "" END',
		),
		'recall_date'=>array(
			'selector'=>'eb.recall_date',
			'nullable'=>1,
		),
		'refuse_reason'=>array(
			'selector'=>'eb.refuse_reason',
			'log_by'=>'refuse_reason_name',
		),
		'refuse_reason_name'=>array(
			'selector'=>'CASE eb.refuse_reason
				WHEN 1 THEN "'.getResource('ecalls.refuse.reason.1').'"
				WHEN 2 THEN "'.getResource('ecalls.refuse.reason.2').'"
				WHEN 3 THEN "'.getResource('ecalls.refuse.reason.3').'"
				WHEN 4 THEN "'.getResource('ecalls.refuse.reason.4').'"
				WHEN 5 THEN "'.getResource('ecalls.refuse.reason.5').'"
				ELSE "" END',
		),
		'note'=>array(
			'bin'=>1,
			'selector'=>'eb.note',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'eb.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>