<?
$obj = array(
	'name'=>'exp_complaints',
	'nick'=>'mds',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'exp_complaints m
	LEFT JOIN cities c ON c.id=m.city
	LEFT JOIN houses h ON h.id=m.house
	LEFT JOIN districts ds ON ds.id=h.district
	LEFT JOIN admin_districts ad ON ad.id=ds.admin
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN exp_executors ee ON ee.id=m.executor
	LEFT JOIN stamps st ON st.id=m.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'m.id',
		),
		'name'=>array(
			'selector'=>'m.name',
			'desc'=>1,
		),
		'city'=>array(
			'selector'=>'m.city',
			'log_by'=>'city_name',
			'desc'=>1,
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'district'=>array(
			'selector'=>'h.district',
		),
		'district_name'=>array(
			'selector'=>'ds.name',
		),
		'admin_district'=>array(
			'selector'=>'ds.admin',
		),
		'admin_district_name'=>array(
			'selector'=>'ad.name',
		),
		'house'=>array(
			'desc'=>1,
			'selector'=>'m.house',
			'log_by'=>'house_name',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'house_house'=>array(
			'selector'=>'h.house',
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'selector'=>'s.name',
		),
		'executor'=>array(
			'selector'=>'m.executor',
			'log_by'=>'executor_name',
			'nullable'=>1,
		),
		'executor_name'=>array(
			'selector'=>'ee.name',
		),
		'state'=>array(
			'selector'=>'m.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'CASE m.state
				WHEN 1 THEN "'.getResource('exp_complaints.state.1').'"
				WHEN 2 THEN "'.getResource('exp_complaints.state.2').'"
				WHEN 3 THEN "'.getResource('exp_complaints.state.3').'"
				ELSE "" END',
		),
		'state_sign'=>array(
			'selector'=>'CASE m.state
				WHEN 1 THEN "'.getResource('exp_complaints.state.sign.1').'"
				WHEN 2 THEN "'.getResource('exp_complaints.state.sign.2').'"
				WHEN 3 THEN "'.getResource('exp_complaints.state.sign.3').'"
				ELSE "'.getResource('exp_complaints.state.sign.0').'" END',
		),
		'reason'=>array(
			'selector'=>'m.reason',
			'nullable'=>1,
		),
		'entrance'=>array(
			'selector'=>'m.entrance',
			'nullable'=>1,
		),
		'floor'=>array(
			'selector'=>'m.floor',
			'nullable'=>1,
		),
		'apartment'=>array(
			'selector'=>'m.apartment',
			'nullable'=>1,
		),
		'phone'=>array(
			'selector'=>'m.phone',
		),
		'stamp'=>array(
			'selector'=>'m.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>