<?
$obj = array(
	'name'=>'exp_in_use_materials',
	'nick'=>'exum',
	'masters'=>array(
		'points'=>array(
			'table'=>$GLOBALS['exp_materials'],
			'on'=>'id',
			'by'=>'material',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'exp_in_use_materials um
	LEFT JOIN exp_materials m ON m.id=um.material
	LEFT JOIN exp_points p ON p.id=um.point
	LEFT JOIN houses h ON h.id=p.house
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN stamps st ON st.id=um.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'um.id',
		),
		'material'=>array(
			'desc'=>1,
			'selector'=>'um.material',
		),
		'point'=>array(
			'desc'=>1,
			'selector'=>'um.point',
		),
		'unit_name'=>array(
			'selector'=>'case m.unit
				when 1 then "'.getResource('exp.materials.unit.1').'"
				when 2 then "'.getResource('exp.materials.unit.2').'"
				when 3 then "'.getResource('exp.materials.unit.3').'"
				when 4 then "'.getResource('exp.materials.unit.4').'"
				else "" end',
		),
		'point_name'=>array(
			'desc'=>1,
			'selector'=>'CONCAT(s.name, " ", h.house, " '.getResource('exp.points.entrance.short').'", IFNULL(p.entrance,""), " '.getResource('exp.points.floor.short').'", 
							case p.floor
							when -1 then "'.getResource('exp.points.floor.1').'"
							when -2 then "'.getResource('exp.points.floor.2').'"
							when -3 then "'.getResource('exp.points.floor.3').'"
							when -4 then "'.getResource('exp.points.floor.4').'"
							else IFNULL(p.floor,"") end)',
		),
		'amount'=>array(
			'selector'=>'um.amount',
		),
		'amount_cur'=>array(
			'selector'=>'um.amount/100',
			'aggregate'=>'sum',
		),
		'notes'=>array(
			'selector'=>'um.notes',
		),
		'stamp'=>array(
			'selector'=>'um.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>