<?
$obj = array(
	'name'=>'exp_points',
	'nick'=>'exp',
	'BeforeInsert'=>'before_stamped_insert, check_point_city',
	'BeforePost'=>'before_stamped_post, check_point_city',
	'AfterInsert'=>'after_logged_insert,after_point_post',
	'AfterPost'=>'after_logged_post,after_point_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete,after_point_delete',
	'source'=>'exp_points p
	LEFT JOIN cities c ON c.id=p.city
	LEFT JOIN exp_executors ex ON ex.id=p.executor
	LEFT JOIN houses h ON h.id=p.house
	LEFT JOIN districts d ON d.id=h.district
	LEFT JOIN admin_districts ad ON ad.id=d.admin
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN point_modems pm ON pm.point=p.id
	LEFT JOIN point_tv_nodes pt ON pt.point=p.id
	LEFT JOIN stamps st ON st.id=p.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'p.id',
		),
		'city'=>array(
			'selector'=>'p.city',
			'log_by'=>'city_name',
			'desc'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'district'=>array(
			'selector'=>'h.district',
			'log_by'=>'district_name',
			'desc'=>1,
		),
		'district_name'=>array(
			'selector'=>'d.name',
		),
		'admin_district'=>array(
			'selector'=>'d.admin',
			'log_by'=>'admin_district_name',
			'desc'=>1,
		),
		'admin_district_name'=>array(
			'selector'=>'ad.name',
		),
		'inv_number' => array(
			'selector' => 'p.inv_number',
			'nullable'=>1,
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'selector'=>'s.name',
		),
		'house'=>array(
			'desc'=>1,
			'selector'=>'p.house',
			'log_by'=>'house_name',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'house_house'=>array(
			'selector'=>'h.house',
		),
		'entrance'=>array(
			'selector'=>'p.entrance',
			'nullable'=>1,
		),
		'floor'=>array(
			'selector'=>'p.floor',
			'nullable'=>1,
			'log_by'=>'floor_name',
		),
		'floor_name'=>array(
			'selector'=>'case p.floor
				when -1 then "'.getResource('exp.points.floor.1').'"
				when -2 then "'.getResource('exp.points.floor.2').'"
				when -3 then "'.getResource('exp.points.floor.3').'"
				when -4 then "'.getResource('exp.points.floor.4').'"
				else p.floor end',
		),
		'type'=>array(
			'selector'=>'p.type',
			'nullable'=>1,
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'case p.type
				when 1 then "'.getResource('exp.points.type.1').'"
				when 2 then "'.getResource('exp.points.type.2').'"
				when 3 then "'.getResource('exp.points.type.3').'"
				when 4 then "'.getResource('exp.points.type.4').'"
				when 5 then "'.getResource('exp.points.type.5').'"
				else "" end',
		),
		'executor'=>array(
			'selector'=>'p.executor',
			'nullable'=>1,
			'log_by'=>'executor_name',
		),
		'executor_name'=>array(
			'selector'=>'ex.name',
		),
		'notes'=>array(
			'selector'=>'p.notes',
		),
		'date'=>array(
			'selector'=>'p.date',
			'nullable'=>1,
		),
		'place'=>array(
			'selector'=>'p.place',
		),
		'coord_1'=>array(
			'selector'=>'p.coord_1',
			'nullable'=>1,
		),
		'coord_2'=>array(
			'selector'=>'p.coord_2',
			'nullable'=>1,
		),
		'photo_file1'=>array(
			'selector'=>'p.photo_file1',
		),
		'photo_file2'=>array(
			'selector'=>'p.photo_file2',
		),
		'photo_file3'=>array(
			'selector'=>'p.photo_file3',
		),
		'photo_file4'=>array(
			'selector'=>'p.photo_file4',
		),
		'in_proekt'=>array(
			'selector'=>'p.in_proekt',
		),
		'in_proekt_sign'=>array(
			'selector'=>'IF(p.in_proekt, "+", "-")',
		),
		'acting'=>array(
			'selector'=>'p.acting',
		),
		'acting_sign'=>array(
			'selector'=>'IF(p.acting, "+", "-")',
		),
		'mob'=>array(
			'selector'=>'p.mob',
		),
		'mob_sign'=>array(
			'selector'=>'IF(p.mob, "+", "-")',
		),
		'power'=>array(
			'selector'=>'p.power',
		),
		'power_sign'=>array(
			'selector'=>'IF(p.power, "+", "-")',
		),
		'splices'=>array(
			'selector'=>'p.splices',
		),
		'splices_sign'=>array(
			'selector'=>'IF(p.splices, "+", "-")',
		),
		'checked'=>array(
			'selector'=>'p.checked',
		),
		'checked_sign'=>array(
			'selector'=>'IF(p.checked, "+", "-")',
		),
		'proekt'=>array(
			'selector'=>'p.proekt',
		),
		'kod'=>array(
			'selector'=>'p.kod',
		),
		'splices_list'=>array(
			'selector'=>'p.splices_list',
		),
		'modems_cnt'=>array(
			'selector'=>'IFNULL(pm.cnt,0)',
		),
		'tv_nodes_cnt'=>array(
			'selector'=>'IFNULL(pt.cnt,0)',
		),
		'stamp'=>array(
			'selector'=>'p.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>