<?
$obj = array(
	'name'=>'exp_repair_requests',
	'nick'=>'exrrs',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_insert',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'exp_repair_requests r
	LEFT JOIN cities ci ON ci.id=r.city
	LEFT JOIN exp_points p ON p.id=r.point
	LEFT JOIN houses ph ON ph.id=p.house
	LEFT JOIN districts ds ON ds.id=ph.district
	LEFT JOIN admin_districts ad ON ad.id=ds.admin
	LEFT JOIN streets ps ON ps.id=ph.street
	LEFT JOIN stamps st ON st.id=r.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'r.id',
		),
		'city'=>array(
			'selector'=>'r.city',
			'log_by'=>'city_name',
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'point'=>array(
			'selector'=>'r.point',
			'log_by'=>'point_name',
			'nullable'=>1,
		),
		'point_name'=>array(
			'selector'=>'CONCAT(ps.name, " ", ph.house, " '.getResource('exp.points.entrance.short').'", IFNULL(p.entrance,""), " '.getResource('exp.points.floor.short').'", 
				case p.floor
				when -1 then "'.getResource('exp.points.floor.1').'"
				when -2 then "'.getResource('exp.points.floor.2').'"
				when -3 then "'.getResource('exp.points.floor.3').'"
				when -4 then "'.getResource('exp.points.floor.4').'"
				else IFNULL(p.floor,"") end)',
		),
		'district'=>array(
			'selector'=>'ph.district',
		),
		'district_name'=>array(
			'selector'=>'ds.name',
		),
		'street'=>array(
			'selector'=>'ph.street',
		),
		'street_name'=>array(
			'selector'=>'ps.name',
		),
		'house'=>array(
			'selector'=>'p.house',
		),
		'house_house'=>array(
			'selector'=>'ph.house',
		),
		'entrnace'=>array(
			'selector'=>'p.entrance',
		),
		'floor'=>array(
			'selector'=>'case p.floor
				when -1 then "'.getResource('exp.points.floor.1').'"
				when -2 then "'.getResource('exp.points.floor.2').'"
				when -3 then "'.getResource('exp.points.floor.3').'"
				when -4 then "'.getResource('exp.points.floor.4').'"
				else IFNULL(p.floor,"") end',
		),
		'address'=>array(
			'selector'=>'r.address',
			'nullable'=>1,
		),
		'type'=>array(
			'selector'=>'r.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'CASE r.type
				WHEN 1 THEN "'.getResource('exp.repair.requests.type.1').'"
				WHEN 2 THEN "'.getResource('exp.repair.requests.type.2').'"
				ELSE "" END',
		),
		'state'=>array(
			'selector'=>'r.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'CASE r.state
				WHEN 1 THEN "'.getResource('exp.repair.requests.state.1').'"
				WHEN 2 THEN "'.getResource('exp.repair.requests.state.2').'"
				WHEN 3 THEN "'.getResource('exp.repair.requests.state.3').'"
				WHEN 4 THEN "'.getResource('exp.repair.requests.state.4').'"
				WHEN 5 THEN "'.getResource('exp.repair.requests.state.5').'"
				ELSE "" END',
		),
		'priority'=>array(
			'selector'=>'r.priority',
			'log_by'=>'priority_name',
		),
		'priority_name'=>array(
			'selector'=>'CASE r.priority
				WHEN 1 THEN "'.getResource('exp.repair.requests.priority.1').'"
				WHEN 2 THEN "'.getResource('exp.repair.requests.priority.2').'"
				WHEN 3 THEN "'.getResource('exp.repair.requests.priority.3').'"
				ELSE "" END',
		),
		'crash_date'=>array(
			'selector'=>'r.crash_date',
			'nullable'=>1,
		),
		'description'=>array(
			'selector'=>'r.description',
			'nullable'=>1,
		),
		'solution'=>array(
			'selector'=>'r.solution',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'r.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>