<?
$obj = array(
	'name'=>'exp_reports_entrances',
	'nick'=>'eres',
	'masters'=>array(
		'houses'=>array(
			'table'=>$GLOBALS['exp_reports'],
			'on'=>'id',
			'by'=>'report',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert, change_entrance_state',
	'AfterPost'=>'after_logged_post, change_entrance_state',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'exp_reports_entrances re
		LEFT JOIN entrances e ON e.id=re.entrance
		LEFT JOIN houses h ON h.id=e.house
		LEFT JOIN streets s ON s.id=h.street
		LEFT JOIN stamps st ON st.id=re.stamp
		LEFT JOIN operators cr ON cr.id = st.created_by
		LEFT JOIN staff crs ON crs.id=cr.person
		LEFT JOIN operators md ON md.id = st.modified_by
		LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'re.id',
		),
		'report' => array(
			'selector' => 're.report',
			'desc'=>1,
		),
		'entrance' => array(
			'selector' => 're.entrance',
			'log_by'=>'entrance_name',
			'desc'=>1,
		),
		'number'=>array(
			'selector'=>'e.number',
			'desc'=>1,
		),
		'entrance_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house, " #", e.number)',
		),
		'type'=>array(
			'selector'=>'e.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'case
				when e.type=0 then "'.getResource('entrances.type.0').'"
				when e.type=1 then "'.getResource('entrances.type.1').'"
				else "" end',
		),
		'notes'=>array(
			'selector'=>'re.notes',
		),
		'stamp'=>array(
			'selector'=>'re.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>