<?
$obj = array(
	'fields'=>array(
		'id'=>array(
			'title'=>getResource('exp_reports.id'),
			'readonly'=>1,
		),
		'date'=>array(
			'title'=>getResource('exp_reports.date'),
			'required'=>1,
			'control'=>'date',
			'default'=>$GLOBALS['calendar']->getDate().' 00:00:00',
			'with_time'=>1,
		),
		'type'=>array(
			'title'=>getResource('exp_reports.type'),
			'required'=>1,
			'control'=>'select',
			'skip_finder'=>1,
			'list'=>array(
				'1'=>getResource('exp_reports.type.1'),
				'2'=>getResource('exp_reports.type.2'),
				'3'=>getResource('exp_reports.type.3'),
				'4'=>getResource('exp_reports.type.4'),
			),
		),
		'executor'=>array(
			'title'=>getResource('exp_reports.executor'),
			'link'=>'exp_executors.php?id=[executor]',
			'required'=>1,
			'control'=>'lookup',
			'label'=>'[executor_name]',
			'source'=>'?lookup=executor',
			'id'=>'lookup_executor',
		),
		'city'=>array(
			'title'=>getResource('exp_reports.city'),
			'link'=>'cities.php?id=[city]',
			'required'=>1,
			'control'=>'select',
			'list'=>'getCities',
			'skip_finder'=>1,
		),
		'house'=>array(
			'title'=>getResource('exp_reports.house'),
			'required'=>1,
			'link'=>'houses.php?id=[house]',
			'control'=>'lookup',
			'label'=>'[house_name]',
			'source'=>'?lookup=house',
			'id'=>'lookup_house',
			'comment'=>'[admin_district_name], [district_name]',
		),
		'entrances'=>array(
			'title'=>getResource('exp_reports.entrances'),
			'comment'=>getResource('exp_reports.entrances.comment'),
		),
		'exp_point'=>array(
			'type'=>'hidden',
		),
		'entrance'=>array(
			'title'=>getResource('exp_reports.entrance'),
			'control'=>'short',
		),
		'floor'=>array(
			'title'=>getResource('exp_reports.floor'),
			'control'=>'select',
			'skip_finder'=>1,
			'list'=>array(
				'-1'=>getResource('exp.points.floor.1'),
				'1'=>'1','2'=>'2','3'=>'3','4'=>'4','5'=>'5',
				'6'=>'6','7'=>'7','8'=>'8','9'=>'9','10'=>'10',
				'11'=>'11','12'=>'12','13'=>'13','14'=>'14','15'=>'15',
				'16'=>'16','17'=>'17','18'=>'18','19'=>'19','20'=>'20',
				'21'=>'21','22'=>'22','23'=>'23','24'=>'24','25'=>'25',
				'-2'=>getResource('exp.points.floor.2'),
				'-3'=>getResource('exp.points.floor.3'),
				'-4'=>getResource('exp.points.floor.4'),
			),
		),
		'number'=>array(
			'title'=>getResource('exp_reports.number'),
			'control'=>'short',
		),
		'place'=>array(
			'title'=>getResource('exp_reports.place'),
			'control'=>'textarea',
			'height'=>4,
		),
		'cable_hor'=>array(
			'title'=>getResource('exp_reports.cable.hor'),
			'control'=>'checkbox',
		),
		'cable_ver'=>array(
			'title'=>getResource('exp_reports.cable.ver'),
			'control'=>'checkbox',
		),
		'exp_trunk'=>array(
			'type'=>'hidden',
		),
		'trunk_begin_point'=>array(
			'title'=>getResource('exp.trunks.begin'),
			'required_by'=>'type',
			'required_if'=>'3',
			'link'=>'exp_points.php?id=[begin_point]',
			'control'=>'lookup',
			'default'=>1,
			'source'=>'?lookup=point',
			'id'=>'lookup_begin',
		),
		'trunk_end_point'=>array(
			'title'=>getResource('exp.trunks.end'),
			'required_by'=>'type',
			'required_if'=>'3',
			'link'=>'exp_points.php?id=[end_point]',
			'control'=>'lookup',
			'default'=>1,
			'source'=>'?lookup=point',
			'id'=>'lookup_end',
		),
		'trunk_type'=>array(
			'title'=>getResource('exp.trunks.type'),
			'control'=>'select',
			'skip_finder'=>1,
			'list'=>array(
				'1'=>getResource('exp.trunks.type.1'),
				'2'=>getResource('exp.trunks.type.2'),
				'3'=>getResource('exp.trunks.type.3'),
			),
		),
		'trunk_material'=>array(
			'title'=>getResource('exp.trunks.material'),
			'link'=>'exp_materials.php?id=[material]',
			'control'=>'lookup',
			'default'=>1,
			'source'=>'?lookup=material',
		),
		'trunk_length'=>array(
			'title'=>getResource('exp.trunks.length'),
			'control'=>'short',
		),
		'notes'=>array(
			'title'=>getResource('exp_reports.notes'),
			'control'=>'textarea',
			'height'=>4,
		),
		'created'=>array(
			'readonly'=>1,
			'title'=>getResource('exp_reports.created'),
		),
		'created_name'=>array(
			'title'=>getResource('exp_reports.created.by'),
			'readonly'=>1,
		),
		'modified'=>array(
			'readonly'=>1,
			'title'=>getResource('exp_reports.modified'),
		),
		'modified_name'=>array(
			'title'=>getResource('exp_reports.modified.by'),
			'readonly'=>1,
		),
	),
);
?>