<?
$obj = array(
	'name'=>'exp_reports',
	'nick'=>'exrpts',
	'BeforeInsert'=>'before_stamped_insert, apply_report, insert_point, insert_trunk',
	'BeforePost'=>'before_stamped_post, apply_report, update_point, update_trunk',
	'AfterInsert'=>'after_logged_insert, change_house_tv_state, change_entrance_state',
	'AfterPost'=>'after_logged_post, change_house_tv_state, change_entrance_state',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'exp_reports m
	LEFT JOIN cities c ON c.id=m.city
	LEFT JOIN houses h ON h.id=m.house
	LEFT JOIN districts ds ON ds.id=h.district
	LEFT JOIN admin_districts ad ON ad.id=ds.admin
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN exp_executors ee ON ee.id=m.executor
	LEFT JOIN exp_points p ON p.id=m.exp_point
	LEFT JOIN exp_trunks et ON et.id=m.exp_trunk
	LEFT JOIN stamps st ON st.id=m.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'m.id',
		),
		'date'=>array(
			'selector'=>'m.date',
			'nullable'=>1,
			'desc'=>1,
		),
		'city'=>array(
			'selector'=>'m.city',
			'log_by'=>'city_name',
			'desc'=>1,
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'district'=>array(
			'selector'=>'h.district',
		),
		'district_name'=>array(
			'selector'=>'ds.name',
		),
		'admin_district'=>array(
			'selector'=>'ds.admin',
		),
		'admin_district_name'=>array(
			'selector'=>'ad.name',
		),
		'house'=>array(
			'desc'=>1,
			'selector'=>'m.house',
			'log_by'=>'house_name',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'house_house'=>array(
			'selector'=>'h.house',
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'selector'=>'s.name',
		),
		'executor'=>array(
			'selector'=>'m.executor',
			'log_by'=>'executor_name',
			'nullable'=>1,
		),
		'executor_name'=>array(
			'selector'=>'ee.name',
		),
		'type'=>array(
			'selector'=>'m.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'CASE m.type
				WHEN 1 THEN "'.getResource('exp_reports.type.1').'"
				WHEN 2 THEN "'.getResource('exp_reports.type.2').'"
				WHEN 3 THEN "'.getResource('exp_reports.type.3').'"
				WHEN 4 THEN "'.getResource('exp_reports.type.4').'"
				ELSE "" END',
		),
		'exp_point'=>array(
			'selector'=>'m.exp_point',
			'nullable'=>1,
		),
		'number'=>array(
			'selector'=>'p.inv_number',
		),
		'entrance'=>array(
			'selector'=>'p.entrance',
		),
		'floor'=>array(
			'selector'=>'p.floor',
		),
		'place'=>array(
			'selector'=>'p.place',
		),
		'notes'=>array(
			'selector'=>'m.notes',
			'nullable'=>1,
		),
		'cable_hor'=>array(
			'selector'=>'m.cable_hor',
			'log_by'=>'cable_hor_sign',
		),
		'cable_hor_sign'=>array(
			'selector'=>'IF(m.cable_hor=1, "+", "-")',
		),
		'cable_ver'=>array(
			'selector'=>'m.cable_ver',
			'log_by'=>'cable_ver_sign',
		),
		'cable_ver_sign'=>array(
			'selector'=>'IF(m.cable_ver=1, "+", "-")',
		),

		'exp_trunk'=>array(
			'selector'=>'m.exp_trunk',
			'nullable'=>1,
		),
		'trunk_begin_point'=>array(
			'selector'=>'et.begin_point',
		),
		'trunk_end_point'=>array(
			'selector'=>'et.end_point',
		),
		'trunk_type'=>array(
			'selector'=>'et.type',
		),
		'trunk_material'=>array(
			'selector'=>'et.material',
		),
		'trunk_length'=>array(
			'selector'=>'et.length',
		),
		'entrances'=>array(
			'selector'=>'m.entrances',
		),
		'stamp'=>array(
			'selector'=>'m.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>