<?
$obj = array(
	'name'=>'exp_tasks',
	'nick'=>'exts',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert,after_task_post,complete_date',
	'AfterPost'=>'after_logged_post,after_task_post,complete_date',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete,after_task_delete',
	'source'=>'exp_tasks s

	LEFT JOIN exp_points ex ON ex.id=s.point
	LEFT JOIN houses ph ON ph.id=ex.house
	LEFT JOIN streets ps ON ps.id=ph.street

	LEFT JOIN exp_trunks et ON et.id=s.trunk
	LEFT JOIN exp_points bp ON bp.id=et.begin_point
	LEFT JOIN houses bh ON bh.id=bp.house
	LEFT JOIN streets bs ON bs.id=bh.street
	LEFT JOIN exp_points ep ON ep.id=et.end_point
	LEFT JOIN houses eh ON eh.id=ep.house
	LEFT JOIN streets es ON es.id=eh.street

	LEFT JOIN exp_executors e ON e.id=s.executor
	LEFT JOIN stamps st ON st.id=s.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'s.id',
		),
		'name'=>array(
			'desc'=>1,
			'selector'=>'s.name',
		),
		'state'=>array(
			'selector'=>'s.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'case s.state
				when 1 then "'.getResource('exp.tasks.state.1').'"
				when 2 then "'.getResource('exp.tasks.state.2').'"
				when 3 then "'.getResource('exp.tasks.state.3').'"
				when 4 then "'.getResource('exp.tasks.state.4').'"
				else "" end',
		),
		'type'=>array(
			'selector'=>'s.type',
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'case s.type
				when 1 then "'.getResource('exp.tasks.type.1').'"
				when 2 then "'.getResource('exp.tasks.type.2').'"
				when 3 then "'.getResource('exp.tasks.type.3').'"
				else "" end',
		),
		'priority'=>array(
			'selector'=>'s.priority',
			'log_by'=>'priority_name',
		),
		'priority_name'=>array(
			'selector'=>'case s.priority
				when 1 then "'.getResource('exp.tasks.priority.1').'"
				when 2 then "'.getResource('exp.tasks.priority.2').'"
				when 3 then "'.getResource('exp.tasks.priority.3').'"
				else "" end',
		),
		'begin_date'=>array(
			'selector'=>'s.begin_date',
			'nullable'=>1,
		),
		'end_date'=>array(
			'selector'=>'s.end_date',
			'nullable'=>1,
		),
		'complete'=>array(
			'selector'=>'s.complete',
			'nullable'=>1,
		),
		'crash_date'=>array(
			'selector'=>'s.crash_date',
			'nullable'=>1,
		),
		'point'=>array(
			'selector'=>'s.point',
			'nullable'=>1,
			'log_by'=>'point_name',
		),
		'point_name'=>array(
			'selector'=>'CONCAT(ps.name, " ", ph.house, " '.getResource('exp.points.entrance.short').'", IFNULL(ex.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case ex.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(ex.floor,"") end)',
		),
		'trunk'=>array(
			'selector'=>'s.trunk',
			'nullable'=>1,
		),
		'description'=>array(
			'selector'=>'s.description',
		),
		'executor'=>array(
			'selector'=>'s.executor',
			'nullable'=>1,
			'log_by'=>'executor_name',
		),
		'executor_name'=>array(
			'selector'=>'e.name',
		),
		'current_state'=>array(
			'selector'=>'s.current_state',
		),
		'discharge'=>array(
			'selector'=>'s.discharge',
		),
		'file'=>array(
			'selector'=>'s.file',
		),
		'stamp'=>array(
			'selector'=>'s.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>