<?
$obj = array(
	'name'=>'hosts',
	'nick'=>'hts',
	'BeforeInsert'=>'before_computer_apply, before_stamped_insert,verify_restricted_names',
	'BeforePost'=>'before_computer_apply, before_stamped_post,verify_restricted_names',
	'AfterInsert'=>'after_computer_post, add_auto_firewall, after_logged_insert',
	'AfterPost'=>'after_computer_post, after_logged_post',
	'AfterDelete'=>'after_computer_delete, after_stamped_delete, after_logged_delete',
	'source'=>'hosts h
	LEFT JOIN domains d ON d.id = h.domain
	LEFT JOIN clients c ON c.id = h.client
	LEFT JOIN cities ci ON ci.id=c.city
	LEFT JOIN departments p ON p.id = c.department
	LEFT JOIN houses hs ON hs.id=c.house_id
	LEFT JOIN streets s ON hs.street = s.id
	LEFT JOIN modems m ON m.id = h.modem
	LEFT JOIN domains msd ON msd.id = m.domain
	LEFT JOIN modems_states x ON x.id = m.state_id
	LEFT JOIN mac_vendors v ON v.code=SUBSTRING(h.mac, 1, 8)
	LEFT JOIN pair_status_names pan ON pan.id=h.pair_a_status
	LEFT JOIN pair_status_names pbn ON pbn.id=h.pair_b_status
	LEFT JOIN stamps st ON st.id=h.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'h.id',
		),
		'ip'=>array(
			'desc'=>1,
			'selector'=>'h.ip',
			'order_by'=>'INET_ATON(h.ip)',
		),
		'mac'=>array(
			'selector'=>'h.mac',
			'nullable'=>1,
		),
		'vendor'=>array(
			'selector'=>'v.id',
			'nullable'=>1,
			'log_by'=>'vendor_name',
		),
		'vendor_name'=>array(
			'selector'=>'v.name',
			'nullable'=>1,
		),
		'name'=>array(
			'selector'=>'h.name',
		),
		'login'=>array(
			'selector'=>'h.login',
			'nullable'=>1,
		),
		'password'=>array(
			'selector'=>'h.password',
			'nullable'=>1,
		),
		'domain'=>array(
			'selector'=>'h.domain',
			'nullable'=>1,
			'log_by'=>'domain_name',
		),
		'domain_name'=>array(
			'bin'=>1,
			'selector'=>'d.name',
		),
		'city'=>array(
			'selector'=>'c.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'client'=>array(
			'selector'=>'h.client',
			'desc'=>1,
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'client_login'=>array(
			'selector'=>'c.login',
		),
		'client_department'=>array(
			'bin'=>1,
			'selector'=>'c.department',
		),
		'department_name'=>array(
			'bin'=>1,
			'selector'=>'p.name',
		),
		'street'=>array(
			'selector'=>'hs.street',
			'log_by'=>'street_name',
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'house_id'=>array(
			'selector'=>'c.house_id',
			'log_by'=>'house_name',
		),
		'house'=>array(
			'selector'=>'hs.house',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", hs.house)',
		),
		'entrance'=>array(
			'selector'=>'c.entrance',
		),
		'floor'=>array(
			'selector'=>'c.floor',
		),
		'apartment'=>array(
			'selector'=>'c.apartment',
		),
		'connection_type'=>array(
			'selector'=>'c.connection_type',
		),
		'modem'=>array(
			'selector'=>'h.modem',
			'log_by'=>'modem_name',
		),
		'modem_name'=>array(
			'bin'=>1,
			'selector'=>"CONCAT(IFNULL(CONCAT(msd.name, '.'), ''), m.name)",
		),
		'modem_ip'=>array(
			'bin'=>1,
			'selector'=>'m.ip',
			'order_by'=>'INET_ATON(m.ip)',
		),
		'modem_state'=>array(
			'selector'=>'x.state',
		),
		'modem_state_sign'=>array(
			'selector'=>'IF((m.audit=0) || (x.state IS NULL), "", IF(x.state, "+", "-"))',
		),
		'port'=>array(
			'selector'=>'h.port',
		),
		'vlan'=>array(
			'selector'=>'h.vlan',
		),
		'notes'=>array(
			'selector'=>'h.notes',
		),
		'countable'=>array(
			'aggregate'=>'sum',
		),
		'pair_a_status'=>array(
			'selector'=>'h.pair_a_status',
		),
		'pair_a_status_name'=>array(
			'selector'=>'pan.name',
		),
		'pair_b_status'=>array(
			'selector'=>'h.pair_b_status',
		),
		'pair_b_status_name'=>array(
			'selector'=>'pbn.name',
		),
		'pair_a_distance'=>array(
			'selector'=>'h.pair_a_distance',
		),
		'pair_b_distance'=>array(
			'selector'=>'h.pair_b_distance',
		),
		'stamp'=>array(
			'selector'=>'h.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
?>