<?
$obj = array(
	'fields'=>array(
		'city'=>array(
			'title'=>getResource('houses.city'),
			'link'=>'cities.php?id=[city]',
			'required'=>1,
			'control'=>'select',
			'list'=>'getCities',
			'skip_finder'=>1,
		),
		'district'=>array(
			'title'=>getResource('houses.district'),
			'link'=>'districts.php?id=[district]',
			'control'=>'lookup',
			'label'=>'[district_name]',
			'source'=>'?lookup=district',
			'id'=>'lookup_district',
			'required'=>1,
		),
		'street'=>array(
			'title'=>getResource('houses.street'),
			'link'=>'streets.php?id=[street]',
			'required'=>1,
			'control'=>'lookup',
			'label'=>'[street_name]',
			'source'=>'?lookup=street',
			'id'=>'lookup_street',
		),
		'house'=>array(
			'title'=>getResource('houses.house'),
			'navigator'=>1,
			'control'=>'short',
			'required'=>1,
		),
		'coords'=>array(
			'title'=>getResource('houses.coords'),
		),
		'show_on_map'=>array(
			'title'=>getResource('houses.show.on.map'),
			'control'=>'checkbox',
			'default'=>1,
		),
		/*'state'=>array(
			'title'=>getResource('houses.state'),
			'control'=>'select',
			'list'=>array(
				'1'=>getResource('houses.state.1'),
				'2'=>getResource('houses.state.2'),
				'3'=>getResource('houses.state.3'),
				'4'=>getResource('houses.state.4'),
			),
		),
		*/
		'internet'=>array(
			'title'=>getResource('houses.internet_int'),
			'control'=>'select',
			'skip_finder'=>1,
			'list'=>array(
				'0'=>getResource('houses.int.state.0'),
				'1'=>getResource('houses.int.state.1'),
				'2'=>getResource('houses.int.state.2'),
			),
		),
		'internet_reason'=>array(
			'title'=>getResource('houses.internet.reason'),
			'control'=>'textarea',
			'height'=>2,
			'required_by'=>'internet',
			'required_if'=>'0',
		),
		'link_up_internet'=>array(
			'title'=>getResource('houses.link_up_internet'),
			'control'=>'date',
			'with_time'=>1,
		),
		'tv'=>array(
			'title'=>getResource('houses.tv_int'),
			'control'=>'select',
			'skip_finder'=>1,
			'list'=>array(
				'0'=>getResource('houses.int.state.0'),
				'1'=>getResource('houses.int.state.1'),
				'2'=>getResource('houses.int.state.2'),
			),
		),
		'tv_reason'=>array(
			'title'=>getResource('houses.tv.reason'),
			'control'=>'textarea',
			'height'=>2,
			'required_by'=>'tv',
			'required_if'=>'0',
		),
		'link_up_tv'=>array(
			'title'=>getResource('houses.link_up_tv'),
			'control'=>'date',
			'with_time'=>1,
		),
		'house_state'=>array(
			'title'=>getResource('houses.house_state'),
			'control'=>'checkbox',
		),
		'floors'=>array(
			'title'=>getResource('houses.floors'),
			'comment'=>getResource('houses.floors.comment'),
			'control'=>'short',
		),
		'entrances'=>array(
			'title'=>getResource('houses.entrances'),
			'control'=>'short',
			//'readonly'=>1,
		),
		'appartments'=>array(
			'title'=>getResource('houses.appartments'),
			'control'=>'short',
		),
		'clients'=>array(
			'title'=>getResource('houses.clients'),
			'comment'=>getResource('houses.clients.comment'),
			'readonly'=>1,
		),
		'clients_tv'=>array(
			'title'=>getResource('houses.clients.tv'),
			'comment'=>getResource('houses.clients.tv.comment'),
			'readonly'=>1,
		),
		'population'=>array(
			'title'=>getResource('houses.population'),
			'comment'=>getResource('houses.population.comment'),
			'readonly'=>1,
			'format'=>$GLOBALS['form_percent'],
		),
		'population_tv'=>array(
			'title'=>getResource('houses.population.tv'),
			'comment'=>getResource('houses.population.tv.comment'),
			'readonly'=>1,
			'format'=>$GLOBALS['form_percent'],
		),
		'served_by'=>array(
			'title'=>getResource('houses.served.by'),
			'comment'=>getResource('houses.served.by.comment'),
			'control'=>'select',
			'skip_finder'=>1,
			'list'=>array(
				'1'=>getResource('houses.served.by.1'),
				'2'=>getResource('houses.served.by.2'),
				'3'=>getResource('houses.served.by.3'),
				'4'=>getResource('houses.served.by.4'),
			),
		),
		'kpreo'=>array(
			'title'=>getResource('houses.kpreo'),
			'link'=>'kpreos.php?id=[kpreo]',
			'control'=>'lookup',
			'label'=>'[kpreo_n]',
			'source'=>'?lookup=kpreo',
			'id'=>'lookup_kpreo',
		),
		'kpreo1'=>array(
			'title'=>getResource('houses.kpreo'),
			'link'=>'kpreos.php?id=[kpreo1]',
			'control'=>'lookup',
			'label'=>'[kpreo1_n]',
			'source'=>'?lookup=kpreo',
			'id'=>'lookup_kpreo1',
		),
		'koop'=>array(
			'title'=>getResource('houses.koop'),
			'link'=>'koops.php?id=[koop]',
			'control'=>'lookup',
			'label'=>'[koop_n]',
			'source'=>'?lookup=koop',
			'id'=>'lookup_koop',
		),
		'koop1'=>array(
			'title'=>getResource('houses.koop'),
			'link'=>'koops.php?id=[koop1]',
			'control'=>'lookup',
			'label'=>'[koop1_n]',
			'source'=>'?lookup=koop',
			'id'=>'lookup_koop1',
		),
		'dispatching'=>array(
			'title'=>getResource('houses.dispatching'),
			//'required'=>1,
			'control'=>'select',
			'list'=>'getDispatching',
			'skip_finder'=>1,
		),
		'contract'=>array(
			'title'=>getResource('houses.contract'),
			'control'=>'select',
			'skip_finder'=>1,
			'list'=>array(
				'1'=>getResource('houses.contract.1'),
				'2'=>getResource('houses.contract.2'),
			),
		),
		'post_office'=>array(
			'title'=>getResource('houses.post.office'),
			'control'=>'short',
		),
		'notes'=>array(
			'title'=>getResource('houses.notes'),
			'control'=>'textarea',
			'height'=>4,
		),
		'verified'=>array(
			'title'=>getResource('houses.verified'),
			'control'=>'checkbox',
		),
		'created'=>array(
			'readonly'=>1,
			'title'=>getResource('houses.created'),
		),
		'created_name'=>array(
			'title'=>getResource('houses.created.by'),
			'readonly'=>1,
		),
		'modified'=>array(
			'readonly'=>1,
			'title'=>getResource('houses.modified'),
		),
		'modified_name'=>array(
			'title'=>getResource('houses.modified.by'),
			'readonly'=>1,
		),
	),
);
?>