<?
$obj = array(
	'name'=>'houses',
	'nick'=>'hss',
	'BeforeInsert'=>'before_stamped_insert, check_house_city',
	'BeforePost'=>'before_stamped_post, check_house_city',
	'AfterInsert'=>'after_logged_insert, edit_entrances, generate_new_house_tv_boxes',
	'AfterPost'=>'after_logged_post, edit_entrances, update_entrances_connection',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'houses h
	LEFT JOIN cities c ON c.id=h.city
	LEFT JOIN dispatching disp ON disp.id=h.dispatching
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN districts d ON d.id=h.district
	LEFT JOIN admin_districts a ON a.id=d.admin
	LEFT JOIN kpreos k ON k.id=h.kpreo
	LEFT JOIN kpreos k1 ON k1.id=h.kpreo1
	LEFT JOIN koops ko ON ko.id=h.koop
	LEFT JOIN koops ko1 ON ko1.id=h.koop1
	LEFT JOIN population p ON p.house=h.id
	LEFT JOIN population_tv ptv ON ptv.house=h.id
	LEFT JOIN entrances_info ei ON ei.house=h.id
	LEFT JOIN stamps st ON st.id=h.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'h.id',
		),
		'city'=>array(
			'selector'=>'h.city',
			'log_by'=>'city_name',
			'desc'=>1,
		),
		'city_name'=>array(
			'selector'=>'c.name',
		),
		'street'=>array(
			'selector'=>'h.street',
			'nullable'=>1,
			'log_by'=>'street_name',
			'desc'=>1,
		),
		'street_name'=>array(
			'selector'=>'s.name',
		),
		'house'=>array(
			'desc'=>1,
			'selector'=>'h.house',
		),
		'coords'=>array(
			'selector'=>'h.coords',
		),
		'house_state'=>array(
			'selector'=>'h.house_state',
			'log_by'=>'house_state_sign',
		),
		'house_state_sign'=>array(
			'selector'=>'IF(h.house_state, "+", "-")',
		),
		'district'=>array(
			'selector'=>'h.district',
			'nullable'=>1,
			'log_by'=>'district_name',
		),
		'district_name'=>array(
			'selector'=>'d.name',
		),
		'dispatching'=>array(
			'selector'=>'h.dispatching',
			'nullable'=>1,
		),
		'admin'=>array(
			'selector'=>'d.admin',
		),
		'admin_name'=>array(
			'selector'=>'a.name',
		),
		'kpreo'=>array(
			'selector'=>'h.kpreo',
			'nullable'=>1,
			'log_by'=>'kpreo_number',
		),
		'kpreo_n'=>array(
			'selector'=>'k.number',
		),
		'kpreo1'=>array(
			'selector'=>'h.kpreo1',
			'nullable'=>1,
			'log_by'=>'kpreo1_number',
		),
		'kpreo1_n'=>array(
			'selector'=>'k1.number',
		),
		'kpreo_number'=>array(
			'selector'=>'case h.served_by
				WHEN 1 THEN k.number
				WHEN 4 THEN CONCAT(k.number, ", ", k1.number)
				ELSE "" END',
		),
		'koop'=>array(
			'selector'=>'h.koop',
			'nullable'=>1,
			'log_by'=>'koop_n',
		),
		'koop_n'=>array(
			'selector'=>'ko.name',
		),
		'koop1'=>array(
			'selector'=>'h.koop1',
			'nullable'=>1,
			'log_by'=>'koop1_name',
		),
		'koop1_n'=>array(
			'selector'=>'ko1.name',
		),
		'koop_name'=>array(
			'selector'=>'case h.served_by
				WHEN 2 THEN ko.name
				WHEN 4 THEN CONCAT(ko.name, ", ", ko1.name)
				ELSE "" END',
		),
		'state'=>array(
			'selector'=>'h.state',
			'nullable'=>1,
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'case
				when h.state=1 then "'.getResource('houses.state.1').'"
				when h.state=2 then "'.getResource('houses.state.2').'"
				when h.state=3 then "'.getResource('houses.state.3').'"
				when h.state=4 then "'.getResource('houses.state.4').'"
				else "" end',
		),
		'entrance_type'=>array(
			'selector'=>'case
				when ei.type=0 then "'.getResource('houses.entrance.type.1').'"
				when ei.type=ei.amount then "'.getResource('houses.entrance.type.2').'"
				else CONCAT(ei.type, "/", ei.amount) end',
		),
		'queries'=>array(
			'selector'=>'h.queries',
		),
		'floors'=>array(
			'selector'=>'h.floors',
			'nullable'=>1,
		),
		'entrances'=>array(
			'selector'=>'h.entrances',
			'nullable'=>1,
			'aggregate'=>'sum',
		),
		'appartments'=>array(
			'selector'=>'h.appartments',
			'nullable'=>1,
			'aggregate'=>'sum',
		),
		'clients'=>array(
			'selector'=>'IFNULL(p.amount,0)',
			'aggregate'=>'sum',
		),
		'clients_tv'=>array(
			'selector'=>'IFNULL(ptv.amount,0)',
			'aggregate'=>'sum',
		),
		'population'=>array(
			'selector'=>'round(IFNULL(p.amount,0) / h.appartments * 100,2)',
			'aggregate'=>'round(sum(IFNULL(p.amount,0)) / sum(IFNULL(h.appartments,0)) * 100,2)',
		),
		'population_tv'=>array(
			'selector'=>'round(IFNULL(ptv.amount,0) / h.appartments * 100,2)',
			'aggregate'=>'round(sum(IFNULL(ptv.amount,0)) / sum(IFNULL(h.appartments,0)) * 100,2)',
		),
		'served_by'=>array(
			'selector'=>'h.served_by',
			'nullable'=>1,
			'log_by'=>'served_by_name',
		),
		'served_by_name'=>array(
			'selector'=>'case
				when h.served_by=1 then "'.getResource('houses.served.by.1').'"
				when h.served_by=2 then "'.getResource('houses.served.by.2').'"
				when h.served_by=3 then "'.getResource('houses.served.by.3').'"
				when h.served_by=4 then "'.getResource('houses.served.by.4').'"
				else "" end',
		),
		'contract'=>array(
			'selector'=>'h.contract',
			'log_by'=>'contract_name',
		),
		'contract_name'=>array(
			'selector'=>'case h.contract
				when 1 then "'.getResource('houses.contract.1').'"
				when 2 then "'.getResource('houses.contract.2').'"
				else "" end',
		),
		'internet' => array(
			'selector' => 'h.internet',
			'log_by'=>'internet_int',
		),
		'internet_int'=>array(
			'selector'=>'case h.internet
				when 2 then "*"
				when 1 then "+"
				when 0 then "-"
				else "" end',
		),
		'internet_name'=>array(
			'selector'=>'case h.internet
				when 0 then "'.getResource('houses.int.state.0').'"
				when 1 then "'.getResource('houses.int.state.1').'"
				when 2 then "'.getResource('houses.int.state.2').'"
				else "" end',
		),
		'link_up_internet'=>array(
			'selector'=>'h.link_up_internet',
		),
		'internet_reason' => array(
			'selector' => 'h.internet_reason',
		),
		'tv' => array(
			'selector' => 'h.tv',
			'log_by'=>'tv_int',
		),
		'tv_int'=>array(
			'selector'=>'case h.tv
				when 2 then "*"
				when 1 then "+"
				when 0 then "-"
				else "" end',
		),
		'tv_name'=>array(
			'selector'=>'case h.tv
				when 0 then "'.getResource('houses.int.state.0').'"
				when 1 then "'.getResource('houses.int.state.1').'"
				when 2 then "'.getResource('houses.int.state.2').'"
				else "" end',
		),
		'link_up_tv'=>array(
			'selector'=>'h.link_up_tv',
		),
		'tv_reason' => array(
			'selector' => 'h.tv_reason',
		),
		'post_office'=>array(
			'selector'=>'h.post_office',
			'nullable'=>1,
		),
		'notes'=>array(
			'selector'=>'h.notes',
			'nullable'=>1,
		),
		'tie'=>array(
			'selector'=>'ei.tie',
			'log_by'=>'tie_name',
		),
		'tie_name'=>array(
			'selector'=>'case ei.tie
				when 1 then "'.getResource('entrances.tie.1').'"
				when 2 then "'.getResource('entrances.tie.2').'"
				when 3 then "'.getResource('entrances.tie.3').'"
				else "" end',
		),
		'show_on_map'=>array(
			'selector'=>'h.show_on_map',
			'log_by'=>'show_on_map_sign',
		),
		'show_on_map_sign'=>array(
			'selector'=>'if(h.show_on_map, "+", "-")',
		),
		'verified'=>array(
			'selector'=>'h.verified',
		),
		'verified_sign'=>array(
			'selector'=>'IF(h.verified, "+", "-")',
		),
		'stamp'=>array(
			'selector'=>'h.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>