<?
$obj = array(
	'name'=>'jobs',
	'nick'=>'jbs',
	'BeforeInsert'=>'before_stamped_insert,SynchHouse,check_job_entrance,before_job_insert, check_job_city, check_job_contract_duplicate',
	'BeforePost'=>'before_stamped_post,SynchHouse,check_job_entrance,before_job_post, check_job_city, check_job_contract_duplicate',
	'AfterInsert'=>'after_logged_insert,check_job_unconfigured_modems, after_job_post',
	'AfterPost'=>'after_logged_post,check_job_unconfigured_modems, after_job_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'jobs j
	LEFT JOIN cities z ON z.id=j.city
	LEFT JOIN jobs_finders jf ON jf.id=j.found_by
	LEFT JOIN job_types jt ON jt.id = j.type
	LEFT JOIN clients cl ON cl.id=j.client_id
	LEFT JOIN connection_types clct ON clct.id=cl.connection_type
	LEFT JOIN tv_types cltv ON cltv.id=cl.tv_type
	LEFT JOIN je_count je ON je.job=j.id
	LEFT JOIN connection_types ct ON ct.id=j.connection_type
	LEFT JOIN streets s ON s.id=j.street
	LEFT JOIN houses h ON h.street=j.street AND h.house=j.house
	LEFT JOIN districts d ON d.id=h.district
	LEFT JOIN staff sf ON sf.id=j.worker
	LEFT JOIN clients c ON c.id=j.found_by_client
	LEFT JOIN kpreos r ON r.id=h.kpreo
	LEFT JOIN koops k ON k.id=h.koop
	LEFT JOIN stamps st ON st.id=j.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person
	LEFT JOIN stamps cst ON cst.id=cl.stamp',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'j.id',
			'title'=>getResource('jobs.id'),
		),
		'city'=>array(
			'selector'=>'j.city',
			'title'=>getResource('jobs.city'),
			'log_by'=>'city_name',
			'desc'=>1,
		),
		'city_name'=>array(
			'selector'=>'z.name',
		),
		'type'=>array(
			'selector'=>'j.type',
			'nullable'=>1,
			'title'=>getResource('jobs.type'),
			'log_by'=>'type_name',
		),
		'type_name'=>array(
			'selector'=>'jt.name',
			'title'=>getResource('jobs.type'),
		),
		'jt_type'=>array(
			'selector'=>'jt.type',
		),
		'skip_graph'=>array(
			'selector'=>'j.skip_graph',
			'title'=>getResource('jobs.skip.graph'),
			'log_by'=>'skip_graph_sign',
		),
		'skip_graph_sign'=>array(
			'title'=>getResource('jobs.skip.graph'),
			'selector'=>'IF(j.skip_graph, "+", "-")',
		),
		'kpreo' => array(
			'selector'=>'r.number',
		),
		'koop' => array(
			'selector'=>'k.name',
		),
		'served_by' => array(
			'title'=>getResource('houses.served.by'),
			'selector'=>'case h.served_by '.
				'when 1 then CONCAT("' . getResource("houses.served.by.1") . ' ", r.number) '.
				'when 2 then CONCAT("' . getResource("houses.served.by.2") . ' ", k.name) '.
				'end',
		),
		'street'=>array(
			'selector'=>'j.street',
			'nullable'=>1,
			'skip_log'=>1,
		),
		'street_name'=>array(
			'selector'=>'s.name',
			'title'=>getResource('houses.street'),
		),
		'district'=>array(
			'selector'=>'h.district',
		),
		'district_name'=>array(
			'selector'=>'d.name',
			'title'=>getResource('houses.district'),
		),
		'jobs_extras'=>array(
			'selector'=>'ifnull(je.coun ,0)',
			'aggregate'=>'sum',
		),
		'house_id'=>array(
			'selector'=>'j.house_id',
			'title'=>getResource('clients.house'),
			'log_by'=>'house_name',
		),
		'house'=>array(
			'title'=>getResource('clients.house'),
			'selector'=>'j.house',
			'nullable'=>1,
			'skip_log'=>1,
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
			'title'=>getResource('clients.house'),
			'desc'=>1,
		),
		'lat'=>array(
			'selector'=>'IFNULL(h.lat,0)',
		),
		'lng'=>array(
			'selector'=>'IFNULL(h.lng,0)',
		),
		'entrance'=>array(
			'selector'=>'j.entrance',
			'nullable'=>1,
			'title'=>getResource('jobs.entrance'),
		),
		'floor'=>array(
			'selector'=>'j.floor',
			'nullable'=>1,
			'title'=>getResource('jobs.floor'),
		),
		'apartment'=>array(
			'selector'=>'j.apartment',
			'nullable'=>1,
			'title'=>getResource('jobs.apartment'),
		),
		'client'=>array(
			'selector'=>'j.client',
			'title'=>getResource('jobs.contact'),
		),
		'client_id'=>array(
			'selector'=>'j.client_id',
			'nullable'=>1,
			'title'=>getResource('jobs.client'),
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(cl.last_name, " ", cl.first_name, " (", cl.login,")")',
			'title'=>getResource('jobs.client'),
		),
		'connection_type'=>array(
			'selector'=>'j.connection_type',
			'title'=>getResource('jobs.connection.type'),
			'log_by'=>'connection_type_name',
		),
		'connection_type_name'=>array(
			'selector'=>'ct.name',
			'title'=>getResource('jobs.connection.type'),
		),
		'client_connection_type'=>array(
			'selector'=>'cl.connection_type',
			'title'=>getResource('jobs.client.connection.type'),
			'log_by'=>'client_connection_type_name',
		),
		'client_connection_type_name'=>array(
			'selector'=>'clct.name',
			'title'=>getResource('jobs.client.connection.type'),
		),
		'client_tv_type'=>array(
			'selector'=>'cl.tv_type',
			'title'=>getResource('jobs.client.tv.type'),
			'log_by'=>'client_tv_type_name',
		),
		'client_tv_type_name'=>array(
			'selector'=>'cltv.name',
			'title'=>getResource('jobs.client.tv.type'),
		),
		'phone'=>array(
			'selector'=>'j.phone',
			'title'=>getResource('jobs.phone'),
		),
		'alarm'=>array(
			'selector'=>'j.alarm',
		),
		'worker'=>array(
			'selector'=>'j.worker',
			'nullable'=>1,
			'title'=>getResource('jobs.worker'),
			'log_by'=>'worker_name',
		),
		'worker_name'=>array(
			'selector'=>'sf.name',
			'title'=>getResource('jobs.worker'),
		),
		'date'=>array(
			'title'=>getResource('jobs.date'),
			'selector'=>'j.date',
			'desc'=>1,
		),
		'time'=>array(
			'title'=>getResource('jobs.time'),
			'selector'=>'date_format(j.date, "%H:%i")',
		),
		'notes'=>array(
			'selector'=>'j.notes',
			'title'=>getResource('jobs.notes'),
		),
		'state'=>array(
			'selector'=>'j.state',
			'title'=>getResource('jobs.state'),
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'title'=>getResource('jobs.state'),
			'selector'=>'case j.state '.
				"when 1 then '".getResource('jobs.state.1')."' ".
				"when 2 then '".getResource('jobs.state.2')."' ".
				"when 3 then '".getResource('jobs.state.3')."' ".
				"when 4 then '".getResource('jobs.state.4')."' ".
				"when 5 then '".getResource('jobs.state.5')."' ".
				"end",
		),
		'found_by'=>array(
			'selector'=>'j.found_by',
			'title'=>getResource('jobs.found.by'),
			'log_by'=>'found_by_name',
			'nullable'=>1,
		),
		'found_by_name'=>array(
			'title'=>getResource('jobs.found.by'),
			'selector'=>'jf.name',
		),
		'found_by_client'=>array(
			'title'=>getResource('jobs.found.by'),
			'selector'=>'j.found_by_client',
			'nullable'=>1,
			'log_by'=>'found_by_client_name',
		),
		'found_by_client_name'=>array(
			'title'=>getResource('jobs.found.by'),
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'found_by_memo'=>array(
			'selector'=>'j.found_by_memo',
			'title'=>getResource('jobs.found.by.memo'),
		),
		'used_before'=>array(
			'selector'=>'j.used_before',
			'title'=>getResource('jobs.used.before'),
			'log_by'=>'used_before_name',
		),
		'used_before_name'=>array(
			'title'=>getResource('jobs.used.before'),
			'selector'=>'case j.used_before '.
				"when 0 then '".getResource('jobs.used.before.0')."' ".
				"when 1 then '".getResource('jobs.used.before.1')."' ".
				"end",
		),
		'used_before_memo'=>array(
			'selector'=>'j.used_before_memo',
			'title'=>getResource('jobs.used.before.memo'),
			'nullable'=>0,
		),
		'contract'=>array(
			'title'=>getResource('jobs.contract'),
			'selector'=>'IFNULL(cl.contract, j.contract)',
			'nullable'=>1,
		),
		'cost' => array(
			'title'=>getResource('jobs.cost'),
			'selector'=>'j.cost/100',
			'aggregate'=>'sum',
		),
		'stamp'=>array(
			'selector'=>'j.stamp',
		),
		'client_created'=>array(
			'selector'=>'cst.created',
			'title'=>getResource('jobs.client.created'),
		),
		'created'=>array(
			'selector'=>'st.created',
			'title'=>getResource('jobs.created'),
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
			'title'=>getResource('jobs.created.by'),
		),
		'modified'=>array(
			'selector'=>'st.modified',
			'title'=>getResource('jobs.modified'),
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
			'title'=>getResource('jobs.modified.by'),
		),
	),
);
?>