<?
$obj = array(
	'name'=>'client_expenses',
	'nick'=>'clx',
	'masters'=>array(
			'jobs'=>array(
				'table'=>$GLOBALS['jobs'],
				'on'=>'id',
				'by'=>'job',
			),
		),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'client_expenses e
	LEFT JOIN jobs j ON j.id=e.job
	LEFT JOIN clients jc ON jc.id = j.client_id
	LEFT JOIN clients c ON c.id = e.client
	LEFT JOIN modems m ON m.id=cs.modem
	LEFT JOIN houses h ON h.id=j.house_id
	LEFT JOIN districts d ON d.id=h.district
	LEFT JOIN streets s ON h.street = s.id
	LEFT JOIN stamps st ON st.id=e.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person
	LEFT JOIN stamps cst ON cst.id=jc.stamp
	LEFT JOIN operators ccr ON ccr.id = cst.created_by',
	'fields'=>array(
		'id'=>array(
			'selector'=>'e.id',
			'key'=>1,
		),
		'work_type'=>array(
			'selector'=>'j.type',
		),
		'work_type_name'=>array(
			'desc'=>1,
			'selector'=>'case j.type '.
				'when 1 then "'.getResource('jobs.type.1').'" '.
				'when 2 then "'.getResource('jobs.type.2').'" '.
				'when 3 then "'.getResource('jobs.type.3').'" '.
				'when 4 then "'.getResource('jobs.type.4').'" '.
				'when 5 then "'.getResource('jobs.type.5').'" '.
				'end',
		),
		'job'=>array(
			'selector'=>'e.job',
		),
		'job_name'=>array(
			'selector'=>'CONCAT(j.id, " - ", IFNULL(s.name,""), " ", IFNULL(h.house,""), ", ", IFNULL(j.apartment, ""))',
		),
		'job_client'=>array(
			'selector'=>'j.client_id',
		),
		'job_client_name'=>array(
			'selector'=>'CONCAT(jc.last_name, " ", jc.first_name, " (", jc.login,")")',
		),
		'client'=>array(
			'selector'=>'e.client',
			'desc'=>1,
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'house_id'=>array(
			'selector'=>'c.house_id',
		),
		'house'=>array(
			'selector'=>'h.house',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'district_name'=>array(
			'selector'=>'d.name',
		),
		'entrance'=>array(
			'selector'=>'c.entrance',
		),
		'floor'=>array(
			'selector'=>'c.floor',
		),
		'floors'=>array(
			'selector'=>'h.floors',
		),
		'apartment'=>array(
			'selector'=>'c.apartment',
		),
		'cable'=>array(
			'selector'=>'e.cable',
			'aggregate'=>'sum',
		),
		'cable_in'=>array(
			'selector'=>'e.cable_in',
			'aggregate'=>'sum',
		),
		'cable_out'=>array(
			'selector'=>'e.cable - e.cable_in',
			'aggregate'=>'sum',
		),
		'cable_type'=>array(
			'selector'=>'e.cable_type',
		),
		'connection'=>array(
			'selector'=>'e.connection',
		),
		'connection_name'=>array(
			'selector'=>'case
				when e.connection=1 then "'.getResource('client.expenses.connection.1').'"
				when e.connection=2 then "'.getResource('client.expenses.connection.2').'"
				when e.connection=3 then "'.getResource('client.expenses.connection.3').'"
				else "" end',
		),
		'connection_port'=>array(
			'selector'=>'e.connection_port',
			'nullable'=>1,
		),
		'modem_name'=>array(
			'selector'=>'m.name',
		),
		'modem_entrance'=>array(
			'selector'=>'m.entrance',
		),
		'modem_floor'=>array(
			'selector'=>'m.floor',
		),
		'stamp'=>array(
			'selector'=>'e.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
		'client_stamp'=>array(
			'selector'=>'c.stamp',
		),
		'client_created'=>array(
			'selector'=>'cst.created',
		),
		'client_created_by'=>array(
			'selector'=>'cst.created_by',
		),
		'client_created_name'=>array(
			'selector'=>'ccr.name',
		),
	),
);
$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "c.department='$d'";
}
if(isset($GLOBALS['oper']->system_access['worker_features'])){
	$obj['filters']['by_oper'] = "st.created_by='".$GLOBALS['oper']->id."'";
}
?>