<?
$obj = array(
	'name'=>'clients',
	'nick'=>'cls2',
	'BeforePost'=>'pre_client_post, before_stamped_post',
	'BeforeInsert'=>'pre_client_insert, before_stamped_insert, set_contract_from_job',
	'BeforeDelete'=>'pre_client_delete',
	'AfterInsert'=>'client_insert2, after_logged_insert, keep_job_connection_type, spread_client',
	'AfterPost'=>'client_post, after_logged_post, keep_job_connection_type',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'clients c
	LEFT JOIN cities z ON z.id=c.city
	LEFT JOIN houses h ON h.id=c.house_id
	LEFT JOIN streets s ON h.street = s.id
	LEFT JOIN departments d ON c.department = d.id
	LEFT JOIN connection_types ct ON c.connection_type = ct.id
	LEFT JOIN tv_types tt ON c.tv_type = tt.id
	LEFT JOIN stamps st ON st.id=c.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'c.id',
		),
		'city'=>array(
			'selector'=>'c.city',
			'log_by'=>'city_name',
			'desc'=>1,
		),
		'city_name'=>array(
			'selector'=>'z.name',
		),
		'account'=>array(
			'selector'=>'c.account',
		),
		'last_name'=>array('bin'=>1,),
		'first_name'=>array('bin'=>1,),
		'patronymic'=>array('bin'=>1),
		'name'=>array(
			'selector'=>'CONCAT(last_name, " ", first_name)',
			'desc'=>1,
		),
		'department'=>array(
			'selector'=>'c.department',
			'lookup'=>'department',
			'log_by'=>'department_name',
		),
		'department_name'=>array(
			'selector'=>'d.name',
			'bin'=>1,
		),
		'connection_type'=>array(
			'selector'=>'c.connection_type',
			'lookup'=>'connection_type',
			'log_by'=>'connection_type_name',
		),
		'connection_type_name'=>array(
			'bin'=>1,
			'selector'=>'ct.name',
		),
		'tv_type'=>array(
			'selector'=>'c.tv_type',
			'log_by'=>'tv_type_name',
			'nullable'=>1,
		),
		'tv_type_name'=>array(
			'selector'=>'tt.name',
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'house_id'=>array(
			'selector'=>'c.house_id',
			'log_by'=>'house_name',
		),
		'house'=>array(
			'selector'=>'h.house',
		),
		'house_name'=>array(
			'selector'=>'CONCAT(s.name, " ", h.house)',
		),
		'building'=>array(),
//		'letter'=>array(),
		'entrance'=>array(),
		'floor'=>array(),
		'apartment'=>array(),
		'surveyor'=>array('bin'=>1),
		'phone'=>array(
			'selector'=>'c.phone',
		),
		'mobile'=>array(
			'selector'=>'c.mobile',
		),
		'passport'=>array(),
		'passport_info'=>array(),
		'login'=>array(
			'selector'=>'c.login',
			'desc'=>1,
		),
		'pass'=>array(
			'selector'=>'c.pass',
		),
		'email'=>array(
			'selector'=>'c.email',
		),
		'bank_account'=>array(),
		'contract'=>array(
		    'nullable'=>1,
			'selector'=>'c.contract',
		),
		'notice'=>array(
			'auto_insert'=>'3',
		),
		'alarm'=>array(
			'selector'=>'c.alarm',
			'auto_insert'=>'300',
			'log_by'=>'alarm_cur',
		),
		'alarm_cur'=>array(
			'selector'=>'c.alarm/100',
		),
		'block'=>array(
			'selector'=>'c.block',
			'log_by'=>'block_cur',
		),
		'block_cur'=>array(
			'selector'=>'c.block/100',
		),
		'reduction'=>array(
			'selector'=>'c.reduction',
			'log_by'=>'reduction_cur',
		),
		'reduction_cur'=>array(
			'selector'=>'c.reduction/100',
			'aggregate'=>'sum',
		),
		'blockable'=>array(
			'auto_insert'=>1,
		),
		'state'=>array(
			'selector'=>'c.state',
			'log_by'=>'state_name',
		),
		'state_name'=>array(
			'selector'=>'case
				when c.state=0 then "'.getResource('clients.state.0.short').'"
				when c.state=1 then "'.getResource('clients.state.1.short').'"
				when c.state=2 then "'.getResource('clients.state.2.short').'"
				when c.state=3 then "'.getResource('clients.state.3.short').'"
				else "" end',
		),
		'notes'=>array(
			'selector'=>'c.notes',
		),
		'stamp'=>array(
			'selector'=>'c.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array (
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array (
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['fields']['department']['auto_insert'] = $d;
	$obj['fields']['department']['auto_post'] = $d;
//	$obj['filters']['department'] = "c.department='$d'";
}
?>