<?
$obj = array(
	'name'=>'job_types',
	'nick'=>'jt',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'job_types p
	LEFT JOIN cities c ON c.id=p.city
	LEFT JOIN charge_types ct ON ct.id=p.charge_type
	LEFT JOIN stamps st ON st.id=p.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'p.id',
		),
		'city'=>array(
			'selector'=>'p.city',
			'nullable'=>1,
			'log_by'=>'city_name',
		),
		'city_name'=>array(
			'selector'=>"c.name",
		),
		'name'=>array(
			'desc'=>1,
			'selector'=>'p.name',
		),
		'abbr'=>array(
			'selector'=>'p.abbr',
		),
		'number'=>array(
			'selector'=>'p.number',
		),
		'type'=>array(
			'desc'=>1,
			'selector'=>'p.type',
			'log_by'=>'type_name',
		),
		'type_name' => array(
			'selector'=>'case p.type
				when 1 then "'.getResource('jt.type.1').'"
				when 2 then "'.getResource('jt.type.2').'"
				when 3 then "'.getResource('jt.type.3').'"
				else "" end',
		),
		'charge_type'=>array(
			'selector'=>'p.charge_type',
			'nullable'=>1,
			'log_by'=>'charge_type_name',
		),
		'charge_type_name'=>array(
			'selector'=>"CONCAT(ct.name, ' (', ROUND(ct.price/100, 2), ')')",
		),
		'notes'=>array(
			'selector'=>'p.notes',
		),
		'actual'=>array(
			'selector'=>'p.actual',
			'log_by'=>'actual_sign',
		),
		'actual_sign' => array(
			'selector'=>'case p.actual
				when 1 then "+"
				when 0 then "-"
				else "" end',
		),
		'fee_0'=>array(
			'selector'=>'p.fee_0',
			'log_by'=>'fee_0_cur',
		),
		'fee_0_cur'=>array(
			'selector'=>'p.fee_0/100',
		),
		'fee_1'=>array(
			'selector'=>'p.fee_1',
			'log_by'=>'fee_1_cur',
		),
		'fee_1_cur'=>array(
			'selector'=>'p.fee_1/100',
		),
		'auto_complete'=>array(
			'selector'=>'p.auto_complete',
		),
		'abon_incremental'=>array(
			'selector'=>'p.abon_incremental',
			'log_by'=>'abon_incremental_name',
		),
		'abon_incremental_name' => array(
			'selector'=>'case p.abon_incremental
				when 1 then "'.getResource('jt.abon.incremental.1').'"
				when 2 then "'.getResource('jt.abon.incremental.2').'"
				else "" end',
		),
		'repair'=>array(
			'selector'=>'p.repair',
		),
		'repair_sign'=>array(
			'selector'=>'IF(p.repair, "+", "-")',
		),
		'stamp'=>array(
			'selector'=>'p.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
			'skip_log'=>1,
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>