<?
$obj = array(
	'name'=>'houses',
	'nick'=>'khss',
	'readonly'=>1,
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'houses h
	LEFT JOIN streets s ON s.id=h.street
	LEFT JOIN districts d ON d.id=h.district
	LEFT JOIN admin_districts a ON a.id=d.admin
	LEFT JOIN stamps st ON st.id=h.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'h.id',
		),
		'street'=>array(
			'selector'=>'h.street',
			'nullable'=>1,
		),
		'street_name'=>array(
			'selector'=>'s.name',
		),
		'house'=>array(
			'desc'=>1,
			'selector'=>'h.house',
		),
		'district'=>array(
			'selector'=>'h.district',
			'nullable'=>1,
		),
		'district_name'=>array(
			'selector'=>'d.name',
		),
		'admin'=>array(
			'selector'=>'d.admin',
		),
		'admin_name'=>array(
			'selector'=>'a.name',
		),
		
		'koop'=>array(
			'selector'=>'h.koop',
			'nullable'=>1,
		),
		'state'=>array(
			'selector'=>'h.state',
			'nullable'=>1,
		),
		'state_name'=>array(
			'selector'=>'case
				when h.state=1 then "'.getResource('houses.state.1').'"
				when h.state=2 then "'.getResource('houses.state.2').'"
				when h.state=3 then "'.getResource('houses.state.3').'"
				when h.state=4 then "'.getResource('houses.state.4').'"
				else "" end',
		),
		'queries'=>array(
			'selector'=>'h.queries',
		),
		'floors'=>array(
			'selector'=>'h.floors',
			'nullable'=>1,
		),
		'entrances'=>array(
			'selector'=>'h.entrances',
			'nullable'=>1,
			'aggregate'=>'sum',
		),
		'appartments'=>array(
			'selector'=>'h.appartments',
			'nullable'=>1,
			'aggregate'=>'sum',
		),
		'notes'=>array(
			'selector'=>'h.notes',
			'nullable'=>1,
		),
		'stamp'=>array(
			'selector'=>'h.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>