<?

/**
 * @author tregub
 * @copyright 2010
 */

$obj = array(
	'name'=>'houses',
	'nick'=>'kpr',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'houses d
	LEFT JOIN streets s ON s.id=d.street
	LEFT JOIN population p ON p.house=d.id
	LEFT JOIN stamps st ON st.id=d.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'d.id',
		),
		'street' => array(
			'selector' => 's.name'
		),
		
		'house' => array(
			'selector' => 'd.house'
		),
		
		'floors' => array(
			'selector'=>'d.floors',
			'nullable'=>1,
		),
		
		'entrances' => array(
			'selector'=>'d.entrances',
			'nullable'=>1,
			'aggregate'=>'sum',
		),
		
		'appartments' => array(
			'selector'=>'d.appartments',
			'nullable'=>1,
			'aggregate'=>'sum',
		),
		
		'clients' => array(
			'selector'=>'IFNULL(p.amount,0)',
			'aggregate'=>'sum',
		),
		
		'population' => array(
			'selector'=>'floor(IFNULL(p.amount,0) / d.appartments * 100)',
		),

		'kpreo' => array(
			'selector' => 'd.kpreo'
		),
		'stamp'=>array(
			'selector'=>'d.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>