<?
$obj = array(
	'name'=>'mail_lists_clients',
	'nick'=>'mlcs',
	'masters'=>array(
		'mail_lists'=>array(
			'table'=>$GLOBALS['lists'],
			'on'=>'id',
			'by'=>'mail_list',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'BuildMailLists, after_logged_insert',
	'AfterPost'=>'BuildMailLists, after_logged_post',
	'AfterDelete'=>'BuildMailLists, after_stamped_delete, after_logged_delete',
	'source'=>'mail_lists_clients mlc
	LEFT JOIN clients c ON c.id = mlc.client
	LEFT JOIN stamps st ON st.id=mlc.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'mlc.id',
		),
		'mail_list'=>array(
			'selector'=>'mlc.mail_list',
			'desc'=>1,
		),
		'client'=>array(
			'selector'=>'mlc.client',
			'desc'=>1,
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'client_email'=>array(
			'bin'=>1,
			'selector'=>'c.email',
		),
		'stamp'=>array(
			'selector'=>'mlc.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>