<?
$obj = array(
	'name'=>'ip_use_hours',
	'nick'=>'stall',
	'readonly'=>1,
	'source'=>'ip_use_hours l
	LEFT JOIN ip_uses iu ON iu.id=l.ip_use
	LEFT JOIN personal_period_resource_uses ppru ON ppru.id=iu.personal_period_resource_use
	LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
	LEFT JOIN rules r ON r.id=iu.rule
	LEFT JOIN hosts h ON h.id=iu.host
	LEFT JOIN modems m ON m.id=h.modem
	LEFT JOIN clients c ON c.id=h.client',
	'fields'=>array(
		'ip_use'=>array(
			'selector'=>'l.ip_use',
			'key'=>1,
		),
		'host'=>array(
			'selector'=>'iu.host',
		),
		'ip'=>array(
			'selector'=>'h.ip',
			'order_by'=>'INET_ATON(h.ip)',
		),
		'client'=>array(
			'selector'=>'h.client',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'modem'=>array(
			'selector'=>'h.modem',
		),
		'modem_name'=>array(
			'bin'=>1,
			'selector'=>'m.name',
		),
		'rule'=>array(
			'selector'=>'iu.rule',
		),
		'rule_name'=>array(
			'bin'=>1,
			'selector'=>'r.for_client',
		),
		'from_time'=>array(
			'selector'=>'l.hour',
		),
		'to_time'=>array(
			'selector'=>'ADDDATE(l.hour, INTERVAL 1 HOUR)',
		),
		'bytes'=>array(
			'selector'=>'l.bytes',
			'aggregate'=>'sum',
		),
		'price'=>array(
			'selector'=>'ru.price',
		),
		'price_cur'=>array(
			'selector'=>'ru.price/100',
		),
		'unit_size'=>array(
			'selector'=>'round(ru.unit_size/1000000)',
		),
		'cost'=>array(
			'selector'=>'l.bytes * ru.price / ru.unit_size / 100',
			'aggregate'=>'sum',
		),
	),
);
?>