<?
$obj = array(
	'fields'=>array(
		'type'=>array(
			'title'=>getResource('modems.type'),
			'default'=>1,
			'control'=>'select',
			'skip_finder'=>1,
			'required'=>1,
			'list'=>array(
				'1'=>getResource('modems.type.1'),
				'2'=>getResource('modems.type.2'),
				'3'=>getResource('modems.type.3'),
			),
		),
		'managment_vlan' => array(
			'title' => getResource('modems.managment_vlan'),
			'control'=>'short',
		),
		'vlan' => array(
			'title' => getResource('modems.local.vlan'),
			'control'=>'short',
		),
		'ip'=>array(
			'title'=>getResource('modems.ip'),
			'required'=>1,
		),
		'mac'=>array(
			'title'=>getResource('modems.mac'),
			'format'=>$GLOBALS['fLowerCase'],
			//'required'=>1,
		),
		'name'=>array(
			'title'=>getResource('modems.name'),
		),
		'ip_core_route'=>array(
			'title'=>getResource('modems.ip.core.route'),
		),
		'real_ip_vlan'=>array(
			'title'=>getResource('modems.real.ip.vlan'),
			'control'=>'short',
		),
		'domain'=>array(
			'title'=>getResource('modems.domain'),
			'link'=>'domains.php?id=[domain]',
			'control'=>'select',
			'list'=>'getDomains',
			'control'=>'lookup',
			'label'=>'[domain_name]',
			'source'=>'?lookup=domain',
		),
		'profile'=>array(
			'title'=>getResource('modems.profile'),
			'link'=>'modem_profiles.php?id=[profile]',
			'required'=>1,
			'control'=>'lookup',
			'label'=>'[profile_name]',
			'source'=>'?lookup=modem_profile',
		),
		'department'=>array(
			'title'=>getResource('modems.department'),
			'link'=>'departments.php?id=[department]',
			'required'=>1,
			//'control'=>'select',
			//'list'=>'getDepartments',
			'control'=>'lookup',
			'label'=>'[department_name]',
			'source'=>'?lookup=department',
		),
		'city'=>array(
			'title'=>getResource('modems.city'),
			'link'=>'cities.php?id=[city]',
			'control'=>'select',
			'list'=>'getCities',
			'skip_finder'=>1,
		),
		'exp_point'=>array(
			'title'=>getResource('modems.exp.point'),
			'link'=>'exp_points.php?id=[exp_point]',
			'control'=>'lookup',
			'label'=>'[exp_point_name]',
			'source'=>'?lookup=point',
			'id'=>'lookup_point',
		),
		'street'=>array(
			'title'=>getResource('clients.street'),
			'link'=>'streets.php?id=[street]',
			'control'=>'lookup',
			'label'=>'[street_name]',
			'source'=>'?lookup=street',
			'id'=>'lookup_street',
		),
		'house'=>array(
			'title'=>getResource('clients.house'),
			'control'=>'short',
		),
		'entrance'=>array(
			'title'=>getResource('clients.entrance'),
			'positive'=>1,
			'control'=>'short',
		),
		'floor'=>array(
			'title'=>getResource('clients.floor'),
			'control'=>'short',
		),
		'check_address'=>array(
			'title'=>getResource('modems.check.address'),
			'comment'=>getResource('modems.check.address.comment'),
			'positive'=>1,
			'control'=>'checkbox',
			'default'=>1,
		),
		'modem'=>array(
			'title'=>getResource('modems.modem'),
			'link'=>'modems.php?id=[modem]',
			'control'=>'select',
			'list'=>'getModems',
			'control'=>'lookup',
			'label'=>'[modem_name]',
			'source'=>'?lookup=modem',
		),
		'port'=>array(
			'title'=>getResource('modems.port'),
			'positive'=>1,
			'control'=>'short',
		),
		'uplink'=>array(
			'title'=>getResource('modems.uplink'),
			'positive'=>1,
			'control'=>'short',
		),
		'address_space'=>array(
			'title'=>getResource('modems.address.space'),
			'comment'=>getResource('modems.address.space.comment'),
			'control'=>'textarea',
			'height'=>3,
		),
		'notes'=>array(
			'title'=>getResource('modems.notes'),
			'control'=>'textarea',
			'height'=>6,
		),
		'audit'=>array(
			'title'=>getResource('modems.audit'),
			'control'=>'checkbox',
			'default'=>'1',
		),
		'check_power'=>array(
			'title'=>getResource('modems.check.power'),
			'control'=>'checkbox',
			'default'=>'1',
		),
		'auto_update'=>array(
			'control'=>'checkbox',
			'title'=>getResource('modems.auto_update'),
		),
		'model'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.model'),
		),
		'firmware'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.firmware'),
		),
		'loader'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.loader'),
		),
		'diag'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.diag'),
		),
		'power_name'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.power'),
		),
		'up_since'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.up.since'),
		),
		'state_sign'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.state'),
		),
		'state_date'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.state.date'),
		),
		'clients_2'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.clients'),
			'comment'=>getResource('modems.clients.comment'),
		),
		'clients'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.clients.total'),
			'comment'=>getResource('modems.clients.total.comment'),
		),
		'clients_gig'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.clients.gig'),
			'comment'=>getResource('modems.clients.gig.comment'),
		),
		'created'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.created'),
		),
		'created_name'=>array(
			'title'=>getResource('modems.created.by'),
			'readonly'=>1,
		),
		'modified'=>array(
			'readonly'=>1,
			'title'=>getResource('modems.modified'),
		),
		'modified_name'=>array(
			'title'=>getResource('modems.modified.by'),
			'readonly'=>1,
		),
	),
);
if($GLOBALS['oper']->department){
	unset($obj['fields']['department']);
}
?>