<?
$obj = array(
	'name'=>'modems',
	'nick'=>'mpds',
	'source'=>'modems m
	LEFT JOIN modems ms ON ms.id=m.modem
	LEFT JOIN domains d ON d.id = m.domain
	LEFT JOIN modem_profiles p ON p.id = m.profile
	LEFT JOIN streets s ON s.id = m.street
	LEFT JOIN departments dp ON dp.id = m.department
	LEFT JOIN modems_states x ON x.id = m.state_id',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'m.id',
		),
		'level'=>array(
			'selector'=>$GLOBALS['deep_selector'],
		),
		'name'=>array(
			'bin'=>1,
			'desc'=>1,
			'selector'=>'m.name',
		),
		'ip'=>array (
			'desc'=>1,
			'selector'=>'m.ip',
			'order_by'=>'INET_ATON(m.ip)',
		),
		'mac'=>array(
			'selector'=>'m.mac',
			'nullable'=>1,
		),
		'modem'=>array(
			'selector'=>'m.modem',
			'nullable'=>1,
		),
		'modem_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(ms.ip, " (",ms.name,")")',
		),
		'port'=>array(
			'selector'=>'m.port',
		),
		'domain'=>array(
			'selector'=>'m.domain',
			'nullable'=>1,
		),
		'domain_name'=>array(
			'bin'=>1,
			'selector'=>'d.name',
		),
		'profile'=>array(
			'selector'=>'m.profile',
		),
		'profile_name'=>array(
			'bin'=>1,
			'selector'=>'p.name',
		),
		'street'=>array(
			'selector'=>'m.street',
			'nullable'=>1,
		),
		'street_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'house'=>array(
			'selector'=>'m.house',
		),
		'entrance'=>array(
			'selector'=>'m.entrance',
		),
		'floor'=>array(
			'selector'=>'m.floor',
		),
		'check_address'=>array(
			'selector'=>'m.check_address',
		),
		'up_since'=>array(
			'selector'=>'m.up_since',
		),
		'model'=>array(
			'selector'=>'m.model',
		),
		'firmware'=>array(
			'selector'=>'m.firmware',
		),
		'department'=>array(
			'selector'=>'m.department',
		),
		'department_name'=>array(
			'bin'=>1,
			'selector'=>'dp.name',
		),
		'notes'=>array(
			'selector'=>'m.notes',
		),
		'state'=>array(
			'selector'=>'x.state',
		),
		'loss_in'=>array(
			'selector'=>'x.loss_in - x.loss_in_prev',
		),
		'loss_out'=>array(
			'selector'=>'x.loss_out - x.loss_out_prev',
		),
		'state_sign'=>array(
			'selector'=>'IF((m.audit=0) || (x.state IS NULL), "", IF(x.state, "+", "-"))',
		),
		'state_date'=>array(
			'selector'=>'IF(m.audit=0, "", x.date)',
		),
	),
);

$d = $GLOBALS['oper']->department;
if($d){
	$obj['filters']['department'] = "m.department='$d'";
}
?>