<?
$obj = array(
	'name'=>'movements',
	'nick'=>'ms',
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_move_insert, after_logged_insert',
	'AfterPost'=>'after_move_post, after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_move_delete, after_logged_delete',
	'source'=>'movements m
	LEFT JOIN cities ci ON ci.id=m.city
	LEFT JOIN clients c ON c.id=m.client
	LEFT JOIN houses h ON c.house_id=h.id
	LEFT JOIN streets ss ON ss.id=h.street
	LEFT JOIN districts ds ON ds.id=h.district
	LEFT JOIN connection_types ct ON ct.id=c.connection_type
	LEFT JOIN tv_types tt ON tt.id=c.tv_type
	LEFT JOIN accounts s ON s.id=m.src
	LEFT JOIN accounts d ON d.id=m.dst
	LEFT JOIN system_accounts sa ON sa.account=m.src
	LEFT JOIN stamps st ON st.id=m.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'m.id',
		),
		'city'=>array(
			'selector'=>'m.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'client'=>array(
			'selector'=>'m.client',
		),
		'client_name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (",IFNULL(c.contract,""),")")',
		),
		'connection_type'=>array(
			'selector'=>'c.connection_type',
		),
		'connection_type_name'=>array(
			'selector'=>'ct.name',
		),
		'tv_type'=>array(
			'selector'=>'c.tv_type',
		),
		'tv_type_name'=>array(
			'selector'=>'tt.name',
		),
		'street'=>array(
			'selector'=>'h.street',
		),
		'street_name'=>array(
			'selector'=>'ss.name',
		),
		'house_id'=>array(
			'selector'=>'c.house_id',
		),
		'house'=>array(
			'selector'=>'h.house',
		),
		'apartment'=>array(
			'selector'=>'c.apartment',
		),
		'calendar_period'=>array(
			'selector'=>'m.calendar_period',
		),
		'src'=>array(
			'selector'=>'m.src',
			'desc'=>1,
			'log_by'=>'src_name',
		),
		'src_name'=>array(
			'bin'=>1,
			'selector'=>'s.name',
		),
		'src_type'=>array(
			'bin'=>1,
			'selector'=>'s.type',
		),
		'dst'=>array(
			'selector'=>'m.dst',
			'desc'=>1,
			'log_by'=>'dst_name',
		),
		'dst_name'=>array(
			'bin'=>1,
			'selector'=>'d.name',
		),
		'dst_type'=>array(
			'bin'=>1,
			'selector'=>'d.type',
		),
		'amount'=>array(
			'selector'=>'m.amount',
			'log_by'=>'amount_cur',
			'desc'=>1,
		),
		'amount_cur'=>array(
			'selector'=>'m.amount/100',
			'aggregate'=>'sum',
		),
		'date'=>array(
			'selector'=>'m.date',
			'desc'=>1,
		),
		'note'=>array(
			'nullable'=>1,
			'selector'=>'m.note',
		),
		'label'=>array(
			'selector'=>'sa.label',
		),
		'stamp'=>array(
			'selector'=>'m.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_person'=>array(
			'selector'=>'cr.person',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>