<?
$obj = array(
	'name'=>'pays_import',
	'nick'=>'pim',
	'masters'=>array(
		'pays_import_head'=>array(
			'table'=>$GLOBALS['import_head'],
			'on'=>'id',
			'by'=>'head',
		),
	),
	'source'=>'pays_import pi
	LEFT JOIN clients c ON c.account=pi.dst
	LEFT JOIN system_accounts sa ON sa.account=pi.src
	LEFT JOIN calendar_periods cp ON cp.id=pi.calendar_period',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'pi.id',
		),
		'head'=>array(
			'selector'=>'pi.head',
		),
		'pos'=>array(
			'selector'=>'pi.pos',
		),
		'src'=>array(
			'selector'=>'pi.src',
			'nullable'=>1,
			'log_by'=>'src_name',
		),
		'src_name'=>array(
			'selector'=>'sa.name',
		),
		'dst'=>array(
			'selector'=>'pi.dst',
			'nullable'=>1,
		),
		'client'=>array(
			'selector'=>'c.id',
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", IFNULL(c.contract,""), ")")',
		),
		'amount'=>array(
			'selector'=>'pi.amount',
			'log_by'=>'amount_cur',
		),
		'amount_cur'=>array(
			'selector'=>'pi.amount/100',
			'aggregate'=>'sum',
		),
		'info'=>array(
			'selector'=>'pi.info',
		),
		'valid'=>array(
			'selector'=>'pi.valid',
			'log_by'=>'valid_sign',
		),
		'valid_sign'=>array(
			'selector'=>'if(pi.valid, "+", "-")',
		),
		'note'=>array(
			'selector'=>'pi.note',
		),
		'calendar_period'=>array(
			'selector'=>'pi.calendar_period',
		),
		'date'=>array(
			'selector'=>'pi.date',
		),
	),
);
?>