<?
$obj = array(
	'name'=>'poll_votes',
	'nick'=>'povs',
	'masters'=>array(
		'clients'=>array(
			'table'=>$GLOBALS['polls'],
			'on'=>'id',
			'by'=>'poll',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'poll_votes pv
	LEFT JOIN polls p ON pv.poll = p.id
	LEFT JOIN poll_options po ON pv.poll_option = po.id
	LEFT JOIN clients c ON pv.client = c.id
	LEFT JOIN stamps st ON st.id=pv.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'poll'=>array(
			'desc'=>1,
			'selector'=>'pv.poll',
			'key'=>1,
			'log_by'=>'poll_title',
		),
		'poll_title'=>array(
			'selector'=>'p.title',
		),
		'client'=>array(
			'desc'=>1,
			'selector'=>'pv.client',
			'key'=>1,
			'log_by'=>'client_name',
		),
		'client_name'=>array(
			'bin'=>1,
			'selector'=>'CONCAT(c.last_name, " ", c.first_name, " (", c.login,")")',
		),
		'poll_option'=>array(
			'selector'=>'pv.poll_option',
			'log_by'=>'poll_option_body',
		),
		'poll_option_body'=>array(
			'bin'=>1,
			'selector'=>'po.body',
		),
		'stamp'=>array(
			'selector'=>'po.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>