<?
$obj = array(
	'name'=>'stats_arpu',
	'nick'=>'arpu',
	'readonly'=>1,
	'source'=>'connection_types ct
	LEFT JOIN stats_arpu sa ON sa.connection_type=ct.id
	LEFT JOIN cities ci ON ci.id=sa.city
	LEFT JOIN (SELECT connection_type, SUM(use_plan) as use_plan FROM connection_type_resources GROUP BY connection_type) x ON x.connection_type=ct.id',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'ct.id',
		),
		'city'=>array(
			'selector'=>'ct.city',
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'name'=>array(
			'bin'=>1,
			'selector'=>'ct.name',
		),
		'prepay_sum'=>array(
			'bin'=>1,
			'selector'=>'(ct.abon_amount + IFNULL(x.use_plan,0))/100',
		),
		'count_non_dead'=>array(
			'selector'=>'ifnull(sa.count_non_dead, 0)',
			'aggregate'=>'sum',
		),
		'count_dead'=>array(
			'selector'=>'ifnull(sa.count_dead, 0)',
			'aggregate'=>'sum',
		),
		'count_total'=>array(
			'selector'=>'ifnull(sa.count_total, 0)',
			'aggregate'=>'sum',
		),
		'p_count_non_dead'=>array(
			'selector'=>'ifnull(sa.p_count_non_dead, 0)',
			'aggregate'=>'sum',
		),
		'p_count_dead'=>array(
			'selector'=>'ifnull(sa.p_count_dead, 0)',
			'aggregate'=>'sum',
		),
		'p_count_total'=>array(
			'selector'=>'ifnull(sa.p_count_total, 0)',
			'aggregate'=>'sum',
		),
		'pay_non_dead'=>array(
			'selector'=>'ifnull(sa.pay_non_dead, 0)/100',
			'aggregate'=>'sum',
		),
		'pay_dead'=>array(
			'selector'=>'ifnull(sa.pay_dead, 0)/100',
			'aggregate'=>'sum',
		),
		'pay_total'=>array(
			'selector'=>'ifnull(sa.pay_total, 0)/100',
			'aggregate'=>'sum',
		),
		'p_pay_non_dead'=>array(
			'selector'=>'ifnull(sa.p_pay_non_dead, 0)',
			'aggregate'=>'sum',
		),
		'p_pay_dead'=>array(
			'selector'=>'ifnull(sa.p_pay_dead, 0)',
			'aggregate'=>'sum',
		),
		'p_pay_total'=>array(
			'selector'=>'ifnull(sa.p_pay_total, 0)',
			'aggregate'=>'sum',
		),
		'arpu'=>array(
			'selector'=>'ifnull(sa.arpu, 0)/100',
		),
		'connected'=>array(
			'selector'=>'ifnull(sa.connected, 0)',
			'aggregate'=>'sum',
		),
	),
);
?>