<?
$obj = array(
	'name'=>'tv_nodes',
	'nick'=>'tvpds',
	'BeforeInsert'=>'before_stamped_insert, check_node_circle',
	'BeforePost'=>'before_stamped_post, check_node_circle',
	'BeforeDelete'=>'before_profile_delete',
	'AfterInsert'=>'after_logged_insert, recalc_tv_nodes_nest',
	'AfterPost'=>'after_logged_insert, recalc_tv_nodes_nest',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, recalc_tv_nodes_nest',
	'source'=>'tv_nodes n
	LEFT JOIN tv_nodes_nest tnn ON tnn.id=n.id
	LEFT JOIN tv_node_types t ON t.id=n.type
	LEFT JOIN cities ci ON ci.id=n.city
	LEFT JOIN exp_points p ON p.id=n.point
	LEFT JOIN houses ph ON ph.id=p.house
	LEFT JOIN districts ds ON ds.id=ph.district
	LEFT JOIN admin_districts ad ON ad.id=ds.admin
	LEFT JOIN streets ps ON ps.id=ph.street
	LEFT JOIN stamps st ON st.id=n.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'n.id',
		),
		'level'=>array(
			'selector'=>'tnn.level',
		),
		'name'=>array(
			'selector'=>'n.name',
		),
		'type'=>array(
			'selector'=>'n.type',
			'log_by'=>'type_name',
			'nullable'=>1,
		),
		'type_name'=>array(
			'selector'=>'t.name',
		),
		'city'=>array(
			'selector'=>'n.city',
			'log_by'=>'city_name',
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'point'=>array(
			'selector'=>'n.point',
			'log_by'=>'point_name',
			'nullable'=>1,
		),
		'point_name'=>array(
			'selector'=>'CONCAT(ps.name, " ", ph.house, " '.getResource('exp.points.entrance.short').'", IFNULL(p.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case p.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(p.floor,"") end)',
		),
		'district'=>array(
			'selector'=>'ph.district',
		),
		'district_name'=>array(
			'selector'=>'ds.name',
		),
		'street'=>array(
			'selector'=>'ph.street',
		),
		'street_name'=>array(
			'selector'=>'ps.name',
		),
		'house'=>array(
			'selector'=>'p.house',
		),
		'house_house'=>array(
			'selector'=>'ph.house',
		),
		'entrnace'=>array(
			'selector'=>'p.entrance',
		),
		'floor'=>array(
			'selector'=>'case p.floor
				when -1 then "'.getResource('exp.points.floor.1').'"
				when -2 then "'.getResource('exp.points.floor.2').'"
				when -3 then "'.getResource('exp.points.floor.3').'"
				when -4 then "'.getResource('exp.points.floor.4').'"
				else IFNULL(p.floor,"") end',
		),
		'entrances'=>array(
			'selector'=>'n.entrances',
		),
		'notes'=>array(
			'selector'=>'n.notes',
		),
		'power_in'=>array(
			'selector'=>'n.power_in',
		),
		'power_in_cur'=>array(
			'selector'=>'n.power_in/100',
		),
		'power_out'=>array(
			'selector'=>'n.power_out',
		),
		'power_out_cur'=>array(
			'selector'=>'n.power_out/100',
		),
		'audit'=>array(
			'selector'=>'n.audit',
		),
		'audit_sign'=>array(
			'selector'=>'IF(n.audit, "+", "-")',
		),
		'stamp'=>array(
			'selector'=>'n.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>