<?
$obj = array(
	'name'=>'tv_nodes',
	'nick'=>'tvnds',
	'BeforeInsert'=>'before_stamped_insert, check_node_circle,validate_host_ip_duplicate',
	'BeforePost'=>'before_stamped_post, check_node_circle,validate_host_ip_duplicate',
	'BeforeDelete'=>'before_profile_delete',
	'AfterInsert'=>'after_logged_insert, recalc_tv_nodes_nest, recalc_tv_clients',
	'AfterPost'=>'after_logged_insert, recalc_tv_nodes_nest, recalc_tv_clients',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete, recalc_tv_nodes_nest, recalc_tv_clients',
	'source'=>'tv_nodes n
	LEFT JOIN tv_node_types t ON t.id=n.type
	LEFT JOIN tv_node_profiles tp ON tp.id=n.profile
	LEFT JOIN tv_nodes_power tw ON tw.tv_node=n.id
	LEFT JOIN tv_nodes pn ON pn.id=n.parent
	LEFT JOIN tv_node_types pt ON pt.id=pn.type
	LEFT JOIN cities ci ON ci.id=n.city
	LEFT JOIN exp_points p ON p.id=n.point
	LEFT JOIN houses ph ON ph.id=p.house
	LEFT JOIN districts ds ON ds.id=ph.district
	LEFT JOIN admin_districts ad ON ad.id=ds.admin
	LEFT JOIN streets ps ON ps.id=ph.street
	LEFT JOIN tv_nodes_clients tnc ON tnc.tv_node=n.id
	LEFT JOIN stamps st ON st.id=n.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'key'=>1,
			'selector'=>'n.id',
		),
		'name'=>array(
			'selector'=>'n.name',
		),
		'ip'=>array(
			'selector'=>'n.ip',
			'nullable'=>1,
		),
		'mac'=>array(
			'selector'=>'n.mac',
			'nullable'=>1,
		),
		'profile'=>array(
			'selector'=>'n.profile',
			'nullable'=>1,
		),
		'profile_name'=>array(
			'selector'=>'tp.name',
		),
		'type'=>array(
			'selector'=>'n.type',
			'log_by'=>'type_name',
			'nullable'=>1,
		),
		'type_name'=>array(
			'selector'=>'t.name',
		),
		'parent'=>array(
			'selector'=>'n.parent',
			'log_by'=>'parent_name',
			'nullable'=>1,
		),
		'parent_name'=>array(
			'selector'=>'pn.name',
		),
		'city'=>array(
			'selector'=>'n.city',
			'log_by'=>'city_name',
			'nullable'=>1,
		),
		'city_name'=>array(
			'selector'=>'ci.name',
		),
		'point'=>array(
			'selector'=>'n.point',
			'log_by'=>'point_name',
			'nullable'=>1,
		),
		'point_name'=>array(
			'selector'=>'CONCAT(ps.name, " ", ph.house, " '.getResource('exp.points.entrance.short').'", IFNULL(p.entrance,""), " '.getResource('exp.points.floor.short').'", 
								case p.floor
								when -1 then "'.getResource('exp.points.floor.1').'"
								when -2 then "'.getResource('exp.points.floor.2').'"
								when -3 then "'.getResource('exp.points.floor.3').'"
								when -4 then "'.getResource('exp.points.floor.4').'"
								else IFNULL(p.floor,"") end)',
		),
		'district'=>array(
			'selector'=>'ph.district',
		),
		'district_name'=>array(
			'selector'=>'ds.name',
		),
		'street'=>array(
			'selector'=>'ph.street',
		),
		'street_name'=>array(
			'selector'=>'ps.name',
		),
		'house'=>array(
			'selector'=>'p.house',
		),
		'house_house'=>array(
			'selector'=>'ph.house',
		),
		'entrnace'=>array(
			'selector'=>'p.entrance',
		),
		'floor'=>array(
			'selector'=>'case p.floor
				when -1 then "'.getResource('exp.points.floor.1').'"
				when -2 then "'.getResource('exp.points.floor.2').'"
				when -3 then "'.getResource('exp.points.floor.3').'"
				when -4 then "'.getResource('exp.points.floor.4').'"
				else IFNULL(p.floor,"") end',
		),
		'entrances'=>array(
			'selector'=>'n.entrances',
		),
		'notes'=>array(
			'selector'=>'n.notes',
		),
		'power_in'=>array(
			'selector'=>'n.power_in',
		),
		'power_in_cur'=>array(
			'selector'=>'n.power_in/100',
		),
		'power_out'=>array(
			'selector'=>'t.power_out',
		),
		'power_out_cur'=>array(
			'selector'=>'t.power_out/100',
		),
		'input_power'=>array(
			'selector'=>'IF(n.audit,tw.input_power,NULL)',
		),
		'output_power'=>array(
			'selector'=>'IF(n.audit,tw.output_power,NULL)',
		),
		'input_power_cur'=>array(
			'selector'=>'IF(n.audit,tw.input_power/100,NULL)',
		),
		'output_power_cur'=>array(
			'selector'=>'IF(n.audit,tw.output_power/100,NULL)',
		),
		'input_deviation'=>array(
			'selector'=>'IF(n.audit,(tw.input_power - n.power_in)/100,NULL)',
		),
		'output_deviation'=>array(
			'selector'=>'IF(n.audit,(tw.output_power - t.power_out)/100,NULL)',
		),
		'available'=>array(
			'selector'=>'IF(n.audit,tw.available,NULL)',
		),
		'audit'=>array(
			'selector'=>'n.audit',
		),
		'audit_sign'=>array(
			'selector'=>'IF(n.audit, "+", "-")',
		),
		'clients'=>array(
			'selector'=>'tnc.clients',
			'aggregate'=>'sum',
		),
		'clients_total'=>array(
			'selector'=>'tnc.clients_total',
		),
		'apartments'=>array(
			'selector'=>'tnc.apartments',
		),
		'stamp'=>array(
			'selector'=>'n.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>