<?
$obj = array(
	'fields'=>array(
		'last_name'=>array(
			'title'=>getResource('clients.last_name'),
			'required'=>1,
		),
		'first_name'=>array(
			'title'=>getResource('clients.first_name'),
		),
		'patronymic'=>array(
			'title'=>getResource('clients.patronymic'),
		),
		'connection_type'=>array(
			'title'=>getResource('clients.connection.type'),
			'control'=>'select',
			'required'=>1,
			'list'=>'getConnectionTypes',
			'link'=>'connection_types.php?id=[connection_type]',
		),
		'department'=>array(
			'title'=>getResource('clients.department'),
			'control'=>'select',
			'required'=>1,
			'list'=>'getDepartments',
			'link'=>'departments.php?id=[department]',
		),
		'street'=>array(
			'title'=>getResource('clients.street'),
			'required'=>1,
			'control'=>'select',
			'list'=>'getStreets',
			'link'=>'streets.php?id=[street]',
		),
		'house'=>array(
			'title'=>getResource('clients.house'),
			'required'=>1,
			'control'=>'short',
		),
		'building'=>array(
			'title'=>getResource('clients.building'),
			'control'=>'short',
		),
		'letter'=>array(
			'title'=>getResource('clients.letter'),
			'control'=>'short',
		),
		'entrance'=>array(
			'title'=>getResource('clients.entrance'),
			'positive'=>1,
			'control'=>'short',
		),
		'floor'=>array(
			'title'=>getResource('clients.floor'),
			'positive'=>1,
			'control'=>'short',
		),
		'apartment'=>array(
			'title'=>getResource('clients.apartment'),
			'control'=>'short',
		),
		'surveyor'=>array(
			'title'=>getResource('clients.surveyor'),
			'control'=>'short',
		),
		'phone'=>array(
			'title'=>getResource('clients.phone'),
		),
		'login'=>array(
			'title'=>getResource('clients.login'),
			'required'=>1,
		),
		'pass'=>array(
			'title'=>getResource('clients.password'),
			'control'=>'password',
			'with_confirm'=>1,
		),
		'email'=>array(
			'title'=>getResource('clients.email'),
			'comment'=>getResource('clients.form.email.comment'),
		),
		'bank_account'=>array(
			'title'=>getResource('clients.bank.account'),
		),
		'contract'=>array(
			'title'=>getResource('clients.contract'),
		),
		'notice'=>array(
			'title'=>getResource('clients.notice'),
			'control'=>'short',
			'positive'=>1,
			'default'=>3,
			'comment'=>getResource('clients.form.notice.comment'),
		),
		'alarm'=>array(
			'title'=>getResource('clients.alarm'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
			'default'=>'300',
			'comment'=>getResource('clients.form.alarm.comment'),
		),
		'block'=>array(
			'title'=>getResource('clients.block'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
			'default'=>0,
			'comment'=>getResource('clients.form.block.comment'),
		),
		'reduction'=>array(
			'title'=>getResource('clients.reduction'),
			'control'=>'short',
			'format'=>$GLOBALS['fcurrency'],
			'default'=>0,
			'comment'=>getResource('clients.reduction.comment'),
		),
		'blockable'=>array(
			'title'=>getResource('clients.blockable'),
			'control'=>'checkbox',
			'default'=>1,
			'comment'=>getResource('clients.form.blockable.comment'),
		),
		'deposit'=>array(
			'title'=>getResource('clients.deposit'),
			'readonly'=>1,
		),
		'created'=>array(
			'readonly'=>1,
			'title'=>getResource('clients.created'),
		),
		'created_name'=>array(
			'title'=>getResource('clients.created.by'),
			'readonly'=>1,
		),
		'modified'=>array(
			'readonly'=>1,
			'title'=>getResource('clients.modified'),
		),
		'modified_name'=>array(
			'title'=>getResource('clients.modified.by'),
			'readonly'=>1,
		),
	),
);
if($GLOBALS['oper']->department){
	unset($obj['fields']['department']);
}

?>