<?
$obj = array(
	'name'=>'connection_type_resources',
	'nick'=>'ctr',
	'masters'=>array(
		'connection_types'=>array(
			'table'=>$GLOBALS['connection_types'],
			'on'=>'id',
			'by'=>'connection_type',
		),
	),
	'BeforeInsert'=>'before_stamped_insert',
	'BeforePost'=>'before_stamped_post',
	'AfterInsert'=>'after_logged_insert',
	'AfterPost'=>'after_logged_post',
	'AfterDelete'=>'after_stamped_delete, after_logged_delete',
	'source'=>'connection_type_resources ctr
	LEFT JOIN connection_types ct ON ct.id=ctr.connection_type
	LEFT JOIN resource_types rt ON rt.id=ctr.resource_type
	LEFT JOIN system_accounts ud ON ud.account=ctr.use_dst
	LEFT JOIN system_accounts pd ON pd.account=ctr.penalty_dst
	LEFT JOIN system_accounts bs ON bs.account=ctr.bonus_src
	LEFT JOIN system_accounts bld ON bld.account=ctr.bonus_lost_dst
	LEFT JOIN stamps st ON st.id=ctr.stamp
	LEFT JOIN operators cr ON cr.id = st.created_by
	LEFT JOIN staff crs ON crs.id=cr.person
	LEFT JOIN operators md ON md.id = st.modified_by
	LEFT JOIN staff mds ON mds.id=md.person',
	'fields'=>array(
		'id'=>array(
			'selector'=>'ctr.id',
		),
		'connection_type'=>array(
			'desc'=>1,
		),
		'connection_type_name'=>array(
			'bin'=>1,
			'selector'=>'ct.name',
		),
		'resource_type'=>array(
			'desc'=>1,
			'key'=>1,
		),
		'resource_type_name'=>array(
			'bin'=>1,
			'selector'=>'rt.name',
		),
		'use_dst'=>array(
			'selector'=>'ctr.use_dst',
		),
		'use_dst_name'=>array(
			'bin'=>1,
			'selector'=>'ud.name',
		),
		'use_plan'=>array(
			'selector'=>'ctr.use_plan',
		),
		'use_plan_cur'=>array(
			'selector'=>'ctr.use_plan/100',
		),
		'use_limit'=>array(
			'selector'=>'ctr.use_limit',
		),
		'use_limit_cur'=>array(
			'selector'=>'ctr.use_limit/100',
		),
		'penalty_dst'=>array(
			'selector'=>'ctr.penalty_dst',
			'nullable'=>1,
		),
		'penalty_dst_name'=>array(
			'bin'=>1,
			'selector'=>'pd.name',
		),
		'bonus_src'=>array(
			'selector'=>'ctr.bonus_src',
			'nullable'=>1,
		),
		'bonus_src_name'=>array(
			'bin'=>1,
			'selector'=>'bs.name',
		),
		'bonus_amount'=>array(
			'selector'=>'ctr.bonus_amount',
		),
		'bonus_amount_cur'=>array(
			'selector'=>'ctr.bonus_amount/100',
		),
		'bonus_name'=>array(
			'selector'=>'ctr.bonus_name',
			'nullable'=>1,
		),
		'bonus_priority'=>array(
			'selector'=>'ctr.bonus_priority',
		),
		'bonus_lost_dst'=>array(
			'selector'=>'ctr.bonus_lost_dst',
			'nullable'=>1,
		),
		'bonus_lost_dst_name'=>array(
			'bin'=>1,
			'selector'=>'bld.name',
		),
		'stamp'=>array(
			'selector'=>'ctr.stamp',
		),
		'created'=>array(
			'selector'=>'st.created',
		),
		'created_by'=>array(
			'selector'=>'st.created_by',
		),
		'created_name'=>array(
			'bin'=>1,
			'selector'=>'crs.name',
		),
		'modified'=>array(
			'selector'=>'st.modified',
		),
		'modified_by'=>array(
			'selector'=>'st.modified_by',
		),
		'modified_name'=>array(
			'bin'=>1,
			'selector'=>'mds.name',
		),
	),
);
?>