<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:17 $
$Revision: 1.9 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('classes/ActionLoggerTool.php');
loadStrings(BOOT.'jobs/strings.txt');
loadStrings(BOOT.'houses/strings.txt');

$doc->title .= ' :: '.getResource('calendar.title');

required_access('jobs');


include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'house':	lookup('house', $_GET['city'] ? array('h.city='.addslashes($_GET['city'])) : array());
	case 'client':	lookup('client', $_GET['city'] ? array('c.city='.addslashes($_GET['city'])) : array());
	case 'worker':	lookup('worker', $_GET['city'] ? array('s.city='.addslashes($_GET['city'])) : array());
	case 'tzt':		lookup('tzt', $_GET['city'] ? array('x.city='.addslashes($_GET['city'])) : array());
	case 'job_type':lookup('job_type', $_GET['city'] ? array('t.city='.addslashes($_GET['city'])) : array());
}

if(isset($_GET['worker_candidates'])){
	list($year, $month, $day, $house, $type) = explode("-", $_GET['worker_candidates']);
	if($house && $type){
		$house = loadRecord("SELECT id, district, lat, lng FROM houses WHERE id='".addslashes($house)."'");
		$date = sprintf("%04d-%02d-%02d", $year, $month, $day);
		header("Content-Type: text/plain; charset=cp1251");
		$arr = createPrompt($house, $date, $type);
		array_walk($arr, function(&$v, $k){
			$v = '"'.$k.'":'.$v.'';
		});
		echo "{".implode(",", $arr)."}";
	}
	exit;
}

function getJobsFinders(){
	return loadByQuery("SELECT id, name as value FROM jobs_finders WHERE actual=1 ORDER BY name");
}

function generate_contract($table){
	$new = $table->new_record;
	$contract_base = date("ymd", _parse_datetime($new['date']));
	$contracts = my_merge(array(
		loadByQuery("SELECT contract as id, id as value FROM jobs WHERE contract LIKE '$contract_base%'"),
		loadByQuery("SELECT contract as id, id as value FROM clients WHERE contract LIKE '$contract_base%'"),
	));
	for($i=1; $i<1000; $i++){
		$try = $contract_base.sprintf("%03s", $i);
		if(!isset($contracts[$try])){
			$table->new_record['contract'] = $try;
			return;
		}
	}
	$table->error(getResource('jobs.error.out.of.contracts'));
}

function check_job_city($table){
	$new = $table->new_record;
	$check = array(
		'house_id'=>'houses',
		'client_id'=>'clients',
	);
	foreach($check as $field=>$table_name){
		$arr = loadRecord("SELECT city FROM $table_name WHERE id='".$new[$field]."'");
		if($arr && ($arr['city']!=$new['city'])){
			$table->error(getResource('jobs.error.'.$field.'.city'));
		}
	}
}

function before_job_insert($table){
	$new = $table->new_record;
	if(!$new['contract']){
		unset($table->new_record['contract']);
//		if($new['type']==1 || $new['type']==5){
			if(!$new['client_id']){
				generate_contract($table);
			}
//		}
	}
}

function before_job_post($table){
	$cur = $table->current_record;
	$new = $table->new_record;
	if(!$new['contract']){
		unset($table->new_record['contract']);
		if(($new['type']==1 || $new['type']==5) && !$new['client_id'] && $new['state']!=3){
			if(!$cur['contract']){
				generate_contract($table);
			}
		}
	}
}

function check_job_entrance($table){
	$job = $table->new_record;
	$type = loadRecord("SELECT type FROM job_types WHERE id='".addslashes($job['type'])."'");
	$house = loadRecord("SELECT * FROM houses WHERE id='".addslashes($job['house_id'])."'");
	if($type['type']==1 && !$house['internet']){
		$table->error(getResource('jobs.house.no.internet'));
	}
	if($type['type']==2 && !$house['tv']){
		$table->error(getResource('jobs.house.no.tv'));
	}
	$entrance = loadRecord("SELECT * FROM entrances WHERE house='".addslashes($job['house_id'])."' AND number='".addslashes($job['entrance'])."'");
	if($entrance){
		if($type['type']==1 && !$entrance['internet']){
			$table->error(getResource('jobs.entrance.no.internet'));
		}
		if($type['type']==2 && !$entrance['tv']){
			$table->error(getResource('jobs.entrance.no.tv'));
		}
	}
}

function after_job_post($table){
	global $db;
	$job = $table->current_record;
	if($job['state']!=1 || $table->isChanged('state')){
		$db->Execute(sprintf("UPDATE jobs j
			LEFT JOIN houses h ON h.street=j.street AND h.house=j.house 
			LEFT JOIN entrances e ON e.house=h.id AND e.number=j.entrance 
			LEFT JOIN job_types jt ON jt.id=j.type
			SET j.cost=IF(e.type=1, jt.fee_1, jt.fee_0),
			j.entrance_type=e.type WHERE j.id='%s'", $job['id']));
	}
}

function obrabotka($table){
	global $db, $oper;
	$new = $table->new_record;
	if($new['tech_zone_time'] < 0){
		$id = abs($new['tech_zone_time']);
		$query = $db->Execute("SELECT id FROM tech_zone_times WHERE tech_zone =  '$id'");
		$values;
		while($rezult = $db->Next($query)){
			$stamp = create_stamp();
			$values .= "('".$new['city']."', '" . $new['person'] . "','" . $new['date'] . "','" . $rezult['id'] . "','$stamp'),";
		}
		$values = substr($values, 0, strlen($values) - 1);
		$db->Execute("INSERT IGNORE INTO tech_zones_graph (city, person, date, tech_zone_time, stamp) VALUES $values");
		$table->abort = 1;
	}
}

function DeleteOldJob($table)
{
	global $db, $oper;
	
	$type = $table->new_record['type'];
	if($type == 3 || $type == 4 || $type == 5)
	{
		$house = $table->new_record['house_id'];
		$apartment = $table->new_record['apartment'];
		$db->Execute("DELETE FROM `jobs` WHERE ( house_id =  '$house' AND apartment =  '$apartment' AND (state =  '3' OR state =  '4')  AND  type = '$type')  ");
	}
}

$def = array();

if(isset($_GET['ecall'])){
	$eid = $_GET['ecall'];
	if($ecall = loadRecord(sprintf("SELECT * FROM ecalls WHERE id='%s'", addslashes($eid)))){
		if($ecall['assumed_house']){
			$def['house_id'] = $ecall['assumed_house'];
			if($house = loadRecord(sprintf("SELECT street FROM houses WHERE id='%s'", $ecall['assumed_house']))){
				$def['street'] = $house['street'];
			}
		}else{
			if($street = loadRecord(sprintf("SELECT id FROM streets WHERE name='%s'", $ecall['street']))){
				$def['street'] = $street['id'];
			}
		}
		$def['contact'] = $ecall['contact'];
		$def['house'] = $ecall['house'];
		$def['apartment'] = $ecall['apartment'];
		$phones = array();
		if($ecall['phone']){
			$phones[] = $ecall['phone'];
		}
		if($ecall['mobile']){
			$phones[] = $ecall['mobile'];
		}
		$def['phone'] = implode(", ", $phones);
	}
}

if(isset($_GET['rcall'])){
	$eid = $_GET['rcall'];
	if($request = loadRecord(sprintf("SELECT * FROM con_requests WHERE id='%s'", addslashes($eid)))){
		$def['city'] = $request['city'];
		if($request['house_id']){
			$def['house_id'] = $request['house_id'];
			if($house = loadRecord(sprintf("SELECT street FROM houses WHERE id='%s'", $request['house_id']))){
				$def['street'] = $house['street'];
			}
		}else{
			if($street = loadRecord(sprintf("SELECT id FROM streets WHERE name='%s'", $request['street_name']))){
				$def['street'] = $street['id'];
			}
		}
		$def['contact'] = $request['client'];
		$def['house'] = $request['house'];
		$def['apartment'] = $request['appartment'];
		$def['phone'] = $request['phone'];
		$jtype = loadRecord(sprintf("SELECT id FROM job_types WHERE type='%s' AND city='%s'", addslashes($request['type']), addslashes($request['city'])));
		$def['type'] = $jtype['id'];
	}
}

if(isset($_GET['get_contacts'])){
	$cid = $_GET['get_contacts'];
	if($arr = loadRecord(sprintf("SELECT concat(c.last_name, ' ', c.first_name, ' ', c.patronymic), c.phone, c.city, c.house_id, c.apartment, c.entrance, c.floor FROM clients c LEFT JOIN houses h ON h.id=c.house_id WHERE c.id='%s'", addslashes($cid)))){
		header("Content-Type: text/plain; charset=".$doc->charset);
		echo implode("|", $arr);
	}
	exit;
}

if(isset($_GET['get_existent'])){
	header("Content-Type: text/plain; charset=".$doc->charset);
	list($house_id, $apartment, $id) = explode("|", $_GET['get_existent']);
	$olds = loadRecords(sprintf("SELECT j.id, j.date, j.type, j.state, j.notes, jt.name
		FROM jobs j
		LEFT JOIN job_types jt ON jt.id=j.type
		WHERE j.house_id='%s' AND j.apartment='%s' AND j.id!='%s' AND j.state IN (0,3,4) ORDER BY j.id DESC", 
		addslashes($house_id), addslashes($apartment), addslashes($id)));
	foreach($olds as $old){
		$link = 'calendar.php?jbs_brief=0&jbs_id='.$old['id'].'&cdate='.substr($old['date'], 0, 10).'#jbs';
?>
	<span style="font-weight:bold; color:red;"></span>: <a href="<?=$link?>"> <?=$old['id']?> <?=$old['name']?> <?=substr($old['date'], 0, -3)?></a> - <b><?=getResource('jobs.state.'.$old['state'])?></b> (<?=$old['notes']?>)<br>
<?
	}
	exit;
}

function SynchHouse($table){
	global $db;
	$result = $db->Execute("SELECT street, house FROM houses WHERE id=" . $table->new_record['house_id']);
	$data = $db->Next($result);
	$table->new_record['street'] = $data['street'];
	$table->new_record['house'] = $data['house'];
}

function createWdistance($lat, $lng, $date){
	global $db;
	static $created;
	if(!$created){
		$created = true;
		$day = substr($date, 0, 10);
		//        
		$db->Execute('CREATE TEMPORARY TABLE wdistance ENGINE=Memory
		SELECT j.worker, min(pow(h.lat-'.($lat+0).', 2) + pow(h.lng-'.($lng+0).', 2)) dist
		FROM jobs j
		LEFT JOIN houses h ON h.id=j.house_id
		WHERE j.date BETWEEN "'.addslashes($day).'" AND ADDDATE("'.addslashes($day).'", INTERVAL 1 DAY)
		GROUP BY j.worker');
	}
}


function getWorkersByJob(){
	global $jobs, $db;
	createJcount();
//	$db->debug = 1;
	$job = $jobs->active_record;
	$jid = $job['id'];
	$worker = $job['worker'];
	createWdistance($job['lat'], $job['lng'], $job['date']);
	//   ,    .  (   )
	$day = substr($job['date'], 0, 10);
	$db->Execute('CREATE TEMPORARY TABLE in_graph ENGINE=Memory
		SELECT tzg.person
		FROM tech_zones_graph tzg
		INNER JOIN jtzt ON jtzt.tzt=tzg.tech_zone_time AND jtzt.job="'.$jid.'"
		WHERE tzg.date = "'.addslashes($day).'"
	');
	//    .  
	$db->Execute('CREATE TEMPORARY TABLE jc_pre ENGINE=Memory SELECT tzt FROM jtzt WHERE job="'.$jid.'"');
	//    ", -     ,    "
	$db->Execute('CREATE TEMPORARY TABLE jc ENGINE=Memory
		SELECT j.worker, count(DISTINCT j.id) as count, min(j.id) as min_job
		FROM jtzt x 
		INNER JOIN jc_pre y ON y.tzt=x.tzt
		LEFT JOIN jobs j ON j.id=x.job
		WHERE j.skip_graph=0
		GROUP BY j.worker
	');
	$arr = loadRecords('SELECT o.id, o.name AS value, 
		IF(ig.person IS NULL, 0, IF(IFNULL(jc.count,0)=0, 1, IF(jc.min_job="'.$jid.'", 1, 0) )) as ok,
		IFNULL(jc.count, 0) - IF(o.id="'.$worker.'", 1 , 0) as jcount,
		IFNULL(x.cnt, 0) as jcount2,
		IFNULL(d.dist, 0) as dist
		FROM staff o
		LEFT JOIN wdistance d ON d.worker=o.id
		LEFT JOIN ranks r ON r.id=o.rank
		LEFT JOIN in_graph ig ON ig.person=o.id
		LEFT JOIN jc ON jc.worker=o.id
		LEFT JOIN (
			SELECT worker, count(*) cnt FROM jobs 
			WHERE date BETWEEN "'.addslashes($day).'" AND ADDDATE("'.addslashes($day).'", INTERVAL 1 DAY)
			GROUP BY worker
		) x ON x.worker=o.id
		WHERE o.status=1 AND r.accept_jobs=1
		ORDER BY 3 desc, IFNULL(x.cnt, 0)=0 DESC, 6, o.name');
	$result = array();
	$separated = false;
	
	foreach($arr as $op){
		if(!isset($jcount)){
			$jcount = $op['jcount'];
		}
		if(!$op['ok'] && !$separated){
			$result[' '] = '--';
			$separated = true;
		}/*
		if($separated && ($op['jcount'] != $jcount)){
			$jcount = $op['jcount'];
			$result[str_repeat(' ', $jcount + 1)] = '--';
		}*/
		$result[$op['id']] = $op['value']. " (".$op['jcount2']. ")";
	}
	return $result;
}

class CountCellRenderer2 {
	function render($column, $record){
		$val = $record[$column->name];
        $class = $val == 0 ? 'green_lighted' : ($val > 1 ? 'red_lighted' : '');
		return sprintf("<td class='%s' align='right'>%s</td>", $class, $val);
	}
}

class CountCellRenderer {
	function render($column, $record){
		$val = $record[$column->name];
        $class = $val > 0 ? 'green_lighted' : ($val < 0 ? 'red_lighted' : '');
		return sprintf("<td class='%s' align='right'>%s</td>", $class, $val);
	}
}

class StateCellRenderer {
	function render($column, $record){
		return sprintf("<td class='state%s' style='width: 6.5em;'>%s</td>", $record['state'], $record['state_name']);
	}
}
$state_cell = new StateCellRenderer();

class FormatJobDate {
	function toString($value){
		return substr($value, 11, 5);
	}
	function fromString($str){
		global $calendar;
		sscanf($str, "%02d:%02d", $h, $m);
		$h = max(min(23, $h), 0);
		$m = max(min(59, $m), 0);
		return $calendar->getDate().' '.sprintf("%02d:%02d", $h, $m);
	}
}
$fJobDate = new FormatJobDate();

ob_start();
?><style><?
include BOOT.'calendar/calendar.css';
include BOOT.'calendar/job.css'
?></style><?
$doc->page->contents['css'] = ob_get_clean();

include_once("classes/context/include.php");
$beanFactory = new ArrayBeanFactory('boot/calendar/calendar.php');
$beanFactory->setParent($beans);

//$db->debug = 1;
$calendar = $beanFactory->getBean('jobsCalendar');
$calendar->process();

$doc->page->contents['calendar'] = $calendar->render();

$menu = new PNamedMenu($nil,BOOT.'calendar/menu.php');

// jtzt   " <->  ."
// ..      ,        
function createJtzt($date){
	global $db;
	static $created;
	if(!$created){
		$created = true;
		$day = substr($date, 0, 10);
		$db->Execute('
		CREATE TEMPORARY TABLE jtzt ENGINE=Memory
			SELECT 
				j.id as job,
				x.tzt as tzt
			FROM jobs j
			LEFT JOIN houses h ON h.house=j.house AND h.street=j.street
			LEFT JOIN districts d ON d.id=h.district
			LEFT JOIN (
				SELECT v.*, tzt.from_time, tzt.to_time
				FROM tech_zones_view v 
				LEFT JOIN tech_zone_times tzt ON tzt.id=v.tzt
			) x ON x.job_type=j.type AND h.district=x.district AND CAST(j.date AS TIME) >= x.from_time AND CAST(j.date AS TIME) < x.to_time
			WHERE j.date BETWEEN "'.addslashes($day).'" AND ADDDATE("'.addslashes($day).'", INTERVAL 1 DAY)');
		$db->Execute('ALTER TABLE jtzt ADD KEY(job)');
	}
}

createJtzt($calendar->getDate());

$db->Execute('CREATE TEMPORARY TABLE je_count ENGINE=Memory SELECT job, Count(*) as coun FROM jobs_extras GROUP BY job');
$db->Execute('ALTER TABLE je_count ADD KEY(job)');

$jobs = new PTable($db,BOOT.'jobs/table.php');
$jobs->readonly = !$oper->system_access['jobs'];
addCityPolicy($jobs, 'j.city');

if($calendar->isActive()){
	$day = $GLOBALS['calendar']->getDate();
	$jobs->filters['calendar'] = 'j.date BETWEEN "'.addslashes($day).'" AND ADDDATE("'.addslashes($day).'", INTERVAL 1 DAY)';
	$doc->page->contents['_menu'] = $menu;
}else{
	$menu->selected = 'list';
	$period = new PPeriod($nil,BOOT.'jobs/period-form.php');
	if($period->active){
		if($from = $period->getFrom()){
			$jobs->filters['from'] = sprintf("j.date >= '%s'", $from);
		}
		if($to = $period->getTo()){
			$jobs->filters['to'] = sprintf("j.date <= '%s'", $to);
		}
	}
}


// -        .
function createJcount(){
	global $db;
	static $created;
	if(!$created){
		$created = true;
		$db->Execute('
		CREATE TEMPORARY TABLE jcount ENGINE=Memory
		SELECT x.tzt id, count(j.id) as count, j.worker, min(j.id) as min_job
		FROM jtzt x 
		LEFT JOIN jobs j ON j.id=x.job
		WHERE j.state!=3 AND j.skip_graph=0 AND x.job IS NOT NULL
		GROUP BY x.tzt, j.worker');
	}
}

function createPrompt($house, $date, $type){
	global $db;
	//$db->debug = 1;
	createJtzt($date);
	createJcount();
	createWdistance($house['lat'], $house['lng'], $date);
	// OR jc.min_job='".$job['id']."'
	$day = substr($date, 0, 10);
	$query = "SELECT tzt.time_name, g.person, s.name, IFNULL(d.dist, 0) dist, IFNULL(x.cnt,0) cnt
		FROM tech_zones_graph g
		LEFT JOIN staff s ON s.id=g.person
		LEFT JOIN wdistance d ON d.worker=g.person
		LEFT JOIN jcount jc ON jc.id=g.tech_zone_time AND jc.worker=g.person
		LEFT JOIN tech_zone_times tzt ON tzt.id=g.tech_zone_time
		LEFT JOIN (
			SELECT worker, count(*) cnt FROM jobs 
			WHERE date BETWEEN '".addslashes($day)."' AND ADDDATE('".addslashes($day)."', INTERVAL 1 DAY)
			GROUP BY worker
		) x ON x.worker=g.person
		WHERE g.date='".substr($date, 0, 10)."'
			AND (IFNULL(jc.count,0)=0)
			AND g.tech_zone_time IN (SELECT tzt FROM tech_zones_view WHERE district='".$house['district']."' AND job_type='".$type."')
		ORDER BY 1, 4, 3";
	$records = loadRecords($query);
	$options = array();
	foreach ($records as $opt) {
		if($t != $opt['time_name']){
			$t = $opt['time_name'];
			$options[] = '["", "--"]';
		}
		$time = substr($opt['time_name'], 0, 5);
		$options[] = '["'.$opt['person'].'*'.$time.'", "'.$time.' - '.htmlspecialchars($opt['name']).' ('.$opt['cnt'].')"]';
    }
	return $options;
}

switch($menu->selected)
{
    case 'list':
		//$db->debug = 1;
	    $d = $calendar->getDateTime();
        $doc->page->contents['jobs'] = new PMyAccess($jobs,array(
			'title'=>getResource('jobs.title').($calendar->isActive() ? ': '.strftime("%A", $d).' '.date("j", $d).' '.getResource('month.of.'.date("m", $d)) : ''),
			'help'=>HELP_PATH.'//',
			'icon'=>HREF.'images/jobs.gif',
			'grid_boot'=>forceCity(BOOT.'jobs/grid'.($calendar->isActive() ? '' : '_full').'.php'),
			'form_boot'=>forceCity(BOOT.'jobs/form'.($calendar->isActive() ? '' : '_full').'.php'),
			'tool'=>$calendar->isActive() ? NULL : $period,
		));
//		$alog_tool = new ActionLoggerTool($jobs);
//		$doc->page->contents['jobs']->tool = $alog_tool;
//		$doc->page->contents['jobs_alog'] = $alog_tool->get_log_renderer();
		
		if($jobs->isOn()){
			$job = $jobs->active_record;
			$jmenu = new PNamedMenu($nil,BOOT.'jobs/menu.php');
			$doc->page->contents['jmenu'] = $jmenu;
			if(!$jmenu->selected){
				$jmenu->selected = 'ex';
			}
			switch($jmenu->selected){
				case 'ex':
					loadStrings(BOOT.'calendar/jobs_extras/strings.txt');
					include_once('classes/cells/HighlightCellRenderer.php');
					$ticket_cell = new HighlightCellRenderer('ticket_state', array('2'=>'green_lighted'));
					//$db->debug = 1;
					$jet = new PTable($db,BOOT.'calendar/jobs_extras/table.php');
					$jet->readonly = !$oper->system_access['jobs'];
					$doc->page->contents['jet'] = new PMyAccess($jet,array(
						'title'=>getResource('jet.title'),
						'icon'=>HREF.'images/jobs.gif',
						'grid_boot'=>BOOT.'calendar/jobs_extras/grid.php',
						'form_boot'=>BOOT.'calendar/jobs_extras/form.php',
					));
					$params = array(
						'amount'=>$jet->getAggregate('cost'),
						'fio'=>$job['client'],
						'address'=>$job['street_name'].' '.$job['house'].($job['apartment'] ? ', . '.$job['apartment'] : ''),
						'contract'=>$job['contract'],
						'target_name'=>getTrimOption('PAY_ORDER_TARGET_NAME', $job['city']),
						'target_acc'=>getTrimOption('PAY_ORDER_TARGET_ACCOUNT', $job['city']),
						'target_code'=>getTrimOption('PAY_ORDER_TARGET_CODE', $job['city']),
						'bank_name'=>getTrimOption('PAY_ORDER_BANK_NAME', $job['city']),
						'bank_mfo'=>getTrimOption('PAY_ORDER_BANK_MFO', $job['city']),
					);
					$doc->page->contents['ex_order'] = '<a href="order.php?'.implode('&', _Pair($params, 'htmlspecialchars')).'">'.getResource('je.make.order').'</a>';
					break;
				case 'hi':
					loadStrings(BOOT.'action_log/strings.txt');
					$action_log = new PTable($db, BOOT.'action_log/table.php');
					$action_log->filters['by_item'] = '(alo.name="jobs" AND l.item_id="'.$jobs->active_record['id'].'")';
					$doc->page->contents['history'] =  new PMyAccess($action_log, array(
						'title'=>getResource('action.log.title'),
						'icon'=>HREF.'images/log.gif',
						'grid_boot'=>BOOT.'action_log/grid_alt.php',
					));
					break;
				case 'no':
					loadStrings(BOOT.'jobs/notes/strings.txt');
					$notes = new PTable($db,BOOT.'jobs/notes/table.php');
					$notes->readonly = !$oper->system_access['jobs_notes'];
					$doc->page->contents['notes'] = new PMyAccess($notes, array(
						'title'=>getResource('jobs.notes.title'),
						'icon'=>HREF.'images/rules.gif',
						'grid_boot'=>BOOT.'jobs/notes/grid.php',
						'form_boot'=>BOOT.'jobs/notes/form.php',
					));
					break;
			}
		}
        break;
    case 'graph':
    	createJcount();
        loadStrings(BOOT.'calendar/tech_zones_graph/strings.txt');
        $tech_zones_graph = new PTable($db,BOOT.'calendar/tech_zones_graph/table.php');
        if($calendar->isActive()){
			$tech_zones_graph->filters['calendar'] = sprintf('DATE_FORMAT(date, "%%Y-%%m-%%d")="%s"', $GLOBALS['calendar']->getDate());
		}
        $tech_zones_graph->readonly = !$oper->system_access['jobs'];
		addCityPolicy($tech_zones_graph, 'tzg.city');
        $doc->page->contents['tech_zones_graph'] = new PMyAccess($tech_zones_graph,array(
                'title'=>getResource('tech_zones_graph.title'),
                'icon'=>HREF.'images/streets.gif',
                'grid_boot'=>forceCity(BOOT.'calendar/tech_zones_graph/grid.php'),
                'form_boot'=>forceCity(BOOT.'calendar/tech_zones_graph/form.php'),
        ));
		if(!$doc->page->contents['tech_zones_graph']->brief){
		ob_start();
		?>
		<script>
		
		var f = $("form[name=<?=$tech_zones_graph->nick?>]");
		$("[name=city]", f).change(function(){
			lookup_worker.src = '?lookup=worker&target=lookup_worker&city=' + this.value;
			lookup_worker.loaded = false;
			lookup_worker.loadFirst();
		
			lookup_tzt.src = '?lookup=tzt&target=lookup_tzt&city=' + this.value;
			lookup_tzt.loaded = false;
			lookup_tzt.loadFirst();
		}).change();
		
		</script>
		<?
		$doc->page->contents['tztjs'] .= ob_get_clean();
		}
        break;
    case 'nnm':
        loadStrings(BOOT.'calendar/nnm/strings.txt');
		$db->Execute('
			CREATE TEMPORARY TABLE jcount ENGINE=Memory
			SELECT x.tzt id, count(j.id) as count
			FROM jobs j
			LEFT JOIN jtzt x ON x.job=j.id
			WHERE j.state!=3 AND j.skip_graph=0 AND x.job IS NOT NULL AND DATE_FORMAT(j.date, "%Y-%m-%d")="' .$GLOBALS['calendar']->getDate(). '"
			GROUP BY x.tzt');
		$tech_zones_graph = new PTable($db,BOOT.'calendar/nnm/table.php');
        $tech_zones_graph->readonly = !$oper->system_access['jobs'];
        switch($_GET['lookup']){
                case 'operator':	lookup('operator');
        }
        $doc->page->contents['tech_zones_graph'] = new PMyAccess($tech_zones_graph,array(
                'title'=>getResource('nnm.title'),
                'icon'=>HREF.'images/streets.gif',
                'grid_boot'=>BOOT.'calendar/nnm/grid.php',
                'form_boot'=>BOOT.'calendar/nnm/form.php',
        ));
        break;
}
        /*
$d = $calendar->getDateTime();
$doc->page->contents['jobs'] = new PMyAccess($jobs,array(
	'title'=>getResource('jobs.title').($calendar->isActive() ? ': '.strftime("%A", $d).' '.date("j", $d).' '.getResource('month.of.'.date("m", $d)) : ''),
	'icon'=>HREF.'images/jobs.gif',
	'grid_boot'=>BOOT.'jobs/grid'.($calendar->isActive() ? '' : '_full').'.php',
	'form_boot'=>BOOT.'jobs/form'.($calendar->isActive() ? '' : '_full').'.php',
));
*/
$webout = $beanFactory->getBean('appender.webout');
$doc->page->contents['hz'] = $webout->render();
if(!$doc->page->contents['jobs']->brief){
ob_start();
?>
<style>
.state1 {background-color:#bfb;}
.state2 {background-color:#fbb;}
.state3 {background-color:#ccc;}
.state4 {background-color:#9af;}
.stateSelect {width: 100%; border: 1px solid #888;}
.workerSelect {border: 1px solid #888;}
</style>
<script language="JavaScript">

var f = $("form[name=<?=$jobs->nick?>]");
$("[name=city]", f).change(function(){
	lookup_house.src = '?lookup=house&target=lookup_house&city=' + this.value;
	lookup_house.loaded = false;
	lookup_house.loadFirst();
	
	lookup_client.src = '?lookup=client&target=lookup_client&city=' + this.value;
	lookup_client.loaded = false;
	lookup_client.loadFirst();
	
	lookup_fclient.src = '?lookup=client&target=lookup_fclient&city=' + this.value;
	lookup_fclient.loaded = false;
	lookup_fclient.loadFirst();

	lookup_job_type.src = '?lookup=job_type&target=lookup_job_type&city=' + this.value;
	lookup_job_type.loaded = false;
	lookup_job_type.loadFirst();
}).change();


var jtag;
function track_job(){
	var new_tag = $("[name='date[year]']", f).val() + "-" +
		$("[name='date[month]']", f).val() + "-" +
		$("[name='date[day]']", f).val() + "-" +
		$("[name='house_id']", f).val() + "-" +
		$("[name='type']", f).val();
	if(jtag != new_tag){
		jtag = new_tag;
		load_worker_candidates(jtag);
	}
}
setInterval(track_job, 500);

function load_worker_candidates(key){
	$.getJSON('calendar.php', 'worker_candidates=' + key, function(data){
		var candi = $("[id=worker_candidates]", f);
		candi.find('option').remove();
		candi.append(new Option(":", ""));
		$.each(data, function(k, v){
			candi.append(new Option(v[1], v[0]));
		});
	});
}

$("[id=worker_candidates]", f).change(function(){
	var cand = this.value.split("*");
	if(cand.length==2){
		this.form.elements["date[time]"].value = cand[1];
		this.form.elements["worker"].value = cand[0];
	}
});

var colors = ['#fff', '#bfb', '#fbb', '#ccc', '#9af'];

function changeSelectColor(e){
	var targ;
	if (!e) var e = window.event;
	if (e.target) targ = e.target;
	else if (e.srcElement) targ = e.srcElement;
	if (targ.nodeType == 3) // defeat Safari bug
		targ = targ.parentNode;
	var sel = targ;
	var opt;
	var opts = sel.options;
	for(var i=0; i < opts.length; i++){
		opt = opts[i];
		if(opt.value == sel.value){
			sel.style.backgroundColor = opt.style.backgroundColor;
			break;
		}
	}
}

var jForm = document.forms['jbs'];
var sel = jForm.elements['state'];
sel.onchange = changeSelectColor;
sel.className = 'stateSelect';
var opts = sel.options;
for(var i=0; i < opts.length; i++){
	opt = opts[i];
	opt.style.backgroundColor = colors[opt.value];
	if(opt.value == sel.value){
		sel.style.backgroundColor = colors[opt.value];
	}
}

//  "" 
var selWorker = jForm.elements['worker'];
selWorker.onchange = changeSelectColor;
selWorker.className = 'workerSelect';
var opts = selWorker.options;
//var wColor = '#bfb';
var wColors = ['#bfb', '#fcc', '#f88', '#f55', '#c00'];
var w = 0;
for(var i=0; i < opts.length; i++){
	opt = opts[i];
	opt.style.backgroundColor = opt.value > 0 ? wColors[w] : '#fff';
	if(opt.value == selWorker.value){
		selWorker.style.backgroundColor = opt.style.backgroundColor;
	}
	if(opt.text=='--'){
		w++;
		if(w >= wColors.length){
			w = wColors.length - 1;
		}
	}
}

var found_by_memos = [<?=implode(",", array_map(function($a){return $a['id'];}, loadRecords("SELECT id FROM jobs_finders WHERE show_memo=1")))?>];

function changeFoundBy(){
	var cliFoundBy = jForm.elements['found_by_client'].parentNode.parentNode;
	var memFoundBy = jForm.elements['found_by_memo'].parentNode.parentNode;
	var v = selFoundBy.value;
	if(v==5){
		cliFoundBy.style.display = '';
	}else{
		cliFoundBy.style.display = 'none';
	}
	if($.inArray(parseInt(v), found_by_memos)>=0){
		memFoundBy.style.display = '';
	}else{
		memFoundBy.style.display = 'none';
	}
}

function changeUsedBefore(){
	var memUsedBefore = jForm.elements['used_before_memo'].parentNode.parentNode;
	if(selUsedBefore.value==1){
		memUsedBefore.style.display = '';
	}else{
		memUsedBefore.style.display = 'none';
	}
}

var selFoundBy = jForm.elements['found_by'];
selFoundBy.onchange = changeFoundBy;
changeFoundBy();

var selUsedBefore = jForm.elements['used_before'];
selUsedBefore.onchange = changeUsedBefore;
changeUsedBefore();

var contract = jForm.elements['contract'];
var disabler = document.createElement("INPUT");
disabler.type = "checkbox";
disabler.onclick = function(e){
	contract.disabled = !disabler.checked;
};
disabler.onclick();
contract.parentNode.appendChild(disabler);

</script>
<script type="text/javascript" src="scripts/Ajaxer.js"></script>
<script type="text/javascript" src="scripts/job-client-tracker.js"></script>
<script type="text/javascript" src="scripts/job-existense-tracker.js"></script>
<script type="text/javascript">
var cliTracker = new JobClientTracker('jbs');
var exiTracker = new JobExistenseTracker('jbs', document.getElementById('existent'), '<?=$jobs->active_record['id']?>');
exiTracker.track();
</script>
<?
$doc->page->contents['all'] = ob_get_clean();
}
echo $doc->Paint();
?>