<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:16 $
$Revision: 1.14 $
*/
include_once('includes/global.php');
include_once('includes/lookups.php');
include_once('classes/SwitchTool.php');
include_once('classes/ComboTool.php');
loadStrings(BOOT.'calls/strings.txt');

$doc->title .= ' :: '.getResource('client.calls.title');

required_access('calls');
switch($_GET['lookup']){
	case 'client':	lookup('client');
}

if(isset($_GET['check_lang'])){
	$clid = addslashes($_GET['check_lang']);
	echo loadValue("SELECT lang FROM clients WHERE id='$clid'") + 0;
	exit;
}

//$db->debug = 1;

include_once('classes/period.php');
include(BOOT.'period/form.php');
$obj['nick'] = 'clsper';
$obj['active'] = 0;
$period = new PPeriod($nil, $obj);

$type_values = array(
	''=>getResource('client.calls.type').':',
	'1'=>getResource('client.calls.type.1'),
	'2'=>getResource('client.calls.type.2'),
	'4'=>getResource('client.calls.type.4'),
	'5'=>getResource('client.calls.type.5'),
	'6'=>getResource('client.calls.type.6'),
	'3'=>getResource('client.calls.type.3'),
	'7'=>getResource('client.calls.type.7'),
	'8'=>getResource('client.calls.type.8'),
	'9'=>getResource('client.calls.type.9'),
	'10'=>getResource('client.calls.type.10'),
);

$umenu = new PNamedMenu($nil,BOOT.'calls/menu.php');
$doc->page->contents['calls_up_menu'] = $umenu;
switch($umenu->selected){
	case 'ca':
		$calls = new PTable($db,BOOT.'calls/table.php');
		$calls->readonly = !$oper->system_access['calls'];
		$period->commented = false;
		if($period->active){
			if($from = $period->getFrom()){
				$calls->filters['from'] = sprintf("st.created >= '%s'", $from);
			}
			if($to = $period->getTo()){
				$calls->filters['to'] = sprintf("st.created <= '%s'", $to);
			}
		}
		$type_tool = new SwitchTool('ccct', $type_values, '', true);
		if($force_type = $type_tool->value){
			$calls->filters['type'] = sprintf("cc.type = '%s'", addslashes($force_type));
		}
		addCityPolicy($calls, 'c.city');
		
		$doc->page->contents['calls'] = new PMyAccess($calls, array(
			'title'=>getResource('client.calls.title'),
			'help'=>HELP_PATH.'//',
			'icon'=>HREF.'images/calls.gif',
			'grid_boot'=>forceCity(BOOT.'calls/grid.php'),
			'form_boot'=>BOOT.'calls/form.php',
			'tool'=>new ComboTool(array(
				new ComboToolCell($type_tool),
				new ComboToolCell($period),
			)),
		));
		$doc->page->contents['calls']->grid->mode = $force_type ? $force_type : 'any';
		if($force_type){
			$doc->page->contents['calls']->form->fields['type']->type = 'hidden';
			$doc->page->contents['calls']->form->fields['type']->default = $force_type;
			$doc->page->contents['calls']->form->fields['type']->value = $force_type;
		}
		
		if(!$doc->page->contents['calls']->brief){
			ob_start();
			?>
			<script language="JavaScript" src="scripts/call-tracker.js"></script>
			<script language="JavaScript">
			var f = document.forms['ccls'];
			CallTypeTracker(f);
			
			$("[name=client]", f).change(function(){
				$.get("<?=$_SERVER['PHP_SELF']?>?check_lang=" + this.value, function(lang){
					$("[name=client_lang]", f).
						val(0).
						attr("required", lang==0 ? 1 : 0).
						closest("tr").toggle(lang==0);
				});
			}).change();
			
			lookup_client.onchange = function(){
				$("[name=client]", f).trigger('change');
			}
			</script>
			<?
			$doc->page->contents['all'] = ob_get_clean();
		}
		break;
	case 'st':
		$group_by_tool = new SwitchTool('ergt', array(
			'1'=>getResource('client.calls.stats.grouper.1'),
			'2'=>getResource('client.calls.stats.grouper.2'),
			'3'=>getResource('client.calls.stats.grouper.3'),
		), '1', true);
		$group_by_values = array(
			'1'=>'DATE_FORMAT(IFNULL(s.modified, s.created), "%Y-%m-%d")',
			'2'=>'DATE_FORMAT(FROM_UNIXTIME(FLOOR((UNIX_TIMESTAMP(IFNULL(s.modified, s.created)) - 338400)/604800) * 604800 + 345600), "%Y-%m-%d+")',
			'3'=>'DATE_FORMAT(IFNULL(s.modified, s.created), "%Y-%m")',
		);
		$grouper = $group_by_values[$group_by_tool->value];
		$db->Execute("CREATE TEMPORARY TABLE calls_stats ENGINE=Memory
			SELECT
			MAX(cc.id) id,
			count(cc.id) as amount,
			c.city,
			cc.type,
			$grouper as date,
			SUM(IF(cc.status=1, 1, 0)) status_1,
			SUM(IF(cc.status=2, 1, 0)) status_2,
			SUM(IF(cc.status=3, 1, 0)) status_3,
			SUM(IF(cc.status=4, 1, 0)) status_4,
			SUM(IF(cc.status=5, 1, 0)) status_5,
			SUM(IF(cc.refuse_reason=1, 1, 0)) refuse_1,
			SUM(IF(cc.refuse_reason=2, 1, 0)) refuse_2,
			SUM(IF(cc.refuse_reason=3, 1, 0)) refuse_3,
			SUM(IF(cc.refuse_reason=4, 1, 0)) refuse_4,
			SUM(IF(cc.refuse_reason=5, 1, 0)) refuse_5
			FROM client_calls cc
			LEFT JOIN clients c ON c.id=cc.client
			LEFT JOIN stamps s ON s.id=cc.stamp
			GROUP BY c.city, cc.type, $grouper");
		$stats = new PTable($db, BOOT.'calls/stats/table.php');
		$type_values = my_merge(array($type_values, array(
			' '=>'--',
			'o5'=>getResource('client.calls.type.5').' / '.getResource('client.calls.refuse.reasons'),
			'o6'=>getResource('client.calls.type.6').' / '.getResource('client.calls.refuse.reasons'),
		)));
		$type_tool = new SwitchTool('ccct', $type_values, '', true);
		$grid_mode = 'status';
		if($force_type = trim($type_tool->value)){
			if(substr($force_type, 0, 1)=='o'){
				$force_type = substr($force_type, 1);
				$grid_mode = 'refuse';
			}
			$stats->filters['type'] = sprintf("cs.type = '%s'", addslashes($force_type));
		}
		$doc->page->contents['stats'] = new PMyAccess($stats, array(
			'title'=>getResource('client.calls.stats.title'),
			'icon'=>HREF.'images/calls.gif',
			'grid_boot'=>BOOT.'calls/stats/grid.php',
			'tool'=>new ComboTool(array(
				new ComboToolCell($group_by_tool),
				new ComboToolCell($type_tool),
			)),
		));
		$doc->page->contents['stats']->grid->mode = $grid_mode;
		$doc->page->contents['stats']->grid->columns['date']->title = getResource('client.calls.stats.grouper.'.$group_by_tool->value);
		break;
}
echo $doc->Paint();
?>