<?
class DBFImport {

var $sum;
var $info;

function DBFImport($finder, $sum, $info = array()){
	$this->finder = $finder;
	$this->sum = $sum;
	$this->info = $info;
}

function trans($str){
	return iconv('cp866', 'cp1251', $str);
}

function getInfo($row){
	$result = array();
	foreach($this->info as $field){
		$result[] = $field.': '.trim($row[$field]);
	}
	return implode(", ", $result);
}

function bySize($f1, $f2){
	return $f2[1] - $f1[1];
}

function openArch($file){
	$this->extracted = '';
	exec('unrar l '.$file, $out, $err);
	$candidates = array();
	foreach($out as $line){
		if(preg_match("|\s*([\w.]+)\s+(\d+)\s+\d+\s+\d+%.+|", $line, $m)){
			$candidates[] = array($m[1], $m[2]);
		}
	}
	if(!empty($candidates)){
		usort($candidates, array($this, 'bySize'));
		$chosen = '';
		foreach($candidates as $cand){
			if($cand[0][4]=='1'){
				$chosen = $cand[0];
				break;
			}
		}
		if(!$chosen){
			$chosen = $candidates[0][0];
		}
		exec('unrar x -o+ '.$file.' '.$chosen.' '.TMP_DIR.'/', $o, $err);
		if(strstr(strtolower(implode("\n", $o)), 'all ok')){
			$this->extracted = TMP_DIR.'/'.$chosen;
			return $this->extracted;
		}
	}
	return $file;
}

function closeArch(){
	if($this->extracted){
		unlink($this->extracted);
	};
}


function process($fileInfo){
	$items = array();
	$fileName = $this->openArch($fileInfo['tmp_name']);
	$dbf = dbase_open($fileName, 0);
	if ($dbf) {
		$record_numbers = dbase_numrecords($dbf);
		for ($i = 1; $i <= $record_numbers; $i++) {
			$row = dbase_get_record_with_names($dbf, $i);
			$row = array_map(array($this, 'trans'), $row);
			$sum = intval(strval($row[$this->sum] * 100));
			list($valid, $account) = $this->finder->find($row);
			$items[] = array(
				'num'=>$i,
				'account'=>$account,
				'sum'=>$sum,
				'info'=>$this->getInfo($row),
				'valid'=>$valid,
			);
		}
	}
	dbase_close($dbf);
	$this->closeArch();
	return array(
		'head'=>$fileInfo['name'],
		'items'=>$items,
	);
}

}

class ClientComboFinder {

var $members;

function ClientComboFinder($members){
	$this->members = $members;
}

function find($row){
	$last = '';
	foreach($this->members as $m){
		list($valid, $account) = $f = $m->find($row);
		if($valid){
			return $f;
		}
		if($account){
			$last = $f;
		}
	}
	return is_array($last) ? $last : array(false, '');
}

}

class ClientContractFinder {

var $contractField;
var $validator;

function ClientContractFinder($contractField, $validator=''){
	$this->contractField = $contractField;
	$this->validator = $validator;
}

function find($row){
	$contract = trim($row[$this->contractField]);
	if($r = loadRecord(sprintf("SELECT c.id, c.account, s.name as street, h.house as house, c.apartment
		FROM clients c
		LEFT JOIN houses h ON h.id=c.house_id
		LEFT JOIN streets s ON s.id=h.street
		WHERE c.contract='%s'", addslashes($contract)))){
		$valid = $this->validator ? $this->validator->validate($row, $r['street'], $r['house'], $r['apartment']) : true;
		return array($valid, $r['account']);
	}else{
		return array(false, '');
	}
}

}

class TVAbonCodeFinder {

var $codeField;

function TVAbonCodeFinder($codeField, $validator=''){
	$this->codeField = $codeField;
	$this->validator = $validator;
}

/*
ABCOUNT 09ssshhhHqqqQ # 09 -  ; sss -  ; hhh -  ; H -   (0 -  , 1 - , 2 -  ...); 
qqq -  ; Q -     (0 - , 1 -  ...)
*/
function find($row){
	$code = trim($row[$this->codeField]);
	$letters = '';
	$street_code = substr($code, 2, 3) + 0;
	$house_num   = substr($code, 5, 3) + 0;
	$house_let   = substr($code, 8, 1) + 0;
	$let = $house_let > 0 ? $letters[$house_let - 1] : '';
	$house = $house_num.$let;
	$apartment   = substr($code, 9, 3) + 0;
	$q = "SELECT c.id, c.account, s.name as street, h.house as house, c.apartment
		FROM clients c
		LEFT JOIN houses h ON h.id=c.house_id
		LEFT JOIN streets s ON s.id=h.street
		WHERE s.code='$street_code' AND h.house='$house' AND c.apartment='$apartment'
		LIMIT 1";
	if($r = loadRecord($q)){
		$valid = $this->validator ? $this->validator->validate($row, $r['street'], $r['house'], $r['apartment']) : true;
		return array($valid, $r['account']);
	}else{
		return array(false, '');
	}
}

}

?>