<?
class PravexImport2 {

function process($fileInfo){
	$lines = file($fileInfo['tmp_name']);
	$items = array();
	$borders = array();
	$has_prev = false;
	foreach($lines as $line){
		if($line[0]=='-' || $line[0]=='.' || !trim($line)){
			$has_prev = false;
			continue;
		}
		if(preg_match("'([^\|]+\|[^\|]+){7,7}'", $line, $mat)){
			$borders = array();
			$begin = 0;
			while(($end = strpos($line, '|', $begin))!==false){
				$borders[] = $end;
				$begin = $end + 1;
			}
			//print_r ($borders)."<br><br><br>";
		}elseif(!empty($borders)){
			$pline = str_pad($line, 300);
			list($num, $doc_num, $mfo, $account_num, $id_code, $debet, $credit, $text) = $this->breakUp($pline, $borders);
			if(is_numeric(trim($num))){
				$items[] = array(
					'num'=>trim($num),
					'doc_num'=>trim($doc_num),
					'mfo'=>trim($mfo),
					'account_num'=>trim($account_num),
					'id_code'=>trim($id_code),
					'debet'=>trim($debet),
					'credit'=>trim($credit),
					'text'=>trim($text),
					'info'=>$line,
				);
				$has_prev = true;
			}elseif($has_prev){
				$item = $items[count($items)-1];
				$item['text'] .= trim($text);
				$item['info'] .= $line;
				$items[count($items)-1] = $item;
			}
		}
	}
	return array(
		'head'=>sprintf("%s\n%s\n%s", trim($lines[1]), trim($lines[2]), trim($lines[3])),
		'items'=>$this->recognize($items)
	);
}

function recognize($items){
	global $db;
	$result = array();
	foreach($items as $k=>$item){
		$sum = intval(strval($item['credit'] * 100));
		if($sum > 0){
			$account = 0;
			$valid = 0;
			$contract = preg_match("'[^\d]*(\d{8,9})[^\d]*'s",$item['text'], $mat) ? $mat[1] : '';
			if($contract){
				$res = $db->Execute(sprintf("SELECT id, account FROM clients WHERE contract='%s'", addslashes($contract)));
				if($arr = $db->Next($res)){
					$account = $arr['account'];
					$valid = 1;
				}
			}
			$result[] = array(
				'num'=>$item['num'],
				'account'=>$account,
				'sum'=>$sum,
				'info'=>preg_replace("'\s+\n'","\n",$item['info']),
				'valid'=>$valid,
			);
		}
	}
	return $result;
}

function match($s1,$s2){
	$m = 0;
	$len = min(strlen($s1),strlen($s2));
	for($i=0;$i<$len;$i++){
		if($s1[$i]==$s2[$i]){
			$m++;
		}
	}
	return $m;
}

function trans($str){
	static $from = array("\xa0",
	'P','E','T','O','A','H','K','X','','B','M','I', 
	'p','e','t','o','a','h','k','x','','b','m','i');
	static $to = array("\x20",
	'','','','','','','','','','','','', 
	'','','','','','','','','','','','');
	return str_replace($from, $to, $str);
}

function breakUp($line, $borders){
	$result = array();
	$begin = 0;
	foreach($borders as $end){
		$result[] = substr($line, $begin, $end - $begin);
		$begin = $end;
	}
	$result[] = substr($line, $begin);
	return $result;
}

}
?>