<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class IptAccountingDriver {

var $logger;
var $iptAccounter;
var $blockBuilder;
var $allowBuilder;

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('ipt.accounting.driver');
}

function setIptAccounter($obj){
	$this->iptAccounter = $obj;
}

function setBlockBuilder($obj){
	$this->blockBuilder = $obj;
}

function setAllowBuilder($obj){
	$this->allowBuilder = $obj;
}

function readCounters(){
	if(isset($this->iptAccounter)){
		$this->iptAccounter->readCounters();
	}
}

function loadCounters(){
	if(isset($this->iptAccounter)){
		$this->iptAccounter->loadCounters();
	}
}

function getCounter($ip){
	return isset($this->iptAccounter) ? $this->iptAccounter->getCounter($ip) : 0;
}

function beginSetup(){
	$this->logger->debug("begin setup");
	if(isset($this->blockBuilder)){
		$this->blockBuilder->beginSetup();
	}
	if(isset($this->allowBuilder)){
		$this->allowBuilder->beginSetup();
	}
}

function setCounter($ip, $block){
	if($block){
		if(isset($this->blockBuilder)){
			$this->blockBuilder->add($ip);
		}
	}else{
		if(isset($this->allowBuilder)){
			$this->allowBuilder->add($ip);
		}
	}
}

function finishSetup(){
	$this->logger->debug("finish setup");
	if(isset($this->blockBuilder)){
		$this->blockBuilder->finishSetup();
	}
	if(isset($this->allowBuilder)){
		$this->allowBuilder->finishSetup();
	}
}

}
?>