<?
include_once(dirname(__FILE__).'/../tools/IpAddress.php');

class SplitAccountingDriverAlt {

var $beanName;
var $drivers;
var $calculator;

function setBeanName($str){
	$this->beanName = $str;
}

function setCalculator($obj){
	$this->calculator = $obj;
}

function setDrivers($arr){
	$this->drivers = array();
	foreach($arr as $d){
		$scope = array();
		foreach($d['scope'] as $net){
			$scope[] = new SlashedIpAddress($net);
		}
		$d['scope'] = $scope;
		$this->drivers[] = $d;
	}
}

function readCounters(){
	foreach($this->drivers as $d){
		$d['driver']->readCounters();
	}
}

function loadCounters(){
	foreach($this->drivers as $d){
		$d['driver']->loadCounters();
	}
}

function isInScope($ipAddr, $scope){
	foreach($scope as $netAddr){
		if($netAddr->contains($ipAddr)){
			return true;
		}
	}
	return false;
}

function getCounter($ip){
	$ipAddr = new SlashedIpAddress($ip);
	$bytes = 0;
	foreach($this->drivers as $d){
		if($this->isInScope($ipAddr, $d['scope'])){
			$b = $d['driver']->getCounter($ip);
			$bytes = $this->calculator->add($bytes, $b);
		}
	}
	return $bytes;
}

function beginSetup(){
	foreach($this->drivers as $d){
		$d['driver']->beginSetup();
	}
}

function setCounter($ip, $block){
	$ipAddr = new SlashedIpAddress($ip);
	foreach($this->drivers as $d){
		if($this->isInScope($ipAddr, $d['scope'])){
			$d['driver']->setCounter($ip, $block);
		}
	}
}

function finishSetup(){
	foreach($this->drivers as $d){
		$d['driver']->finishSetup();
	}
}

}
?>