<?php

/**
 * @author tregub
 * @copyright 2010
 */

/**
 * snmp      snmp    
 *
 * @package Lanet
 * @author tregub
 * @copyright 2010
 * @version 1
 * @access public
 */
class snmp
{
	private $_ip;
	private $_port;
	private $son;
	private $_security = "security";
	
  /**
   * snmp::get()  snmpget    
   *
   * @param mixed $Object   
   * @return false   ,  
   */
	private function get($Object)
	{
		return @snmpget($this->_ip, "public", $Object);
	}
	
  /**
   * snmp::set()  snmpset    
   *
   * @param mixed $Object   
   * @param mixed $Type  
   * @param mixed $Value 
   * @return
   */
	private function set($Object, $Type, $Value)
	{
		return @snmpset($this->_ip, "security", $Object, $Type, $Value);
	}
	
  /**
   * snmp::snmp() 
   *
   * @param mixed $routerIP  
   * @param mixed $port       
   * @return
   */
	public function snmp($routerIP, $port)
	{
			$this->_ip = $routerIP;
			$this->_port = $port;
			
	}
	
	public function Start()
	{
		$this->son = new SNMPObjectNavigator($this->_ip);
	}
  
  /**
   * snmp::GetOpenStatus()    
   *
   * @return int : up(1), down(2), testing(3), unknown(4), dormant(5), notPresent(6), lowerLayerDown(7)
   */
	public function GetOpenStatus()
	{
		$value = $this->get($this->son->OpenStatus . "." . $this->_port);
		if(strpos($value, "INTEGER") !== false)
		{
			
			$value = strrev($value);
			return $value{1};
		}
		return $value;
	}
	
  /**
   * snmp::GetAdminStatus()   "Admin Status"
   * 
   * @return int : up(1), down(2), testing(3)
   */
	public function GetAdminStatus()
	{ 
		$value = $this->get($this->son->AdminStatus . "." . $this->_port);
		if(strpos($value, "INTEGER") !== false)
		{
			$value = strrev($value);
			return $value{1};
		}
		return $value;
	}
	
  /**
   * snmp::SetAdminStatus()  "Admin Status"
   *
   * @param mixed $value int : up(1), down(2), testing(3)
   * @return bool TRUE  
   */
	public function SetAdminStatus($value)	
	{
		$value = (int)$value;
		if($value > 3 || $value < 1)
		{
			return false; 
		}
		if($this->set($this->son->AdminStatus . "." . $this->_port, 'i', $value))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
  /**
   * snmp::GetSpeedDuplexStatus()   
   *
   * @return int 
   * : reserved(1), 
   * halfDuplex10(2), 
   * fullDuplex10(3), 
   * halfDuplex100(4), 
   * fullDuplex100(5), 
   * halfDuplex1000(6), 
   * fullDuplex1000(7), 
   * halfDuplex10g(8), 
   * fullDuplex10g(9)
   */
	public function GetSpeedDuplexStatus()
	{ // .1.3.6.1.4.1.259.6.10.94.1.2.1.1.4
		
 		$value = $this->get(".1.3.6.1.4.1.259.6.10.94.1.2.1.1.8.".$this->_port);
 		//echo $value;echo 3;
		if(strpos($value, "INTEGER") !== false)
		{//echo $value;
			$value = strrev($value);
			return $value{1};
		}
		//echo $value;
		return $value;
	}
	
  /**
   * snmp::SetSpeedDuplexStatus()   
   *
   * @param mixed $value int 1-9
   * @return bool TRUE    
   */
	public function SetSpeedDuplexStatus($value)
	{
		$value = (int)$value;
		if($value > 7 || $value < 1)
		{
			return false;
		}
		if($this->set($this->son->SpeedDuplexStatus . "." . $this->_port, i, $value))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
  /**
   * snmp::GetAutonegotiation()     
   *
   * @return int 1 - Enabled, 2 -Disabled
   */
	public function GetAutonegotiation()
	{
		$value = $this->get($this->son->Autonegotiation . "." . $this->_port);
		if(strpos($value, "INTEGER") !== false)
		{
			$value = strrev($value);
			return $value{1};
		}
		return $value;
	}
	
  /**
   * snmp::SetAutonegotiation()         
   *
   * @param mixed $value int 1 - Enabled, 2 -Disabled
   * @return bool 
   */
	public function SetAutonegotiation($value)
	{
		$value = (int)$value;
		if($value > 2 || $value < 1)
		{
			return false;
		}
		if($this->set($this->son->Autonegotiation . "." . $this->_port, i, $value))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
  /**
   * snmp::GetSecurityStatus()   "Security Status"
   *
   * @return int 1 - Enabled, 2 -Disabled
   */
	public function GetSecurityStatus()
	{
		$value = $this->get($this->son->SecurityStatus . "." . $this->_port);
		if(strpos($value, "INTEGER") !== false)
		{
			$value = strrev($value);
			return $value{1};
		}
		return $value;
	}
	
  /**
   * snmp::SetSecurityStatus()  "Security Status"
   *
   * @param mixed $value int 1 - Enabled, 2 -Disabled
   * @return bool
   */
	public function SetSecurityStatus($value)
	{
		$value = (int)$value;
		if($value > 2 || $value < 1)
		{
			return false;
		}
		if($this->set($this->son->SecurityStatus . "." . $this->_port, i, $value))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
  /**
   * snmp::IsSetStaticAddress()       
   *
   * @return bool
   */
	/*public function IsSetStaticAddress()
	{
		$a = snmpwalk($this->_ip, "public", $this->son->dot1qStaticUnicastAllowedToGoTo);
		//$r = findOne(bin2hex($a[0]));
		
		foreach($a as $rezult)
		{
			//echo $rezult." Before:".bin2hex($rezult)."After:".$this->findOne(bin2hex($rezult))."<br>";
			if($this->findOne(bin2hex($rezult)) == $this->_port)
				return true;
		}
		return false;
	}
	*/
	
	public function GetDinamicAddressesInPort($port)
	{
		$sn = @snmprealwalk($this->_ip, "public", ".1.3.6.1.2.1.17.4.3.1.2");
		$addresses = Array();
		foreach($sn as $Index=>$value)
		{
			if($value == $port)
			{
				$arr = explode(".",$Index);
				$count = count($arr);
				$mac = $arr[$count-6].".".$arr[$count-5].".".$arr[$count-4].".".$arr[$count-3].".".$arr[$count-2].".".$arr[$count-1];
				//$mac2 = dechex($arr[$count-6]).".".dechex($arr[$count-5]).".".dechex($arr[$count-4]).".".dechex($arr[$count-3]).".".dechex($arr[$count-2]).".".dechex($arr[$count-1]);
				$mac2 = sprintf("%02s",dechex($arr[$count-6])).":".sprintf("%02s",dechex($arr[$count-5])).":".sprintf("%02s",dechex($arr[$count-4])).":".sprintf("%02s",dechex($arr[$count-3])).":".sprintf("%02s",dechex($arr[$count-2])).":".sprintf("%02s",dechex($arr[$count-1]));
				if(@snmpget($this->_ip, "public", ".1.3.6.1.2.1.17.4.3.1.3.$mac") == 3)
				{
					$addresses[] = $mac2;
					//echo "($Index [$mac])<br>";
				}
				
			}
		}
		return $addresses;
	}
	
	private function GetStaticAddressesInPort($port)
	{
		$sn = @snmprealwalk($this->_ip, "public", ".1.3.6.1.2.1.17.4.3.1.2");
		$addresses = Array();
		foreach($sn as $Index=>$value)
		{
			if($value == $port)
			{
				$arr = explode(".",$Index);
				$count = count($arr);
				$mac = $arr[$count-6].".".$arr[$count-5].".".$arr[$count-4].".".$arr[$count-3].".".$arr[$count-2].".".$arr[$count-1];
				if(@snmpget($this->_ip, "public", ".1.3.6.1.2.1.17.4.3.1.3.$mac") == 5)
				{
					$addresses[] = $mac;
					//echo "($Index [$mac])<br>";
				}
				
			}
		}
		return $addresses;
	}

	public function IsSetStaticAddress($addresses)
	{
		$arr = $this->GetStaticAddressesInPort($this->_port);
		
		foreach($arr as $row)
		{
			foreach($addresses as $row2)
			{
				if($row == $this->macD($row2))
				{
					return true;
				}
			}
			
		}
		return false;
	}

	
  /**
   * snmp::SetStaticAddress()     
   *
   * @param mixed $Vlan  VLAN 
   * @param mixed $Mac     "-"
   * @return bool
   */
	public function SetStaticAddress($Vlan, $Mac)
	{
		$Vlan = (int)$Vlan;
		$MacA = explode("-", $Mac);
		$TMac = "$MacA[0]$MacA[1]$MacA[2]$MacA[3]$MacA[4]$MacA[5]";
		$EndMac = $this->macD($TMac);
		$port = $this->packOne($this->_port,8);
		if($this->set($this->son->dot1qStaticUnicastStatus . "." . $Vlan . "." . $EndMac . ".0", "i", 3))
		{
			if($this->set($this->son->dot1qStaticUnicastAllowedToGoTo . "." . $Vlan . "." . $EndMac . ".0", "x", $port))
			{
				return true;
			}
			else
			{
				return false;
			}
			return true;
		}
		else
		{
			return false;
		}
	}
	
  /**
   * snmp::UnSetStaticAddress()       
   *
   * @return bool
   */
	public function UnSetStaticAddress($Vlan,$Mac)
	{
		$Vlan = (int)$Vlan;
		$MacA = explode("-", $Mac);
		$TMac = "$MacA[0]$MacA[1]$MacA[2]$MacA[3]$MacA[4]$MacA[5]";
		$EndMac = $this->macD($TMac);
		$port = $this->packOne($this->_port,8);
		if($this->set($this->son->dot1qStaticUnicastStatus . "." . $Vlan . "." . $EndMac . ".0", i, 2))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
  /**
   * snmp::GetIPSourceGuardPortConfiguration()   IP Source Guard Port Configuration
   *
   * @return int 0 - None, 1 - SIP, 3 - SIP-MAC
   */
	public function GetIPSourceGuardPortConfiguration()
	{
		$value = $this->get($this->son->IPSourceGuardPortConfiguration . "." . $this->_port);
		if(strpos($value, "INTEGER") !== false)
		{
			$value = strrev($value);
			return $value{1};
		}
		return $value;
	}
	
  /**
   * snmp::SetIPSourceGuardPortConfiguration()    IP Source Guard Port Configuration
   *
   * @param mixed $value int 0 - None, 1 - SIP, 2 - SIP-MAC
   * @return bool
   */ 
	public function SetIPSourceGuardPortConfiguration($value)
	{
		$value = (int)$value;
		if($value > 2 || $value < 0)
		{
			return false;
		}
		if($this->set(($this->son->IPSourceGuardPortConfiguration.".".$this->_port), "i", $value))
		{ //echo 23;
			return true;
		}
		else
		{
			return false;
		}
	}

  /**
   * snmp::IsSetStaticIPSourceGuardBindingConfiguration()      StaticIPSourceGuardBindingConfiguration  
   *
   * @param mixed $Vlan int VLAN 
   * @param mixed $Mac string   
   * @return bool
   */
	public function IsSetStaticIPSourceGuardBindingConfiguration($Vlan, $Mac)
	{
		$Vlan = (int)$Vlan;
		$MacA = explode("-", $Mac);
		$TMac = "$MacA[0]$MacA[1]$MacA[2]$MacA[3]$MacA[4]$MacA[5]";
		$EndMac = $this->macD($TMac);
		$val = $this->get($this->son->BasicOID.".1.48.2.1.4.$Vlan.$EndMac");
		//$val =  snmpget($this->_ip, "public", $this->son->BasicOID . ".1.48.2.1.8.$Vlan.$EndMac");
		if($val == 3 || $val == "INTEGER: 3")
		{
			return true;
		}
		else
		{
			return false;
		}

	}
	

	
  /**
   * snmp::SetStaticIPSourceGuardBindingConfiguration()      Static IP Source Guard Binding Configuration
   *
   * @param mixed $Vlan int  VLAN
   * @param mixed $Mac string      "-"
   * @param mixed $host_ip string  IP  
   * @return bool
   */
	public function SetStaticIPSourceGuardBindingConfiguration($Vlan, $Mac, $host_ip)
	{
		$Vlan = (int)$Vlan;
		
		$MacA = explode("-", $Mac);
		$TMac = "$MacA[0]$MacA[1]$MacA[2]$MacA[3]$MacA[4]$MacA[5]";
		$EndMac = $this->macD($TMac);

		try
		{
			if(!$this->SetIPSourceGuardPortConfiguration(2))
			{
				throw new Exception("Cant Set SIP-MAC");
			}
			
			// ES3528MO-MIB::ipSrcGuardBindingsStatus
			if(!$this->set($this->son->BasicOID.".1.48.2.1.8.$Vlan.$EndMac", i , 5))
			{
				$error = $this->son->BasicOID.".1.48.2.1.8.$Vlan.$EndMac";
				throw new Exception('Error In "'.$error.'"');
			}
			
			// ES3528MO-MIB::ipSrcGuardBindingsAddrType
			if(!$this->set($this->son->BasicOID.".1.48.2.1.3.$Vlan.$EndMac", i , 1))
			{
				$error = $this->son->BasicOID.".1.48.2.1.3.$Vlan.$EndMac";
				throw new Exception('Error In "'.$error.'"');
			}
			
			// ES3528MO-MIB::ipSrcGuardBindingsPortIfIndex
			if(!$this->set($this->son->BasicOID.".1.48.2.1.5.$Vlan.$EndMac",a , $host_ip))
			{
				$error = $this->son->BasicOID.".1.48.2.1.5.$Vlan.$EndMac";
				throw new Exception('Error In "'.$error.'"');
			}
			
			// ES3528MO-MIB::ipSrcGuardBindingsIpAddress
			if(!$this->set($this->son->BasicOID.".1.48.2.1.6.$Vlan.$EndMac", i , $this->_port,8))
			{
				$error = $this->son->BasicOID.".1.48.2.1.6.$Vlan.$EndMac";
				throw new Exception('Error In "'.$error.'"');
			}
			
			// ES3528MO-MIB::ipSrcGuardBindingsStatus
			if(!$this->set($this->son->BasicOID.".1.48.2.1.8.$Vlan.$EndMac", i , 1))
			{
				$error = $this->son->BasicOID.".1.48.2.1.8.$Vlan.$EndMac";
				throw new Exception('Error In "'.$error.'"');
			}

			return true;
		}
		catch (Exception $e)
		{	
			echo $e->getMessage();
			return $e->getMessage();
		}
	}
	
   /**
   * snmp::UnSetStaticIPSourceGuardBindingConfiguration()      Static IP Source Guard Binding Configuration
   *
   * @param mixed $Vlan int  VLAN
   * @param mixed $Mac string      "-"
   * @return bool
   */
	public function UnSetStaticIPSourceGuardBindingConfiguration($Vlan, $Mac)
	{
		$Vlan = (int)$Vlan;
		
		$MacA = explode("-", $Mac);
		$TMac = "$MacA[0]$MacA[1]$MacA[2]$MacA[3]$MacA[4]$MacA[5]";
		$EndMac = $this->macD($TMac);
		if($this->set($this->son->BasicOID.".1.48.2.1.8.$Vlan.$EndMac", "i" , 6))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
  /**
   * snmp::findOne()
   *
   * @param mixed $hex
   * @return
   */
	private function findOne($hex){
		$len = strlen($hex);
		$dec = '';
		for($i=0; $i<$len; $i+=2){
			$dec .= sprintf( "%08s" ,decbin(hexdec(substr($hex, $i, 2))));
		}
		return strpos('0'.$dec, '1');
	}
  /**
   * snmp::packOne()
   *
   * @param mixed $pos
   * @param integer $len
   * @return
   */
	private function packOne($pos, $len=8){
		$l = $len*8;
		$dec = substr(str_repeat('0', $l).'1'.str_repeat('0', $l - $pos), -$l);
		$hex = '';
		for($i=0; $i<$len; $i++){
			$b = substr($dec, $i*8, 8);
			$hex .= sprintf("%02s", dechex(bindec(bin2hex($b))));
		}
		return $hex;
	}
  /**
   * snmp::macD()
   *
   * @param mixed $macH
   * @return
   */
	private function macD($macH){
		$macd = array();
		for($i=0; $i < 12; $i+=2){
			$macd[] = hexdec(substr($macH, $i, 2));
		}
		return implode('.',$macd);
	}

	public function dot1dTpFdbPort()
	{
		$values = Array();
		$var = snmprealwalk($this->_ip, "public", ".1.3.6.1.2.1.17.4.3.1.2");
		if(is_array($var))
		{
			foreach($var as $Index => $value)
			{
				//echo $value."<br>";
				if(strlen($value) > 3)
				{
					$value = trim(substr($value,strlen($value)-2));
					//echo $value."<br>";
				}
				
				if($value == $this->_port)
				{
					//echo $value."--- ".$Index."<br>";
					$sub = substr($Index, strlen($value) - 24);
					$tem = explode(".",$sub);
					$values[] = sprintf("%02s",dechex($tem[0]))."-". sprintf("%02s",dechex($tem[1]))."-". sprintf("%02s",dechex($tem[2]))."-". sprintf("%02s",dechex($tem[3]))."-". sprintf("%02s",dechex($tem[4]))."-". sprintf("%02s",dechex($tem[5]));
					//echo dechex(substr($sub,0,2)).": " . $value . "<br>";
					//echo $t."<br>";
				}
				
			}
		}
		return $values;
	}
	
	public function Save($name)
	{
		/*$success = $success && snmp_set($basic_oid.".1.24.1.1.0"], 'i', 2);
	$success = $success && snmp_set($basic_oid.".1.24.1.3.0", 'i', 3);
	$success = $success && snmp_set($basic_oid.".1.24.1.4.0", 's', $target);
	$success = $success && snmp_set($basic_oid.".1.24.1.8.0", 'i', 2);*/
		$this->set($this->son->BasicOID.".1.24.1.1.0",i, 2);
		$this->set($this->son->BasicOID.".1.24.1.3.0",i, 3);
		$this->set($this->son->BasicOID.".1.24.1.4.0",s, $name);
		$this->set($this->son->BasicOID.".1.24.1.8.0",i, 2);;
	}
}

/**
 * SNMPObjectNavigator
 *
 * @package Lanet
 * @author tregub
 * @copyright 2010
 * @version $Id$
 * @access public
 */
class SNMPObjectNavigator
{
  /**
   * SNMPObjectNavigator::SNMPObjectNavigator()
   *
   * @param mixed $ip
   * @return
   */
	public function SNMPObjectNavigator($ip)
	{
		$this->BasicOID = @snmpget($ip, "public", ".1.3.6.1.2.1.1.2.0");
		if(strpos($this->BasicOID, "OID") !== false)
		{
			$this->BasicOID = substr($this->BasicOID,5);
		}

	}
	public $OpenStatus = ".1.3.6.1.2.1.2.2.1.8"; // Values: up(1), down(2), testing(3), unknown(4), dormant(5), notPresent(6), lowerLayerDown(7)
	public $AdminStatus = ".1.3.6.1.2.1.2.2.1.7"; // Values: up(1), down(2), testing(3)
	public $SpeedDuplexStatus = "ES3528MO-MIB::portSpeedDpxCfg"; // reserved(1), halfDuplex10(2), fullDuplex10(3), halfDuplex100(4), fullDuplex100(5), halfDuplex1000(6), fullDuplex1000(7), halfDuplex10g(8), fullDuplex10g(9)
	public $Autonegotiation = "ES3528MO-MIB::portAutonegotiation"; // 1 - Enabled, 2 -Disabled
	public $SecurityStatus = "1.3.6.1.4.1.259.6.10.94.1.17.2.1.1.2"; // 1 - Enabled, 2 -Disabled
	 // ES3528MO-MIB::portSecPortStatus
	public $dot1qStaticUnicastStatus = ".1.3.6.1.2.1.17.7.1.3.1.1.4";
	public $dot1qStaticUnicastAllowedToGoTo = ".1.3.6.1.2.1.17.7.1.3.1.1.3";
	
	public $IPSourceGuardPortConfiguration = ".1.3.6.1.4.1.259.6.10.94.1.48.1.1.2"; // 0 - None, 1 - SIP, 3 - SIP-MAC
	public $BasicOID = "";
	public $dot1dTpFdbPort = ".1.3.6.1.2.1.17.4.3.1.2";
	
}

?>