<?
class Calendar {

var $linkBuilder;
var $template;
var $model;
var $year;
var $month;
var $date;
var $yearKey;
var $monthKey;
var $dayKey;
var $placeHolders;
var $active;
var $activeKey;
var $brief;
var $briefKey;
var $tool;

function setTool($obj){
	$this->tool = $obj;
}

function setLinkBuilder($obj){
	$this->linkBuilder = $obj;
}

function setTemplate($obj){
	$this->template = $obj;
}

function setModel($obj){
	$this->model = $obj;
}

function setPlaceHolders($int){
	$this->placeHolders = $int;
}

function setActiveKey($str){
	$this->activeKey = $str;
}

function setDateKey($str){
	$this->dateKey = $str;
}

function setMonthKey($str){
	$this->monthKey = $str;
}

function setYearKey($str){
	$this->yearKey = $str;
}

function setBriefKey($str){
	$this->briefKey = $str;
}

function getDate(){
	return $this->date;
}

function getDateTime(){
	$d = $this->date;
	return mktime(0,0,0, substr($d,5,2), substr($d,8,2), substr($d,0,4));
}

function isActive(){
	return $this->active;
}

function walkWeek($monday, $dayCallback){
	$y = date("Y", $monday);
	$m = date("m", $monday);
	$d = date("d", $monday);
	for($i=0; $i<7; $i++){
		$weekDayDate = mktime(0,0,0, $m, $d+$i, $y);
		call_user_func($dayCallback, $i+1,
			date("Y", $weekDayDate),
			date("m", $weekDayDate),
			date("d", $weekDayDate));
	}
}

function isToday($year, $month, $day){
	return $year==date("Y") && $month==date("m") && $day==date("d");
}

function isSelectedDate($year, $month, $day){
	return $this->date==$year.'-'.$month.'-'.$day;
}

function buildRecordLink($arr=array()){
	return $this->linkBuilder->build(array_merge($arr, array($this->dateKey=>$this->forDate)));
}

function acceptWeekDay($weekday, $year, $month, $day){
	$this->weekDay = $weekday;
	$this->forDate = $year.'-'.$month.'-'.$day;
	$date = mktime(0,0,0, $month, $day, $year);
	$this->weeks[$this->weekIndex]['days'][$weekday]['completeCount'] = 0;
	$this->weeks[$this->weekIndex]['days'][$weekday]['incompleteCount'] = 0;
	$this->weeks[$this->weekIndex]['days'][$weekday]['hint'] = $this->model->getHint($year, $month, $day, $this);
	$this->weeks[$this->weekIndex]['days'][$weekday]['title'] = date("j", $date).' '.getResource('month.of.'.date("m", $date));
	$this->weeks[$this->weekIndex]['days'][$weekday]['day'] = date("j", $date);
	$this->weeks[$this->weekIndex]['days'][$weekday]['month'] = getResource('month.of.'.date("m", $date));
	$this->weeks[$this->weekIndex]['days'][$weekday]['link'] = $this->linkBuilder->build(array(
		$this->dateKey=>$this->forDate,
	));
	if($weekday > 5){
		$this->weeks[$this->weekIndex]['days'][$weekday]['weekend'] = 1;
	}
	if($month==$this->month){
		$this->weeks[$this->weekIndex]['days'][$weekday]['currentmonth'] = 1;
	}
	if($this->isSelectedDate($year, $month, $day)){
		$this->weeks[$this->weekIndex]['days'][$weekday]['selected'] = 1;
		$this->weeks[$this->weekIndex]['brief'] = false;
		$this->briefIndex = $this->weekIndex;
	}
	if($this->isToday($year, $month, $day)){
		$this->weeks[$this->weekIndex]['current'] = 1;
		$this->weeks[$this->weekIndex]['days'][$weekday]['current'] = 1;
	}
	if($this->weekSelected || !$this->brief){
		$records = $this->model->getRenderedRecords($year, $month, $day,$this);
	}else{
		$records = array();
	}
	$this->weeks[$this->weekIndex]['days'][$weekday]['records'] = $records;
	$this->weeks[$this->weekIndex]['height'] = max($this->weeks[$this->weekIndex]['height'], count($records));
}

function getParam($key, $def){
	return isset($_GET[$key]) ? $_GET[$key] : $def;
}

function process(){
	global $pe6yc_storage;
	$this->year = $this->getParam($this->yearKey, date("Y"));
	$this->month = $this->getParam($this->monthKey, date("m"));
	$this->model->prepare($this->getMonday($this->year, $this->month), $this);
	$this->date = $this->getParam($this->dateKey, date("Y-m-d"));
	$this->active = $this->getParam($this->activeKey, 1);
	$this->brief = $pe6yc_storage->restore($this->briefKey, 0);
	if(isset($_GET[$this->briefKey])){
		$this->brief = $_GET[$this->briefKey];
		$pe6yc_storage->store($this->briefKey, $this->brief);
	}
}

function getMonday($year, $month){
	$day1OfWeek = date("w", mktime(0,0,0,$month, 1, $year));
	if($day1OfWeek==0){
		$day1OfWeek = 7;
	}
	return mktime(0,0,0, $month, 1 - ($day1OfWeek-1), $year);
}

function render(){
	$this->weeks = array();

	$monday = $this->getMonday($this->year, $this->month);

	$this->weekIndex = 1;
	do{
		$x = _parse_datetime($this->date);
		$this->weekSelected = $x>=$monday && $x<=($monday + 60*60*24*7);
		$this->weeks[$this->weekIndex]['brief'] = $this->brief;
		$this->walkWeek($monday, array($this, 'acceptWeekDay'));
		$this->weeks[$this->weekIndex]['height'] = max($this->weeks[$this->weekIndex]['height'], $this->placeHolders);
		$monday = mktime(0,0,0, date("m", $monday), date("d", $monday) + 7, date("Y", $monday));
		$this->weekIndex++;
	}while(date("m", $monday)==$this->month);

	$date = mktime(0,0,0, $this->month, 1, $this->year);
	$prevMonth = mktime(0,0,0, $this->month - 1, 1, $this->year);
	$nextMonth = mktime(0,0,0, $this->month + 1, 1, $this->year);
	$ctx = array(
		'weeks'=>$this->weeks,
		'active'=>$this->active,
		'activeSwitch'=>$this->linkBuilder->build(array(
			$this->activeKey=>!$this->active,
		)),
		'brief'=>$this->brief,
		'briefSwitch'=>$this->linkBuilder->build(array(
			$this->briefKey=>!$this->brief,
		)),
		'monthName'=>strftime("%B %Y", $date),
		'prevMonth'=>$this->linkBuilder->build(array(
			$this->monthKey=>date("m", $prevMonth),
			$this->yearKey=>date("Y", $prevMonth),
		)),
		'nextMonth'=>$this->linkBuilder->build(array(
			$this->monthKey=>date("m", $nextMonth),
			$this->yearKey=>date("Y", $nextMonth),
		)),
		'icons'=>array(
			'1'=>HREF.'images/link.gif',
			'2'=>HREF.'images/repair.gif',
		),
	);
	if($this->tool){
		$ctx['tool'] = $this->tool->render();
	}
	return $this->template->render($ctx);
}

}
?>