<?
class CaseOption {

var $name;
var $description;
var $cases;
var $value;
var $desired_indent;
var $case_indent;
var $present;

function setName($name){
	$this->name = $name;
	$this->desired_indent = strlen($name);
}

function setDescription($description){
	$this->description = $description;
}

function setCases($cases){
	$this->cases = $cases;
	$this->case_indent = 0;
	foreach($this->cases as $name=>$case){
		$this->case_indent = max($this->case_indent, strlen($name));
	}
}

function setValue($value){
	$this->value = $value;
}

function getValue(){
	return $this->value;
}

function parse($lexer){
	$token = $lexer->get(0);
	if($token){
		if(isset($this->cases[$token])){
			if(!$this->present){
				$this->present = true;
				$lexer->consume();
				$this->value = $token;
				return true;
			}else{
				$lexer->error("'%s' already has been set to '%s'", $this->name, $this->value);
			}
		}
	}
}

function isPresent(){
	return $this->present;
}

function getDesiredIndent(){
	return $this->desired_indent;
}

function showHelp($indent){
	printf("%-".$indent."s - %s\n", $this->name, $this->description);
	foreach($this->cases as $name=>$desc){
		printf("%-".$indent."s   %-".$this->case_indent."s - %s\n", "", $name, $desc);
	}
}

}
?>