<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class CompositBeanFactory {

var $parent;
var $items;
var $recursive = false;

function CompositBeanFactory($items = array()){
	$this->setItems($items);
}

function setItems($items){
	$this->items = $items;
	foreach($this->items as $k=>$v){
		$this->items[$k]->setParent($this);
	}
}

function setParent($parent){
	$this->parent = $parent;
}

function hasBean($name){
	if(!$this->recursive){
		$this->recursive = true;
		foreach($this->items as $k=>$v){
			if($this->items[$k]->hasBean($name)){
				$this->recursive = false;
				return true;
			}
		}
		$this->recursive = false;
	}
	return false;
}

function getBean($name){
	if(!$this->recursive){
		$this->recursive = true;
		foreach($this->items as $k=>$v){
			if($this->items[$k]->hasBean($name)){
				$this->recursive = false;
				return $this->items[$k]->getBean($name);
			}
		}
		$this->recursive = false;
	}
	die(sprintf("Bean '%s' not found", $name));
}

}
?>