<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class AccessTrackerDAO {

var $connection;
var $splitter;
var $queries = array(
	'list_states'=>"SELECT client, state, connection_type FROM access_tracker",
	'list_queue'=>"SELECT q.modem, UNIX_TIMESTAMP(q.added) added, q.task, t.status FROM access_tracker_queue q LEFT JOIN delayed_tasks t ON t.id=q.task ORDER BY q.added DESC",
	'append'=>"REPLACE INTO access_tracker_queue (modem, added, task) VALUES (%s, FROM_UNIXTIME(%s), %s)",
	'remove'=>"DELETE FROM access_tracker_queue WHERE modem=%s",
	'save'=>"REPLACE INTO access_tracker (client, state, connection_type) VALUES (%s, %s, %s)",
	'touch'=>"SELECT 1",
);

var $time;

function setConnection($connection){
	$this->connection = $connection;
}

function setSplitter($splitter){
	$this->splitter = $splitter;
}

function touch(){
	$t = time();
	if($t > $this->time + 60){
	    $this->connection->query($this->queries['touch']);
	    $this->time = $t;
	}
}

function listStates(){
	$this->time = time();
	$q = $this->queries['list_states'];
	$q = $this->splitter->patch($q." WHERE client >= [client_from] AND client < [client_to]", $q);
	return $this->connection->select($q);
}

function listQueue(){
	$this->time = time();
	return $this->connection->select($this->queries['list_queue']);
}

function saveState($clid, $state, $con_type){
	$this->time = time();
	return $this->connection->update($this->queries['save'], $clid, $state, $con_type);
}

function appendToQueue($modem, $time, $task = ''){
	$this->time = time();
	return $this->connection->update($this->queries['append'], $modem, $time, $task ? $task : 'NULL');
}

function removeFromQueue($modem){
	$this->time = time();
	return $this->connection->update($this->queries['remove'], $modem);
}

}
?>