<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class BlocksDAO {

var $connection;
var $splitter;
var $queries = array(
	'select'=>"SELECT id, client, type, resource_type
		FROM blocks
		WHERE (actual_from IS NULL || now()>=actual_from) AND (actual_to IS NULL || now() < actual_to)",
	'select_by_client'=>"SELECT id, client, type, resource_type FROM blocks WHERE client=%s AND (actual_from IS NULL || now()>=actual_from) AND (actual_to IS NULL || now() < actual_to)",
	'select_finished'=>"SELECT id, client, type, UNIX_TIMESTAMP(actual_from) actual_from, UNIX_TIMESTAMP(actual_to) actual_to FROM blocks
		WHERE client='%s' AND actual_from >= FROM_UNIXTIME('%s') AND actual_to <= now() AND resource_type IS NULL AND type=2 AND prolonged=0
		ORDER BY actual_from",
	'mark_prolonged'=>"UPDATE blocks SET prolonged=1 WHERE id='%s'",
);

function setConnection($connection){
	$this->connection = $connection;
}

function setSplitter($splitter){
	$this->splitter = $splitter;
}

function iterator(){
	$q = $this->queries['select'];
	$q = $this->splitter->patch($q." AND client >= [client_from] AND client < [client_to]", $q);
	return $this->connection->select($q);
}

function iteratorByClient($clid){
	return $this->connection->select($this->queries['select'], $clid);
}

function iteratorFinishedByClient($clid, $from){
	return $this->connection->select($this->queries['select_finished'], $clid, $from);
}

function markProlonged($bid){
	$this->connection->update($this->queries['mark_prolonged'], $bid);
}

}
?>