<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class IpUsesDAO {

var $profiler;
var $connection;
var $splitter;
var $queries = array(
	'select'=>"SELECT iu.id, iu.personal_period_resource_use, iu.host, iu.rule, iu.bytes 
		FROM ip_uses iu 
		LEFT JOIN personal_period_resource_uses ppru ON ppru.id=iu.personal_period_resource_use
		LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
		WHERE ru.calendar_period=%s AND ru.movement IS NULL",
	'update'=>"UPDATE ip_uses SET bytes=%s WHERE id=%s",
	'insert'=>"INSERT INTO ip_uses (personal_period_resource_use, host, rule, bytes) VALUES (%s, %s, %s, %s)",
);

function setConnection($connection){
	$this->connection = $connection;
}

function setProfiler($obj){
	$this->profiler = $obj;
}

function setSplitter($splitter){
	$this->splitter = $splitter;
}

function iterator($calendar_period_id){
	$q = $this->queries['select'];
	$q = $this->splitter->patch($q." AND ru.client >= [client_from] AND ru.client < [client_to]", $q);
	return $this->connection->select($q, $calendar_period_id);
}

function update($id, $bytes){
//	$this->profiler->enter('dao.iu.update');
	$this->connection->nextAsync();
	$res = $this->connection->update($this->queries['update'], $bytes, $id);
//	$this->profiler->leave('dao.iu.update');
	return $res;
}

function insert($ppru_id, $host_id, $rule_id, $bytes){
	return $this->connection->insert_auto($this->queries['insert'], $ppru_id, $host_id, $rule_id, $bytes);
}

}
?>