<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class MySqlConnection {

var $dieOnError = false;
var $link;
var $logger;
var $errors = array();
var $isolationLevel;
var $profiler;
var $nulls = false;
var $autoquote = false;

function setProfiler($obj){
	$this->profiler = $obj;
}

function setHost($host){
	$this->host = $host;
}

function setDatabase($database){
	$this->database = $database;
}

function setUser($user){
	$this->user = $user;
}

function setPassword($password){
	$this->password = $password;
}

function setCharset($charset){
	$this->charset = $charset;
}

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('mysql');
}

function setDieOnError($bool){
	$this->dieOnError = $bool;
}

function setIsolationLevel($str){
    $this->isolationLevel = $str;
}

function setNulls($bool){
    $this->nulls = $bool;
}

function setAutoquote($bool){
    $this->autoquote = $bool;
}

function initBean(){
	$this->connect();
	if(isset($this->charset)){
		$this->query("SET NAMES %s", $this->charset);
	}
	if($this->isolationLevel){
	    $this->query("SET SESSION TRANSACTION ISOLATION LEVEL %s", $this->isolationLevel);
	}
}

function clearErrors(){
	$this->errors = array();
}

function hasErrors(){
	return !empty($this->errors);
}

function connect(){
	$this->link = mysql_connect($this->host, $this->user, $this->password) 
	or die(sprintf("Could not connect to %s as %s with%s password specified", $this->host, $this->user, $this->password ? "":"out"));
	mysql_select_db($this->database, $this->link)
	or die(sprintf("Could not select database %s at %s", $this->database, $this->host));
}

function close(){
	 mysql_close($this->link);
}

function nextAsync(){
}

function query($sql){
	if(func_num_args() > 1){
		$args = func_get_args();
		$c = count($args);
		for($i=1; $i < $c; $i++){
			$v = $args[$i];
			if(strlen($v)==0){
				$args[$i] = $this->nulls;
			}elseif(!is_numeric($v)){
				$v = addslashes($v);
				if($this->autoquote){
					$v = "'".$v."'";
				}
				$args[$i] = $v;
			}
		}
		$sql = call_user_func_array('sprintf', $args);
	}
	$this->logger->debug($this->skip_extra_whitespace($sql).";");
	$this->profiler->enter('mysql_query');
	$res = mysql_query($sql, $this->link);
	$this->profiler->leave('mysql_query');
	if($res){
		return $res;
	}else{
		$err = mysql_error($this->link);
		if(strstr($err, 'has gone away')){
		    $this->logger->warning('disconnected trying to reconnect...');
		    $this->connect();
		    if($res = mysql_query($sql, $this->link)){
		        return $res;
		    }
		}
		$this->logger->error($err.": ".$this->skip_extra_whitespace($sql).";");
		$this->errors[] = $err;
		if($this->dieOnError){
			die($err);
		}
	}
}

function select($sql){
	$args = func_get_args();
	if($res = call_user_func_array(array($this, 'query'), $args)){
		return new MySqlSelect($res);
	}
}

function update($sql){
	$args = func_get_args();
	if($res = call_user_func_array(array($this, 'query'), $args)){
		return mysql_affected_rows($this->link);
	}
}

function insert($sql){
	$args = func_get_args();
	if($res = call_user_func_array(array($this, 'query'), $args)){
		return mysql_affected_rows($this->link);
	}
}

function insert_auto($sql){
	$args = func_get_args();
	if($res = call_user_func_array(array($this, 'query'), $args)){
		return $this->getInsertedId();
	}
}

function getInsertedId(){
	$select = $this->select("SELECT LAST_INSERT_ID() as id");
	$arr = $select->next();
	return $arr['id'];
}

function skip_extra_whitespace($str){
	return preg_replace('|\s+|',' ', $str);
}

}

class MySqlSelect {

var $res;

function MySqlSelect($res){
	$this->res = $res;
}

function next(){
	return mysql_fetch_assoc($this->res);
}

}
?>