<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class PersonalFirewallDAO {

var $connection;
var $splitter;
var $select = "SELECT f.host, f.rule FROM hosts_firewall f LEFT JOIN hosts h ON h.id=f.host";
var $select_schedule = 'SELECT DISTINCT b.host
	FROM block_schedule b
	LEFT JOIN hosts h ON h.id=b.host
	WHERE (
		(b.type=0 AND b.day_bits & POW(2, (DATE_FORMAT(NOW(), "%w") + 6) % 7)) OR
		(b.type=1 AND b.date = DATE_FORMAT(NOW(), "%Y-%m-%d"))
	) AND (
		EXTRACT(HOUR_SECOND FROM now()) BETWEEN b.from_time AND b.to_time
	)';
var $findFix = "CREATE TEMPORARY TABLE _fix_firewall  ENGINE=Memory
	SELECT CONCAT(f.host, ':', f.rule) id
	FROM hosts_firewall f
	LEFT JOIN rules r ON r.id=f.rule
	LEFT JOIN hosts h ON h.id=f.host
	LEFT JOIN clients c ON c.id=h.client
	LEFT JOIN personal_periods pp ON pp.marker=1 AND pp.client=c.id
	LEFT JOIN
	(SELECT rule, connection_type
	 FROM connection_type_rules ctr
	 LEFT JOIN connection_type_resources ctrs ON ctrs.id=ctr.connection_type_resource
	) x ON x.connection_type=IFNULL(pp.connection_type, c.connection_type) AND x.rule=f.rule
	WHERE x.rule is NULL";
var $makeFix = "DELETE FROM hosts_firewall 
	WHERE CONCAT(host, ':', rule) IN (SELECT id FROM _fix_firewall)";

function setConnection($connection){
	$this->connection = $connection;
}

function setSplitter($splitter){
	$this->splitter = $splitter;
}

function fix(){
	$this->connection->query($this->findFix);
	$this->connection->query($this->makeFix);
}

function iterator(){
	$q = $this->select;
	$q = $this->splitter->patch($q." WHERE h.client >= [client_from] AND h.client < [client_to]", $q);
	return $this->connection->select($q);
}

function iteratorSchedule(){
	$q = $this->select_schedule;
	$q = $this->splitter->patch($q." AND h.client >= [client_from] AND h.client < [client_to]", $q);
	return $this->connection->select($q);
}


}
?>