<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class ResourceUsesDAO {

var $profiler;
var $connection;
var $splitter;
var $queries = array(
	'select'=>"SELECT id, client, resource_type, unit_size, price, src, dst, amount FROM resource_uses 
		WHERE calendar_period=%s AND movement IS NULL",
	'update'=>"UPDATE resource_uses SET amount=%s WHERE id=%s",
	'insert'=>"INSERT INTO resource_uses (calendar_period, client, resource_type, unit_size, price, src, dst, amount) VALUES (%s, %s, %s, %s, %s, IF(%s, %s, NULL), IF(%s, %s, NULL), %s)",
	'mark'=>"UPDATE resource_uses SET movement=%s WHERE id=%s",
);

function setConnection($connection){
	$this->connection = $connection;
}

function setProfiler($obj){
	$this->profiler = $obj;
}

function setSplitter($splitter){
	$this->splitter = $splitter;
}

function iterator($cp){
	$q = $this->queries['select'];
	$q = $this->splitter->patch($q." AND client >= [client_from] AND client < [client_to]", $q);
	return $this->connection->select($q, $cp);
}

function update($id, $amount){
//	$this->profiler->enter('dao.ru.update');
	$this->connection->nextAsync();
	$res = $this->connection->update($this->queries['update'], $amount, $id);
//	$this->profiler->leave('dao.ru.update');
	return $res;
}

function insert($cp, $clid, $res_type, $unit_size, $price, $src, $dst, $amount){
	$src = $src + 0;
	$dst = $dst + 0;
	return $this->connection->insert_auto($this->queries['insert'], $cp, $clid, $res_type, $unit_size, $price, $src, $src, $dst, $dst, $amount);
}

function markMoved($ruid, $moid){
	$this->connection->update($this->queries['mark'], $moid, $ruid);
}

}

?>