<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class TransactionInterceptor {

var $connection;
var $logger;
var $level = 0;

function setConnection($obj){
	$this->connection = $obj;
}

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('transaction');
}

function invoke($invocation){
	if($this->level==0){
		$this->logger->debug("starting new transaction");
		$this->connection->query("BEGIN");
	}
	$this->level++;
	$result = $invocation->proceed();
	$this->level--;
	if($this->connection->hasErrors()){
		$this->logger->debug("rollbacking transaction");
		$this->connection->query("ROLLBACK");
	}else{
		$this->logger->debug("commiting transaction");
		$this->connection->query("COMMIT");
	}
	return $result;
}

}
?>