<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class AvalPayDelegate {

var $fromPattern;
var $toPattern;
var $takeAll = true;
var $titlePattern = '|LANET_NETWORK_\d+_R\d+|i';
var $headerPattern = '|LANET_NETWORK_(\d\d)(\d\d)(\d\d\d\d)_|is';
var $recordPattern = '|[^;]+;([\d\.]+);(.+)|i';
var $stampManager;
var $connection;
var $calendarPeriodsManager;
var $account;
var $paysImportManager;
var $logger;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('mail.pay.aval');
}

function setAccount($int){
	$this->account = $int;
}

function setFromPattern($addr){
	$this->fromPattern = $addr;
}

function setToPattern($addr){
	$this->toPattern = $addr;
}

function setTakeAll($bool){
	$this->takeAll = $bool;
}

function setTitlePattern($str){
	$this->titlePattern = $str;
}

function setStampManager($obj){
	$this->stampManager = $obj;
}

function setConnection($obj){
	$this->connection = $obj;
}

function setCalendarPeriodsManager($obj){
	$this->calendarPeriodsManager = $obj;
}

function setPaysImportManager($obj){
	$this->paysImportManager = $obj;
}

function process($msg){
	if(preg_match($this->toPattern, $msg['addr_to'])){
		$this->logger->info("found: %s from: %s", $msg['subject'], $msg['addr_from']);
		if(preg_match($this->fromPattern, $msg['addr_from'])){
			if(preg_match($this->titlePattern, $msg['subject'])){
				$body = $msg['body'];
				if($body == 'Body too large. Saved in attachment.'){
					$body = $msg['attachments'][0]['body'];
				}
				if(substr($body, 0, 5)=='begin'){ // uue
					$body = substr($body, strpos($body, "\n") + 1, -4); // skip first and last lines
					$body = str_replace("\r", "", $body);
					$body = convert_uudecode($body);
				}
				$lines = explode("\n", $body);
				$header = trim(array_shift($lines));
				$header2 = substr($header, 0, strpos($header, ";"));
				if(preg_match($this->headerPattern, $header, $m)){
					$date = $m[3].'-'.$m[2].'-'.$m[1];
				}else{
					$date = date("Y-m-d", $msg['date'] ? $msg['date'] : time());
				}
				$cp = $this->calendarPeriodsManager->getCurrent();
				$stamp = $this->stampManager->createStamp();
				$hid = $this->connection->insert_auto("INSERT INTO pays_import_head (head, stamp) VALUES ('%s', %s)", $header, $stamp);
				$num = 0;
				$valid_count = 0;
				foreach($lines as $line){
					if(trim($line)){
						if(preg_match($this->recordPattern, $line, $m)){
							$num++;
							$sum = intval(strval($m[1] * 100));
							$contract = trim($m[2]);
							$valid = 0;
							$account = 'null';
							$sel = $this->connection->select("SELECT id, account FROM clients WHERE contract='%s'", $contract);
							if($arr = $sel->next()){
								$account = $arr['account'];
								$valid = 1;
								$valid_count++;
							}
							$this->connection->insert("INSERT INTO pays_import (head, pos, src, dst, amount, info, valid, note, calendar_period, date) 
								VALUES (%s, %s, %s, %s, %s, '%s', %s,  '%s', '%s', '%s')",
								$hid, $num, $this->account, $account, $sum, $line, $valid, $header2, $cp['id'], $date);
						}else{
							$this->logger->warning("bad line: %s", $line);
						}
					}
				}
				if($valid_count > 0){
					$this->logger->info("received: %s, valid: %s", $num, $valid_count);
					$this->paysImportManager->moveValid($hid);
				}else{
					$this->logger->warning("no records");
				}
			}else{
				$this->logger->warning("wrong subject: %s", $msg['subject']);
			}
			return true;
		}else{
			$this->logger->info("wrong source: %s", $msg['addr_from']);
		}
		return $this->takeAll;
	}
	return false;
}

}
?>