<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class AccountTypesManager {

var $logger;
var $accountsDAO;
var $accountTypes;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('account.types');
}

function setAccountsDAO($obj){
	$this->accountsDAO = $obj;
}

function initBean(){
	$this->accountTypes = array();
	$it = $this->accountsDAO->typesIterator();
	while($arr = $it->next()){
		$this->accountTypes[$arr['id']] = $arr;
	}
	$it = $this->accountsDAO->typesResourcesIterator();
	while($arr = $it->next()){
		$this->accountTypes[$arr['account_type']]['resources'][$arr['resource_type']] = 1;
	}
}

function getAccountType($id){
	if(isset($this->accountTypes[$id])){
		return $this->accountTypes[$id];
	}
}

function isApplicable($tid, $rtid){
	if(!is_numeric($tid) || !is_numeric($rtid)){
		$ex = new Exception();
		$this->logger->warning($ex->getTraceAsString());
	}
	return isset($this->accountTypes[$tid]['resources'][$rtid]);
}

function show(){
	print_r($this->accountTypes);
}

}
?>