<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class CalendarPeriodsService {

var $logger;
var $calendarPeriodsDAO;
var $accountStatesDAO;
var $resourceUsesManager;
var $timeService;
var $calendarPeriodsManager;
var $jobsExtrasService;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('calendar.periods');
}

function setCalendarPeriodsDAO($obj){
	$this->calendarPeriodsDAO = $obj;
}

function setResourceUsesManager($obj){
	$this->resourceUsesManager = $obj;
}

function setTimeService($obj){
	$this->timeService = $obj;
}

function setAccountStatesDAO($obj){
	$this->accountStatesDAO = $obj;
}

function setCalendarPeriodsManager($obj){
	$this->calendarPeriodsManager = $obj;
}

function setJobsExtrasService($obj){
	$this->jobsExtrasService = $obj;
}

function checkPeriod(){
	$current = $this->calendarPeriodsManager->getCurrent();
	if($current['period_end'] <= $this->timeService->getTime()){
		$this->logger->debug("closing calendar period %d", $current['id']);
		$this->resourceUsesManager->load();
		$this->jobsExtrasService->process();
		$this->resourceUsesManager->payResourceUses();
		$this->calendarPeriodsManager->closeCurrentCalendarPeriod();
		$this->calendarPeriodsManager->nextCalendarPeriod();
	}
}

function future(){
	$current = $this->calendarPeriodsManager->getCurrent();
	$this->logger->debug("begin calc future accounts states in calendar period [%d]", $current['id']);
	$this->accountStatesDAO->futureStates($current['id'], $this->timeService->getTime());
	$this->logger->debug("end calc");
}

}
?>