<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class Fetcher {

var $logger;
var $bonusesManager;
var $calendarPeriodsService;
var $personalPeriodPlansManager;
var $personalPeriodsService;
var $trafficAccounter;
var $shapersManager;
var $notificator;
var $jobsExtrasService;
var $jobsService;
var $clientsManager;
var $rulesManager;
var $profiler;
var $resourceUsesManager;
var $accountsManager;
var $delayedTasksManager;
var $splitter;
var $timeService;
var $workdir;
var $ipUseLogDAO;

function setIpUseLogDAO($obj){
	$this->ipUseLogDAO = $obj;
}

function setWorkdir($str){
	$this->workdir = $str;
}

function setTimeService($obj){
	$this->timeService = $obj;
}

function setDelayedTasksManager($obj){
	$this->delayedTasksManager = $obj;
}

function setAccountsManager($obj){
	$this->accountsManager = $obj;
}

function setResourceUsesManager($obj){
	$this->resourceUsesManager = $obj;
}

function setProfiler($obj){
	$this->profiler = $obj;
}

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('fetcher');
}

function setCalendarPeriodsService($obj){
	$this->calendarPeriodsService = $obj;
}

function setClientsManager($obj){
	$this->clientsManager = $obj;
}

function setRulesManager($obj){
	$this->rulesManager = $obj;
}

function setPersonalPeriodPlansManager($obj){
	$this->personalPeriodPlansManager = $obj;
}

function setPersonalPeriodsService($obj){
	$this->personalPeriodsService = $obj;
}

function setTrafficAccounter($obj){
	$this->trafficAccounter = $obj;
}

function setBonusesManager($obj){
	$this->bonusesManager = $obj;
}

function setShapersManager($obj){
	$this->shapersManager = $obj;
}

function setNotificator($obj){
	$this->notificator = $obj;
}

function setJobsExtrasService($obj){
	$this->jobsExtrasService = $obj;
}

function setJobsService($obj){
	$this->jobsService = $obj;
}

function setSplitter($obj){
	$this->splitter = $obj;
}

function fetch(){
	$this->logger->debug("begin");
	$opt = getopt('w:a:r:t:');
	if(!isset($opt['r'])){
		$this->logger->error('set range by -r option');
		return;
	}
	if(isset($opt['t'])){
		$this->timeService->setTime($opt['t']);
	}
	$range = explode(":", $opt['r']);
	if(count($range)!=2){
		$this->logger->error('wrong range');
	}
	$range = array(intval($range[0]), intval($range[1]));

	$this->splitter->setClientsRange($range);

	$this->rulesManager->loadCounters();
	$this->clientsManager->load();
	$this->accountsManager->load();
	$this->bonusesManager->load();
	$this->resourceUsesManager->load();
	$this->personalPeriodPlansManager->load();
	$this->shapersManager->load();
	
	$this->trafficAccounter->fetch();
	
	$this->ipUseLogDAO->flushFile($this->workdir.'/iul.dump');
	
	$this->jobsService->process();
	//$this->personalPeriodPlansManager->updateActualUses();
	$this->personalPeriodsService->checkPeriods();
	$this->bonusesManager->checkExpiredBonuses();
	$this->notificator->load();
	$this->notificator->notify();
	if($this->personalPeriodsService->hasPeriodsChanged() || $this->shapersManager->checkPlanRemake() || $this->shapersManager->checkValueRemake()){
		$this->delayedTasksManager->appendOffline('3', 'task.shapers.remake', 1);
	}
	$this->logger->debug("end");
	$this->profiler->dump();
}

}
?>