<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class FetcherMaster {

var $logger;
var $rulesManager;
var $profiler;
var $spawner;
var $calendarPeriodsService;
var $stateUpdateService;
var $clientsDAO;
var $timeService;
var $workdir;

function setWorkdir($str){
	$this->workdir = $str;
}

function setClientsDAO($obj){
	$this->clientsDAO = $obj;
}

function setCalendarPeriodsService($obj){
	$this->calendarPeriodsService = $obj;
}

function setTimeService($obj){
	$this->timeService = $obj;
}

function setProfiler($obj){
	$this->profiler = $obj;
}

function setSpawner($obj){
	$this->spawner = $obj;
}

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('fetcher.master');
}

function setRulesManager($obj){
	$this->rulesManager = $obj;
}

function fetch(){
	$time = $this->timeService->getTime();
	
	$opt = getopt('w:a:x:');
	$split = max(1, isset($opt['x']) ? intval($opt['x']) : 1);
	
	$this->logger->info("=== BEGIN ===");
	file_put_contents($this->workdir.'/iul.dump', '');
	$this->rulesManager->readCounters();
	$this->calendarPeriodsService->future();

	$this->account($split);

	$this->calendarPeriodsService->checkPeriod();
	$this->calendarPeriodsService->future();

	$pids = array();
	
	$cmd = $_SERVER['argv'][0].' -a make -t '.$time.' -x '.$split;
	$pids[] = $this->spawner->spawn($cmd);
	
	$cmd = $_SERVER['argv'][0].' -a update';
	$pids[] = $this->spawner->spawn($cmd);
	
//	$cmd = $_SERVER['argv'][0].' -a correct_ppru'; // -   -a update,  
//	$pids[] = $this->spawner->spawn($cmd);
	
	$cmd = $_SERVER['argv'][0].' -a spread_log -f '.$this->workdir.'/iul.dump -t '.$time;
	$pids[] = $this->spawner->spawn($cmd);

	$this->clientsDAO->replaceExpiredConnectionTypes();
	$this->clientsDAO->replaceExpiredTvTypes();
	
	$this->spawner->waitFor($pids);
	$this->logger->info("=== END ===");
	$this->profiler->dump();
}

function account($split){
	$time = $this->timeService->getTime();
	$pids = array();
	$count = $this->clientsDAO->getCount();
	$size = intval($count / $split);
	$prev = 1;
	for($i = 1; $i <= $split; $i++){
		$from = $prev;
		if($i==$split){
			$to = $this->clientsDAO->getLastId() + 1;
		}else{
			$to = $this->clientsDAO->getShiftId($i * $size);
		}
		$cmd = $_SERVER['argv'][0].' -a fetch_slave -r '.$from.':'.$to.' -t '.$time;
		$pids[] = $this->spawner->spawn($cmd);
		$prev = $to;
	}
	$this->spawner->waitFor($pids);
}

}
?>