<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class IpUseLogCleaner {

var $logger;
var $db;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('ip.use.log.cleaner');
}

function setConnection($obj){
	$this->db = $obj;
}

function process(){
	$t = date("YmdHis");

	$new_time_table = '_ip_use_time_new_'.$t;
	$old_time_table = '_ip_use_time_old_'.$t;
	
	$this->db->update("CREATE TABLE $new_time_table (
		ip_use INT UNSIGNED NOT NULL,
		from_time TIMESTAMP NOT NULL,
		to_time TIMESTAMP NOT NULL,
		bytes BIGINT UNSIGNED NOT NULL,
		PRIMARY KEY(from_time, ip_use),
		KEY(ip_use)
	) ENGINE=InnoDB SELECT * FROM ip_use_time WHERE from_time > SUBDATE(now(), INTERVAL 1 DAY)");
	$this->db->update("RENAME TABLE ip_use_time TO $old_time_table, $new_time_table TO ip_use_time");
	$this->db->update("DROP TABLE $old_time_table");

	$new_hours_table = '_ip_use_hours_new_'.$t;
	$old_hours_table = '_ip_use_hours_old_'.$t;
	$this->db->update("CREATE TABLE $new_hours_table (
		ip_use INT UNSIGNED NOT NULL,
		hour TIMESTAMP NOT NULL,
		bytes BIGINT UNSIGNED NOT NULL,
		PRIMARY KEY(hour, ip_use),
		KEY(ip_use)
	) ENGINE=InnoDB SELECT * FROM ip_use_hours WHERE hour > SUBDATE(now(), INTERVAL 10 DAY)");
	$this->db->update("RENAME TABLE ip_use_hours TO $old_hours_table, $new_hours_table TO ip_use_hours");
	$this->db->update("DROP TABLE $old_hours_table");
/*
	$this->db->update("DELETE FROM ip_use_time WHERE from_time < SUBDATE(now(), INTERVAL 1 DAY)");
	$this->db->update("DELETE FROM ip_use_hours WHERE hour < SUBDATE(now(), INTERVAL 1 MONTH)");
	$this->db->update("OPTIMIZE TABLE ip_use_time");
	$this->db->update("OPTIMIZE TABLE ip_use_hours");
*/
//	$this->db->update("DELETE FROM ip_use_days WHERE day < SUBDATE(now(), INTERVAL 2 YEAR)");
}

}