<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class IpUseLogPacker {

var $logger;
var $ipUseLogPackerDAO;
var $optionsManager;
var $timeService;
var $transactionManager;
var $granules = array(
	'd'=>86400,
	'h'=>3600,
	'm'=>60,
);

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('ip.use.log.packer');
}

function setIpUseLogPackerDAO($obj){
	$this->ipUseLogPackerDAO = $obj;
}

function setOptionsManager($obj){
	$this->optionsManager = $obj;
}

function setTimeService($obj){
	$this->timeService = $obj;
}

function setTransactionManager($obj){
	$this->transactionManager = $obj;
}

function pak(){
	$opt = $this->optionsManager->getOption('PAK_PERIODS');
	if($opt['actual']){
		$config = array();
		$lines = explode("\n", trim($opt['value']));
		$i = 0;
		$pak = array();
		foreach($lines as $line){
			$i++;
			$line = trim($line);
			if($line && substr($line,0,1)!='#'){
				$key_val = explode("=", $line);
				if(count($key_val)==2){
					$key = trim($key_val[0]);
					if($key > 0){
						$val = trim($key_val[1]);
						$unit = strtolower(substr($val, -1));
						if(isset($this->granules[$unit])){
							$granula = trim(substr($val, 0, -1));
							if($granula > 0){
								$pak[$key * $this->granules['d']] = $granula * $this->granules[$unit];
							}else{
								$this->logger->warning("skipping invalid config line %s: %s", $i, $line);
							}
						}else{
							$this->logger->warning("skipping invalid config line %s: %s", $i, $line);
						}
					}else{
						$this->logger->warning("skipping invalid config line %s: %s", $i, $line);
					}
				}else{
					$this->logger->warning("skipping invalid config line %s: %s", $i, $line);
				}
			}
		}
		if(!empty($pak)){
			$this->pakByIntervals($pak);
		}else{
			$this->logger->info("pack configuration is empty");
		}
	}else{
		$this->logger->info("packing is disabled by configuration");
	}
}

function pakByIntervals($pak){
	$this->logger->info("packing...");
	$time = $this->timeService->getTime();
	$this->transactionManager->begin();
	$this->ipUseLogPackerDAO->prepare();
	krsort($pak);
	$fromTime=0;
	foreach($pak as $border=>$granula){
		$toTime = $time - $border;
		$this->logger->info("packing [%s - %s], granulation %s", date("Y-m-d H:i:s", $fromTime), date("Y-m-d H:i:s", $toTime), $granula);
		$this->ipUseLogPackerDAO->movePackedData($fromTime, $toTime, $granula);
		$fromTime = $toTime;
	}
	$this->logger->info("keep unpacked [%s - ...]", date("Y-m-d H:i:s", $fromTime));
	$this->ipUseLogPackerDAO->moveUnpackedData($fromTime);
	$this->ipUseLogPackerDAO->finalize();
	$this->transactionManager->end();
	$this->logger->info("packing finished");
}

}
?>