<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class JobsExtrasService {

var $jobsExtrasDAO;
var $clientsManager;
var $chargeTypesManager;
var $resourceUsesManager;
var $transactionManager;
var $payManager;
var $logger;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('jobs.extras.service');
}

function setJobsExtrasDAO($obj){
	$this->jobsExtrasDAO = $obj;
}

function setClientsManager($obj){
	$this->clientsManager = $obj;
}

function setChargeTypesManager($obj){
	$this->chargeTypesManager = $obj;
}

function setResourceUsesManager($obj){
	$this->resourceUsesManager = $obj;
}

function setTransactionManager($obj){
	$this->transactionManager = $obj;
}

function setPayManager($obj){
	$this->payManager = $obj;
}

function process(){
	$this->clientsManager->load();
	$this->resourceUsesManager->load();
	$this->payManager->load();
	$this->extras = array();
	$it = $this->jobsExtrasDAO->iterator();
	$count = 0;
	while($arr = $it->next()){
		$this->extras[$arr['client']][$arr['id']] = $arr;
		$count++;
	}
	$this->logger->debug("%s extras loaded", $count);
	foreach($this->extras as $clid=>$arr){
		$client = $this->clientsManager->getClient($clid);
		$this->logger->debug('charging extras for %s', $client['login']);
		$this->transactionManager->begin();
		$this->resourceUsesManager->begin();
		foreach($arr as $eid=>$extra){
			$charge_type = $this->chargeTypesManager->getChargeType($extra['charge_type']);
			$this->logger->debug('charging %s, %s', $charge_type['name'], $extra['amount']);
			$ruid = $this->payManager->payThis($client, '', $charge_type['account'], $charge_type['resource_type'], $charge_type['unit_size'], $charge_type['price'], $extra['amount']);
			if($ruid){
				$this->jobsExtrasDAO->setResourceUse($eid, $ruid);
			}
		}
		$this->resourceUsesManager->apply();
		$this->transactionManager->end();
	}
}

}
?>