<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class JobsService {

var $jobsDAO;
var $clientsManager;
var $chargeTypesManager;
var $resourceUsesManager;
var $transactionManager;
var $payManager;
var $logger;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('jobs.service');
}

function setJobsDAO($obj){
	$this->jobsDAO = $obj;
}

function setClientsManager($obj){
	$this->clientsManager = $obj;
}

function setChargeTypesManager($obj){
	$this->chargeTypesManager = $obj;
}

function setResourceUsesManager($obj){
	$this->resourceUsesManager = $obj;
}

function setTransactionManager($obj){
	$this->transactionManager = $obj;
}

function setPayManager($obj){
	$this->payManager = $obj;
}

function process(){
	$this->clientsManager->load();
	$this->resourceUsesManager->load();
	$this->payManager->load();
	$this->jobs = array();
	$it = $this->jobsDAO->iterator();
	$count = 0;
	while($arr = $it->next()){
		$this->jobs[$arr['client']][$arr['id']] = $arr;
		$count++;
	}
	$this->logger->debug("%s jobs loaded", $count);
	foreach($this->jobs as $clid=>$arr){
		$client = $this->clientsManager->getClient($clid);
		$this->logger->debug('charging jobs for %s', $client['login']);
		$this->transactionManager->begin();
		$this->resourceUsesManager->begin();
		foreach($arr as $jid=>$job){
			$charge_type = $this->chargeTypesManager->getChargeType($job['charge_type']);
			$this->logger->debug('charging %s, %s', $charge_type['name'], 1);
			$ruid = $this->payManager->payThis($client, '', $charge_type['account'], $charge_type['resource_type'], $charge_type['unit_size'], $charge_type['price'], 1);
			if($ruid){
				$this->jobsDAO->setResourceUse($jid, $ruid);
			}
		}
		$this->resourceUsesManager->apply();
		$this->transactionManager->end();
	}
}

}
?>