<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class ModemsTreeView {

var $hostsDAO;
var $modemsDAO;
var $location;
var $model;

function setHostsDAO($obj){
	$this->hostsDAO = $obj;
}

function setModemsDAO($obj){
	$this->modemsDAO = $obj;
}

function setLocation($str){
	$this->location = $str;
}

function setModel($str){
	$this->model = $str;
}

function create(){
	$this->hosts = array();
	$it = $this->hostsDAO->iterator();
	while($arr = $it->next()){
		$this->hosts[$arr['modem']][$arr['id']] = $arr;
	}

	$this->kids = array();
	$this->modems = array();
	$root = array();
	$it = $this->modemsDAO->iterator();
	while($arr = $it->next()){
		$this->modems[$arr['id']] = $arr;
		if($arr['modem']){
			$this->kids[$arr['modem']][] = $arr['id'];
		}else{
			$root[] = $arr['id'];
		}
	}

	$this->view = array();
	foreach($root as $rid){
		$this->walkTree2($rid);
	}
	foreach($this->view as $vid=>$view){
		$modem = $this->modems[$vid];
		$fileName = $this->location.'/'.$modem['name'];
		$content = '';
		usort($view, array($this, 'byStruct2'));
		foreach($view as $host){
			if($host['mac'] && $host['vlan'] 
				&& (substr($host['ip'],0,5)!='77.87') 
				&& (substr($host['ip'],0,6)!='194.50') 
				&& ($host['vlan']!='11')){
				$m = $this->modems[$host['modem']];
				//$content .= $host['vlan'].' '.$host['mac'].' '.$host['ip']."\n";
				$vlan = $host['vlan'] + 1000;
				$content .= sprintf("snmpset -v 1 -c security %s ".
					".1.3.6.1.2.1.4.22.1.1.%s.%s i %s ".
					".1.3.6.1.2.1.4.22.1.2.%s.%s x %s ".
					".1.3.6.1.2.1.4.22.1.3.%s.%s a %s ".
					".1.3.6.1.2.1.4.22.1.4.%s.%s i 4\n",
					$modem['ip'],
					$vlan, $host['ip'], $vlan,
					$vlan, $host['ip'], str_replace(':', '', $host['mac']),
					$vlan, $host['ip'], $host['ip'],
					$vlan, $host['ip']);
			}
		}
		file_put_contents($fileName, $content);
		chmod($fileName, 0744);
	}
}

//snmpset -v 1 -c security 10.0.6.19 .1.3.6.1.2.1.4.22.1.1.1021.10.6.21.35 i 1021 .1.3.6.1.2.1.4.22.1.2.1021.10.6.21.35 x 0016171394f2 .1.3.6.1.2.1.4.22.1.3.1021.10.6.21.35 a 10.6.21.35 .1.3.6.1.2.1.4.22.1.4.1021.10.6.21.35 i 4

function walkTree2($mid, $router=''){
	$modem = $this->modems[$mid];
	if($modem['model']==$this->model){
		$router = $modem;
		$this->view[$mid] = array();
	}
	if(isset($this->hosts[$mid]) && $router){
		foreach($this->hosts[$mid] as $host){
			$this->view[$router['id']][] = $host;
		}
	}
	if(isset($this->kids[$mid])){
		foreach($this->kids[$mid] as $kid){
			$this->walkTree2($kid, $router);
		}
	}
}

function byStruct2($h1, $h2){
	$r = $h2['vlan'] - $h1['vlan'];
	if($r==0){
		$r = strcmp($h1['ip'], $h2['ip']);
	}
	return $r;
}

function walkTree($mid, $path = array()){
	$modem = $this->modems[$mid];
	if(isset($path[$modem['modem']])){
		$path[$modem['modem']] = $modem['port'];
	}
	if($modem['model']==$this->model){
		$path[$mid] = 0;
		$this->view[$mid] = array();
	}
	if(isset($this->hosts[$mid])){
		foreach($this->hosts[$mid] as $host){
			foreach($path as $vid=>$port){
				$host['view_port'] = $host['modem']==$vid ? $host['port'] : $port;
				$this->view[$vid][] = $host;
			}
		}
	}
	if(isset($this->kids[$mid])){
		foreach($this->kids[$mid] as $kid){
			$this->walkTree($kid, $path);
		}
	}
}


}
?>