<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class OptionsManager {

var $logger;
var $optionsDAO;
var $options;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('options');
}

function setOptionsDAO($obj){
	$this->optionsDAO = $obj;
}

function initBean(){
	$this->options = array();
	$it = $this->optionsDAO->iterator();
	while($arr = $it->next()){
		$this->options[$arr['id']] = $arr;
	}
	$this->logger->debug("%s options loaded", count($this->options));
}

function getOption($id){
	return $this->options[$id];
}

function getOptionValue($key){
	if(isset($this->options[$key])){
		$opt = $this->options[$key];
		if($opt['actual']){
			return $opt['value'];
		}
	}
}

function getTrimOptionValue($key){
	return trim($this->getOptionValue($key));
}

function getDirOptionValue($key){
	$opt = $this->getTrimOptionValue($key);
	if($opt && substr($opt,-1,1)!='/'){
		$opt .= '/';
	}
	return $opt;
}

function show(){
	print_r($this->options);
}

}
?>