<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class PersonalFirewallManager {

var $logger;
var $personalFirewallDAO;
var $firewall;
var $schedule;
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('personal.firewall');
}

function setPersonalFirewallDAO($obj){
	$this->personalFirewallDAO = $obj;
}

function load(){
	if(!$this->loaded){
		$this->personalFirewallDAO->fix();
		$this->firewall = array();
		$it = $this->personalFirewallDAO->iterator();
		$counter = 0;
		while($arr = $it->next()){
			$this->firewall[$arr['host']][$arr['rule']] = 1;
			$counter++;
		}
		$this->logger->debug("%s personal firewall rules loaded", $counter);
		
		$this->schedule = array();
		$it = $this->personalFirewallDAO->iteratorSchedule();
		while($arr = $it->next()){
			$this->schedule[$arr['host']] = 1;
		}
		$this->logger->debug("%s schedule rules loaded", count($this->schedule));
		$this->loaded = true;
	}
}

function isClosed($host, $rule){
	return isset($this->firewall[$host][$rule]) || isset($this->schedule[$host]);
}

function show(){
	print_r($this->firewall);
}

}
?>