<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class PersonalPeriodsManager {

var $logger;
var $personalPeriodsDAO;
var $periods;
var $loaded;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('personal.periods');
}

function setPersonalPeriodsDAO($obj){
	$this->personalPeriodsDAO = $obj;
}

function load(){
	if(!$this->loaded){
		$this->periods = array();
		$it = $this->personalPeriodsDAO->iterator();
		while($arr = $it->next()){
			$this->periods[$arr['client']] = $arr;
		}
		$this->logger->debug("%s personal periods loaded", count($this->periods));
		$this->loaded = true;
	}
}

function getClientPersonalPeriod($clid){
	if(isset($this->periods[$clid])){
		return $this->periods[$clid];
	}
}

function setClientPersonalPeriod($period){
	$this->periods[$period['client']] = $period;
}

function walkPeriods($callback){
	foreach($this->periods as $period){
		call_user_func($callback, $period);
	}
}

function show(){
	print_r($this->periods);
}

}
?>