<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class PersonalPeriodsPolicy {

var $personalPeriodsManager;
var $personalPeriodPlansManager;
var $calculator;
var $loaded;

function setPersonalPeriodsManager($obj){
	$this->personalPeriodsManager = $obj;
}

function setPersonalPeriodPlansManager($obj){
	$this->personalPeriodPlansManager = $obj;
}

function setCalculator($obj){
	$this->calculator = $obj;
}

function load(){
	if(!$this->loaded){
		$this->personalPeriodsManager->load();
		$this->personalPeriodPlansManager->load();
		$this->loaded = true;
	}
}

function isResourceBlocked($clid, $rtid){
	if(($period = $this->personalPeriodsManager->getClientPersonalPeriod($clid)) && $period['state']==1){
		if($plan = $this->personalPeriodPlansManager->getPlan($period['id'], $rtid)){
			return $this->calculator->cmp($plan['use_limit'], '0') > 0 &&
				$this->calculator->cmp($plan['use_actual'], $plan['use_limit']) >=0;
		}
	}
}

function isClientDisconnected($clid){
	if(($period = $this->personalPeriodsManager->getClientPersonalPeriod($clid)) && $period['state']==1){
		return false;
	}else{
		return true;
	}
}

}
?>