<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

include_once dirname(__FILE__).'/TaskException.php';
include_once dirname(__FILE__).'/Task.php';

class CommandLineProcessor implements TaskProcessor {

var $logger;
var $beanFactory;
var $resultString;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('task.cli.processor');
}

function execute($data){
	$strings = explode("\n", $data);
	$line = 0;
	$exit_code = 0;
	foreach($strings as $command){
		$line++;
		$command = trim($command);
		if($command && $command[0]!='#'){
			$this->logger->debug('exec command at line %s: %s', $line, $command);
			$out = array();
			exec($command, $out, $exit_code);
			echo implode("\n", $out);
			if($exit_code){
				$this->logger->error('failed command at line %s: %s', $line, $command);
				break;
			}
		}
	}
	return $exit_code;
}

}
?>