<?
include_once('classes/excel/Worksheet.php');
include_once('classes/excel/Workbook.php');

class AccReport {

var $connection;
var $calendarPeriodsDAO;

var $tvResourceType = 15;

function setConnection($obj){
	$this->connection = $obj;
}

function setCalendarPeriodsDAO($obj){
	$this->calendarPeriodsDAO = $obj;
}

function num2($str){
	return  $str;//number_format($str , 0, '.', '');
}

function generate($src_table, $cp){
	ob_start();
	$wb = new Workbook("-");
	$f = array(
		'' => $wb->add_format(),
		'bold' => $wb->add_format()->set_bold()->set_align('left'),
		'right_bold' => $wb->add_format()->set_align('right')->set_bold(),
		'right' => $wb->add_format()->set_align('right'),
		'num' => $wb->add_format()->set_align('right')->set_num_format('# ##0'),
		'caption'=>$wb->add_format()->set_top(1)->set_bottom(1),
		'caption_right'=>$wb->add_format()->set_top(1)->set_bottom(1)->set_align('right'),
	);

	$sh = $wb->add_worksheet();
	$sh->set_column(0, 0, 25);
	$sh->set_column(1, 1, 16);
	$sh->set_column(2, 2, 20);
	$i = 0;
	
	$cp_arr = $this->calendarPeriodsDAO->getById($cp);
	$mediana = intval(($cp_arr['period_begin'] + $cp_arr['period_end']) / 2);
	$title = strftime("%B", $mediana);
	$sh->write_string($i,0, strftime("%B", $mediana), $f['right_bold']);
	$sh->write_number($i,1, strftime("%Y", $mediana), $f['bold']);
	$sh->write_string($i,2, '', $f['bold']);
	$i+=2;
	
	$sh->write_string($i,0, "", $f['bold']);
	$sh->write_string($i,1, "", $f['']);
	$sh->write_string($i,2, "", $f['']);
	$i++;
	$sh->write_string($i,0, " ", $f['caption']);
	$sh->write_string($i,1, "", $f['caption_right']);
	$sh->write_string($i,2, " ", $f['caption_right']);
	$i++;
	
	$sel = $this->connection->select(
		"SELECT tt.name name, sum(m.amount) amount, count(DISTINCT pp.client) cnt
		FROM personal_period_resource_uses ppru
		LEFT JOIN personal_periods pp ON pp.id=ppru.personal_period
		LEFT JOIN connection_types ppct ON ppct.id=pp.connection_type
		INNER JOIN %s x ON x.id=pp.client
		LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
		LEFT JOIN tv_types tt ON tt.id=pp.tv_type
		INNER JOIN movements m ON m.id=ru.movement
		WHERE ru.resource_type='%s' AND ru.calendar_period='%s' AND ppct.service_type=2
		GROUP BY pp.tv_type", $src_table, $this->tvResourceType, $cp);
	$amount = 0; $count = 0;
	while($arr = $sel->next()){
		$sh->write_string($i,0, $arr['name'], $f['']);
		$sh->write_number($i,1, $this->num2($arr['cnt']), $f['num']);
		$sh->write_number($i,2, $this->num2($arr['amount']/100), $f['num']);
		$amount += $arr['amount'];
		$count += $arr['cnt'];
		$i++;
	}
	$sh->write_string($i,0, ' ', $f['']);
	$sh->write_number($i,1, $this->num2($count), $f['num']);
	$sh->write_number($i,2, $this->num2($amount/100), $f['num']);
	$i+=2;
	
	$sel = $this->connection->select(
		"SELECT sum(m.amount) amount, count(DISTINCT pp.client) cnt
		FROM personal_period_resource_uses ppru
		LEFT JOIN personal_periods pp ON pp.id=ppru.personal_period
		LEFT JOIN connection_types ppct ON ppct.id=pp.connection_type
		INNER JOIN %s x ON x.id=pp.client
		LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
		INNER JOIN clients c ON c.account=ru.src
		INNER JOIN movements m ON m.id=ru.movement
		WHERE ru.calendar_period='%s' AND ppct.service_type&1=1",
		$src_table, $cp);
	$arr = $sel->next();
	$sh->write_string($i,0, ' ( )', $f['']);
	$sh->write_number($i,1, $this->num2($arr['cnt']), $f['num']);
	$sh->write_number($i,2, $this->num2($arr['amount']/100), $f['num']);
	$i+=2;
	
	$sh->write_string($i,0, "", $f['bold']);
	$sh->write_string($i,1, "", $f['']);
	$sh->write_string($i,2, "", $f['']);
	$i++;
	$sh->write_string($i,0, " ", $f['caption']);
	$sh->write_string($i,1, "", $f['caption_right']);
	$sh->write_string($i,2, "", $f['caption_right']);
	$i++;
	
	$sel = $this->connection->select(
		"SELECT tt.name, sum(cas.state_end) amount, count(*) cnt
		FROM calendar_account_states cas
		INNER JOIN clients c ON c.account=cas.account
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		LEFT JOIN tv_types tt ON tt.id=c.tv_type
		INNER JOIN %s x ON x.id=c.id
		WHERE cas.calendar_period='%s' AND ct.service_type=2 AND c.tv_type IS NOT NULL AND tt.offline=0
		GROUP BY c.tv_type",
		$src_table, $cp);
	$amount = 0; $count = 0;
	while($arr = $sel->next()){
		$sh->write_string($i,0, $arr['name'], $f['']);
		$sh->write_number($i,1, $this->num2($arr['cnt']), $f['num']);
		$sh->write_number($i,2, $this->num2($arr['amount']/100), $f['num']);
		$amount += $arr['amount'];
		$count += $arr['cnt'];
		$i++;
	}
	$sh->write_string($i,0, ' ', $f['']);
	$sh->write_number($i,1, $this->num2($count), $f['num']);
	$sh->write_number($i,2, $this->num2($amount/100), $f['num']);
	$i+=2;
	
	$sel = $this->connection->select(
		"SELECT sum(cas.state_end) amount, count(*) cnt
		FROM calendar_account_states cas
		INNER JOIN clients c ON c.account=cas.account
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		LEFT JOIN tv_types tt ON tt.id=c.tv_type
		INNER JOIN %s x ON x.id=c.id
		WHERE cas.calendar_period='%s' AND (c.tv_type IS NULL OR tt.offline=1) AND ct.service_type&1=1",
		$src_table, $cp);
	$arr = $sel->next();
	$sh->write_string($i,0, '', $f['']);
	$sh->write_number($i,1, $this->num2($arr['cnt']), $f['num']);
	$sh->write_number($i,2, $this->num2($arr['amount']/100), $f['num']);
	$i+=1;
	$sel = $this->connection->select(
		"SELECT sum(cas.state_end) amount, count(*) cnt
		FROM calendar_account_states cas
		INNER JOIN clients c ON c.account=cas.account
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		LEFT JOIN tv_types tt ON tt.id=c.tv_type
		INNER JOIN %s x ON x.id=c.id
		WHERE cas.calendar_period='%s' AND c.tv_type IS NOT NULL AND tt.offline=0 AND ct.service_type=3",
		$src_table, $cp);
	$arr = $sel->next();
	$sh->write_string($i,0, ' + ', $f['']);
	$sh->write_number($i,1, $this->num2($arr['cnt']), $f['num']);
	$sh->write_number($i,2, $this->num2($arr['amount']/100), $f['num']);
	$i+=2;

	$sh->write_string($i,0, "  ", $f['bold']);
	$sh->write_string($i,1, "", $f['']);
	$sh->write_string($i,2, "", $f['']);
	$i++;
	$sh->write_string($i,0, "", $f['caption']);
	$sh->write_string($i,1, '', $f['caption']);
	$sh->write_string($i,2, "", $f['caption_right']);
	$i++;
	
	$sel = $this->connection->select("SELECT sa.name, sum(m.amount) amount
		FROM movements m
		INNER JOIN clients c ON c.account=m.dst
		INNER JOIN %s x ON x.id=c.id
		INNER JOIN system_accounts sa ON sa.account=m.src
		WHERE m.calendar_period='%s'
		GROUP BY m.src", $src_table, $cp);
	while($arr = $sel->next()){
		$sh->write_string($i,0, $arr['name'], $f['']);
		$sh->write_string($i,1, '', $f['']);
		$sh->write_number($i,2, $this->num2($arr['amount']/100), $f['num']);
		$i++;
	}

	$wb->close();
	$str = ob_get_clean();
	return $str;

}

}
?>