<?
class Processor {

function process($cmd, $stdin_reader, $stdout_writer, $stderr_writer){
	$descriptorspec = array(
		0 => array("pipe", "r"), // stdin
		1 => array("pipe", "w"), // stdout
		2 => array("pipe", "w"), // stderr
	);
	$stdin_closed = false;
	if($process = proc_open($cmd, $descriptorspec, $pipes)){
		$stdin_reader->open();
		$stdout_writer->open();
		$stderr_writer->open();
		while(!feof($pipes[1]) || !feof($pipes[2])){
			if(!$stdin_closed){
				$buf = $stdin_reader->read();
				if($buf == -1){
					fclose($pipes[0]);
					$stdin_reader->close();
					$stdin_closed = true;
				}else{
					if(strlen($buf) > 0){
						fwrite($pipes[0], $buf);
					}
				}
			}
			$read = array();
			if(!feof($pipes[1])){
				$read[] = $pipes[1];
			}
			if(!feof($pipes[2])){
				$read[] = $pipes[2];
			}
			$write = array();
			if(!$stdin_closed){
				$write[] = $pipes[0];
			}
			$ready = stream_select($read, $write, $except=null, $timeout = null);
			if(in_array($pipes[1], $read)){
				$buf = fread($pipes[1], 8192);
				if(strlen($buf) > 0){
					$stdout_writer->write($buf);
				}
			}
			if(in_array($pipes[2], $read)){
				$buf = fread($pipes[2], 8192);
				if(strlen($buf) > 0){
					$stderr_writer->write($buf);
				}
			}
		}
		if(!$stdin_closed){
			fclose($pipes[0]);
			$stdin_reader->close();
		}
		fclose($pipes[1]);
		fclose($pipes[2]);
		$stdout_writer->close();
		$stderr_writer->close();
		return proc_close($process);
	}else{
		return -1;
	}
}

}

?>