<?
class Spawner {

var $childs;
var $logger;

function setLoggerFactory($obj){
	$this->logger = $obj->getLogger('spawner');
}

function spawn($cmd){
	$descriptorspec = array(
		0 => array("pipe", "r"), // stdin
		1 => array("pipe", "w"), // stdout
		2 => array("pipe", "w"), // stderr
	);
	if($process = proc_open($cmd, $descriptorspec, $pipes)){
		$status = proc_get_status($process);
		$this->childs[$status['pid']] = array(
			'cmd'=>$cmd,
			'process'=>$process,
			'pipes'=>$pipes,
			'active'=>true,
			'pid'=>$status['pid'],
		);
		$this->logger->debug('spawned [%s]: %s', $status['pid'], $cmd);
		return $status['pid'];
	}else{
		$this->logger->error('cant spawn %s', $cmd);
	}
}

function waitFor($pids){
	$has_open = true;
	while($has_open){
		$has_open = false;
		foreach($pids as $pid){
			if(isset($this->childs[$pid])){
				$child = $this->childs[$pid];
				if($child['active']){
					$pipes = $child['pipes'];
					if(!feof($pipes[1]) || !feof($pipes[2])){
						$has_open = true;
						$read = array($pipes[1], $pipes[2]);
						$ready = stream_select($read, $write=null, $except=null, $timeout = null);
						if(in_array($pipes[1], $read)){
							$buf = trim(fread($pipes[1], 8192));
							if($buf){
								//$this->logger->info('[%s] stdout: %s', $pid, $buf);
							}
						}
						if(in_array($pipes[2], $read)){
							$buf = trim(fread($pipes[2], 8192));
							if($buf){
								$this->logger->error('[%s] stderr: %s', $pid, $buf);
							}
						}
					}else{
						fclose($pipes[0]);
						fclose($pipes[1]);
						fclose($pipes[2]);
						$this->childs[$pid]['active'] = false;
						$this->childs[$pid]['exit'] = proc_close($child['process']);
						$this->logger->debug('[%s] finished', $pid);
					}
				}
			}
		}
	}
}

}
?>