<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

include_once __DIR__.'/TvNodeDriver.php';

class SnmpTvNodeDriver extends TvNodeDriver {

var $ini;
var $defaults;
var $targetData;
var $logger;
var $tvNodeDriverDAO;

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('snmp.tv.node');
}

function setDefaults($arr){
	$this->defaults = $arr;
}

function setTvNodeDriverDAO($obj){
	$this->tvNodeDriverDAO = $obj;
}

function getOpt($name, $default = ''){
	if(isset($this->ini[$name])){
		return $this->ini[$name];
	}else{
		if(isset($this->defaults[$name])){
			return $this->defaults[$name];
		}else{
			return $default;
		}
	}
}

function getSnmpVal($value){
	$v = explode(":", trim($value));
	return trim(array_pop($v));
}

function snmp_get($oid){
	$result =  @snmpget(
		$this->targetData['ip'],
		$this->getOpt('snmp_reader'),
		$oid,
		$this->getOpt('snmp_timeout'),
		$this->getOpt('snmp_retries')
	);
	if($result === FALSE){
		throw new Exception("cant read $oid from ".$this->targetData['ip']);
	}
	return $this->getSnmpVal($result);
}

/* interface method */
function setTargetProfile($id){
	if($this->targetProfile != $id){
		$arr = $this->tvNodeDriverDAO->getTvNodeProfileById($id);
		$this->ini = parse_ini_string($arr['config']);
	}
	parent::setTargetProfile($id);
}

/* interface method */
function setTargetNode($id){
	if($this->targetNode != $id){
		$this->setTargetProfile($this->targetData['profile']);
		$this->targetData = $this->tvNodeDriverDAO->getTvNodeById($id);
	}
	parent::setTargetNode($id);
}

/* interface method */
function getInputPower(){
	return $this->snmp_get($this->getOpt('oid_input_power'));
}

/* interface method */
function getOutputPower(){
	return $this->snmp_get($this->getOpt('oid_output_power'));
}

}
?>