<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class TvNodeAuditor {

var $tvNodeDriverDAO;
var $tvNodeDriverRegistry;

function setLogFactory($logFactory){
	$this->logger = $logFactory->getLogger('tv.node.auditor');
}

function setTvNodeDriverDAO($obj){
	$this->tvNodeDriverDAO = $obj;
}

function setTvNodeDriverRegistry($obj){
	$this->tvNodeDriverRegistry = $obj;
}

function process(){
	$this->tvNodeDriverDAO->preloadAll();
	$this->tvNodeDriverDAO->walkNodes(array($this, 'auditNode'));
}

function auditNode($node){
	if($node['audit']){
		if($profile = $this->tvNodeDriverDAO->getTvNodeProfileById($node['profile'])){
			if($driver = $this->tvNodeDriverRegistry->getDriver($profile['driver'])){
				$driver->setTargetNode($node['id']);
				$in = $out = $available = 0;
				try{
					$in = $driver->getInputPower() * 10;
					$out = $driver->getOutputPower() * 10;
					$available = 1;
				}catch(Exception $ex){
					$this->logger->warning($ex->getMessage());
				}
				$prev_power = $this->tvNodeDriverDAO->getTvNodePowerById($node['id']);
				if(!$prev_power || ($prev_power['available']!=$available) || ($prev_power['input_power']!=$in) || ($prev_power['output_power']!=$out)){
					$this->tvNodeDriverDAO->updatePower($node['id'], $available, $in, $out);
				}
			}
		}
	}
}

}
?>
