<?/* author: Ponomarev Denis <ponomarev@gmail.com> */

class TvNodeDriverDAO {

var $connection;
var $nodes = array();
var $profiles = array();
var $power = array();

function setConnection($obj){
	$this->connection = $obj;
}

function preloadAll(){
	$this->preloadProfiles();
	$this->preloadNodes();
	$this->preloadPower();
}

function preloadProfiles(){
	$this->profiles = array();
	$sel = $this->connection->select("SELECT * FROM tv_node_profiles");
	while($arr = $sel->next()){
		$this->profiles[$arr['id']] = $arr;
	}
}

function preloadNodes(){
	$this->nodes = array();
	$sel = $this->connection->select("SELECT * FROM tv_nodes");
	while($arr = $sel->next()){
		$this->nodes[$arr['id']] = $arr;
	}
}

function preloadPower(){
	$this->power = array();
	$sel = $this->connection->select("SELECT * FROM tv_nodes_power");
	while($arr = $sel->next()){
		$this->power[$arr['tv_node']] = $arr;
	}
}

function getTvNodeById($id){
	if(!isset($this->nodes[$id])){
		$sel = $this->connection->select("SELECT * FROM tv_nodes WHERE id='%s'", $id);
		$this->nodes[$id] = $sel->next();
	}
	return $this->nodes[$id];
}

function getTvNodePowerById($id){
	if(!isset($this->power[$id])){
		$sel = $this->connection->select("SELECT * FROM tv_nodes_power WHERE tv_node='%s'", $id);
		$this->power[$id] = $sel->next();
	}
	return $this->power[$id];
}

function getTvNodeProfileById($id){
	if(!isset($this->profiles[$id])){
		$sel = $this->connection->select("SELECT * FROM tv_node_profiles WHERE id='%s'", $id);
		$this->profiles[$id] = $sel->next();
	}
	return $this->profiles[$id];
}

function updatePower($id, $available, $in, $out){
	$this->connection->update("REPLACE INTO tv_nodes_power (tv_node, available, input_power, output_power) VALUES ('%s', '%s', '%s', '%s')", $id, $available, $in, $out);
}

function walkNodes($callback){
	foreach($this->nodes as $node){
		call_user_func($callback, $node);
	}
}

}
?>