<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.29 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('functions/mail.php');
include_once('functions/homedir.php');
include_once('functions/accounts.php');
include_once('functions/uses.php');
loadStrings(BOOT.'rules/strings.txt');
loadStrings(BOOT.'client_info/strings.txt');
loadStrings(BOOT.'movements/strings.txt');
loadStrings(BOOT.'webmoney/strings.txt');
loadStrings(BOOT.'personal_periods/strings.txt');
loadStrings(BOOT.'mailboxes/strings.txt');
loadStrings(BOOT.'homedirs/strings.txt');
loadStrings(BOOT.'bonuses/strings.txt');
loadStrings(BOOT.'hosts/strings.txt');
loadStrings(BOOT.'connection_types/strings.txt');
loadStrings(BOOT.'charge_types/strings.txt');
loadStrings(BOOT.'charge_subscriptions/strings.txt');

define(CARD_MISSMATCH_COUNT, 3);

$doc->title .= ' :: '.getResource('clientroom.title');

//$db->debug = 1;

$period = new PPeriod2($nil,BOOT.'period/form2.php');

$clients = new PTable($db,BOOT.'client_info/table.php');
$clients->Locate(array('id'=>$_SESSION['client_id']));
if(!$clients->isOn()){
	exit;
}

$client = $clients->active_record;

function pre_pass_post($table){
	if($table->current_record['id'] != $_SESSION['client_id']){
		return 'soso';
	}
	if(CRYPT_CLIENTS_PASS && $table->isChanged('pass')){
		$table->new_record['pass'] = crypt($table->new_record['pass']);
	}
}

function before_schedule_apply($table){
	if($table->new_record['from_time'] >= $table->new_record['to_time']){
		$table->error(getResource('block.schedule.error.time.reverse'));
	}
}

class SwitchForm extends PForm {
	function Process(){
		global $db, $stats_hosts, $action_logger, $client, $firewall_fields;
		$host = $stats_hosts->active_record['id'];
		$ip = $stats_hosts->active_record['ip'];
		$rules = getRules();
		$post = array();
		if($this->submiter=='open'){
			$db->Execute("DELETE FROM hosts_firewall WHERE host='$host'");
			foreach($this->fields as $rule=>$obj){
				$post[$rules[$rule]] = 0;
			}
			if($client['acl_pref'] != 0){
				$db->Execute("UPDATE clients SET acl_pref='0' WHERE id='".$client['id']."'");
				write_port_acl($client['id'], $host);
			}
		}else{
			$close = $this->submiter=='close';
			$replace = array();
			$delete = array();
			$acl = 0;
			foreach($this->fields as $rule=>$obj){
				if(substr($rule, 0, 4)=='acl_'){
					if($obj->value || $close){
						$acl += intval(substr($rule, 4));
					}
				}else{
					if($obj->value || $close){
						$replace[] = sprintf("(%d, %d)", $host,	$rule);
						$x = 1;
					}else{
						$delete[] = $rule;
						$x = 0;
					}
					$old = $firewall_fields[$rule];
					if($old['value']!=$x){
						$post[isset($rules[$rule]) ? $rules[$rule] : $rule] = $old['value'].'*->*'.$x;
					}
				}
			}
			if($client['acl_pref'] != $acl){
				$db->Execute("UPDATE clients SET acl_pref='".$acl."' WHERE id='".$client['id']."'");
				write_port_acl($client['id'], $host);
			}
			if(count($replace) > 0){
				$query  = "REPLACE INTO hosts_firewall (host,rule) VALUES ".implode(", ", $replace);
				$db->Execute($query);
			}
			if(count($delete) > 0){
				$query  = "DELETE FROM hosts_firewall WHERE host='$host' AND rule IN (".implode(", ", $delete).")";
				$db->Execute($query);
			}
		}
		if(!empty($post)){
			$desc = array('client'=>$client['name'], 'ip'=>$ip);
			$action_logger->log_posted('hosts_firewall', '', $desc, $post);
		}
	}
}

class CardForm extends PForm {
	function Process(){
		global $db, $client;
		define(CARD_MISSMATCH_COUNT, 3);
		$code =  $this->fields['code']->value;
		$arr = $db->Next($db->Execute(sprintf("SELECT id, amount, account, movement, expire < now() as expired FROM cards WHERE code_private='%s'", addslashes($code))));
		if($arr){
			if($arr['movement'] > 0){
				return getResource('cards.error.used');
			}
			if($arr['expired']){
				return getResource('cards.error.expired');
			}
			$db->Begin();
			$mid = move($arr['account'], $client['account'], $arr['amount']);
			$db->Execute(sprintf("UPDATE cards SET movement='%s' WHERE id='%s'", $mid, $arr['id']));
			if($db->hasErrors()){
				$db->Rollback();
			}else{
				$db->Commit();
			}
		}else{
			$_SESSION['card_try'] += 1;
			$msg = sprintf(getResource('cards.error.invalid'), $_SESSION['card_try'], CARD_MISSMATCH_COUNT);
			if($_SESSION['card_try'] == CARD_MISSMATCH_COUNT){
				$msg .= '<br>'.getResource('cards.error.bye');
			}
			return $msg;
		}
	}
}

class CCTForm extends PForm {
	function Process(){
		global $db, $next_connection_type, $public_con_types, $client, $action_logger;
		$id = $this->fields['connection_type']->value;
		if($id && ($id!=$next_connection_type['id']) && isset($public_con_types[$id])){
			$new = $public_con_types[$id];
			$cost = 0;
			if($new['enter_cost']){
				$cost = $new['enter_cost'];
			}elseif($new['amount'] < $next_connection_type['amount']){
				$cost = CCT_COST * 100;
			}
			if($cost > 0){
				$rtid = getTrimOption('CCT_RESOURCE_TYPE');
				$dst = getTrimOption('CCT_DST');
				if(isEnoughFundsForRes($client['id'], $rtid, $cost)){
					$db->Begin();
					addSlitResourceUse($client['id'], $rtid, $dst, 1, $cost, 1);
					$db->Execute(sprintf("UPDATE clients SET connection_type='%s' WHERE id='%s'", $id, $client['id']));
					$db->End();
				}else{
					return getResource('clientroom.cct.insufficient');
				}
			}else{
				$db->Execute(sprintf("UPDATE clients SET connection_type='%s' WHERE id='%s'", $id, $client['id']));
			}
			// log
			$desc = array('id'=>$client['id'], 'last_name'=>$client['last_name'], 'first_name'=>$client['first_name'], 'login'=>$client['login']);
			$post = array('connection_type'=>$next_connection_type['name'].'*->*'.$new['name']);
			$action_logger->log_posted('clients', $client['id'], $desc, $post);
		}
	}
}

class BoostForm extends PForm {
	function Process(){
		global $db, $next_connection_type, $boost_types, $client, $action_logger;
		$id = $this->fields['connection_type']->value;
		if($id && ($id!=$next_connection_type['id']) && isset($boost_types[$id])){
			$new = $boost_types[$id];
			if($new['enter_cost'] > 0){
				$cost = $new['enter_cost'];
				$rtid = getTrimOption('CCT_RESOURCE_TYPE');
				$dst = getTrimOption('CCT_DST');
				if(isEnoughFundsForRes($client['id'], $rtid, $cost)){
					$db->Begin();
					addSlitResourceUse($client['id'], $rtid, $dst, 1, $cost, 1);
					$db->Execute(sprintf("UPDATE clients SET connection_type='%s' WHERE id='%s'", $id, $client['id']));
					$db->End();
				}else{
					return getResource('clientroom.cct.insufficient');
				}
			}else{
				$db->Execute(sprintf("UPDATE clients SET connection_type='%s' WHERE id='%s'", $id, $client['id']));
			}
			// log
			$desc = array('id'=>$client['id'], 'last_name'=>$client['last_name'], 'first_name'=>$client['first_name'], 'login'=>$client['login']);
			$post = array('connection_type'=>$next_connection_type['name'].'*->*'.$new['name']);
			$action_logger->log_posted('clients', $client['id'], $desc, $post);
		}
	}
}

class SelfLimitationsForm extends PForm {
	function Process(){
		global $db, $client, $action_logger;
		$replace = array();
		$delete = array();
		$post = array();
		$rtypes = getResourceTypes();
		foreach($this->fields as $rt=>$obj){
			if($obj->value){
				$replace[] = sprintf("(%s, %s, %s)", $client['id'], $rt, $obj->value);
			}else{
				$delete[] = $rt;
			}
			$post[$rtypes[$rt]] = $obj->value;
		}
		if(count($replace) > 0){
			$query  = sprintf("REPLACE INTO self_limitations (client, resource_type, amount) VALUES %s", implode(", ", $replace));
			$db->Execute($query);
		}
		if(count($delete) > 0){
			$query  = sprintf("DELETE FROM self_limitations WHERE client=%s AND resource_type IN (%s)", $client['id'], implode(", ", $delete));
			$db->Execute($query);
		}
		$desc = array('id'=>$client['id'], 'last_name'=>$client['last_name'], 'first_name'=>$client['first_name'], 'login'=>$client['login']);
		$action_logger->log_posted('self_limitations', '', $desc, $post);
	}
}

function getClientBonuses(){
	global $client;
	static $bonuses;
	if(!isset($bonuses)){
		$bonuses = loadByQuery(sprintf("SELECT account as id, name as value FROM bonus_accounts WHERE client='%s'", $client['id']));
	}
	return $bonuses;
}

function createPays($account){
	global $db, $doc, $portmone_opt, $client, $beans, $private;
	$cp = getCurrentCalendarPeriod();
	$portmone_opt = array(
		'payee' => getTrimOption('PORTMONE_PAYEE', $client['city']),
		'login' => getTrimOption('PORTMONE_LOGIN', $client['city']),
		'password' => getTrimOption('PORTMONE_PASSWORD', $client['city']),
		'account' => getSystemAccountByCode('PAY_PORTMONE'),
	);
	if($portmone_opt['account'] && $portmone_opt['payee'] && $portmone_opt['login'] && $portmone_opt['password']){
		if(isset($_GET['SHOPORDERNUMBER'])){
			if($_SESSION['last_pm_pay']!=$_GET['SHOPORDERNUMBER']){
				$_SESSION['last_pm_pay'] = $_GET['SHOPORDERNUMBER'];
				$doc->page->contents['pm_notify']  = '
				<script language="JavaScript">
					alert("'.getResource('portmone.pay.result').'");
				</script>';
			}
			unset($_GET['SHOPORDERNUMBER']);
			unset($_GET['BILL_AMOUNT']);
			unset($_GET['APPROVALCODE']);
			unset($_GET['RESULT']);
		/*
			//$_GET['SHOPORDERNUMBER'] = '1653-1204816578';
			list($clid, $pay_date) = explode("-", $_GET['SHOPORDERNUMBER']);
			if($clid==$client['id']){
				$ch = curl_init();
				$port_from = time() - 60*60*24*3;
				$port_to = time() + 60*60*24*2;
				$params = array(
					'SHOPORDERNUMBER'=>$_GET['SHOPORDERNUMBER'],
					'SHOP_ID'=>$portmone_opt['payee'],
					'LOG'=>urlencode($portmone_opt['login']),
					'PASS'=>urlencode($portmone_opt['password']),
					'SUCCESS'=>0,
					'STARTDAY'=>date("j", $port_from),
					'STARTMONTH'=>date("n", $port_from),
					'STARTYEAR'=>date("Y", $port_from),
					'ENDDAY'=>date("j", $port_to),
					'ENDMONTH'=>date("n", $port_to),
					'ENDYEAR'=>date("Y", $port_to),
					'PAYMENTTYPE'=>1,
				);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_URL, 'https://www.portmone.com.ua/secure/bills/results.php');
				curl_setopt($ch, CURLOPT_POSTFIELDS, implode("&", _Pair($params)));
				ob_start();
				curl_exec($ch);
				$result = trim(ob_get_contents());
				ob_end_clean();
				include_once(ROOT.'classes/xml/StringXmlParser.php');
				include_once(ROOT.'classes/xml/PortmoneResponseDelegate.php');
				$parser = new StringXmlParser();
				$parser->setLogFactory($beans->getBean('loggerFactory'));
				$delegate = new PortmoneResponseDelegate();
				$parser->parse($delegate, $result);
				if(isset($delegate->orders[$_GET['SHOPORDERNUMBER']])){
					$order = $delegate->orders[$_GET['SHOPORDERNUMBER']];
					$amount = intval($order['total'] * 100);
					for($i=0; $i < 3; $i++){
						$db->Begin();
						$mid = move($portmone_opt['account'], $client['account'], $amount);
						$db->Execute(sprintf("INSERT INTO portmone_pays (client, movement, code, date, amount) VALUES (%s, %s, '%s', FROM_UNIXTIME(%s), %s)",
							$client['id'], $mid, $order['ordernumber'], $pay_date, intval($order['total'] * 100)));
						if($db->hasErrors()){
							$db->Rollback();
						}else{
							$db->Commit();
							break;
						}
					}
					header("Location:"._URI(array('SHOPORDERNUMBER', 'BILL_AMOUNT', 'APPROVALCODE', 'RESULT')));
					exit;
				}
			}
		*/
		}
	}

	$pmenu = new PNamedMenu($nil,BOOT.'client_info/pays/menu.php');
	if(!$pmenu->empty){
		$doc->page->contents['pays_icon'] = '<br><div class="access_head"><img src="'.HREF.'images/dollar.gif" vspace="2" hspace="2" style="vertical-align: middle;">'.getResource('clientroom.pays.title').'</div>';
		$doc->page->contents['pays_menu'] = $pmenu;
	}
	switch($pmenu->selected){
		case 'ca':
			loadStrings(BOOT.'cards/strings.txt');
			$doc->page->contents['card'] = new CardForm($nil,BOOT.'client_info/pays/form.php');
			break;
		case 'or':
			$doc->page->contents['order'] = new PForm($nil,BOOT.'client_info/pays/order-form.php');
			break;
		case 'wm':
			$doc->page->contents['wm'] = new PForm($nil,BOOT.'client_info/pays/wm-form.php');
			$doc->page->contents['wm_disabler']  = '
			<script language="JavaScript">
				setTimeout("document.wm.ok.disabled = true", 1000 * 600);
				setTimeout("document.wm.LMI_PAYMENT_AMOUNT.disabled = true", 1000 * 600);
			</script>';
			break;
		case 'priv':
			$min_pay = getNumOption('PRIVATE_MIN_PAY', $client['city']);
			if(isset($_POST['private_amount']) && ($_POST['private_amount'] >= $min_pay)){
				$private = array();
				$password = getTrimOption('PRIVATE_PASSWORD', $client['city']);
				$percent = getTrimOption('PRIVATE_PERCENT', $client['city']);
				$amount = intval(strval($_POST['private_amount']));
				if(isset($percent)){ 		
					$private['amount'] =  $amount+$amount*($percent/100);
				}else {
					$private['amount'] =  $amount;
				}
				$private['order_id'] = time().'-'.$client['id'];
				$private['public_key'] = getTrimOption('PRIVATE_MER_ID', $client['city']);
				
				$private['currency'] ='UAH'; 
				$private['type']     ='buy';
//				$private['language'] ='ru';
//				$private['sandbox']  ='1';
				
				
				
				
				
				//$password = '34074xhjqmwf8gs';
//				$private['order_id'] ='111176767666676';
				//$private['order_id'] = 'TEST_Lanet_'.date('Ymd_His').'_'.$private['order_id'];
				//$private['merid'] = 'I0110020';
				//$private['amount'] = '000000000100';
				
				echo $private['amount'];
        $private['description'] = $client['contract'];

        $private['signature'] = base64_encode(sha1(
        $password. 
        $private['amount'].
        $private['currency'].
        $private['public_key'].
        $private['order_id'].
        $private['type'].
        $private['sandbox'].
        $private['description'].
        'https://stat.kvant.mk.ua/client_info.php?cmenu_selected=mo'.
        'https://stat.kvant.mk.ua/pay-private.php',
		true));



/*
		$private['signature'] = base64_encode(sha1(join('',compact(
		$password.
		$private['amount'].
		$private['currency'].
		G$private['public_key'].
		$private['order_id'].
		$private['type'].
		$private['description'].
		$private['result_url'].
		$private['server_url'])),
		
true));
*/
				
				$db->Execute(sprintf("INSERT INTO private_pays (client, date, amount, order_id) VALUES ('%s', now(), '%s', '%s')",
					$client['id'], $private['amount']*100, $private['order_id']));
				$doc->page->contents['priv'] = new PForm($nil,BOOT.'client_info/pays/private-form.php');
				$doc->page->contents['priv_disabler']  = '
				<script language="JavaScript">
					setTimeout("document.priv.submit();", 1000 * 3);
				</script>';
			}else{
				if(isset($_POST['private_amount']) && ($_POST['private_amount'] < $min_pay)){
					$GLOBALS['private_warn'] = 1;
				}
				$doc->page->contents['priv_pre'] = new PForm($nil,BOOT.'client_info/pays/private-pre-form.php');
				$doc->page->contents['pre_auto']  = '
				<script language="JavaScript">
					setTimeout("document.privpre.ok.disabled = true", 1000 * 600);
					setTimeout("document.privpre.private_amount.disabled = true", 1000 * 600);
				</script>';
			}
			break;
		case 'ups':
			$doc->page->contents['ups'] = new PForm($nil,BOOT.'client_info/pays/ups-form.php');
			$doc->page->contents['ups_disabler']  = '
			<script language="JavaScript">
				setTimeout("document.ups.pay.disabled = true", 1000 * 600);
				setTimeout("document.ups.amount.disabled = true", 1000 * 600);
			</script>';
			break;
		case 'pm':
			$portmone_opt['code'] = $client['id'].'-'.time();
			$doc->page->contents['portmone_script'] = '
			<script language="JavaScript">
			function calcTaxed(f, target){
				var form = f.form;
				var t = form.elements[target];
				var v = f.value.replace(" ", "").replace(",",".");
				t.value = Math.ceil(v * 10000 / 95)/100;
			}
			function calcUntaxed(f, target){
				var form = f.form;
				var t = form.elements[target];
				var v = f.value.replace(" ", "").replace(",",".");
				t.value = Math.floor(v * 95)/100;
			}
			</script>';
			$doc->page->contents['portmone_form'] = new PForm($nil,BOOT.'client_info/pays/portmone-form.php');
			$doc->page->contents['portmone_disabler']  = '
			<script language="JavaScript">
				setTimeout("document.pm_form.ok.disabled = true", 1000 * 600);
				setTimeout("document.pm_form.BILL_AMOUNT.disabled = true", 1000 * 600);
			</script>';
			break;
	}
}

function createInOut($account, $for_deposit = false){
	global $db, $doc, $portmone_opt, $client, $beans, $private;
	$cp = getCurrentCalendarPeriod();
	$db->Execute(sprintf("CREATE TEMPORARY TABLE mov_in  ENGINE=Memory
		SELECT calendar_period, src, dst, sum(amount) amount, date
		FROM movements WHERE dst=%s AND date<now() GROUP BY calendar_period, src, dst, date", $account));
	$mov_in = new PTable($db,BOOT.'client_info/movements/mov_in/table.php');
	$doc->page->contents['mov_in'] = new PMyAccess($mov_in,array(
		'title'=>getResource('clientroom.movements.in'),
		'icon'=>HREF.'images/dollar.gif',
		'icon_attributes'=>'width=29 height=42',
		'grid_boot'=>BOOT.'client_info/movements/mov_in/grid.php',
	));
//	$doc->page->contents['more_space'] = '<br><br>';
	$db->Execute(sprintf("CREATE TEMPORARY TABLE mov_out (
			calendar_period bigint not null,
			src bigint not null,
			dst bigint not null,
			amount bigint not null,
			date datetime) ENGINE=Memory
		SELECT calendar_period, src, dst, sum(amount) amount, date
		FROM movements WHERE src=%s  AND date<now() GROUP BY calendar_period, src, dst, date", $account));
	$db->Execute(sprintf("INSERT INTO mov_out
		SELECT calendar_period, src, dst, sum(floor(amount * price / unit_size)), period_end
		FROM resource_uses ru
		LEFT JOIN calendar_periods cp ON cp.id=ru.calendar_period
		WHERE
			calendar_period=%s
			AND src=%s
			AND dst IS NOT NULL
			AND movement IS NULL
			AND floor(amount * price / unit_size) > 0
		GROUP BY dst", $cp, $account));
	$mov_out = new PTable($db, BOOT.'client_info/movements/mov_out/table.php');
	$doc->page->contents['mov_out'] = new PMyAccess($mov_out,array(
		'title'=>getResource('clientroom.movements.out'),
		'icon'=>HREF.'images/dollar.gif',
		'icon_attributes'=>'width=29 height=42',
		'grid_boot'=>BOOT.'client_info/movements/mov_out/grid.php',
	));
}

$res = $db->Execute(sprintf("SELECT id, connection_type, state, UNIX_TIMESTAMP(period_begin) as period_begin, UNIX_TIMESTAMP(period_end) as period_end
	FROM personal_periods WHERE marker=1 AND client='%s'", $clients->active_record['id']));
$personal_period = $db->Next($res);

//$db->debug = 1;

$connection_type = loadRecord(sprintf("SELECT * FROM connection_types WHERE id='%s'", $personal_period ? $personal_period['connection_type'] : $clients->active_record['connection_type']));
$next_connection_type = loadRecord(sprintf("
	select ct.*, ct.abon_amount + IFNULL(x.use_plan,0) as amount, IFNULL(ctv.cost,0) as tv_amount
	from connection_types ct
	LEFT JOIN connection_type_tv ctv ON ctv.connection_type=ct.id AND ctv.tv_type='%s'
	left join (
	  select sum(use_plan) use_plan, connection_type from connection_type_resources group by connection_type
	) x on x.connection_type=ct.id
	where ct.id='%s'", $client['tv_type'], $client['connection_type']));

$boost_types = loadAssoc("SELECT ct.*, b.name boost_name
	FROM connection_type_boost b
	LEFT JOIN connection_types ct ON ct.id=b.boost
	WHERE b.connection_type='".$client['connection_type']."'");

$arr = $clients->active_record;

if(isset($_GET['offlinehelp'])){
	include 'includes/offline_help.php';
}

$doc->page->contents['cinfo'] = "<table width=\"100%\"><tr><td class=\"cname\">".$arr['last_name']." ".$arr['first_name']."</td>
<!--<td align='right' style=\"padding:4px;\"><a href=\"http://www.lanet.ua/company/help/connect\" style=\"font-size: 10pt; font-weight:bold;\"><img src=\"images/info.gif\" align=\"middle\" border=0 hspace=4>  </a></td>-->
</tr></table>";
//$doc->page->contents['howto'] = "<div width='100%' align='right' style=\"padding:4px;\"><a href=\"http://rada.lanet.ua/\">Online-  </a>&nbsp;<img src=\"images/help.png\" style=\"vertical-align: middle;\">&nbsp;<a href=\"http://www.lanet.ua/company/help/connect\">  </a></div>";
$doc->page->contents['howto'] = "<br>";

$ads = loadRecords("SELECT a.id, a.body, q.body as q_body FROM ads a LEFT JOIN queries q ON q.id=a.query 
	WHERE (q.id IS NOT NULL) AND (a.city IS NULL OR a.city='".$client['city']."') AND (a.period_begin IS NULL OR a.period_begin<=now()) AND (a.period_end IS NULL OR a.period_end>=now()) ORDER BY a.number");

function not_global_ad($str){
	ob_start();
	eval('?>'.$str.'<?');
	return ob_get_clean();
}

foreach($ads as $ad){
	if(loadRecord(sprintf("SELECT x.id FROM (%s) x WHERE x.id='%s'", prepare_multiquery($ad['q_body']), $client['id']))){
		$doc->page->contents['ad_'.$ad['id']] = not_global_ad($ad['body']);
	}
}


if(!isset($_SESSION['polls'])){
	$_SESSION['polls'] = loadAssoc("SELECT p.id FROM polls p
		LEFT JOIN poll_votes v ON v.poll=p.id AND v.client='".$client['id']."'
		INNER JOIN queries q ON q.id=p.query
		WHERE (v.poll IS NULL) AND (p.city IS NULL OR p.city='".$client['city']."') 
		AND (p.period_begin IS NULL OR p.period_begin<=now()) AND (p.period_end IS NULL OR p.period_end>=now()) ORDER BY p.priority DESC");
}


foreach($_SESSION['polls'] as $pid=>$poll){
	$q = loadValue("SELECT body FROM queries WHERE id=(SELECT query FROM polls WHERE id='".$pid."')");
	if(loadRecord(sprintf("SELECT x.id FROM (%s) x WHERE x.id='%s'", prepare_multiquery($q), $client['id']))){
		$doc->final = "<div id='overlay'></div>";
		$doc->page->contents['poll_begin'] = "<div class='poll'>";
		include 'includes/poll.php';
		$doc->page->contents['poll_end'] = "</div>";
		break;
	}
}

function compareBonuses($b1, $b2){
	return $b2['priority'] - $b1['priority'];
}

function prognoseBonuses(){
	global $client, $personal_period;
	$cp = getCurrentCalendarPeriod();
	//  
	$bonuses = loadAssoc("SELECT ba.account_type, cas.state_end as state, at.priority
		FROM bonus_accounts ba
		INNER JOIN account_types at ON at.id=ba.account_type
		LEFT JOIN calendar_account_states cas ON cas.account=ba.account AND cas.calendar_period='".$cp."'
		WHERE client='".$client['id']."' AND (ba.actual_from IS NULL OR actual_from <= now()) AND (ba.actual_to IS NULL OR actual_to > now())", 'account_type');
	//   ,      
	if($personal_period && $personal_period['state']==1){
		$close = loadRecords("SELECT account_type, end_amount FROM connection_type_bonuses WHERE connection_type='".$personal_period['connection_type']."' AND end_dst IS NOT NULL");
		foreach($close as $arr){
			if(isset($bonuses[$arr['account_type']])){
				$bonuses[$arr['account_type']]['state'] = min($bonuses[$arr['account_type']]['state'], $arr['end_amount']);
			}
		}
	}
	//     
	$open = loadRecords("SELECT ctb.account_type, ctb.start_amount as state, at.priority
		FROM connection_type_bonuses ctb 
		LEFT JOIN account_types at ON at.id=ctb.account_type
		WHERE ctb.connection_type='".$client['connection_type']."' AND start_src IS NOT NULL");
	foreach($open as $arr){
		if(isset($bonuses[$arr['account_type']])){
			$bonuses[$arr['account_type']]['state'] += $arr['state'];
		}else{
			$bonuses[$arr['account_type']] = $arr;
		}
	}
	$resMap = loadRecords("SELECT account_type, resource_type FROM account_resource_types");
	foreach($resMap as $res){
		if(isset($bonuses[$res['account_type']])){
			$bonuses[$res['account_type']]['resource_types'][$res['resource_type']] = 1;
		}
	}
	uasort($bonuses, 'compareBonuses');
	return $bonuses;
}

function cur($val){
	return number_format($val/100, 2, '.', ' ');
}

class Needle {
	var $sum = 0;
	var $members = array();
	var $bonuses;

	function Needle($bonuses){
		$this->bonuses = $bonuses;
	}

	function add($amount, $rtid=''){
		$this->members[] = cur($amount);
		if($rtid){
			foreach($this->bonuses as $at=>$bonus){
				if(isset($bonus['resource_types'][$rtid]) && ($bonus['state'] > 0)){
					$fit = min($bonus['state'], $amount);
					$amount -= $fit;
					$this->bonuses[$at]['state'] -= $fit;
				}
			}
		}
		$this->sum += $amount;
		return $amount;
	}
}

$bonuses = prognoseBonuses();
//print_r($bonuses);
$needle = new Needle($bonuses);

if($next_connection_type['abon_dst']){
	$needle->add($next_connection_type['abon_amount'], $next_connection_type['abon_resource_type']);
}

$needle->add($next_connection_type['tv_amount'], getTrimOption('TV_RESOURCE_TYPE'));

if($credit_arr = $db->Next($db->Execute(sprintf("SELECT sum(amount) amount FROM credits WHERE client='%s' AND
	(actual_from IS NULL || now()>=actual_from) AND (actual_to IS NULL || now() < actual_to)", $client['id'])))){
	$credit = $credit_arr['amount'] ? $credit_arr['amount'] : '0';
}else{
	$credit = '0';
}

$charges_needle = 0;
//    -  ,        
if(!loadRecord("SELECT id FROM connection_types WHERE credit_con_type='".$client['connection_type']."'")){
	$charges = loadRecords(sprintf("SELECT s.amount * t.price / t.unit_size as needle, t.resource_type
		FROM charge_subscriptions s
		LEFT JOIN charge_types t ON s.type=t.id
		WHERE s.client=%s", $client['id']));
	foreach($charges as $ch){
		$charges_needle += $needle->add($ch['needle'], $ch['resource_type']);
	}
}

$plans = $db->Next($db->Execute(sprintf("SELECT sum(use_plan) use_plan
	FROM connection_type_resources ctr
	WHERE ctr.connection_type=%s", $next_connection_type['id'])));
$needle->add($plans['use_plan']);

$plans = $db->Next($db->Execute(sprintf("
	SELECT sum(
		if((pp.state=1) && (ppp.use_actual < ppp.use_plan), ppp.use_plan - ppp.use_actual, 0) +
		if((pp.state=2) && (ctr.penalty_type=0) && (ppp.use_actual < ppp.use_plan), ppp.use_plan - ppp.use_actual, 0) +
		if((pp.state=2) && (ctr.penalty_type=2), if(ppp.use_plan > ppp.use_actual, if((ppp.use_plan - ppp.use_actual) > ctr.use_plan, ctr.use_plan, ppp.use_plan - ppp.use_actual), 0), 0)
	) as use_lack
	  FROM personal_period_plans ppp
	  LEFT JOIN personal_periods pp ON pp.id=ppp.personal_period
--		  left join clients c on c.id=pp.client
		  left join connection_type_resources ctr on ctr.connection_type=pp.connection_type and ctr.resource_type=ppp.resource_type
		WHERE pp.marker=1 AND pp.client=%s
	", $client['id'])));

$use_lack = $plans['use_lack'];

$client['deposit2'] = ($client['deposit'] - $use_lack);

$needle->add($use_lack);

//print_r($needle);

$miss = $needle->sum - $client['deposit'] - $credit + $arr['block'];

function get_credit_connection_type(){
	global $next_connection_type, $personal_period;
	//  -       
	if($next_connection_type['credit_con_type']){
		$prev_type = $personal_period['connection_type'];
		//      ,     
		if(!$prev_type || !loadRecord("SELECT id FROM connection_types WHERE credit_con_type='".$prev_type."' LIMIT 1")){
			return loadRecord("SELECT * FROM connection_types WHERE id='".$next_connection_type['credit_con_type']."'");
		}
	}
}

$credit_type = '';
$warnings = array();
if($next_connection_type['service_type']==0){
	$warnings['offline'] = getResource('clientroom.offline.warning');
}else{
	$low_deposit = $arr['blockable'] && (gmp_cmp($arr['deposit'], gmp_sub($arr['block'], $credit)) < 0);
	
	$admin_disconnect = $db->Next($db->Execute(sprintf("SELECT id, type, client_note, UNIX_TIMESTAMP(actual_from) actual_from, UNIX_TIMESTAMP(actual_to) actual_to
		FROM blocks
		WHERE client=%s AND resource_type IS NULL AND (actual_from IS NULL || actual_from <= now()) AND (actual_to IS NULL || actual_to > now())", $client['id'])));
	if($admin_disconnect){
		if($admin_disconnect['type']==2){
			$warnings['self_disconnects'] = sprintf(getResource('clientroom.blocks.blocked.1'), date("Y-m-d H:i", $admin_disconnect['actual_from']), date("Y-m-d H:i", $admin_disconnect['actual_to']));
			$warnings['unblock'] = getResource('clientroom.blocks.blocked.2');
		}else{
			$warnings['admin_disconnects'] = $admin_disconnect['client_note'] ? (getResource('clientroom.admin.block').'<br><pre>'.$admin_disconnect['client_note'].'</pre>') : getResource('clientroom.dead.info.admin');
		}
	}else{
		if($personal_period['state']!=1){
			if($miss > 0){
				$warnings['not_ready'] = sprintf(getResource('clientroom.dead.info.period'), cur($needle->sum - $use_lack), cur($miss));
				if(!$low_deposit){
					$credit_type = get_credit_connection_type();
				}
			}
		}else{
			$admin_blocks = $db->Next($db->Execute(sprintf("SELECT COUNT(*) as count FROM blocks
				WHERE client=%s AND resource_type IS NOT NULL AND (actual_from IS NULL || actual_from <= now()) AND (actual_to IS NULL || actual_to > now())", $client['id'])));
			if($admin_blocks['count'] > 0){
				$warnings['admin_blocks'] = getResource('clientroom.block.info.admin');
			}elseif($low_deposit){
				if($next_connection_type['service_type']&1){
					$warnings['deposit'] = getResource('clientroom.deposit.blocked.info');
				}
			}
		}
	}
}

if(!empty($warnings)){
	$doc->page->contents['warnings'] = sprintf("<font color=red><b>%s</b></font><br><br>", getResource('clientroom.deposit.warning.intro').implode("<br><br>", $warnings));
}

if($credit_type){
	if(isset($_GET['use_credit_period'])){
		$db->Execute("UPDATE clients SET connection_type='".$credit_type['id']."' WHERE id='".$client['id']."'");
		header("Location:client_info.php");
	}
	$d = '';
	switch(substr($credit_type['period_days'], -1)){
	case '1': $d = ''; break;
	case '2':
	case '3':
	case '4': $d = ''; break;
	}
	$d = $credit_type['period_days'].' '.$d;
	$doc->page->contents['credit_type_info'] = "<font color=green><b>".sprintf(getResource('clientroom.credit.type.info'), $d, $d)."</b></font> <br>" . getResource('clientroom.credit.type.info.mes');
	$doc->page->contents['credit_type_use'] = '<br><br><form method="get" action="client_info.php">
		<input type="hidden" name="use_credit_period" value="1">
		<button type="submit">'.getResource('clientroom.credit.type.use').'</button></form><br>';
}


//$show_deposit = number_format($arr['deposit_cur'], 2, '.', ' ');
$show_deposit = cur($arr['deposit'] - $use_lack);
if($low_deposit){
	$show_deposit = sprintf("<font color=red><b>%s</b></font>", $show_deposit);
}
$iarr = array();
$iarr[] = array(
	getResource('clientroom.deposit'),
	$show_deposit,
	getResource('clientroom.deposit.comment.2'),
);

$cp = getCurrentCalendarPeriod();
$bonuses = loadRecords("SELECT at.name, at.description, cas.state_end state
	FROM bonus_accounts ba 
	LEFT JOIN account_types at ON at.id=ba.account_type
	LEFT JOIN calendar_account_states cas ON cas.account=ba.account AND cas.calendar_period='".$cp."'
	WHERE ba.client='".$client['id']."' AND at.front_page=1");
foreach($bonuses as $bonus){
	$iarr[] = array(
		$bonus['name'],
		frmt_3_2($bonus['state']/100),
		$bonus['description'],
	);
}

if($use_lack > 0){
	$iarr[] = array(
		getResource('clientroom.traffic'),
		number_format($use_lack/100, 2, '.', ' '),
		getResource('clientroom.traffic.comment'),
	);
}

/*
$iarr[] = array(
	getResource('clients.alarm'),
	$arr['alarm_cur'],
	getResource('clientroom.alarm.comment'),
);
*/
/*
$iarr[] = array(
	getResource('clients.block'),
	$arr['block_cur'],
	getResource('clientroom.block.comment'),
);
*/
$next_name = $next_connection_type['name'];
if($next_connection_type['service_type']==0){
	$next_name = "<font color=red>".$next_name."</font>";
}

$cct_button = '<form method="get" action="client_info.php" style="display:inline;"><input type="hidden" name="cmenu_selected" value="cct"><button type="submit">'.getResource('clientroom.connection.type.change').'</button></form>';
$boost_button = '<form method="get" action="client_info.php" style="display:inline;"><input type="hidden" name="cmenu_selected" value="bst"><button type="submit">'.getResource('clientroom.connection.type.boost').'</button></form>';

$ct_comment = '';
if($next_connection_type['allow_leave']){
	$ct_comment .= $cct_button;
}
if(!empty($boost_types)){
	$ct_comment .= $boost_button;
}
if(!$ct_comment){
	$ct_comment .= getResource('clientroom.connection.type.comment');
}

$iarr[] = array(
	getResource('clientroom.connection.type'),
	$next_name,
	$ct_comment,
);

if($client['tv_type']){
	$iarr[] = array(
		getResource('clientroom.tv.type'),
		$client['tv_type_name'],
		$client['tv_type_info'],
	);
}

$iarr[] = array(
	getResource('clientroom.period.end'),
	strftime("%e %b %H:%M" ,$personal_period['period_end']),
	$personal_period['state']==2 ? getResource('clientroom.period.end.comment.2') : getResource('clientroom.period.end.comment'),
);
if($next_connection_type['service_type'] > 0){
	if(!empty($needle->members)){
		$iarr[] = array(
			getResource('clientroom.miss'),
			cur(max($miss, 0)),
			sprintf(getResource('clientroom.miss.comment')),
		);
	}
}

if($arr['contract']){
	$iarr[] = array(
		getResource('clientroom.contract'),
		$arr['contract'],
		getResource('clientroom.contract.comment'),
	);
}

include 'includes/unshape.php';

$header = "";
foreach($iarr as $item){
	$header .= sprintf("<tr class='grid_row'>\n\t\t<td width='0%%' nowrap>%s</td>\n\t\t<td width='10%%' align='right' nowrap>%s</td>\n\t\t<td width='80%%'>%s</td>\n\t</tr>\n", $item[0], $item[1], $item[2]);
}
$doc->page->contents['header'] = "<table class='grid' border='0' width='100%' cellspacing='0' cellpadding='0'>\n".$header."</table>\n";

$cmenu = new PNamedMenu($nil,BOOT.'client_info/menu.php');
$doc->page->contents['client_menu'] = $cmenu;

$db->Execute("CREATE TEMPORARY TABLE state_names (state tinyint not null primary key, name varchar(255)) ENGINE=Memory");
$db->Execute(sprintf("INSERT INTO state_names VALUES (0, '%s'), (1, '%s'), (2, '%s')",
	getResource('personal.periods.state.none'),
	getResource('personal.periods.state.open'),
	getResource('personal.periods.state.closed')
));
$tariffs = new PTable($db,BOOT.'client_info/rules/table.php');
$stats_hosts = new PTable($db,BOOT.'client_info/hosts/table.php');
$host_count = $stats_hosts->getCount();
if($host_count==0){
	unset($cmenu->items['ho']);
	unset($cmenu->items['ta']);
	unset($cmenu->items['sl']);
}
$personal_periods = new PTable($db,BOOT.'client_info/personal_periods/table.php');
if($personal_periods->getCount()==0){
	unset($cmenu->items['pr']);
}
$bonuses = new PTable($db,BOOT.'client_info/bonuses/table.php');
if($bonuses->getCount()==0){
	unset($cmenu->items['bo']);
}
$homedirs = new PTable($db,BOOT.'client_info/homedirs/table.php');
if($homedirs->getCount()==0){
	unset($cmenu->items['hd']);
}
$mailboxes = new PTable($db,BOOT.'client_info/mailboxes/table.php');
if($mailboxes->getCount()==0){
	unset($cmenu->items['ma']);
}
$subscriptions = new PTable($db,BOOT.'client_info/charge_subscriptions/table.php');
if($subscriptions->getCount()==0){
	unset($cmenu->items['su']);
}
$credits = new PTable($db,BOOT.'client_info/credits/table.php');
if($credits->getCount()==0){
	//unset($cmenu->items['cd']);
}

// && isset($_SESSION['client_supervisor'])
if(!(DRWEB_CHARGE_TYPE && DRWEB_API_URL && DRWEB_GROUP && DRWEB_USER && DRWEB_PASSWORD)){
	unset($cmenu->items['dw']);
}

$arr = loadRecord(sprintf("SELECT count(*) cnt
				FROM connection_type_rules ctr
				LEFT JOIN connection_type_resources ctrs ON ctrs.id=ctr.connection_type_resource
				WHERE ctrs.connection_type=%s", $connection_type['id']));
$by_traffic = $arr['cnt'] > 0;
if(!$by_traffic){
	unset($cmenu->items['ta']);
	unset($cmenu->items['sl']);
}
if($cmenu->selected!='cct' && $cmenu->selected!='bst' && !isset($cmenu->items[$cmenu->selected]) && $host_count>0){
	$cmenu->selected = 'ho';
}

switch($cmenu->selected){
	case 'he':
		include('includes/clients_documents.php');
		break;
	case 'dw':
		include('includes/drweb3.php');
		break;
	case 'bst':
		$doc->page->contents['boost_title'] = '<img src="'.HREF.'/images/switcher.gif" align="middle" vspace="6"><span class="access_head">'.getResource('clientroom.boost.title').'</span>';
		$boost_candidates = array();
		$js_names = array();
		$confirms = array();
		foreach($boost_types as $id=>$arr){
			$name = $arr['boost_name'];
			if($arr['enter_cost'] > 0){
				$name .= ' '.sprintf(getResource('clientroom.boost.cost'), $arr['enter_cost']/100);
				$confirms[] = $id.':"'.sprintf(getResource('clientroom.boost.confirm.payed'), $arr['enter_cost']/100).'"';
			}else{
				$name .= ' '.getResource('clientroom.boost.cost.free');
				$confirms[] = $id.':"'.getResource('clientroom.boost.confirm.free').'"';
			}
			$boost_candidates[$arr['id']] = $name;
			$js_names[] = sprintf("ct_names[%s] = \"%s\";\n", $arr['id'], $arr['name']);
		}
		$doc->page->contents['boost_confirm'] = '
		<script language="Javascript">
			function BoostValidator(name){
				if(CommonFormCheck(name)){
					var frm = document.forms[name];
					var ct_names = new Object();
					'.implode("", $js_names).'
					var confirms = {'.implode(", ", $confirms).'};
					var ct = frm.connection_type.value;
					var msg = sprintf("'.getResource('clientroom.boost.confirm').'", ct_names[ct]);
					msg += "\n\n" + confirms[ct];
					return confirm(msg);
				}else{
					return false;
				}
			}
		</script>';
		$doc->page->contents['boost_form'] = new BoostForm($nil,BOOT.'client_info/boost/form.php');
		$doc->page->contents['boost_text'] = getResource('clientroom.boost.comment');
		break;
	case 'cct':
		if($next_connection_type['allow_leave']){
			$doc->page->contents['cct_title'] = '<img src="'.HREF.'/images/switcher.gif" align="middle" vspace="6"><span class="access_head">'.getResource('clientroom.cct.title').'</span>';
			$res = $db->Execute(sprintf("select ct.id, ct.name, ct.enter_cost, ct.abon_amount + x.use_plan as amount
				from connection_types ct
				left join (
				  select sum(use_plan) use_plan, connection_type from connection_type_resources group by connection_type
				) x on x.connection_type=ct.id
				where ct.allow_enter AND (max_hosts=0 || max_hosts >= %s)
				".($next_connection_type['city'] ? (" AND ct.city='".$next_connection_type['city']."'") : "")."
				order by substring(ct.name,1,3), amount", $host_count));
			$cct_candidates = array();
			$public_con_types = array();
			$js_names = array();
			while($arr = $db->Next($res)){
				$public_con_types[$arr['id']] = $arr;
				if($arr['id']!=$next_connection_type['id']){
					$cct_candidates[$arr['id']] = $arr['name'];
					$js_names[] = sprintf("ct_names[%s] = \"%s\";\n", $arr['id'], $arr['name']);
				}
			}
			$confirms = array();

			foreach($cct_candidates as $id=>$name){
				if($id!=$next_connection_type['id']){
					if($public_con_types[$id]['enter_cost'] > 0){
						$cct_candidates[$id] = $name.' '.sprintf(getResource('clientroom.cct.cost'), $public_con_types[$id]['enter_cost']/100);
						$confirms[] = $id.':"'.sprintf(getResource('clientroom.cct.confirm.payed'), $public_con_types[$id]['enter_cost']/100).'"';
					}else{
						if($public_con_types[$id]['amount'] < $next_connection_type['amount']){
							$cct_candidates[$id] = $name.' '.sprintf(getResource('clientroom.cct.cost'), CCT_COST);
							$confirms[] = $id.':"'.sprintf(getResource('clientroom.cct.confirm.payed'), CCT_COST).'"';
						}else{
							$cct_candidates[$id] = $name.' '.getResource('clientroom.cct.cost.free');
							$confirms[] = $id.':"'.getResource('clientroom.cct.confirm.free').'"';
						}
					}
				}
			}
			$doc->page->contents['cct_confirm'] = '
			<script language="Javascript">
				function CCTValidator(name){
					if(CommonFormCheck(name)){
						var frm = document.forms[name];
						var ct_names = new Object();
						'.implode("", $js_names).'
						var confirms = {'.implode(", ", $confirms).'};
						var ct = frm.connection_type.value;
						var msg = sprintf("'.getResource('clientroom.cct.confirm').'", ct_names[ct]);
						msg += "\n\n" + confirms[ct];
						return confirm(msg);
					}else{
						return false;
					}
				}
			</script>';
			$doc->page->contents['cct_form'] = new CCTForm($nil,BOOT.'client_info/cct/form.php');
			$doc->page->contents['cct_text'] = '<div style="padding:2px;">'.sprintf(getResource('clientroom.cct.comment'), CCT_COST).'</div>';
		}
		break;
	case 'ta':
		$tariffs_acc = $doc->page->contents['tariffs'] = new PMyAccess($tariffs,array(
			'title'=>getResource('clientroom.tariffs.title'),
			'icon'=>HREF.'images/tariffs.gif',
			'grid_boot'=>BOOT.'client_info/rules/grid.php',
		));
		break;
	case 'sl':
		$doc->page->contents['self_limitations'] = '<img src="'.HREF.'images/limitations.png" align="middle" vspace="6"><span class="access_head">'.getResource('self.limitations.title').'</span>';
		$res = $db->Execute(sprintf("
		SELECT rt.id, rt.name, IFNULL(sl.amount,0) as amount
		FROM connection_type_resources ctr
		LEFT JOIN self_limitations sl ON sl.resource_type = ctr.resource_type AND sl.client=%s
		LEFT JOIN resource_types rt ON rt.id=ctr.resource_type
		WHERE ctr.connection_type=%s ORDER BY rt.name",$client['id'], $connection_type['id']));
		while($arr = $db->Next($res)){
			$self_limitations_fields[$arr['id']] = array(
				'control'=>'short',
				'format'=>$GLOBALS['fcurrency'],
				'title'=>$arr['name'],
				'value'=>$arr['amount'],
				'label'=>getResource('self.limitations.amount'),
			);
		}
		$doc->page->contents['switcher'] = new SelfLimitationsForm($nil,BOOT.'client_info/self_limitations/form.php');
		$doc->page->contents['switcher_desc'] = '<br>'. sprintf(getResource('clientroom.limit.description'), $personal_period['id']);
		break;
	case 'mo':
		createPays($client['account']);
		createInOut($client['account'], true);
		break;
	case 'cd':
		class AddCreditForm extends PForm {
			function Process(){
				global $db, $client, $credit_propose, $action_logger;
				$db->Execute(sprintf("INSERT INTO stamps (created, created_by) VALUES (now(), '%d')", CLIENT_OPERATOR));
				$stamp = $db->getJustInserted('stamps', 'id');
				$db->Execute(sprintf("INSERT INTO credits (client, amount, actual_from, actual_to, type, stamp)
					VALUES ( %s, %s, FROM_UNIXTIME(%s), FROM_UNIXTIME(%s), '3', %s)", $client['id'],
					$credit_propose['sum'],
					$credit_propose['from'],
					$credit_propose['to'],
					$stamp));
				$cid = $db->getJustInserted('credits', 'id');
				$inserted = array(
					'id'=>$cid,
					'client'=>$$client['name'],
					'amount'=>$credit_propose['sum'],
					'actual_from'=>date("Y-m-d H:i:s", $credit_propose['from']),
					'actual_to'=>date("Y-m-d H:i:s", $credit_propose['to']),
				);
				$action_logger->log_inserted('credits', $cid, $inserted);
			}
		}

		$doc->page->contents['credits'] = new PMyAccess($credits,array(
			'title'=>getResource('clientroom.credits.title'),
			'icon'=>HREF.'images/dollar.gif',
'icon_attributes'=>'width=29 height=42',
			'grid_boot'=>BOOT.'client_info/credits/grid.php',
		));
		if($next_connection_type['allow_credits']){
			$credit_propose = array(
				'sum' => max($next_connection_type['amount'] + $charges_needle, 3000),
				'from' => time(),
				'to' => time() + 60 * 60 * 24 * 4,
			);
			$doc->page->contents['credits_descr'] = sprintf(getResource('clientroom.credit.description'), $credit_propose['sum']/100).'<br><br>';
			$ex_credit = $db->Next($db->Execute(sprintf("SELECT UNIX_TIMESTAMP(ADDDATE(actual_from, INTERVAL 1 MONTH)) open_date
				FROM credits WHERE client=%s AND type=3 AND
				adddate(actual_from, interval 1 month) > now()", $client['id'])));
			if(!$ex_credit){
				$doc->page->contents['credits_form'] = new AddCreditForm($nil, BOOT.'client_info/credits/form.php');
			}else{
				$doc->page->contents['credits_form'] = sprintf(getResource('clientroom.credit.denied'), date("Y-m-d H:i", $ex_credit['open_date']));
			}
		}
		break;
	case 'pr':
		$doc->page->contents['personal_periods'] = new PMyAccess($personal_periods,array(
			'title'=>getResource('clientroom.personal.periods.title'),
			'icon'=>HREF.'images/picks.gif',
			'grid_boot'=>BOOT.'client_info/personal_periods/grid.php',
		));
		if($personal_periods->isOn()){
			$personal_period = $personal_periods->active_record;
/*			$pmenu = new PNamedMenu($nil, BOOT.'client_info/personal_periods/menu.php');
			$doc->page->contents['pmenu'] = $pmenu;
			switch($pmenu->selected){
				case 'ru':
					$db->Execute(sprintf("CREATE TEMPORARY TABLE pp_uses
						SELECT ru.calendar_period, ppru.personal_period, ru.resource_type, ru.src, ru.price, ru.unit_size, sum(ppru.amount) amount, ceil(sum(ppru.amount)*ru.price/ru.unit_size) cost
						FROM personal_period_resource_uses ppru
						LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
						WHERE ppru.personal_period=%s AND src IS NOT NULL AND dst IS NOT NULL
						GROUP BY ru.id", $personal_period['id']));
					createClientAccountReference('src_names');
					$resource_uses = new PTable($db,BOOT.'client_info/personal_periods/resource_uses/table.php');
					$resource_uses->readonly = !$oper->system_access['resource_uses'];
					$doc->page->contents['resource_uses'] = new PMyAccess($resource_uses,array(
						'title'=>getResource('resource.uses.title'),
						'icon'=>HREF.'images/resource_uses.gif',
						'grid_boot'=>BOOT.'client_info/personal_periods/resource_uses/grid.php',
					));
					break;
				case 'pl':
			}
*/
			$plans = new PTable($db,BOOT.'client_info/personal_periods/personal_period_plans/table.php');
			$plans->readonly = !$oper->system_access['personal_periods'];
			$doc->page->contents['plans'] = new PMyAccess($plans,array(
				'title'=>getResource('personal.period.plans.title'),
				'icon'=>HREF.'images/homedir.gif',
				'grid_boot'=>BOOT.'client_info/personal_periods/personal_period_plans/grid.php',
			));
			break;

		}
		break;
	case 'su':
		$doc->page->contents['subscriptions'] = new PMyAccess($subscriptions, array(
			'title'=>getResource('clientroom.charge.subscriptions.title'),
			'icon'=>HREF.'images/picks.gif',
			'grid_boot'=>BOOT.'client_info/charge_subscriptions/grid.php',
		));
		break;
	case 'bo':
		$bonuses->readonly = 1;
		$doc->page->contents['bonuses'] = new PMyAccess($bonuses,array(
			'title'=>getResource('clientroom.bonuses.title'),
			'icon'=>HREF.'images/dollar.gif',
'icon_attributes'=>'width=29 height=42',
			'grid_boot'=>BOOT.'client_info/bonuses/grid.php',
		));
		if($bonuses->isOn()){
			createInOut($bonuses->current_record['account']);
		}
		break;
	case 'hd':
		$doc->page->contents['homedirs'] = new PMyAccess($homedirs,array(
			'title'=>getResource('clientroom.homedirs.title'),
			'icon'=>HREF.'images/homedir.png',
			'grid_boot'=>BOOT.'client_info/homedirs/grid.php',
			'form_boot'=>BOOT.'client_info/homedirs/form.php',
			'brief'=>0,
			'briefable'=>0,
		));
		if(!$homedirs->isOn()){
			$homedirs->Locate();
		}
		break;
	case 'ma':
		$doc->page->contents['mailboxes'] = new PMyAccess($mailboxes,array(
			'title'=>getResource('clientroom.mailboxes.title'),
			'icon'=>HREF.'images/box.png',
			'grid_boot'=>BOOT.'client_info/mailboxes/grid.php',
			'form_boot'=> BOOT.'client_info/mailboxes/form.php',
			'briefable'=>0,
			'brief'=>0,
		));
		if(!$mailboxes->isOn()){
			$mailboxes->Locate();
		}
		break;
	case 'op':
		$opt = new PTable($db,BOOT.'client_info/pass/table.php');
		$opt->Locate(array('id'=>$_SESSION['client_id']));
		if($opt->isOn()){
			$doc->page->contents['options'] = new PAccess($opt,array(
				'title'=>getResource('clientroom.options.title'),
				'icon'=>HREF.'images/config.png',
				'form_boot'=>BOOT.'client_info/pass/form.php',
				'briefable'=>0,
			));
		}
		break;
	case 'ex':
		ob_end_clean();
		header("Location:".HREF.'logoff.php');
		exit;
		break;
	case 'tr':
		include 'includes/client_info_troubles.php';
		break;
	case 'bl':
		include 'includes/client_info_blocks.php';
		break;
	case 'ho':
		$doc->page->contents['stats_hosts'] = new PMyAccess($stats_hosts,array(
			'title'=>getResource('clientroom.hosts.title'),
			'icon'=>HREF.'images/hosts.png',
			'grid_boot'=>BOOT.'client_info/hosts/grid.php',
		));
		if(!$by_traffic){
			break;
		}
		if($stats_hosts->getCount()==1 && !$stats_hosts->isOn()){
			$stats_hosts->Locate();
		}
		if($stats_hosts->isOn()){
			$host = $stats_hosts->active_record['id'];
			$hmenu = new PNamedMenu($nil,BOOT.'client_info/hosts/menu.php');
			$doc->page->contents['host_menu'] = $hmenu;
			switch($hmenu->selected){
				case 'fi':
					$doc->page->contents['firewall_title'] = '<img src="'.HREF.'/images/switcher.png" align="middle" vspace="6"><span class="access_head">'.getResource('clientroom.hosts.firewall.title').'</span>';
					//$db->debug = 1;
					$res = $db->Execute(sprintf("
					SELECT ctr.rule, r.for_client as name, IF(hf.rule IS NULL,0,1) as block
					FROM connection_type_rules ctr
					LEFT JOIN connection_type_resources ctrs ON ctrs.id=ctr.connection_type_resource
					LEFT JOIN rules r ON r.id=ctr.rule
					LEFT JOIN hosts_firewall hf ON hf.rule=ctr.rule AND hf.host='%d'
					WHERE ctrs.connection_type='%d' AND ctr.blockable = '1' ORDER BY r.name",$host,$connection_type['id']));
					while($arr = $db->Next($res)){
						$firewall_fields[$arr['rule']] = array(
							'control'=>'checkbox',
							'title'=>$arr['name'],
							'value'=>$arr['block'],
							'label'=>getResource('clientroom.access.closed'),
						);
					}
					$has_rules = !empty($firewall_fields);
					//if(isset($_SESSION['client_supervisor'])){
						$options = array(
							'destination' => '/var/lib/tftpboot/',
							'snmp-timeout' => 200000,
							'snmp-retries' => 1,
							'snmp-reader' => 'public',
							'snmp-writer' => 'security',
							'http-timeout' => '10',
							'http-user' => 'security',
							'http-password' => 'security',
							'model-oid' => '.1.3.6.1.2.1.1.2.0',
						);
						$edgecore_models = array(
							'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
							'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
							'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
							'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
							'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
							'.1.3.6.1.4.1.259.10.1.27.101'=>'ES3510-28T',
							                            
						);
						/*
						snmp_set_oid_numeric_print(1);
						snmp_set_quick_print(1);
						snmp_set_valueretrieval(SNMP_VALUE_PLAIN);
						$harr = $stats_hosts->active_record;
						$modem = loadRecord("SELECT id, ip, name, model FROM modems WHERE id=".$harr['modem']);
						$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], $options['model-oid'], $options['snmp-timeout'], $options['snmp-retries']);
						if(isset($edgecore_models[$model_oid]) && $edgecore_models[$model_oid]=='ES3552M'){
							$firewall_fields['acl_2'] = array(
								'control'=>'checkbox',
								'title'=>getResource('clientroom.access.acl.2'),
								'value'=>($client['acl_pref'] & 2) ? 1 : 0,
								'label'=>getResource('clientroom.access.closed'),
							);
						}
						*/
					//}
					$doc->page->contents['switcher'] = new SwitchForm($nil,BOOT.'client_info/switcher/form.php');
					
					if($has_rules){
						loadStrings(BOOT.'block_schedule/strings.txt');
						$block_schedule = new PTable($db, BOOT.'client_info/block_schedule/table.php');
						$doc->page->contents['block_schedule'] =  new PMyAccess($block_schedule, array(
							'title'=>getResource('block.schedule.title.2'),
							'icon'=>HREF.'images/switcher-time.png',
							'grid_boot'=>BOOT.'client_info/block_schedule/grid.php',
							'form_boot'=>BOOT.'client_info/block_schedule/form.php',
							'briefable'=>0,
						));
						ob_start();
						?>
						<script>
							var frm = document.forms['bschs'];
							var f = $("form[name=bschs]");
						
							$("select[name=type]", f).change(function(){
								$("input[name='date[year]']", f).closest("tr").toggle(this.value=='1');
								$("input[name='day_bits[1]']", f).closest("tr").toggle(this.value!='1');
							}).change();
							
							$(f).submit(function(event){
								if(frm.submiter.value!='insert'){
									return true;
								}
								if(!frm.validateResult){
									return false;
								}
								return confirm(" ,        ?");
							});
						</script>
						<?
						$doc->page->contents['js'] .= ob_get_clean();
					}
					break;
				case 'lo':
					$doc->page->contents['period'] = $period;
					$tables = array(
						'1'=>'table.php',
						'2'=>'table-hour.php',
						'3'=>'table-day.php',
					);
					if(isset($tables[$period->detail])){
						//$db->debug = 1;
						$log = new PTable($db,BOOT.'log/'.$tables[$period->detail]);
						$id = $stats_hosts->active_record['id'];
						$log->filters['host'] = "host='$id'";
						$from = $period->getFrom();
						$to = $period->getTo();
						if($from){
							$log->filters['from'] = sprintf($log->fields['from_time']->getSelector()." >= '%s'", $from);
						}
						if($to){
							if($from){
								$log->filters['from_to'] = sprintf($log->fields['from_time']->getSelector()." <= '%s'", $to);
							}
							$log->filters['to'] = sprintf($log->fields['to_time']->getSelector()." <= '%s'", $to);
						}
						$doc->page->contents['log'] = new PMyAccess($log,array(
							'title'=>getResource('clientroom.hosts.log.title'),
							'icon'=>HREF.'images/log.png',
							'grid_boot'=>BOOT.'log/grid.php',
						));
						//unset($doc->page->contents['log']->grid->columns['cost']);
						//unset($doc->page->contents['log']->grid->columns['price']);
						$doc->page->contents['log']->grid->columns['rule_name']->link = '';
					}
					break;
				case 'ip':
					$period->fields['detail']->type = 'hidden';
					$doc->page->contents['period'] = $period;
					$ipcad_ip = $stats_hosts->active_record['ip'];
					include("includes/stat_ipcad.php");
					break;
				case 'mc':
					include_once('functions/host.php');
					function change_mac_only($table){
						global $stats_hosts;
						$table->new_record = array(
							'mac'=>$table->new_record['mac'],
						);
						if(!$table->isChanged('mac')){
							$table->abort = 1;
							return;
						}
						$arr = loadRecord("SELECT COUNT(*) c FROM action_log
							WHERE operator='".CLIENT_OPERATOR."'
							AND object=(SELECT id FROM action_log_objects WHERE name='hosts')
							AND item_id='".$stats_hosts->active_record['id']."'
							AND date > SUBDATE(NOW(), INTERVAL 1 DAY)");
						if($arr['c'] >= 5){
							$table->error(sprintf(getResource('clientroom.info.change.mac.limit'), 5));
						}
					}
					ob_start();
					?>
					<ul>
					<li>      mac-  ,        .</li>
					<li>    mac-.     ,      .</li>
					<li>   mac-    3-10   ,     "".</li>
					<li>    5-   .</li>
					<li>       .</li>
					<li> mac-       <a href="?offlinehelp"></a>.</li>
					</ul>
					<script type="text/javascript" src="scripts/strict-input-tracker.js"></script>
					<script type="text/javascript">$(function(){
						var f = document.forms['sthts'];
						StrictInputTracker(f.elements['mac'], /.*/, /[\-;\.]/g, ":");
						$(f).submit(function(event){
							if(!f.validateResult){
								return false;
							}
							return confirm(" ,     mac-  " + f.elements['mac'].value + "?");
						});
					});
					</script>
					<?
					$doc->page->contents['mac-form-intro'] = ob_get_clean();
					$GLOBALS['appendOfflineDelay'] = 3 * 60;
					$doc->page->contents['mac-form'] = new PDBForm($stats_hosts, BOOT.'client_info/hosts/form.php');
					loadStrings(BOOT.'action_log/strings.txt');
//					$db->debug = 1;
					$action_log = new PTable($db, BOOT.'client_info/hosts/action_log/table.php');
					$action_log->filters['by_item'] = '(l.object=(SELECT id FROM action_log_objects WHERE name="hosts") AND l.item_id="'.$stats_hosts->active_record['id'].'")';
					$action_log->filters['by_oper'] = 'l.operator="'.CLIENT_OPERATOR.'"';
					function ActionLogFormat2($val) {
						$val = substr($val, strpos($val, "*diff*") + 7);
						$val = htmlspecialchars($val, ENT_QUOTES );
						$val = preg_replace("|^([^\\n:]+\: )|mi", '<b>\1</b>', $val);
						$val = preg_replace("|^(<b>[^\:]+\: </b>)|m", '<span class=diff>\1</span>', $val);
						$val = preg_replace("|(\*\-\&gt;\*)|m", ' <span class=diff><b>&raquo;</b></span> ', $val);
						return '<div style="max-height:400px; overflow:auto;;">'.str_replace("\n", "<br>", $val).'</div>';
					}
					$doc->page->contents['history'] =  new PMyAccess($action_log, array(
						'title'=>getResource('action.log.title'),
						'icon'=>HREF.'images/log.gif',
						'grid_boot'=>BOOT.'client_info/hosts/action_log/grid.php',
					));
					break;
				case 'in':
					$doc->page->contents['graph'] = '
						<div align="center">
						<br><br>'.getResource('stat.graph.day').'<br>
						<img src="'.HREF.'graph/host.php?id='.$stats_hosts->active_record['id'].'&amp;period=day">
						<br><br>'.getResource('stat.graph.month').'<br>
						<img src="'.HREF.'graph/host.php?id='.$stats_hosts->active_record['id'].'&amp;period=month">
						<br><br>'.getResource('stat.graph.year').'<br>
						<img src="'.HREF.'graph/host.php?id='.$stats_hosts->active_record['id'].'&amp;period=year">
						</div>';
					break;
			}
		}else{
			$doc->page->contents['help'] = '<br>&nbsp;'.getResource('clientroom.hosts.prompt').'<br><br>';
		}
		break;
}
echo $doc->Paint();
?>
