<?
include_once('includes/global.php');
include_once('classes/period.php');
include_once('classes/SwitchTool.php');
include_once('classes/ComboTool.php');
loadStrings(BOOT.'exp_movements/strings.txt');
loadStrings(BOOT.'exp_movements/exp_movements_details/strings.txt');
loadStrings(BOOT.'exp_materials/strings.txt');

$doc->title .= ' :: '.getResource('exp_movements.title');

required_access('exp_storages');

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'place':		lookup('exp_storage_place');
	case 'material':
		$place = loadRecord('SELECT * FROM exp_storage_places WHERE id='.addslashes($_GET['place']));
		if($place['account'] > 0){
			new Lookup('m.id', 'CONCAT(m.name," (", CONVERT(s.amount USING cp1251),")")', 'exp_storages s LEFT JOIN exp_materials m ON m.id=s.material', array('s.place='.$place['id'], 's.amount > 0'));
		}else{
			lookup('exp_material');
		}
}

function auto_mov_state($table){
	if(!$table->new_record['state']){
		$table->new_record['state'] = 2;
	}
	if(!$table->new_record['date']){
		$table->new_record['date'] = date("Y-m-d H:i:s");
	}
}

function check_rest_over($table){
	global $mov;
	if($mov['src_account']){
		$arr = loadRecord("SELECT amount FROM exp_storages WHERE place='".$mov['src']."' AND material='".$table->new_record['material']."'");
		if($arr['amount'] < $table->new_record['amount']){
			$table->error(getResource('exp_movements_details.error.over'));
		}
	}
}

function update_storages($table){
	global $db, $exp_movements;
	$db->Execute("DELETE FROM exp_storages");
	$db->Execute("INSERT INTO exp_storages (material, amount, place)
	SELECT material, sum(amount) as amount, place
	FROM (
		SELECT m.src as place, md.material, -sum(md.amount) amount
		FROM exp_movements_details md
		LEFT JOIN exp_movements m ON m.id=md.movement WHERE m.state=3
		GROUP BY m.src, md.material
		UNION
		SELECT m.dst as place, md.material, sum(md.amount) amount
		FROM exp_movements_details md
		LEFT JOIN exp_movements m ON m.id=md.movement WHERE m.state=3 
		GROUP BY m.dst, md.material
	) z
	LEFT JOIN exp_storage_places p ON p.id=z.place 
	WHERE p.account='1'
	GROUP BY place, material");
	recalc_rests();
}

function recalc_rests(){
	global $db;
	$rests = array();
	$res = $db->Execute("SELECT md.id, m.src, m.dst, md.material, md.amount, md.src_rest, md.dst_rest
		FROM exp_movements_details md
		LEFT JOIN exp_movements m ON m.id=md.movement
		ORDER by m.date, m.id");
	$modif = 0;
	while($arr = $db->Next($res)){
		$rests[$arr['src']][$arr['material']] -= $arr['amount'];
		$rests[$arr['dst']][$arr['material']] += $arr['amount'];
		if($rests[$arr['src']][$arr['material']] != $arr['src_rest'] || $rests[$arr['dst']][$arr['material']] != $arr['dst_rest']){
			$db->Execute("UPDATE exp_movements_details SET src_rest='".$rests[$arr['src']][$arr['material']]."', dst_rest='".$rests[$arr['dst']][$arr['material']]."' WHERE id='".$arr['id']."'");
			$modif++;
		}
	}
	return $modif;
}

//$db->debug = 1;

//recalc_rests();

include(BOOT.'period/form.php');
$obj['nick'] = 'exmper';
$obj['active'] = 0;
$period = new PPeriod($nil, $obj);
$period->commented = false;

$hmenu = new PNamedMenu($nil,BOOT.'exp_movements/menu.php');
$doc->page->contents['mov_menu'] = $hmenu;
switch($hmenu->selected){
	case 'mv':
		$exp_movements = new PTable($db,BOOT.'exp_movements/table.php');
		$exp_movements->readonly = !$oper->system_access['exp_storages'];
		if($period->active){
			if($from = $period->getFrom()){
				$exp_movements->filters['from'] = sprintf("p.date >= '%s'", $from);
			}
			if($to = $period->getTo()){
				$exp_movements->filters['to'] = sprintf("p.date <= '%s'", $to);
			}
		}
		$doc->page->contents['exp_movements'] = new PMyAccess($exp_movements,array(
			'title'=>getResource('exp_movements.title'),
			'help'=>HELP_PATH.'//',
			'icon'=>HREF.'images/expenses.gif',
			'grid_boot'=>BOOT.'exp_movements/grid.php',
			'form_boot'=>BOOT.'exp_movements/form.php',
			'tool'=>$period,
		));
		if($exp_movements->isOn()){
			$mov = $exp_movements->active_record;
			
			$exp_movements_details = new PTable($db,BOOT.'exp_movements/exp_movements_details/table.php');
			$exp_movements_details->readonly = !$oper->system_access['exp_storages'] || $mov['state']==3;
			$doc->page->contents['exp_movements_details'] = new PMyAccess($exp_movements_details,array(
				'title'=>getResource('exp_movements_details.title'),
				'icon'=>HREF.'images/expenses.gif',
				'grid_boot'=>BOOT.'exp_movements/exp_movements_details/grid.php',
				'form_boot'=>BOOT.'exp_movements/exp_movements_details/form.php',
			));
		}
		break;
	case 'vw':
		$view = new PTable($db,BOOT.'exp_movements/view/table.php');
		$view->readonly = 1;
		if($period->active){
			if($from = $period->getFrom()){
				$view->filters['from'] = sprintf("m.date >= '%s'", $from);
			}
			if($to = $period->getTo()){
				$view->filters['to'] = sprintf("m.date <= '%s'", $to);
			}
		}
		$filter_tool = new SwitchTool('pft', loadByQuery("SELECT id, name FROM exp_storage_places ORDER BY name", 'id', 'name', array(''=>'')), '', false);
		if($filter_tool->value){
			$view->filters['place'] = '(m.src="'.$filter_tool->value.'" OR m.dst="'.$filter_tool->value.'")';
		}
		$view->filters['state'] = 'm.state=3';
		$doc->page->contents['view'] = new PMyAccess($view,array(
			'title'=>getResource('exp_movements_details.view.title'),
			'icon'=>HREF.'images/expenses.gif',
			'grid_boot'=>BOOT.'exp_movements/view/grid.php',
			'form_boot'=>BOOT.'exp_movements/view/form.php',
			'tool'=>new ComboTool(array(
				new ComboToolCell($filter_tool),
				new ComboToolCell($period)
			)),
		));
		break;
}

echo $doc->Paint();
?>