<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.16 $
*/
include_once('includes/global.php');
include_once('classes/cells/UpCellRenderer.php');
loadStrings(BOOT.'districts/strings.txt');
loadStrings(BOOT.'houses/strings.txt');
loadStrings(BOOT.'exp_reports/strings.txt');
loadStrings(BOOT.'exp_points/strings.txt');
loadStrings(BOOT.'exp_trunks/strings.txt');

$doc->title .= ' :: '.getResource('exp_reports.title');

required_access('exp_reports');
//$db->debug = 1;

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'house': lookup('house', $_GET['city'] ? array('h.city='.addslashes($_GET['city'])) : array());
	case 'executor': lookup('exp_executor');
//	case 'point': lookup('exp_house_point', array("p.house='".addslashes($_GET['house'])."'", 'p.type=1'));
	case 'point':
		lookup('exp_point',  $_GET['city'] ? array('p.city='.addslashes($_GET['city'])) : array());
	case 'material':
		lookup('exp_material_cable');
}

function change_entrance_state($table){
	global $db;
	$arr = $table->current_record;
	if($arr['type']==2){
		foreach(preg_split("|[\s,;.]+|", $arr['entrances'], -1, PREG_SPLIT_NO_EMPTY) as $entrance){
			$db->Execute("UPDATE entrances SET type=1 WHERE house='".$arr['house']."' AND number='".$entrance."'");
		}
	}
}

function change_house_tv_state($table){
	global $db;
	$arr = $table->current_record;
	if($arr['type']==4){
		$sum = loadRecord("SELECT sum(cable_hor) hor, sum(cable_ver) ver FROM exp_reports WHERE house='".$arr['house']."'");
		if(($sum['hor'] > 0) && ($sum['ver'] > 0)){
			$house = loadRecord("SELECT tv FROM houses WHERE id='".$arr['house']."'");
			if($house['tv']==0){
				$db->Execute("UPDATE houses SET tv=2 WHERE id='".$arr['house']."'");
			}
		}
	}
}

function apply_report($table){
	$type = $table->new_record['type'];
	if($type!=4){
		$table->new_record['cable_hor'] = '';
		$table->new_record['cable_ver'] = '';
	}
	if($type!=2){
		$table->new_record['entrances'] = '';
	}
}

function null($val){
	return strlen($val) > 0 ? "'".$val."'" : 'NULL';
}

function clear_point($table){
	if(($table->new_record['type']!=1)){
		$table->new_record['exp_point'] = '';
	}
	unset($table->new_record['number']);
	unset($table->new_record['entrance']);
	unset($table->new_record['floor']);
	unset($table->new_record['place']);
}

function insert_point($table){
	global $db;
	$new = $table->new_record;
	if(($new['type']==1)){
		$stamp = create_stamp();
		$db->Execute(sprintf("INSERT INTO exp_points (city, house, entrance, floor, type, executor, place, date, stamp, inv_number)
			VALUES (%s, %s, %s, %s, 1, %s, %s, %s, %s, %s)", 
			null($new['city']), null($new['house']), null($new['entrance']), null($new['floor']), null($new['executor']), null($new['place']), null($new['date']), null($stamp), null($new['number'])
		));
		$pid = $db->getJustInserted('exp_points', 'id');
		$table->new_record['exp_point'] = $pid;
	}
	clear_point($table);
}

function update_point($table){
	global $db;
	$new = $table->new_record;
	if(($new['type']==1)){
		if($table->current_record['exp_point']){
			$db->Execute(sprintf("UPDATE exp_points SET city=%s, house=%s, entrance=%s, floor=%s, type=1, executor=%s, place=%s, date=%s, inv_number=%s WHERE id=%s",
				null($new['city']), null($new['house']), null($new['entrance']), null($new['floor']), null($new['executor']), null($new['place']), null($new['date']), null($new['number']),
				$table->current_record['exp_point']
			));
		}else{
			insert_point($table);
		}
	}
	clear_point($table);
}

function clear_trunk($table){
	if(($table->new_record['type']!=3)){
		$table->new_record['exp_trunk'] = '';
	}
	unset($table->new_record['trunk_begin_point']);
	unset($table->new_record['trunk_end_point']);
	unset($table->new_record['trunk_material']);
	unset($table->new_record['trunk_length']);
	unset($table->new_record['trunk_type']);
}

function insert_trunk($table){
	global $db;
	$new = $table->new_record;
	if(($new['type']==3)){
		$stamp = create_stamp();
		$db->Execute(sprintf("INSERT INTO exp_trunks (city, begin_point, end_point, type, material, length, executor, date, stamp)
			VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s)", 
			null($new['city']), null($new['trunk_begin_point']), null($new['trunk_end_point']), null($new['trunk_type']), null($new['trunk_material']), null($new['trunk_length']),  null($new['executor']), null($new['date']), null($stamp)
		));
		$tid = $db->getJustInserted('exp_trunks', 'id');
		$table->new_record['exp_trunk'] = $tid;
	}
	clear_trunk($table);
}

function update_trunk($table){
	global $db;
	$new = $table->new_record;
	if(($new['type']==3)){
		if($table->current_record['exp_trunk']){
			$db->Execute(sprintf("UPDATE exp_trunks SET city=%s, begin_point=%s, end_point=%s, type=%s, material=%s, length=%s, executor=%s, date=%s WHERE id=%s",
				null($new['city']), null($new['trunk_begin_point']), null($new['trunk_end_point']), null($new['trunk_type']), null($new['trunk_material']), null($new['trunk_length']),  null($new['executor']), null($new['date']),
				$table->current_record['exp_trunk']
			));
		}else{
			insert_trunk($table);
		}
	}
	clear_trunk($table);
}

function getHouseEntrances(){
	return loadByQuery("SELECT id, number as value FROM entrances WHERE house='".$GLOBALS['exp_report']['house']."'");
/*
	return loadByQuery("SELECT id, CONCAT(number, ' (', case type
				when 0 then '".getResource('entrances.type.0')."'
				when 1 then '".getResource('entrances.type.1')."'
				else '' end, ')') as value
				FROM entrances WHERE house='".$GLOBALS['exp_report']['house']."'");
*/
}

//$db->debug = 1;

ob_start();
?><style><?
include BOOT.'calendar/calendar.css';
include BOOT.'calendar/report.css'
?></style><?
$doc->page->contents['css'] = ob_get_clean();

include_once("classes/context/include.php");
$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/calendar/web-log.php'),
	new ArrayBeanFactory('boot/calendar/dao.php'),
	new ArrayBeanFactory('boot/calendar/calendar.php'),
));

$calendar = $beanFactory->getBean('reportCalendar');
$calendar->process();
$doc->page->contents['calendar'] = $calendar->render();

$exp_reports = new PTable($db,BOOT.'exp_reports/table.php');
$exp_reports->readonly = !$oper->system_access['exp_reports'];
if($calendar->isActive()){
	$exp_reports->filters['calendar'] = sprintf('DATE_FORMAT(m.date, "%%Y-%%m-%%d")="%s"', $GLOBALS['calendar']->getDate());
}
addCityPolicy($exp_reports, 'm.city');

$doc->page->contents['exp_reports'] = new PMyAccess($exp_reports,array(
	'title'=>getResource('exp_reports.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/rules.gif',
	'grid_boot'=>forceCity(BOOT.'exp_reports/grid.php'),
	'form_boot'=>forceCity(BOOT.'exp_reports/form.php'),
));
/*
if($exp_reports->isOn()){
	$exp_report = $exp_reports->active_record;
	if($exp_report['type']==2){
		$entrances = new PTable($db,BOOT.'exp_reports/entrances/table.php');
		$entrances->readonly = $exp_reports->readonly;
		$doc->page->contents['entrance'] = new PMyAccess($entrances, array(
			'title'=>getResource('entrances.title'),
			'icon'=>HREF.'images/streets.gif',
			'grid_boot'=>BOOT.'exp_reports/entrances/grid.php',
			'form_boot'=>BOOT.'exp_reports/entrances/form.php',
		));
	}
}
*/
if(!$doc->page->contents['exp_reports']->brief){
	ob_start();
?>
<script>
	
	var f = $("form[name=<?=$exp_reports->nick?>]");
	var _frm = f;
	$("[name=city]", f).change(function(){
		lookup_house.src = '?lookup=house&target=lookup_house&city=' + this.value;
		lookup_house.loaded = false;
		lookup_house.loadFirst();

		lookup_begin.src = '?lookup=point&target=lookup_begin&city=' + this.value;
		lookup_begin.loaded = false;
		lookup_begin.loadFirst();

		lookup_end.src = '?lookup=point&target=lookup_end&city=' + this.value;
		lookup_end.loaded = false;
		lookup_end.loadFirst();
	}).change();

	var point_fields = ['number', 'entrance', 'floor', 'place'];
	var trunk_fields = ['trunk_begin_point', 'trunk_end_point', 'trunk_material', 'trunk_length', 'trunk_type'];
	
	$("[name=type]", _frm).change(function(){
	
		var boo = this.value==1;
		$.each(point_fields, function(i, name){
			var x = $("[name=" + name + "]", _frm);
			x.closest("tr").toggle(boo);
		})
		var too = this.value==3;
		$.each(trunk_fields, function(i, name){
			$("[name=" + name + "]", _frm).closest("tr").toggle(too);
		})
		
		$("[name=cable_hor]", _frm).closest("tr").toggle(this.value==4);
		$("[name=cable_ver]", _frm).closest("tr").toggle(this.value==4);
		$("[name=entrances]", _frm).closest("tr").toggle(this.value==2);
	}).change();
  
</script>
<?
	$doc->page->contents['mjs'] .= ob_get_clean();
}
echo $doc->Paint();
?>
