<?
function RemakeDHCPAll(){
	appendOffline(3, 'task.dhcp.remake all', 1, 1);
	return;
}

function RemakeDHCP(){
	global $db;
	static $query = array(
		'modems_width'=>"
			SELECT MAX(LENGTH(CONCAT(m.name,'.',IFNULL(d.name,'')))) as width
			FROM modems m
			LEFT JOIN domains d on d.id=m.domain",
		'modems'=>"
			SELECT m.id, m.name, m.mac, m.ip, d.name as domain
			FROM modems m
			LEFT JOIN domains d ON m.domain = d.id
			LEFT JOIN modem_profiles mp ON m.profile=mp.id
			WHERE  mac>'' AND mp.id is NOT NULL ORDER BY m.name",
		'hosts_width'=>"
			SELECT MAX(LENGTH(CONCAT(h.name,'.',IFNULL(d.name,'')))) as width
			FROM hosts h
			LEFT JOIN domains d on d.id=h.domain",
		'hosts'=>"
			SELECT h.id, h.name, h.mac, h.ip, d.name as domain
			FROM hosts h
			LEFT JOIN domains d ON h.domain = d.id
			WHERE h.mac>'' AND h.ip not like '%/%' ORDER BY h.name",
	);
	appendOffline(3, 'task.dhcp.remake', 1, 1);
	return;
	
	$config = getOption('DHCP_TEMPLATE');
	if($config){
		if(preg_match_all('|\#\%[\d/\.]+\s|', $config, $m)){
			$patterns = array();
			//     
			foreach($m[0] as $mat){
				$arr = explode("/", trim(substr($mat,2)));
				$patterns[] = array(
					'network'=>$arr[0],
					'mask'=>$arr[1],
					'items'=>array(),
				);
			}
			$hosts_w = $db->Next($db->Execute($query['hosts_width']));
			$width = $hosts_w['width'];//  
			$modemsConfDir = getTrimOption('MODEMS_CONFDIR');
			if($modemsConfDir && is_dir($modemsConfDir)){
				$modems_w = $db->Next($db->Execute($query['modems_width']));
				$width = max($width, $modems_w['width']);
				// DHCP   
				$res = $db->Execute($query['modems']);
				while($arr = $db->Next($res)){
					$filename = str_replace(array(':','-'),'',$arr['mac']).'.docsis';
					if(!$arr['name']){
						$arr['name'] = 'modem-'.$arr['id'];
					}
					if($arr['domain']){
						$arr['name'] .= '.'.$arr['domain'];
					}
					foreach($patterns as $k=>$pat){
						if(IpMatch($pat['network'], $pat['mask'], $arr['ip'])){
							$patterns[$k]['items'][$arr['ip']] = sprintf(
								"host %-".$width."s { hardware ethernet %s; fixed-address %s; filename \"%s\";}", 
								$arr['name'], $arr['mac'], $arr['ip'], $filename
							);
						}
					}
				}
			}
			// DHCP   
			$res = $db->Execute($query['hosts']);
			while($arr = $db->Next($res)){
				if(!$arr['name']){
					$arr['name'] = 'host-'.$arr['id'];
				}
				if($arr['domain']){
					$arr['name'] .= '.'.$arr['domain'];
				}
				foreach($patterns as $k=>$pat){
					if(IpMatch($pat['network'], $pat['mask'], $arr['ip'])){
						$patterns[$k]['items'][$arr['ip']] = sprintf(
							"host %-".$width."s { hardware ethernet %s; fixed-address %s;}",
							$arr['name'], $arr['mac'], $arr['ip']
						);
					}
				}
			}
			// 
			foreach($patterns as $k=>$pat){
				if(count($pat['items'])>0){
					$items = implode("\n", $pat['items']);
					$config = str_replace('#%'.$pat['network'].'/'.$pat['mask'], $items, $config);
				}
			}
		}
		// 
		$fileName = getTrimOption('DHCP_CONFIG');
		$command = getOption('DHCP_RESTARTER');
		if($fd = @fopen ($fileName, "w")){
			$writen = fwrite($fd, $config);
			fclose($fd);
			if($writen>0){
				// DHCPD
				if($command){
					$err = ExecuteScript($command);
					if($err){
						PrintStrings("Restart DHCPD", $command);
						return $err;
					}
				}
			}
		}else{
			return sprintf(getResource('save.error'), $fileName);
		}
	}
}
?>