<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:39 $
$Revision: 1.46 $
*/
function getProblemTypes(){
	global $jobs, $db;
	$st = $jobs->active_record['jt_type'] + 0;
	$city = $jobs->active_record['city'] + 0;
	return loadByQuery("SELECT id, name as value FROM job_problem_types WHERE service_type&$st AND (city IS NULL OR city=$city)");
}

function set_client_lang($table){
	global $db;
	$lang = $table->new_record['client_lang'];
	$clid = $table->new_record['client'];
	if($clid && $lang){
		$db->Execute(sprintf("UPDATE clients SET lang='%s' WHERE id='%s'", $lang, $clid));
	}
	unset($table->new_record['client_lang']);
}

function getLangs(){
	return array(
		'1'=>getResource('clients.lang.1'),
		'2'=>getResource('clients.lang.2'),
	);
}

function required_access($access){
	global $doc, $oper;
	if(!isset($oper->system_access[$access])){
		$doc->page->contents['denied'] = getResource('access.denied');
		echo $doc->Paint();
		exit;
	}
}

function getSystemAccountByCode($str){
	return loadValue("SELECT account FROM system_accounts WHERE code='".addslashes($str)."'");
}

function isAvailable($str){
	global $oper;
	return isset($oper->system_access[$str]);
}

function recalc_tv_clients(){
	global $db;
	$nodes = loadRecords("SELECT n.id, n.parent, nc.clients_total, 0 as new_clients_total, nc.clients, 0 as new_clients, nc.apartments, 0 as new_apartments
		FROM tv_nodes n
		LEFT JOIN tv_nodes_clients nc ON nc.tv_node=n.id",
		"id");
	$tv_connections = loadRecords("SELECT DISTINCT tc.client, tc.tv_node
		FROM tv_connections tc
		LEFT JOIN clients c ON c.id=tc.client
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		WHERE ct.service_type > 0");
	foreach($tv_connections as $tv_connection){
		if(isset($nodes[$tv_connection['tv_node']])){
			$node = $nodes[$tv_connection['tv_node']];
			$nodes[$tv_connection['tv_node']]['new_clients']++;
			$branch = array();
			while($node && !in_array($node['id'], $branch)){
				$branch[] = $node['id'];
				$nodes[$node['id']]['new_clients_total']++;
				$node = isset($nodes[$node['parent']]) ? $nodes[$node['parent']] : '';
			}
		}
	}
	$apartments = loadRecords("SELECT max(n.parent) tv_node, hs.id, hs.appartments
		FROM tv_connections tc
		LEFT JOIN tv_nodes n ON n.id=tc.tv_node
		LEFT JOIN clients c ON c.id=tc.client
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		LEFT JOIN houses hs ON hs.id=c.house_id
		WHERE n.parent IS NOT NULL AND ct.service_type > 0
		GROUP BY hs.id");
	foreach($apartments as $arr){
		if(isset($nodes[$arr['tv_node']])){
			$node = $nodes[$arr['tv_node']];
			$branch = array();
			while($node && !in_array($node['id'], $branch)){
				$branch[] = $node['id'];
				$nodes[$node['id']]['new_apartments'] += $arr['appartments'];
				$node = isset($nodes[$node['parent']]) ? $nodes[$node['parent']] : '';
			}
		}
	}
	foreach($nodes as $id=>$node){
		if(($node['clients_total']!=$node['new_clients_total']) || ($node['clients']!=$node['new_clients']) || ($node['apartments']!=$node['new_apartments'])){
			$db->Execute(sprintf("REPLACE INTO tv_nodes_clients (tv_node, clients_total, clients, apartments) VALUES ('%s', '%s', '%s', '%s')", 
				$id, $node['new_clients_total'], $node['new_clients'], $node['new_apartments']));
		}
	}
}

function get_longest_word($str){
	$longest = "";
	foreach(explode(" ", $str) as $word){
	if(strlen($word) > strlen($longest))
		$longest = $word;
	}
	return $longest;
}

function explicit_null($val){
	return $val ?: 'null';
}

function getConcurrents(){
	global $oper;
	$filter = $oper->city_mode ? " INNER JOIN operators_cities oc ON oc.city=c.city AND oc.operator='$oper->id'" : "";
	return loadByQuery("SELECT c.id, c.name AS value FROM concurrents c $filter ORDER BY c.id");
}

function getAccountTypes(){
	return loadByQuery("SELECT id, name AS value FROM account_types ORDER BY name");
}

function addCityPolicy($table, $to='', $alias='ocit'){
	global $oper;
	if($oper->city_mode){
		if(!$to){
			$to = $table->name.'.city';
		}
		//$table->source .= " LEFT JOIN operators_cities $alias ON $alias.city=$to AND $alias.operator=$oper->id";
		//$table->filters['ocity'] = "$alias.city IS NOT NULL";
		$table->filters['ocity'] = "$to IN (SELECT city FROM operators_cities WHERE operator='$oper->id' )";
	}
}

function forceCity($src){
	//  -  PMyAccess
	return $src;
}

function prepare_multiquery($query){
	global $db;
	$q = explode(";", $query);
	$select = '';
	while(!empty($q) && empty($select)){
		$select = trim(array_pop($q));
	}
	foreach($q as $pre){
		$db->Execute($pre);
	}
	return $select;
}

function my_merge($arrs){
	$result = array();
	foreach($arrs as $arr){
		foreach($arr as $k=>$v){
			$result[$k] = $v;
		}
	}
	return $result;
}

function getAllCities(){
	return loadByQuery("SELECT id, name AS value FROM cities ORDER BY name");
}

function getCities(){
	global $oper;
	if($oper->city_mode){
		return loadByQuery("SELECT c.id, c.name AS value 
			FROM cities c 
			LEFT JOIN operators_cities oc ON oc.city=c.id AND oc.operator='$oper->id' 
			WHERE oc.city IS NOT NULL ORDER BY c.name");
	}else{
		return getAllCities();
	}
}

function getStaff(){
	return loadByQuery("SELECT id, name AS value FROM staff ORDER BY name");
}

class ConreqForm extends PForm {

function Create($owner){
	parent::Create($owner, BOOT.'client_info/con-request-form.php');
}

function Process(){
	global $db;
	$db->Begin();
	$stamp = create_stamp();
	$db->Execute(sprintf("INSERT INTO con_requests (city, source, client_id, type, client, street_name, house, entrance, floor, appartment, phone, email, stamp, house_id)
		VALUES ('%s', 4, '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')",
		addslashes($this->fields['city']->value),
		addslashes($this->fields['client']->value),
		2,
		addslashes($this->fields['name']->value),
		addslashes($this->fields['street']->value),
		addslashes($this->fields['house']->value),
		addslashes($this->fields['entrance']->value),
		addslashes($this->fields['floor']->value),
		addslashes($this->fields['apartment']->value),
		addslashes($this->fields['phone']->value),
		addslashes($this->fields['email']->value),
		$stamp,
		addslashes($this->fields['house_id']->value)
	));
	$db->End();
}

}

function getTvTypes(){
	return loadByQuery("SELECT id, name AS value FROM tv_types ORDER BY name");
}

function recalc_coil_use($id){
	global $db;
	$arr = loadRecord("SELECT sum(cable) s FROM coil_uses_details WHERE coil_use='".$id."'");
	$db->Execute("UPDATE coil_uses u SET u.end_length = u.begin_length - '".$arr['s']."' WHERE u.id='".$id."'");
	$use = loadRecord("SELECT * FROM coil_uses WHERE id='".$id."'");
	recalc_coil_item($use['item']);
}

function recalc_coil_item($id){
	global $db;
	$arr = loadRecord("SELECT sum(d.cable) s
		FROM coil_uses_details d
		LEFT JOIN coil_uses u ON u.id=d.coil_use
		WHERE u.item='".$id."'");
	$db->Execute("UPDATE coil_items SET rest=length - '".$arr['s']."' WHERE id='".$id."'");
}

function ActionLogFormat($val) {
	$val = htmlspecialchars($val, ENT_QUOTES );
	$val = preg_replace("|^([^\\n:]+\: )|mi", '<b>\1</b>', $val);
	$diff = strpos($val, "*diff*");
	if($diff > 0){
		$val = substr($val, 0, $diff - 1). preg_replace("|^(<b>[^\:]+\: </b>)|m", '<span class=diff>\1</span>', substr($val, $diff + 6));
	}
	$val = preg_replace("|(\*\-\&gt;\*)|m", ' <span class=diff><b>&raquo;</b></span> ', $val);
	return '<div style="max-height:400px; overflow:auto;;">'.str_replace("\n", "<br>", $val).'</div>';
}

function after_personal_period_delete($table){
	global $db;
	$old = $table->old_record;
	if(!loadRecord(sprintf("SELECT id FROM personal_periods WHERE client='%s' AND marker=1", $old['client']))){
		if($arr = loadRecord(sprintf("SELECT min(id) id FROM personal_periods WHERE client='%s' AND next IS NULL", $old['client']))){
			$db->Execute(sprintf("UPDATE personal_periods SET marker=1 WHERE id='%s'", $arr['id']));
		}
	}
}

function menu_operator($id)
{
	$id = (int)$id;
	global $db;
	
	$db->Execute("DELETE FROM `menu_operator_items` WHERE (`operator`='$id')");
	$db->Execute("DELETE FROM `menu_operator_boxes` WHERE (`operator`='$id')");
	
	$query = "SELECT * FROM `menu_operator_boxes` WHERE operator IS NULL";
	
	$rezult = $db->Execute($query);
	
	while($val = $db->NextObj($rezult))
	{
		$return = $db->Execute("INSERT INTO `menu_operator_boxes` (`id`,`operator`,`title`,`order_num`) VALUES (NULL,'$id','$val->title','$val->order_num')");
		$LastID = $db->getJustInserted("menu_operator_boxes", "id");
		//echo $LastID;
		$query = "SELECT * FROM `menu_operator_items` WHERE menu_box = $val->id AND operator IS NULL";
		
		$rezult2 = $db->Execute($query);
		
		while($val2 = $db->NextObj($rezult2))
		{
			$ins = "INSERT INTO `menu_operator_items` 
			(`id`,`operator`,`menu_item`,`menu_box`,`order_num`, `custom_title`) 
			VALUES (NULL,'$id','$val2->menu_item','$LastID','$val2->order_num', '$val2->custom_title')";
			
			$db->Execute($ins);
		}
	}
}

function getGroups(){
	return loadByQuery("SELECT id, name AS value FROM groups ORDER BY name");
}

function getExpenseMaterialTypes(){
	global $db, $client_expenses;
	return loadByQuery("SELECT t.id, t.name as value FROM expense_material_types t
		INNER JOIN expense_material_job_types jt ON jt.material_type=t.id AND jt.job_type='" . $client_expenses->active_record['work_type'] . "'
		ORDER BY t.name");
}

function getAsteriskScheduleObjects(){
	return loadByQuery("SELECT id, name as value FROM asterisk_schedule_objects");
}

function getJobTypes(){
	global $oper;
	if($oper->city_mode){
		return loadByQuery("SELECT jt.id, jt.name as value 
			FROM job_types jt 
			INNER JOIN operators_cities oc ON oc.city=jt.city AND oc.operator='$oper->id' 
			WHERE actual=1
			ORDER BY number");
	}else{
		return loadByQuery("SELECT id, name as value FROM job_types WHERE actual=1 ORDER BY number");
	}
}

function getCoils(){
	global $oper;
	return loadByQuery("SELECT
		c.id as id, 
		ci.code as value 
		FROM coil_uses c 
		LEFT JOIN coil_items ci ON ci.id=c.item 
		WHERE c.person='$oper->person' AND c.end_date IS NULL");
}

function getAllCoils(){
	global $oper;
	return loadByQuery("SELECT
		c.id as id, 
		CONCAT(ci.code, ' (', CAST(c.begin_date AS DATE),' ',s.name,')') as value 
		FROM coil_uses c 
		LEFT JOIN staff s ON s.id=c.person
		LEFT JOIN coil_items ci ON ci.id=c.item");
}

function getUploadMaxFilesSizeMessage() {
	$size = ini_get ( 'upload_max_filesize' );
	return sprintf ( getResource ( 'upload.size.comment' ), str_replace ( 'M', ' ', $size ) );
}

function getRanks() {
	return loadByQuery ( "SELECT id, name as value FROM ranks ORDER BY name" );
}

function getDistricts() {
	return loadByQuery ( "SELECT id, name as value FROM districts ORDER BY name" );
}

function check_job_unconfigured_modems($table) {
	global $db;
	$new = $table->new_record;
	$filter = array ();
	$fields = array ('street', 'house' );
	foreach ( $fields as $f ) {
		$filter [] = "m." . $f . "='" . addslashes ( $new [$f] ) . "'";
	}
	$filter [] = 'm.type=1';
	$query = "SELECT m.id, m.name, s.name as street_name, m.house, m.entrance, m.floor, m.audit, m.exp_point
		FROM modems m
		LEFT JOIN streets s ON s.id=m.street
		WHERE " . implode ( " AND ", $filter ) . "
		ORDER BY abs(" . $new['entrance'] . " - m.entrance), m.entrance, abs(" . $new['floor'] . " - m.floor)
		LIMIT 1";
	$modems = loadRecords ( $query );
	foreach ( $modems as $modem ) {
		if(!$modem['audit']){
			$task_name = trim ( sprintf ( '  %s', $modem ['name'] ) );
			if (! loadRecord ( "SELECT id FROM exp_tasks WHERE name='" . addslashes ( $task_name ) . "'" )) {
				$db->Execute ( sprintf ( "INSERT INTO stamps (created, created_by) VALUES (now(), '%d')", BILLING_OPERATOR ) );
				$stamp = $db->getJustInserted ( 'stamps', 'id' );
				//$descr = "   \n" . $task_name . "\n" . sprintf ( "%s %s (: %s, : %s)", $modem ['street_name'], $modem ['house'], $modem ['entrance'], $modem ['floor'] );
				$db->Execute ( sprintf ( "INSERT IGNORE INTO exp_tasks (type, name, state, priority, stamp, end_date, point)
					VALUES (1, '%s', 3, 1, '%s', '%s', %s)", 
					addslashes ( $task_name ), $stamp ,$new['date'], $modem['exp_point'] ? $modem['exp_point'] : 'NULL' ));
			}
		}
	}
}

$appendOfflineDelay = 0;

function appendOffline($type, $data, $max_attempts = 1, $fork = 0) {
	global $db, $oper, $appendOfflineDelay;
	$db->Execute ( sprintf ( "INSERT INTO stamps (created, created_by) VALUES (now(), '%d')", $oper->id ) );
	$stamp = $db->getJustInserted ( 'stamps', 'id' );
	$db->Execute ( sprintf ( "INSERT INTO delayed_tasks (proc_type, data, max_attempts, fork, stamp, delay) VALUES ('%s', '%s', '%s', '%s', '%s', '%s')", $type, addslashes ( $data ), $max_attempts, $fork, $stamp, $appendOfflineDelay));
}

class ModemStateCellRenderer {
	function render($column, $record) {
		$val = $record [$column->name];
		$style = array ('+' => 'green_lighted', '-' => 'red_lighted' );
		$style = $style[$val];
		$val = $val == '-' ? '&ndash;' : $val;
		if($link=$column->BuildLink($record)){
			$val = '<a href="'.$link.'">'.$val.'</a>';
		}
		return sprintf ( "<td class='%s' align='center'>%s</td>", $style,  $val);
	}
}

function showFieldLink($tname, $fname, $delete = false) {
	$table = $GLOBALS [$tname];
	if ($table->isOn ()) {
		$fid = $table->active_record [$fname];
		if ($fid) {
			$files = loadRecords ( "SELECT * FROM billing_storage.files WHERE id='" . $fid . "'" );
			return listAttachments ( $files, 'photo', '', $delete);
		}
	}
}

function client_post($table) {
	global $db;
	$id = $table->current_record ['id'];
	$new = $table->new_record;
	export_client ( $table );
	change_client_gecos ( $table );
	if ($table->isChanged ( 'last_name,first_name,login' )) {
		$table->Execute ( sprintf ( "UPDATE accounts SET name='%s' WHERE id='%s'", addslashes ( $new ['last_name'] . ' ' . $new ['first_name'] . ' (' . $new ['login'] . ')' ), $table->current_record ['account'] ) );
		$table->Execute ( sprintf ( "UPDATE bonus_accounts ba LEFT JOIN accounts a ON a.id=ba.account SET a.name=CONCAT('%s', ba.name) WHERE ba.client='%s'", addslashes ( $new ['last_name'] . ' ' . $new ['first_name'] . ' (' . $new ['login'] . ') - ' ), $table->current_record ['id'] ) );
	}
	if($table->isChanged('connection_type')){
		$ct = loadRecord("SELECT * FROM connection_types WHERE id='".$new['connection_type']."'");
		if($ct['service_type']==0){
			$db->Execute("INSERT IGNORE INTO force_offline (client) VALUES ('$id')");
		}else{
			$db->Execute("DELETE FROM force_offline WHERE client='$id'");
			if($ct['service_type']&1 == 0){
				clear_hosts($id);
			}
		}
	}
}

function clear_hosts($clid){
	global $db, $beans;
	//  
	$notes = array();
	$modems = array();
	$hosts = loadRecords("SELECT h.id, h.ip, h.mac, h.modem, m.name, h.port FROM hosts h LEFT JOIN modems m ON m.id=h.modem WHERE h.client='".$clid."'");
	foreach($hosts as $host){
		$db->Execute(sprintf("DELETE FROM hosts WHERE id=%s", $host['id']));
		$notes[] = sprintf(" : ip=%s, mac=%s, modem=%s, port=%s", $host['ip'], $host['mac'], $host['name'], $host['port']);
		$modems[] = $host['modem'];
		if($host['port']){
			$db->Execute(sprintf("REPLACE INTO offline_ports (client, modem, port, date) VALUES (%s, %s, %s, now())",
				$clid, $host['modem'], $host['port']));
		}
	}
	$stamp = create_stamp();
	$db->Execute(sprintf("INSERT INTO client_notes (client, note, stamp) VALUES (%s, '%s', %s)", $clid, implode("\n", $notes), $stamp));
	//     
	$accessTrackerDAO = $beans->getBean('accessTrackerDAO');
	foreach($modems as $modem){
		$accessTrackerDAO->appendToQueue($modem, time());
	}
}

function client_insert($table) {
	return export_client ( $table );
}

function check_client_tv($table){
	$arr = $table->new_record;
	if($arr['tv_type']){
		if(!loadRecord("SELECT * FROM connection_type_tv WHERE connection_type='".$arr['connection_type']."' AND tv_type='".$arr['tv_type']."'")){
			$ct = loadRecord("SELECT name FROM connection_types WHERE id=".$arr['connection_type']);
			$tv = loadRecord("SELECT name FROM tv_types WHERE id=".$arr['tv_type']);
			$table->error(sprintf(getResource('clients.tv.wrong'), $tv['name'], $ct['name']));
		}
	}
}

function check_client_city($table){
	$new = $table->new_record;
	$check = array(
		'house_id'=>'houses',
	);
	foreach($check as $field=>$table_name){
		$arr = loadRecord("SELECT city FROM $table_name WHERE id='".$new[$field]."'");
		if($arr && ($arr['city']!=$new['city'])){
			$table->error(getResource('clients.error.'.$field.'.city'));
		}
	}
}

function check_client_login($table){
	$pattern = getTrimOption('CLIENT_LOGIN_PATTERN');
	if(!preg_match($pattern, $table->new_record['login'])){
		$table->error(getResource('clients.error.bad.login.syntax'));
	}
	if(loadRecord("SELECT id FROM operators WHERE login='".addslashes($table->new_record['login'])."'")){
		$table->error(getResource('clients.error.bad.login.operator'));
	}
}

function check_client_contract_duplicate($table){
	$contract = addslashes($table->new_record ['contract']);
	if ($contract){
		if(loadRecord(sprintf('SELECT id FROM clients WHERE contract="%s" AND id!="%s" LIMIT 1', $contract, $table->old_record['id']))){
			return $table->error(sprintf(getResource('clients.contract.duplicate'), $contract));
		}
		if(loadRecord(sprintf('SELECT id FROM jobs WHERE contract="%s" AND (client IS NULL OR client_id!="%s") LIMIT 1', $contract, $table->old_record['id']))){
			return $table->error(sprintf(getResource('clients.contract.duplicate'), $contract));
		}
	}
}

function check_job_contract_duplicate($table){
	$contract = addslashes($table->new_record ['contract']);
	$client = addslashes($table->new_record ['client']);
	if ($contract){
		if(loadRecord(sprintf('SELECT id FROM jobs WHERE contract="%s" AND id!="%s" AND (client IS NULL OR client_id!="%s") LIMIT 1', $contract, $table->old_record['id'], $client))){
			return $table->error(sprintf(getResource('clients.contract.duplicate'), $contract));
		}
		if(loadRecord(sprintf('SELECT id FROM clients WHERE contract="%s" AND id!="%s" LIMIT 1', $contract, $client))){
			return $table->error(sprintf(getResource('clients.contract.duplicate'), $contract));
		}
	}
}

function pre_client_insert($table) {
	check_client_city($table);
	check_client_login($table);
	check_client_tv($table);
	if (CRYPT_CLIENTS_PASS) {
		$table->new_record ['pass'] = crypt ( $table->new_record ['pass'] );
	}
	$new = $table->new_record;
	$table->Execute ( sprintf ( "INSERT INTO accounts (type, name) VALUES ('%s', '%s')", 'D', addslashes ( $new ['last_name'] . ' ' . $new ['first_name'] . ' (' . $new ['login'] . ')' ) ) );
	$acc = $table->owner->getJustInserted ( 'accounts', 'id' );
	$table->new_record ['account'] = $acc;
	$table->new_record ['surveyor'] = max(0, min(5, $table->new_record ['surveyor']));
}

function pre_client_post($table) {
	check_client_city($table);
	check_client_login($table);
	check_client_tv($table);
	if (CRYPT_CLIENTS_PASS && $table->isChanged ( 'pass' )) {
		$table->new_record ['pass'] = crypt ( $table->new_record ['pass'] );
	}
	$table->new_record ['surveyor'] = max(0, min(5, $table->new_record ['surveyor']));
}

function href_match($m) {
	$href = $m [0];
	$i = strlen ( $href ) - 1;
	while ( preg_match ( '|\W|', $href [$i] ) ) {
		$i --;
	}
	return '<a href="' . substr ( $href, 0, $i + 1 ) . '">' . substr ( $href, 0, $i + 1 ) . '</a>' . substr ( $href, $i + 1 );
}

function auto_href($val) {
	return preg_replace ( '/\b(?<!["\'\=])((https?|ftp|news|nntp|wais|wysiwyg|gopher|javascript|castanet|about)\:\/\/|(www|ftp|fido[0-9]*)\.)[\[\]\@\%\:\+\w\.\/\~\?\-\*=_#&;]+\b\/?/ix', '<a href="$0">$0</a>', $val );
	//return preg_replace_callback('|(?<!>)[a-z]{3,5}://[^\s]+|i', 'href_match', $val);
}

function auto_href2($val) {
	return nl2br ( auto_href ( $val ) );
}

function write_port_acl($clid, $hid) {
	$client = loadRecord ( "SELECT id, acl_pref FROM clients WHERE id=" . $clid );
	$host = loadRecord ( "SELECT id, modem, port FROM hosts WHERE id=" . $hid );
	$modem = loadRecord ( "SELECT id, ip, name, model FROM modems WHERE id=" . $host ['modem'] );
	$options = array ('destination' => '/var/lib/tftpboot/', 'snmp-timeout' => 2000000, 'snmp-retries' => 2, 'snmp-reader' => 'public', 'snmp-writer' => 'security', 'http-timeout' => '10', 'http-user' => 'security', 'http-password' => 'security', 'model-oid' => '.1.3.6.1.2.1.1.2.0' );
	$edgecore_models = array ('.1.3.6.1.4.1.259.6.10.57' => 'ES4612', '.1.3.6.1.4.1.259.6.10.74' => 'ES3526XA', '.1.3.6.1.4.1.259.6.10.94' => 'ES3552M', '.1.3.6.1.4.1.259.8.1.5' => 'ES3510', '.1.3.6.1.4.1.259.8.1.6' => 'ES3510' );
	snmp_set_oid_numeric_print ( 1 );
	snmp_set_quick_print ( 1 );
	snmp_set_valueretrieval ( SNMP_VALUE_PLAIN );
	$model_oid = snmpget ( $modem ['ip'], $options ['snmp-reader'], $options ['model-oid'], $options ['snmp-timeout'], $options ['snmp-retries'] );
	if (isset ( $edgecore_models [$model_oid] )) {
		if ($model_oid == '.1.3.6.1.4.1.259.8.1.6') {
			$model_oid = '.1.3.6.1.4.1.259.8.1.5';
		}
		$acl_oid = $model_oid . '.1.16.4.9.1.2.' . $host ['port'];
		$res = @snmpget ( $modem ['ip'], $options ['snmp-reader'], $acl_oid, $options ['snmp-timeout'], $options ['snmp-retries'] );
		if ($port_acl !== FALSE) {
			$admin_disconnect = loadRecord ( sprintf ( "SELECT id FROM blocks
				WHERE client=%s AND resource_type IS NULL 
				AND (actual_from IS NULL || actual_from <= now()) 
				AND (actual_to IS NULL || actual_to > now()) LIMIT 1", $client ['id'] ) );
			$personal_period = loadRecord ( sprintf ( "SELECT id, state FROM personal_periods WHERE marker=1 AND client='%s'", $client ['id'] ) );
			if ($admin_disconnect || ! $personal_period || ($personal_period ['state'] != 1)) {
				$acl = 1;
			} else {
				$acl = $client ['acl_pref'];
			}
			if ($port_acl != $acl) {
				@snmpset ( $modem ['ip'], $options ['snmp-writer'], $acl_oid, 'i', $acl, $options ['snmp-timeout'], $options ['snmp-retries'] );
			}
		}
	}
}

function upload_storage_files($max) {
	global $db;
	$result = array ();
	$count = 0;
	foreach ( $_FILES as $x => $info ) {
		clearstatcache ();
		$info ['time'] = filemtime ( $info ['tmp_name'] );
		if (is_uploaded_file ( $info ['tmp_name'] ) && ($count < $max)) {
			$db->Execute ( sprintf ( "INSERT INTO billing_storage.files (name, size, type, filedate)
				VALUES ('%s', '%s', '%s', '%s')", addslashes ( $info ['name'] ), filesize ( $info ['tmp_name'] ), addslashes ( $info ['type'] ), date ( 'Y-m-d H:i:s', $info ['time'] ) ) );
			$fid = $db->getJustInserted ( 'files', 'id' );
			$result [$x] = $fid;
			$fp = fopen ( $info ['tmp_name'], "rb" );
			while ( ! feof ( $fp ) ) {
				$binarydata = fread ( $fp, 65535 );
				$db->Execute ( sprintf ( "INSERT INTO billing_storage.file_chunks (file_id, chunk) VALUES ('%s', '%s')", $fid, addslashes ( $binarydata ) ) );
			}
			fclose ( $fp );
			$count ++;
		}
	}
	return $result;
}

function upload_img($max, $size) {
	global $db;
	$result = array ();
	$count = 0;
	foreach ( $_FILES as $x => $info ) 
	{
		clearstatcache ();
		$info ['time'] = filemtime ( $info ['tmp_name'] );
		if (is_uploaded_file ( $info ['tmp_name'] ) && ($count < $max)) 
		{
			list($width, $height) = getimagesize($info ['tmp_name'] );
			$new_width;
			$new_height;
			if($width > $height)
			{
				$new_width = $size;
				$new_height = $height * ($size/$width);
			}
			else
			{
				$new_height = $size;
				$new_width = $width * ($size/$height);
			}
			if($size < $width OR $size < $height)
			{
				$image_p = imagecreatetruecolor($new_width, $new_height);
				$image;
				if($info ['type'] == "image/jpeg")
				{
					$image = imagecreatefromjpeg($info ['tmp_name'] );
				}
				if($info ['type'] == "image/png")
				{
					$image = imagecreatefrompng($info ['tmp_name'] );
				}
				if($info ['type'] == "image/bmp")
				{
					$image = imagecreatefrombmp($info ['tmp_name'] );
				}
				
				
				imagecopyresampled($image_p, $image, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
				imagejpeg($image_p, $info ['tmp_name'], 100);
				
			}
			
			
			$db->Execute ( sprintf ( "INSERT INTO billing_storage.files (name, size, type, filedate)
				VALUES ('%s', '%s', '%s', '%s')", addslashes ( $info ['name'] ), filesize ( $info ['tmp_name'] ), addslashes ( $info ['type'] ), date ( 'Y-m-d H:i:s', $info ['time'] ) ) );
			$fid = $db->getJustInserted ( 'files', 'id' );
			$result [$x] = $fid;
			
			
			
			
			$fp = fopen ( $info ['tmp_name'], "rb" );
			while ( ! feof ( $fp ) ) {
				$binarydata = fread ( $fp, 65535 );
				$db->Execute ( sprintf ( "INSERT INTO billing_storage.file_chunks (file_id, chunk) VALUES ('%s', '%s')", $fid, addslashes ( $binarydata ) ) );
			}
			fclose ( $fp );
			$count ++;
		}
	}
	return $result;
}

class BooleanCellRenderer {
	var $colored;
	function BooleanCellRenderer($colored = 1) {
		$this->colored = $colored;
	}
	function render($column, $record) {
		$val = $record [$column->name];
		$class = $this->colored ? ($val == '+' ? 'green_lighted' : 'red_lighted') : '';
		return sprintf ( "<td class='%s' align='center'>%s</td>", $class, $val == '+' ? '+' : '&ndash;' );
	}
}
$boolean_cell = new BooleanCellRenderer ( );
$boolean_cell2 = new BooleanCellRenderer ( 0 );

function future_mov($val, $record) {
	if ($record ['future']) {
		return sprintf ( '<font color="#aaaaaa">%s</font>', $val );
	} else {
	return $val;
    }
}

function formatFileSize($size) {
	$kb = '1024';
	$mb = '1048576';
	$gb = '1073741824';
	if ($size > $gb) {
		return number_format ( $size / $gb, 2, '.', ' ' ) . ' ';
	} elseif ($size > $mb) {
		return number_format ( $size / $mb, 2, '.', ' ' ) . ' M';
	} elseif ($size > $kb) {
		return number_format ( $size / $kb, 2, '.', ' ' ) . ' ';
	} else {
		return $size . ' ';
	}
}

function getMimeIcon($mime){
	list ( $m1, $m2 ) = explode ( "/", $mime );
	$icon = $mime . '.gif';
	if (! is_file ( dirname ( __FILE__ ) . '/../images/mime/' . $icon )) {
		$icon = $m1 . '/default.gif';
	}
	return $icon;
}

function listAttachments($files, $source, $delimiter='<br>', $delete=false){
	$result = '';
	foreach ( $files as $arr ) {
		$mime = $arr ['type'];
		$icon = getMimeIcon($mime);
		$result .= sprintf('<a href="download.php?source=%s&id=%s"><img vspace=2 hspace=2 border=0 align="absmiddle" src="images/mime/%s">%s</a> <span style="color:#888">(%s)</span>',
			$source, $arr['id'], $icon, $arr['name'], formatFileSize($arr['size']));
		if($delete){
			$result .= ' <a href="'._href_change(array('file_delete'=>$arr['id'.$i])).'" title="'.getResource('file.delete').'" onclick="return confirm(\''.getResource('file.delete.confirm').'\')">&times;</a>';
		}
		$result .= $delimiter;
	}
	return $result;
}

function RemakeShapers() {
	/*
	global $beans;
	ob_start();
	$shapers = $beans->getBean('shapersManager');
	$shapers->make();
	$doc->garbage .= ob_get_clean();
*/
	appendOffline ( '3', 'task.shapers.remake', 1, 1 );
}

function RemakeModemProfile($modem) {
	global $db, $beans, $doc;
	ob_start ();
	$profileBuilder = $beans->getBean ( 'profileBuilder2' );
	$exit_code = $profileBuilder->buildModem ( $modem );
	$doc->garbage .= ob_get_clean ();
	if ($exit_code) {
		$arr = $db->Next ( $db->Execute ( sprintf ( "SELECT * FROM modems WHERE id='%s'", $modem ) ) );
		return sprintf ( getResource ( 'modems.profiles.build.error' ), $exit_code, sprintf ( "%s, %s, %s", $arr ['mac'], $arr ['ip'], $arr ['name'] ) );
	}
}

function RemakeModemProfileTask($modem) {
	appendOffline ( '3', 'task.build.profile ' . $modem, 2, 1 );
}

function RemakeChangedModemProfile($modem, $old) {
	global $db, $beans, $doc;
	ob_start ();
	$profileBuilder = $beans->getBean ( 'profileBuilder2' );
	$exit_code = $profileBuilder->buildChangedModem ( $modem, $old );
	$doc->garbage .= ob_get_clean ();
	if ($exit_code) {
		$arr = $db->Next ( $db->Execute ( sprintf ( "SELECT * FROM modems WHERE id='%s'", $modem ) ) );
		return sprintf ( getResource ( 'modems.profiles.build.error' ), $exit_code, sprintf ( "%s, %s, %s", $arr ['mac'], $arr ['ip'], $arr ['name'] ) );
	}
}

class FormatBytes {
	
	function toString($value) {
		$len = strlen ( $value );
		if (($len > 12) && (substr ( $value, - 12 ) == str_repeat ( '0', 12 ))) {
			$value = substr ( $value, 0, - 12 ) . 'T';
		} elseif (($len > 9) && (substr ( $value, - 9 ) == str_repeat ( '0', 9 ))) {
			$value = substr ( $value, 0, - 9 ) . 'G';
		} elseif (($len > 6) && (substr ( $value, - 6 ) == str_repeat ( '0', 6 ))) {
			$value = substr ( $value, 0, - 6 ) . 'M';
		} elseif (($len > 3) && (substr ( $value, - 3 ) == str_repeat ( '0', 3 ))) {
			$value = substr ( $value, 0, - 3 ) . 'K';
		}
		return $value;
	}
	
	function fromString($str) {
		$str = trim ( $str );
		$last = strtoupper ( substr ( $str, - 1 ) );
		$k = 1;
		switch ($last) {
			case 'K' :
				$k = 1000;
				break;
			case 'M' :
				$k = 1000000;
				break;
			case 'G' :
				$k = 1000000000;
				break;
			case 'T' :
				$k = 1000000000000;
				break;
		}
		if ((strlen ( $str ) > 1) && ($k > 1)) {
			$str = $str * $k;
		}
		return $str;
	}
}

$fbytes = new FormatBytes ( );

class Format100 {
	
	function toString($value) {
		return number_format ( $value / 100, 2, '.', '' );
	}
	
	function fromString($str) {
		return intval ( round ( _Float ( $str ) * 100 ) );
	}
}

$fcurrency = new Format100 ( );

class FormatLowerCase {
	
	function toString($value) {
		return $value;
	}
	
	function fromString($str) {
		return strtolower ( $str );
	}
}

$fLowerCase = new FormatLowerCase ( );

class FormatTimeHM {

	function toString($value) {
		$t = _ValidTime($value);
		return substr($value, 0, -3);
	}

	function fromString($str) {
		return _ValidTime($str);
	}
}

$fTimeHM = new FormatTimeHM ();


$translit = chr(178).'-I,'.chr(179).'-i,-e,i-i,-yi,-E,I-I,-Yi,-a,-b,-v,-g,-d,-e,-e,-g,-z,-i,-y,-k,-l,-m,-n,-o,-p,-r,-s,-t,-u,-f,-h,-sh,-sh,-c,-ch,-,-,-y,-e,-u,-ya,-A,-B,-V,-G,-D,-E,-E,-G,-Z,-I,-Y,-K,-L,-M,-N,-O,-P,-R,-S,-T,-U,-F,-H,-Sh,-Sh,-C,-Ch,-,-,-Y,-E,-U,-Ya';

$resolve_cache = array();

function fmt_ndash($val){
	return str_replace("-", "&ndash;", $val);
}

function fmt_fade_brackets($val){
	return preg_replace('|\([^\)]*\)|','<font color=#666666>\0</font>', $val);
}

function fmt_sip($val){
	return preg_replace('|[\+\(\)\d]{5,}|','<a class="cross" href="sip:\0">\0</a>', $val);
}

function fmt_sip3($val){
	return preg_replace('|[\+\(\)\d]{3,}|','<a class="cross" href="sip:\0">\0</a>', $val);
}

function fmt_resolve($ip) {
	global $resolve_cache;
	if (isset ( $resolve_cache [$ip] )) {
		$name = $resolve_cache [$ip];
	} else {
		$name = gethostbyaddr_timeout ( $ip );
		$resolve_cache [$ip] = $name;
	}
	if ($ip != $name) {
		return sprintf ( "%s&nbsp;<font color=#666666>(%s)</font>", $ip, $name );
	} else {
		return $ip;
	}
}

function frmt_decimal_2($val) {
	return substr ( $val, 0, - 5 ) . ' ' . substr ( $val, - 5, - 2 ) . " <font color=#666666>" . substr ( $val, - 2, 2 ) . "</font>";
}

function frmt_3($val) {
	return sprintf ( "<span class=nw>%s</span>", number_format ( $val, 0, '.', ' ' ) );
}

function frmt_3_2($val) {
	return strlen ( $val ) > 0 ? sprintf ( "<span class=nw>%s</span>", number_format ( $val, 2, '.', ' ' ) ) : '';
}

function frmt_3_3($val) {
	return strlen ( $val ) > 0 ? sprintf ( "<span class=nw>%s</span>", number_format ( $val, 3, '.', ' ' ) ) : '';
}

function fmt_nowrap($val) {
	return sprintf ( "<span class=nw>%s</span>", $val );
}

function SafeForTitle($val) {
	return addslashes ( htmlspecialchars ( $val, ENT_QUOTES ) );
}

function _Translit($str) {
	global $translit;
	static $trans;
	if (! is_array ( $trans )) {
		$trans = array ();
		$assoc = explode ( ",", $translit );
		foreach ( $assoc as $p ) {
			$p = explode ( "-", $p );
			$trans [$p [0]] = $p [1];
		}
	}
	return strtr ( $str, $trans );
}

function StateIcon($state) {
	switch ($state) {
		case 0 :
			$title = '';
			break;
		case 1 :
			$title = '';
			break;
		case 2 :
			$title = '  ';
			break;
		case 3 :
			$title = '  ';
			break;
		case 4 :
			$title = '';
			break;
	}
	return "<img width='10' height='10' align='absmiddle' border='0' title='$title' src='" . HREF . "images/state_$state.png" . "'>";
}

function PrintStrings($title, $s) {
	global $doc;
	$strings = is_array($s) ? $s : explode ( "\n", $s );
	$line = 0;
	ob_start ();
	echo "<table width='100%' class='form'><tr><td width='1%'></td><td><font color='#0000aa'>$title</font></td></tr>";
	foreach ( $strings as $item ) {
		$line ++;
		$item = str_replace ( array (" ", "\t" ), array ("&nbsp;", "&nbsp;&nbsp;&nbsp;&nbsp;" ), $item );
		echo "<tr><td nowrap><font color='#880000'>$line:</font></td><td>$item</td>\n";
	}
	echo "</table>";
	$doc->garbage .= ob_get_clean ();
}

function ExecuteScript($script, $debug = 0, $out_handler = '') {
	global $doc;
	ob_start ();
	$strings = explode ( "\n", $script );
	$line = 0;
	$exit_code = 0;
	echo "<pre><code>";
	foreach ( $strings as $command ) {
		$line ++;
		$command = trim ( $command );
		if ($command && $command [0] != '#') {
			if ($debug) {
				echo "<font color='#880000'>" . $command . "</font>\n";
			}
			$out = array ();
			exec ( $command, $out, $exit_code );
			echo implode ( "\n", $out );
			if ($exit_code) {
				break;
			}
		}
	}
	echo "</code></pre>";
	//$doc->page->contents['exec_script'] .= ob_get_clean();
	$out = ob_get_clean ();
	if($out_handler){
		$out = call_user_func($out_handler, $out);
	}
	$doc->garbage .= $out;
	if ($exit_code) {
		return sprintf ( getResource ( 'exec.runtime.error' ), $line, $command, $exit_code );
	}
}

function IpMatch($network, $mask, $ip) {
	$n = ip2long ( $network );
	$i = ip2long ( $ip );
	if (is_numeric ( $mask )) { // 10.10.10.0/24
		$m = ~ ((1 << (32 - $mask)) - 1);
	} else { // 10.10.10.0/255.255.255.0
		$m = ip2long ( $mask );
   }
	return ! (($n & $m) - ($i & $m));
}

function ValidateMac($mac) {
	$parts = explode ( ":", $mac );
	if (count ( $parts ) != 6) {
		return getResource ( 'mac.error.segment.count' );
	} else {
		foreach ( $parts as $part ) {
			if (strlen ( $part ) != 2 || preg_match ( "'[^0-9a-f]'i", $part )) {
				return sprintf ( getResource ( 'mac.error.segment.wrong' ), $part );
			}
		}
	}
}

function ValidateIp($ip) {
	$parts = explode ( ".", $ip );
	if (count ( $parts ) != 4) {
		return getResource ( 'ip.error.segment.count' );
	} else {
		$i = 1;
		foreach ( $parts as $part ) {
			$sub = explode ( "/", $part );
			if (count ( $sub ) > 1) {
				$mask = intval ( $sub [1] );
			}
			$pint = intval ( $part );
			if ($pint < 0 || $pint > 255 || ($i == 4 && ("$pint" != $sub [0] || "$mask" != $sub [1])) || ($i ++ < 4 && "$pint" != $part)) {
				return sprintf ( getResource ( 'ip.error.segment.wrong' ), $part );
			}
		}
	}
}

function getAdminDistricts() {
	return loadByQuery ( "SELECT id, name AS value FROM admin_districts ORDER BY name" );
}

function getStreets() {
	return loadByQuery ( "SELECT id, name AS value FROM streets ORDER BY name" );
}

function getConnectionTypes() {
	global $oper;
	if($oper->city_mode){
		return loadByQuery ( "SELECT ct.id, ct.name AS value FROM connection_types ct 
			LEFT JOIN operators_cities oc ON oc.city=ct.city AND oc.operator='$oper->id'
			WHERE (oc.city IS NOT NULL)
			ORDER BY ct.name" );
	}else{
		return loadByQuery ( "SELECT id, name AS value FROM connection_types ORDER BY name" );
	}
}

function getDepartments() {
	return loadByQuery ( "SELECT id, name AS value FROM departments ORDER BY name" );
}

function getPublicDepartments() {
	return loadByQuery ( "SELECT id, name AS value FROM departments WHERE hidden=0 ORDER BY name" );
}

function getChargeTypes() {
	return loadByQuery ( "SELECT id, CONCAT(name, ' (', ROUND(price/100, 2), ')') AS value FROM charge_types ORDER BY name" );
}

function getRules() {
	return loadByQuery ( "SELECT id, name AS value FROM rules ORDER BY name" );
}

function getResourceTypes() {
	return loadByQuery ( "SELECT id, name AS value FROM resource_types ORDER BY name" );
}

function getDomains() {
	return loadByQuery ( "SELECT id, name AS value FROM domains WHERE hidden=0 ORDER BY name" );
}

function getHostsActions() {
	return loadByQuery ( "SELECT id, name AS value FROM hosts_actions WHERE hidden=0 ORDER BY name" );
}

function getModemsActions() {
	return loadByQuery ( "SELECT id, name AS value FROM modems_actions WHERE hidden=0 ORDER BY name" );
}

function getHosts() {
	global $oper;
	$dep = $oper->department;
	return loadByQuery ( "SELECT h.id as id, CONCAT(c.last_name, ' ', c.first_name, ' (', c.login, ') - ', h.ip) as value 
	FROM hosts h LEFT JOIN clients c ON c.id=h.client " . ($dep ? " WHERE c.department='$dep'" : "") . " ORDER BY c.last_name, c.first_name, c.login, h.ip" );
}

function getClients($find = '', $first = 0) {
	global $oper;
	$dep = $oper->department;
	return loadByQuery ( "SELECT id, CONCAT(last_name, ' ', first_name, ' (', login, ')') AS value FROM clients " . ($dep ? " WHERE department='$dep'" : "") . " ORDER BY last_name, first_name, login" );
}

function getClientsByExecutor() {
	global $oper;
	return loadByQuery ( sprintf ( "SELECT c.id, CONCAT(c.last_name, ' ', c.first_name, ' (', c.login, ')') AS value 
		FROM jobs j
		LEFT JOIN clients c on c.id=j.client_id
		WHERE j.client_id IS NOT NULL AND j.worker='%s'
		ORDER BY c.last_name, c.first_name, c.login", $oper->person));
}

function getClientsAndContracts() {
	global $oper;
	$dep = $oper->department;
	return loadByQuery ( "SELECT id, CONCAT(last_name, ' ', first_name, ' (', contract, ')') AS value FROM clients " . ($dep ? " WHERE department='$dep'" : "") . " ORDER BY last_name, first_name, login" );
}

function getModems() {
	global $oper;
	$dep = $oper->department;
	return loadByQuery ( "SELECT id, CONCAT(ip, ' (', name, ')') as value FROM modems" . ($dep ? " WHERE department='$dep'" : "") . " ORDER BY ip" );
}

function getCalendarPeriods() {
	$periods = loadRecords ( "SELECT id, UNIX_TIMESTAMP(period_begin) period_begin, UNIX_TIMESTAMP(period_end) period_end FROM calendar_periods ORDER BY period_begin DESC" );
	$result = array ();
	foreach ( $periods as $p ) {
		$result [$p ['id']] = strftime ( "%Y %B", ($p ['period_begin'] + $p ['period_end']) / 2 );
	}
	return $result;
}

function getQueries() {
	return loadByQuery ( "SELECT id, name AS value FROM queries ORDER BY name" );
}

function getJetTypes() {
	return loadByQuery ( "SELECT jet.id, CONCAT(jet.name, ' (', ROUND(IFNULL(ct.price,0)/100, 2), ' / ', ROUND(jet.worker_fee/100, 2) , ')') AS value FROM jobs_extra_types jet
		LEFT JOIN charge_types ct ON ct.id=jet.charge_type
		ORDER BY jet.name" );
}

function getWorkers(){
	global $oper;
	$filter = $oper->city_mode ? " AND (oc.city IS NOT NULL)" : "";
	return loadByQuery("SELECT s.id, s.name AS value
		FROM staff s
		LEFT JOIN ranks r ON r.id=s.rank
		LEFT JOIN operators_cities oc ON oc.city=s.city AND oc.operator='$oper->id'
		WHERE s.status=1 AND r.accept_jobs=1 $filter
		ORDER BY s.name");
}

function getDispatching() {
	return loadByQuery ( "SELECT dispatching.id, CONCAT(kpreos.number, '(', streets.name,' ', dispatching.house, ')') AS value 
		FROM dispatching
		Inner Join kpreos ON dispatching.kp_reo = kpreos.id
		Inner Join streets ON dispatching.street = streets.id " );
}

function getTechZonesTimes() {
	global $oper;
	$filter = $oper->city_mode ? " WHERE (oc.city IS NOT NULL)" : "";
	return loadByQuery ( "SELECT  id, CONCAT(name, ' -> ', time_name) as value FROM (
		SELECT -tz.id as id, tz.name, '  ' as time_name, CAST(0 AS TIME) as from_time, tz.city
		FROM tech_zones tz
		LEFT JOIN operators_cities oc ON oc.city=tz.city AND oc.operator='$oper->id'
		$filter
		UNION
		SELECT tzt.id, tz.name, tzt.time_name, tzt.from_time, tz.city
		FROM tech_zone_times tzt
		LEFT JOIN tech_zones tz ON tzt.tech_zone = tz.id 
		LEFT JOIN operators_cities oc ON oc.city=tz.city AND oc.operator='$oper->id'
		$filter
	) as x
	ORDER BY name, from_time" );
}

function getTechZones() {
	return loadByQuery ( 'SELECT  id, name as value FROM tech_zones' );
}
function getKpReo() {
	return loadByQuery ( 'SELECT  id, number as value FROM kpreos' );
}

function getOperatorCandidates() {
	global $db, $oper;
	$operators = array ();
	$dep = $oper->department;
	$res = $db->Execute ( "SELECT id,  name FROM operators" . ($dep ? " WHERE department='$dep'" : "") . " ORDER BY name" );
	while ( $arr = $db->Next ( $res ) ) {
		$operators [$arr ['id']] = trim ( $arr ['name'] );
	}
	return $operators;
}

function loadValue($query, $def = '') {
	if($rec = loadRecord($query)){
		if(is_array($rec) && !empty($rec)){
			return array_shift($rec);
		}
	}
	return $def;
}

function loadRecord($query) {
	global $db;
	$res = $db->Execute ( $query );
	return $db->Next ( $res );
}

function loadRecords($query, $key = '') {
	global $db;
	$arr = array ();
	$res = $db->Execute ( $query );
	if ($key) {
		while ( $a = $db->Next ( $res ) ) {
			$arr [$a [$key]] = $a;
		}
	} else {
		while ( $a = $db->Next ( $res ) ) {
			$arr [] = $a;
		}
	}
	return $arr;
}

function loadByQuery($query, $key = 'id', $value = 'value', $arr = array ()) {
	global $db;
	$res = $db->Execute ( $query );
	while ( $a = $db->Next ( $res ) ) {
		$arr [$a [$key]] = $a [$value];
	}
	return $arr;
}

function loadAssoc($query, $key = 'id', $arr = array ()) {
	global $db;
	$res = $db->Execute ( $query );
	while ( $a = $db->Next ( $res ) ) {
		$arr [$a [$key]] = $a;
	}
	return $arr;
}


function before_personal_period_post($table) {
	$begin = _parse_datetime ( $table->current_record ['period_begin'] );
	$end = _parse_datetime ( $table->new_record ['period_end'] );
	if ($begin > $end) {
		$table->error ( getResource ( 'prepays.error.period.invalid' ) );
	}
}

function after_personal_period_post($table) {
	global $beans, $db;
	$new = $table->current_record;
	if ($new ['state'] == 1) {
		if ($table->isChanged ( 'connection_type' )) {
			$table->warning ( RemakeShapers () );
		}
		if ($table->isChanged ( 'period_end' )) {
			prolong_charges($new['id']);
		}
	}
}

function prolong_charges($pid){
	global $beans;
	$period = loadRecord("SELECT id, client, unix_timestamp(period_begin) period_begin, unix_timestamp(period_end) period_end
		FROM personal_periods WHERE id='".$pid."'");
	$client = loadRecord ( "SELECT id, account, connection_type, login, first_name, last_name, email, notice, alarm, block, reduction, blockable 
		FROM clients WHERE id=" . $period['client']);
	$subs = loadRecords("SELECT cs.*
		FROM charge_subscriptions cs
		LEFT JOIN charge_types ct ON ct.id=cs.type
		WHERE cs.client='".$client['id']."' AND ct.driver>''");
	foreach($subs as $sub) {
		$type = loadRecord("SELECT * FROM charge_types WHERE id='".$sub['type']."'");
		$driver = $beans->getBean($type['driver']);
		$driver->start($sub, $type, $client, $period);
	}
}

function before_stamped_insert($table) {
	global $db, $oper;
	$db->Execute ( sprintf ( "INSERT INTO stamps (created, created_by) VALUES (now(), '%d')", $oper->id ) );
	$stamp = $db->getJustInserted ( 'stamps', 'id' );
	$table->new_record ['stamp'] = $stamp;
}

function create_stamp(){
	global $db, $oper;
	$db->Execute ( sprintf ( "INSERT INTO stamps (created, created_by) VALUES (now(), '%d')", $oper->id ) );
	return $db->getJustInserted ( 'stamps', 'id' );
}

function before_stamped_post($table) {
	global $db, $oper;
	$stamp = $table->current_record ['stamp'];
	if ($stamp) {
		$db->Execute ( sprintf ( "UPDATE stamps SET modified=now(), modified_by='%d' WHERE id='%d'", $oper->id, $stamp ) );
	} else {
		$db->Execute ( sprintf ( "INSERT INTO stamps (modified, modified_by) VALUES (now(), '%d')", $oper->id ) );
		$stamp = $db->getJustInserted ( 'stamps', 'id' );
		$table->new_record ['stamp'] = $stamp;
	}
}

function update_stamp($stamp){
	global $db, $oper;
	if ($stamp) {
		$db->Execute ( sprintf ( "UPDATE stamps SET modified=now(), modified_by='%d' WHERE id='%d'", $oper->id, $stamp ) );
	}
}

function after_stamped_delete($table) {
	global $db, $oper;
	$stamp = $table->old_record ['stamp'];
	if ($stamp) {
		$db->Execute ( sprintf ( "DELETE FROM stamps WHERE id='%d'", $stamp ) );
	}
}

function after_logged_insert($table) {
	global $action_logger;
	return $action_logger->after_insert ( $table );
}

function after_logged_post($table) {
	global $action_logger;
	return $action_logger->after_post ( $table );
}

function after_logged_delete($table) {
	global $action_logger;
	return $action_logger->after_delete ( $table );
}

function getCurrentCalendarPeriod() {
	global $db;
	static $cp;
	if (! isset ( $cp )) {
		$res = $db->Execute ( "SELECT id FROM calendar_periods WHERE marker=1" );
		if ($period = $db->Next ( $res )) {
			$cp = $period ['id'];
		} else {
			$cp = '';
		}
	}
	return $cp;
}

function arr_append(&$arr1, &$arr2) {
	foreach ( $arr2 as $k => $v ) {
		$arr1 [$k] = $v;
	}
}

/*
function before_prepay_insert($table){
	$arr = $table->Next($table->Execute(sprintf("SELECT price FROM charge_types WHERE id='%s'", $table->new_record['type'])));
	$table->new_record['amount'] = $arr['price'];
}*/

function gethostbyaddr_timeout($ip, $dns = '127.0.0.1', $timeout = 1000) {
   // random transaction number (for routers etc to get the reply back)
	$data = rand ( 0, 99 );
   // trim it to 2 bytes
	$data = substr ( $data, 0, 2 );
   // request header
   $data .= "\1\0\0\1\0\0\0\0\0\0";
   // split IP up
	$bits = explode ( ".", $ip );
   // error checking
	if (count ( $bits ) != 4)
		return "ERROR";
   // there is probably a better way to do this bit...
   // loop through each segment
	for($x = 3; $x >= 0; $x --) {
       // needs a byte to indicate the length of each segment of the request
		switch (strlen ( $bits [$x] )) {
			case 1 : // 1 byte long segment
				$data .= "\1";
				break;
			case 2 : // 2 byte long segment
				$data .= "\2";
				break;
			case 3 : // 3 byte long segment
				$data .= "\3";
				break;
			default : // segment is too big, invalid IP
               return "INVALID";
       }
       // and the segment itself
		$data .= $bits [$x];
   }
   // and the final bit of the request
   $data .= "\7in-addr\4arpa\0\0\x0C\0\1";
   // create UDP socket
	$handle = @fsockopen ( "udp://$dns", 53 );
   // send our request (and store request size so we can cheat later)
	$requestsize = @fwrite ( $handle, $data );
	
   $timeout *= 1000;
	@socket_set_timeout ( $handle, floor ( $timeout / 1000000 ), $timeout % 1000000 );
   // hope we get a reply
	$response = @fread ( $handle, 1000 );
	@fclose ( $handle );
   if ($response == "")
       return $ip;
   // find the response type
	$type = @unpack ( "s", substr ( $response, $requestsize + 2 ) );
	if ($type [1] == 0x0C00) { // answer
       // set up our variables
		$host = "";
       $len = 0;
       // set our pointer at the beginning of the hostname
       // uses the request size from earlier rather than work it out
		$position = $requestsize + 12;
       // reconstruct hostname
		do {
           // get segment size
			$len = unpack ( "c", substr ( $response, $position ) );
           // null terminated string, so length 0 = finished
			if ($len [1] == 0)
               // return the hostname, without the trailing .
				return substr ( $host, 0, strlen ( $host ) - 1 );
           // add segment to our host
			$host .= substr ( $response, $position + 1, $len [1] ) . ".";
           // move pointer on to the next segment
			$position += $len [1] + 1;
		} while ( $len != 0 );
       // error - return the hostname we constructed (without the . on the end)
       return $ip;
   }
   return $ip;
}

function findFreeIp($net_addr, $count, $use_cache = true) {
	static $cache;
	$min = ip2long(long2ip($net_addr->getAddress() & $net_addr->getMask() + 1));
	$max = ip2long(long2ip($net_addr->getAddress() | ~$net_addr->getMask()));
	if($use_cache){
		if(!is_array($cache)){
			$cache = loadByQuery ("SELECT ip FROM modems UNION SELECT ip FROM hosts UNION SELECT ip FROM tv_nodes WHERE ip IS NOT NULL", 'ip', 'ip');
		}
		$existen = $cache;
	}else{
		$filter = sprintf ( "ip not like '%%/%%' AND INET_ATON(ip) >= '%s' AND INET_ATON(ip) <= '%s'", $min, $max );
		$existen = loadByQuery ( "SELECT ip FROM modems WHERE " . $filter . 
			" UNION SELECT ip FROM hosts WHERE " . $filter.
			" UNION SELECT ip FROM tv_nodes WHERE ip IS NOT NULL AND " . $filter,
			'ip', 'ip' );
	}
	$result = array ();
	$deny = array (0, 1, 255 );
	for($i = $min + 1; ($i < $max) && (count($result) < $count); $i++) {
		$low_byte = $i & 255;
		if (!in_array($low_byte, $deny )){
			$ip = long2ip ($i);
			if(!isset($existen[$ip])){
				$result[] = $ip;
			}
		}
	}
	return $result;
}


class FreeIpFinder {
	
	var $db;
	var $free;
	var $per_zone;
	
	function FreeIpFinder($db, $table) {
		$this->db = $db;
		$this->table = $table;
	}
	
	function fillLack($zone, $from, $to) {
		$lack = $this->per_zone - count ( $this->free [$zone] );
		if ($lack > 0) {
			$to = min ( $from + $lack, $to );
			for($i = $from; $i < $to; $i ++) {
				$this->free [$zone] [] = $i;
			}
		}
	}
	
	function find($per_zone, $space = array()) {
		$this->per_zone = $per_zone;
		$this->free = array ();
		$pref_zones = array ();
		$prev_zone = '';
		$prev_term = 2;
		$res = $this->db->Execute ( "
		SELECT ip, 'm' mark FROM modems UNION 
		SELECT ip, 'h' mark FROM hosts UNION 
		SELECT ip, 't' mark FROM tv_nodes WHERE ip IS NOT NULL
		ORDER BY INET_ATON(ip)" );
		while ( $arr = $this->db->Next ( $res ) ) {
			$ip = $arr ['ip'];
			$mark = $arr ['mark'];
			$dot = strrpos ( $ip, '.' );
			$zone = substr ( $ip, 0, $dot );
			$term = substr ( $ip, $dot + 1 );
			if ($zone != $prev_zone) {
				if ($prev_zone) {
					$this->fillLack ( $prev_zone, $prev_term, 255 );
				}
				$prev_zone = $zone;
				$prev_term = 2;
				$this->free [$zone] = array ();
			}
			if ($this->table[0] == $mark) {
				$pref_zones[$zone] = 1;
			}
			$this->fillLack ( $zone, $prev_term, $term );
			$prev_term = $term + 1;
		}
		if ($prev_zone) {
			$this->fillLack ( $prev_zone, $prev_term, 255 );
		}
		$options = array ();
		foreach ( $pref_zones as $pref=>$x ) {
			if (! empty ( $this->free [$pref] )) {
				if (! empty ( $options )) {
					$options [] = '';
				}
				foreach ( $this->free [$pref] as $term ) {
					$options [] = $pref . '.' . $term;
				}
			}
		}
		return $options;
	}

}

function createSelectEditCandidates($name, $arr) {
	$result = sprintf ( "<select id='candidates_%s' onchange='sendInputValue(this, \"%s\", this.value)'>\n", $name, $name );
	foreach ( $arr as $opt ) {
		$result .= sprintf ( "<option value='%s'>%s</option>\n", htmlspecialchars ( $opt ), htmlspecialchars ( $opt ) );
    }
    $result .= "</select>\n";
    return $result;
}

function createLinkEditCandidates($name, $arr, $separator = ', ') {
	$links = array ();
	foreach ( $arr as $opt ) {
		$links [] = sprintf ( "<a href='#' onclick='getInput(this, \"%s\").value=\"%s\"'>%s</a>", $name, $opt, $opt );
	}
	return implode ( $separator, $links );
}

function createIpCandidates($name, $table, $per_zone) {
	global $db;
	$ip_finder = new FreeIpFinder ( $db, $table->name );
	$arr = array ();
	if ($table->isOn ()) {
		$ip = $table->active_record ['ip'];
		$arr [] = $ip;
		$arr [] = '';
	} else {
		$arr [] = '';
    }
	return createSelectEditCandidates ( $name, array_merge ( $arr, $ip_finder->find ( $per_zone ) ) );
	//return createSelectEditCandidates ( $name, array_merge ( $arr, array() ) );
}

function insertSelectOverFile($target, $select) {
    global $db;
    static $counter = 1;
	$filename = TMP_DIR . '/caban/' . session_id () . '-' . ($counter ++);
	$db->Execute ( sprintf ( "%s INTO OUTFILE '%s'", $select, $filename ) );
	$db->Execute ( sprintf ( "LOAD DATA INFILE '%s' IGNORE INTO TABLE %s", $filename, $target ) );
	if(DB_REMOTE){
		exec("ssh -o ConnectTimeout=3 ".DB_REMOTE.'@'.DB_HOST." rm ".$filename);
	}else{
		unlink ( $filename );
	}
}

?>