<?

// --- DOMAINS ---

function FillDomainTemplate($darr, $hosts){
	$tmpl = $darr['host_template'];
	$items = array();
	foreach($hosts as $host){
		$name = $host['name'] ? $host['name'] : 'host-'.$host['id'];
		$items[] = str_replace(
			array("%name", "%ip"),
			array($name, $host['ip']),
			$tmpl);
	}
	$rows = implode("\n", $items);
	$config = str_replace(
		array("%version", "%hosts"),
		array($darr['version'], $rows),
		$darr['template'])."\n";
	return $config;
}

function getDomainMemebers($id){
	global $db;
	$members = array();
	foreach(array("hosts", "modems") as $table){
		$res = $db->Execute("SELECT * FROM $table WHERE domain='$id' AND POSITION('/' IN ip)=0 ORDER BY name");
		while($arr = $db->Next($res)){
			$arr['type'] = $table;
			$members[] = $arr;
		}
	}
	return $members;
}

function SaveDomain($darr, $config){
	global $db;
	$fileName = getDirOption('DNS_DIR');
	if($fileName){
		$fileName .= $darr['name'];
		if($fd = @fopen ($fileName, "w")){
			$writen = fwrite($fd, $config);
			fclose($fd);
			if($remote = getTrimOption('DNS_REMOTE')){
				exec('scp -p '.$fileName.' '.$remote.':'.getDirOption('DNS_DIR'));
			}
		}else{
			return sprintf(getResource('save.error'), $fileName);
		}
	}
}

function NextDomainVersion($prev){
	$date = date("Ymd");
	$version_date = substr($prev,0,8);
	if($version_date != $date){
		$version = $date.'01';
	}else{
		$version_num = substr($prev,8);
		$version_num = ($version_num + 1) % 100;
		if($version_num==0){
			$version_num = 1;
		}
		$version = $version_date.substr('0'.$version_num, -2);
	}
	return $version;
}

function RemakeDomain($id=0){
	global $db;

	appendOffline(3, 'task.dns.remake.domain '.$id, 1, 1);
	return;

	if(getTrimOption('DNS_DIR')){
		$date = date("Ymd");
		$e = new Messages();
		$res = $db->Execute("SELECT * FROM domains".($id ? " WHERE id='$id'" : ""));
		while($darr = $db->Next($res)){
			$darr['version'] = NextDomainVersion($darr['version']);
			$config = FillDomainTemplate($darr, getDomainMemebers($darr['id']));
			$e->Append(SaveDomain($darr, $config));
			$db->Execute("UPDATE domains SET version='".$darr['version']."' WHERE id=".$darr['id']);
		}
		return $e->toHTML();
	}
}

// --- NETWORKS ---

function FillNetworkTemplate($narr, $hosts){
	$domains = loadByQuery("SELECT id, name as value FROM domains");
	$parts = explode("/", $narr['ip']);
	$net = $parts[0];
	$mask = $parts[1];
	if (!is_numeric($mask)){
		$m = ip2long($mask);
		$bin = decbin($m);
		$mask = strpos($bin,'0');
	}
	$c = 4 - ceil((32 - $mask)/8);
	$tmpl = $narr['host_template'];
	$items = array();
	foreach($hosts as $host){
		$ip = implode(".", array_reverse(array_slice(explode(".", $host['ip']), $c)));
		$name = $host['name'] ? $host['name'] : 'host-'.$host['id'];
		$domain = $domains[$host['domain']];
		$domainName = $name;
		if($domain){
			$domainName .= '.'.$domain;
		}
		$items[] = str_replace(
			array("%ip", "%name", "%domainName", "%domain"),
			array($ip, $name, $domainName, $domain ),
			$tmpl);
	}
	$rows = implode("\n", $items);
	$version = date("Ymd").substr('0'.$narr['version'], -2);
	$config = str_replace(
		array("%version", "%hosts"),
		array($version, $rows),
		$narr['template'])."\n";
	return $config;
}

function getNetworkMemebers($ip){
	global $db;
	$parts = explode("/", $ip);
	$net = $parts[0];
	$mask = $parts[1];
	$members = array();
	foreach(array("hosts", "modems") as $table){
		$res = $db->Execute("SELECT * FROM $table WHERE POSITION('/' IN ip)=0 ORDER BY ip");
		while($arr = $db->Next($res)){
			if(IpMatch($net, $mask, $arr['ip'])){
				$arr['type'] = $table;
				$members[] = $arr;
			}
		}
	}
	return $members;
}

function SaveNetwork($narr, $config){
	global $db;
	$fileName = getDirOption('DNS_BACK_DIR');
	if($fileName){
		$fileName .= $narr['filename'];
		if($fd = @fopen ($fileName, "w")){
			$writen = fwrite($fd, $config);
			fclose($fd);
			if($remote = getTrimOption('DNS_REMOTE')){
				exec('scp -p '.$fileName.' '.$remote.':'.getDirOption('DNS_BACK_DIR'));
			}
			$db->Execute("UPDATE networks SET version=version+1 WHERE id=".$narr['id']);
		}else{
			return sprintf(getResource('save.error'), $fileName);
		}
	}
}

function RemakeNetwork($id=0){
	global $db;
	
	appendOffline(3, 'task.dns.remake.network '.$id, 1, 1);
	return;
	
	if(getTrimOption('DNS_BACK_DIR')){
		$e = new Messages();
		$res = $db->Execute("SELECT * FROM networks".($id ? " WHERE id='$id'" : ""));
		while($narr = $db->Next($res)){
			$config = FillNetworkTemplate($narr, getNetworkMemebers($narr['ip']));
			$e->Append(SaveNetwork($narr, $config));
		}
		return $e->toHtml();
	}
}

function GetHostNetwork($ip, $mode = 0){
	global $db;
	$res = $db->Execute("SELECT * FROM networks order by substring_index(ip,'/',-1) desc");
	while($arr = $db->Next($res)){
		$parts = explode("/", $arr['ip']);
		$net = $parts[0];
		$mask = $parts[1];
		if(IpMatch($net, $mask, $ip)){
			return $mode ? $arr : $arr['id'];
		}
	}
}

function RestartDNS(){
	appendOffline(3, 'task.dns.restart', 1);
	return;
	
	$command = getOption('DNS_RESTARTER');
	if($command){
		$err = ExecuteScript($command);
		if($err){
			PrintStrings("Restart DNS", $command);
			return $err;
		}
	}
}

?>