<?
function after_ip_use_log_post($table){
	global $calc;
	if($table->isChanged('bytes')){
		$delta =  $calc->sub($table->new_record['bytes'], $table->old_record['bytes']);
		changeIpUse($table->current_record['ip_use'], $delta);
	}
}

function after_ip_use_log_delete($table){
	global $calc;
	changeIpUse($table->old_record['ip_use'], $calc->sub('0', $table->old_record['bytes']));
}

function after_ip_use_log_insert($table){
	global $calc;
	changeIpUse($table->new_record['ip_use'], $table->new_record['bytes']);
}

function after_ip_use_post($table){
	global $calc;
	if($table->isChanged('bytes')){
		$delta =  $calc->sub($table->new_record['bytes'], $table->old_record['bytes']);
		changePPResourceUse($table->current_record['personal_period_resource_use'], $delta);
	}
}

function after_ip_use_delete($table){
	global $calc;
	changePPResourceUse($table->old_record['personal_period_resource_use'], $calc->sub('0', $table->old_record['bytes']));
}

function after_ip_use_insert($table){
	global $calc;
	changePPResourceUse($table->new_record['personal_period_resource_use'], $table->new_record['bytes']);
}

function after_personal_period_resource_use_post($table){
	global $calc;
	if($table->isChanged('amount')){
		$delta =  $calc->sub($table->new_record['amount'], $table->old_record['amount']);
		changeResourceUse($table->current_record['resource_use'], $delta);
	}
}

function after_personal_period_resource_use_delete($table){
	global $calc;
	changeResourceUse($table->old_record['resource_use'], $calc->sub('0', $table->old_record['amount']));
}

function after_personal_period_resource_use_insert($table){
	global $calc;
	changeResourceUse($table->new_record['resource_use'], $table->new_record['amount']);
}

function after_resource_use_post($table){
	global $calc;
	if($table->isChanged('resource_type,price,unit_size,amount,src,dst')){
		after_resource_use_delete($table);
		after_resource_use_insert($table);
	}
}

function after_resource_use_delete($table){
	global $calc;
	$old = $table->old_record;
	$cp = getCurrentCalendarPeriod();
	if(!$old['movement'] && $old['src'] && $old['dst'] && ($cp==$old['calendar_period'])){
		$old_cost = cost($old['amount'], $old['price'], $old['unit_size']);
		if($calc->cmp($old_cost, '0') > 0){
			moveState($old['calendar_period'], $old['dst'], $old['src'], $old_cost);
		}
	}
}

function after_resource_use_insert($table){
	global $calc;
	$new = $table->current_record;
	$cp = getCurrentCalendarPeriod();
	if(!$new['movement'] && $new['src'] && $new['dst'] && ($cp==$new['calendar_period'])){
		$new_cost = cost($new['amount'], $new['price'], $new['unit_size']);
		if($calc->cmp($new_cost, '0') > 0){
			moveState($new['calendar_period'], $new['src'], $new['dst'], $new_cost);
		}
	}
}

function changeIpUse($iu, $delta){
	global $db;
	$db->debug = 1;
	$db->Execute(sprintf("UPDATE ip_uses SET bytes=bytes + (%s) WHERE id=%s", $delta, $iu));
	$arr = $db->Next($db->Execute(sprintf("SELECT personal_period_resource_use FROM ip_uses WHERE id=%s", $iu)));
	changePPResourceUse($arr['personal_period_resource_use'], $delta);
}

function changePPResourceUse($ppru, $delta){
	global $db;
	$db->Execute(sprintf("UPDATE personal_period_resource_uses SET amount=amount + (%s) WHERE id=%s", $delta, $ppru));
	$arr = $db->Next($db->Execute(sprintf("SELECT resource_use FROM personal_period_resource_uses WHERE id=%s", $ppru)));
	changeResourceUse($arr['resource_use'], $delta);
}

function cost($amount, $price, $unit_size){
	global $calc;
	return $calc->divLow($calc->mul($amount, $price), $unit_size);
}

function changeResourceUse($ru, $delta){
	global $db, $calc;
	$arr = $db->Next($db->Execute(sprintf("SELECT * FROM resource_uses WHERE id=%s", $ru)));
	$db->Execute(sprintf("UPDATE resource_uses SET amount=amount + (%s) WHERE id=%s", $delta, $ru));
	if($arr['src'] && $arr['dst']){
		$old_cost = cost($arr['amount'], $arr['price'], $arr['unit_size']);
		$new_cost = cost($calc->add($arr['amount'], $delta), $arr['price'], $arr['unit_size']);
		$delta_cost = $calc->sub($new_cost, $old_cost);
		if($calc->cmp($delta_cost, '0') != 0){
			moveState($arr['calendar_period'], $arr['src'], $arr['dst'], $delta_cost);
			if($arr['movement']){
				$db->Execute(sprintf("UPDATE movements SET amount = amount + (%s) WHERE id='%s'", $delta_cost, $arr['movement']));
			}
		}
	}
}

function isEnoughFundsForRes($clid, $rtid, $cost){
	global $calc, $db;
	$cp = getCurrentCalendarPeriod();
	$bonuses = loadRecord("
		SELECT IFNULL(sum(IFNULL(cas.state_end, 0)), 0) state
		FROM bonus_accounts ba
		INNER JOIN calendar_account_states cas ON cas.account=ba.account AND cas.calendar_period='".$cp."'
		INNER JOIN account_types at ON at.id=ba.account_type
		INNER JOIN account_resource_types art ON art.account_type=ba.account_type AND art.resource_type='".$rtid."'
		WHERE ba.client='".$clid."' AND (ba.actual_from IS NULL OR actual_from <= now()) AND (ba.actual_to IS NULL OR actual_to > now())");
	if($calc->cmp($bonuses['state'], $cost) >= 0){
		return true;
	}
	$client = loadRecord("SELECT id, account FROM clients WHERE id='".$clid."'");
	$as = getAccountState($cp, $client['account']);
	$deposit = $as['state_end'];
	if($calc->cmp($deposit, 0) > 0){
		$sum = $calc->add($bonuses['state'], $deposit);
		return $calc->cmp($sum, $cost) >= 0;
	}else{
		return false;
	}
}

function addSlitResourceUse($clid, $rtid, $dst, $unit, $price, $amount){
	global $calc;
	$ru = '';
	$cp = getCurrentCalendarPeriod();
	if($calc->cmp($unit, 1) > 0){
		$price = $calc->divLow($calc->mul($amount, $price), $unit);
		$unit = 1;
		$amount = 1;
	}
	$client = loadRecord("SELECT id, account FROM clients WHERE id='".$clid."'");
	$bonuses = loadRecords("
		SELECT ba.account, cas.state_end state
		FROM bonus_accounts ba
		INNER JOIN calendar_account_states cas ON cas.account=ba.account AND cas.calendar_period='".$cp."'
		INNER JOIN account_types at ON at.id=ba.account_type
		INNER JOIN account_resource_types art ON art.account_type=ba.account_type AND art.resource_type='".$rtid."'
		WHERE ba.client='".$clid."' AND (ba.actual_from IS NULL OR actual_from <= now()) AND (ba.actual_to IS NULL OR actual_to > now())");
	for($i=0; $i<$amount; $i++){
		$rest = $price;
		if($rtid){
			foreach($bonuses as $bonus){
				if($calc->cmp($rest, 0) > 0){
					if($calc->cmp($bonus['state'], 0) > 0){
						$fit = $calc->min($bonus['state'], $rest);
						$rest = $calc->sub($rest, $fit);
						$ru = addResourceUse($clid, $rtid, 1, $fit, $bonus['account'], $dst, 1);
					}
				}
			}
		}
		if($calc->cmp($rest, 0) > 0){
			$ru = addResourceUse($clid, $rtid, 1, $rest, $client['account'], $dst, 1);
		}
	}
	return $ru;
}

function addResourceUse($clid, $rtid, $unit, $price, $src, $dst, $amount){
	global $db, $calc;
	$cp = getCurrentCalendarPeriod();
	$ru = $db->Next($db->Execute(sprintf("SELECT * FROM resource_uses
		WHERE calendar_period=%s AND client=%s AND resource_type=%s AND unit_size=%s AND price=%s AND src=%s AND dst=%s",
		$cp, $clid, $rtid, $unit, $price, $src, $dst)));
	if($ru){
		$ruid = $ru['id'];
	}else{
		$db->Execute(sprintf("INSERT INTO resource_uses (calendar_period, client, resource_type, unit_size, price, src, dst)
			VALUES (%s, %s, %s, %s, %s, %s, %s)", $cp, $clid, $rtid, $unit, $price, $src ? $src : 'null', $dst ? $dst : 'null'));
		$ruid = $db->getJustInserted('resource_uses', 'id');
	}
	changeResourceUse($ruid, $amount);
	return $ruid;
}

function prepare_ip_use_data($period){
	global $db;
	$db->Execute("CREATE TEMPORARY TABLE ip_use_prepare (
		ip_use	INT UNSIGNED NOT NULL,
		bytes	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
	$filters = array();
	if($period->active){
		$from = $period->getFrom();
		$to = $period->getTo();
		if($from){
			$from_ts = _parse_datetime($from);
			$from_hour = mktime(date("H", $from_ts), 0, 0, date("m", $from_ts), date("d", $from_ts), date("Y", $from_ts));
			if($from_ts > $from_hour){
				$from_hour = $from_hour + 60 * 60;
			}
			$from_day = mktime(0, 0, 0, date("m", $from_ts), date("d", $from_ts), date("Y", $from_ts));
			if($from_ts > $from_day){
				$from_day = $from_day + 60 * 60 * 24;
			}
			$filters['from'] = sprintf("(day >= '%s')", date("Y-m-d H:i:s", $from_day));
		}
		if($to){
			$to_ts = _parse_datetime($to);
			$to_hour = mktime(date("H", $to_ts), 0, 0, date("m", $to_ts), date("d", $to_ts), date("Y", $to_ts));
			$to_day = mktime(0, 0, 0, date("m", $to_ts), date("d", $to_ts), date("Y", $to_ts));
			$filters['to'] = sprintf("(day < '%s')", date("Y-m-d H:i:s", $to_day));
		}
		if($from){
			$t = $to ? min($from_hour, $to_ts) : $from_hour;
			if($from_ts < $t){
				insertSelectOverFile('ip_use_prepare',
					sprintf("SELECT ip_use, sum(bytes) as bytes FROM ip_use_time WHERE from_time>='%s' AND from_time<='%s' AND to_time<='%s' GROUP BY ip_use",
					date("Y-m-d H:i:s", $from_ts),
					date("Y-m-d H:i:s", $t),
					date("Y-m-d H:i:s", $t)));
			}
			$t = $to ? min($from_day, $to_hour) : $from_day;
			if($from_hour < $t){
				insertSelectOverFile('ip_use_prepare',
					sprintf("SELECT ip_use, sum(bytes) as bytes FROM ip_use_hours WHERE hour>='%s' AND hour<'%s'  GROUP BY ip_use", 
					date("Y-m-d H:i:s", $from_hour),
					date("Y-m-d H:i:s", $t)));
			}
		}
		if($to){
			if(!$from || ($to_hour > $from_day)){
				if($to_day < $to_hour){
					insertSelectOverFile('ip_use_prepare',
						sprintf("SELECT ip_use, sum(bytes) as bytes FROM ip_use_hours WHERE hour>='%s' AND hour<'%s' GROUP BY ip_use", 
						date("Y-m-d H:i:s", $to_day),
						date("Y-m-d H:i:s", $to_hour)));
				}
			}
			if(!$from || ($to_ts > $from_hour)){
				if($to_hour < $to_ts){
					insertSelectOverFile('ip_use_prepare',
						sprintf("SELECT ip_use, sum(bytes) as bytes FROM ip_use_time WHERE from_time>='%s' AND from_time<='%s' AND to_time<='%s' GROUP BY ip_use",
						date("Y-m-d H:i:s", $to_hour),
						date("Y-m-d H:i:s", $to_ts),
						date("Y-m-d H:i:s", $to_ts)));
				}
			}
		}
	}
	if(!$from || !$to || ($from_day < $to_day)){
		insertSelectOverFile('ip_use_prepare',
			"SELECT ip_use, sum(bytes) as bytes FROM ip_use_days".(!empty($filters) ? (" WHERE ".implode(" AND ", $filters)) : ""). " GROUP BY ip_use");
	}
	$db->Execute("CREATE TEMPORARY TABLE ip_use_data ENGINE=Memory SELECT ip_use, sum(bytes) as bytes FROM ip_use_prepare GROUP BY ip_use");
}
?>