<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:17 $
$Revision: 1.9 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('classes/cells/UpCellRenderer.php');
loadStrings(BOOT.'houses/strings.txt');
loadStrings(BOOT.'houses/entrances/strings.txt');

$doc->title .= ' :: '.getResource('houses.title');

if(isset($_GET['get_free'])){
	header("Content-Type: text/html;charset=windows-1251;");
	$id = (int)$_GET['get_free'];
	$rezult = $db->Execute("SELECT dispatching.id, CONCAT( streets.name,' ', dispatching.house) AS value 
						FROM dispatching
						Inner Join kpreos ON dispatching.kp_reo = kpreos.id
						Inner Join streets ON dispatching.street = streets.id WHERE kp_reo=$id");
	while($rez = $db->Next($rezult)){
		$value .= $rez['id']."&".$rez['value']." \n";
	}
	echo $value;
	exit;
}

if(!isset($oper->system_access['houses']))
{
	$doc->page->contents['denied'] = getResource('access.denied');
	echo $doc->Paint();
	exit;
}

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'street':	new Lookup('id', 'name', 'streets', $_GET['city'] ? array('city='.addslashes($_GET['city'])) : array());
	case 'district':	new Lookup('id', 'name', 'districts', $_GET['city'] ? array('city='.addslashes($_GET['city'])) : array());
	case 'koop':	new Lookup('id', 'name', 'koops', $_GET['city'] ? array('city='.addslashes($_GET['city'])) : array());
	case 'kpreo':	new Lookup('id', 'number', 'kpreos', $_GET['city'] ? array('city='.addslashes($_GET['city'])) : array());
}

function check_house_city($table){
	$new = $table->new_record;
	$check = array(
		'street'=>'streets',
		'district'=>'districts',
		'koop'=>'koops',
		'koop1'=>'koops',
		'kpreo'=>'kpreos',
		'kpreo1'=>'kpreos',
	);
	foreach($check as $field=>$table_name){
		$arr = loadRecord("SELECT city FROM $table_name WHERE id='".$new[$field]."'");
		if($arr && ($arr['city']!=$new['city'])){
			$table->error(getResource('houses.error.'.$field.'.city'));
		}
	}
}

function check_entrance_connection($table){
	global $houses;
	$entrance = $table->new_record;
	$house = $houses->active_record;
	if($entrance['internet']==1 && $house['internet']!=1){
		$table->error(getResource('entrnaces.wrong.internet.connection'));
	}
	if($entrance['tv']==1 && $house['tv']!=1){
		$table->error(getResource('entrnaces.wrong.tv.connection'));
	}
}


function update_entrances_connection($table){
	global $db;
	$arr = $table->current_record;
	if($table->isChanged('internet')){
		$db->Execute("UPDATE entrances SET internet='".$arr['internet']."' WHERE house='".$arr['id']."'");
	}
	if($table->isChanged('tv')){
		$db->Execute("UPDATE entrances SET tv='".$arr['tv']."' WHERE house='".$arr['id']."' AND type=1");
	}
}

function update_jobs_entrances($table){
	global $db;
	$db->Execute(sprintf("UPDATE jobs j 
			LEFT JOIN houses h ON h.street=j.street AND h.house=j.house 
			LEFT JOIN entrances e ON e.house=h.id AND e.number=j.entrance 
			LEFT JOIN job_types jt ON jt.id=j.type
			SET j.cost=IF(e.type=1, jt.fee_1, jt.fee_0),
			j.entrance_type=e.type
			WHERE j.state!=1 AND e.id='%s'", $table->current_record['id']));
}

function after_point_post($table){
	global $db;
	
	$arr = upload_storage_files(1);
	if(isset($arr['foto'])){
		if($table->old_record['foto']){
			
			$db->Execute(sprintf("DELETE FROM billing_storage.files WHERE id='%s'", $table->old_record['foto']));
		}
		$db->Execute(sprintf("UPDATE houses_foto SET foto='%s' WHERE id='%s'", $arr['foto'], $table->current_record['id']));
	}
}

function show_photo(){
	global $fotos;
	if($fotos->isOn()){
		if($fotos->active_record['foto']){
			return '<img id="staff_img"
				onclick="picViewer.open(this);stopEvent(event);"
				style="border: 1px solid white; max-height:200px; max-width:500px;"
				src="download.php?source=photo&id='.$fotos->active_record['foto'].'">';
		}
	}
}


function delete_entrance_note_file($table){
	global $db;
	if($table->old_record['file']){
		$db->Execute(sprintf("DELETE FROM billing_storage.files WHERE id='%s'", $table->old_record['file']));
	}
}

function upload_entrance_note_file($table){
	global $db;
	$arr = upload_storage_files(1);
	if(isset($arr['file1'])){
		delete_entrance_note_file($table);
		$db->Execute(sprintf("UPDATE entrance_notes SET file='%s' WHERE id='%s'", $arr['file1'], $table->current_record['id']));
	}
}


class FotoCellRenderer 
{
	function render($val, $rec)
	{
		return '<td align="center"><img 
			onclick="picViewer.open(this);stopEvent(event);"
			style="border: 1px solid white; max-height:300px; max-width:400px;" 
			src="download.php?source=photo&id='.$rec['foto'].'" ></td>';
	}
}

$incFoto = new FotoCellRenderer();

function recalc_entrnaces($table)
{
	global $db;
	$id = $table->current_record ['house'];
	$db->Execute("UPDATE `houses` SET `entrances`=(SELECT COUNT(id) FROM entrances WHERE house=$id) WHERE (`id`='$id') ;");
}

function generate_tv_boxes($hid){
	global $db;
	static $floors_map = array(
		'2'=>array(2),
		'3'=>array(2),
		'4'=>array(3),
		'5'=>array(2,4),
		'6'=>array(3,5),
		'7'=>array(3,6),
		'8'=>array(4,7),
		'9'=>array(2,5,8),
		'10'=>array(3,6,9),
		'11'=>array(2,4,7,10),
		'12'=>array(2,5,8,11),
		'13'=>array(3,6,9,12),
		'14'=>array(2,5,7,10,13),
		'15'=>array(2,5,8,11,14),
		'16'=>array(2,5,8,9,12,15),
		'17'=>array(2,5,8,10,13,16),
		'18'=>array(3,6,9,11,14,17),
		'20'=>array(3,5,8,11,14,17,20),
		'23'=>array(2,4,7,10,13,16,19,23),
	);
	$house = loadRecord("SELECT floors FROM houses WHERE id='$hid'");
	if(isset($floors_map[$house['floors']])){
		$entrances = loadRecords("SELECT number FROM entrances WHERE house='$hid'");
		foreach($entrances as $entrance){
			$ent = $entrance['number'];
			foreach($floors_map[$house['floors']] as $floor){
				$db->Execute("INSERT IGNORE INTO tv_boxes (house, entrance, floor) VALUES ('$hid', '$ent', '$floor')");
			}
		}
	}
}

function generate_new_house_tv_boxes($table){
	generate_tv_boxes($table->new_record['id']);
}

function test_boxes(){
	global $db;
	static $floors_map = array(
		'2'=>array(2),
		'3'=>array(2),
		'4'=>array(3),
		'5'=>array(2,4),
		'6'=>array(3,5),
		'7'=>array(3,6),
		'8'=>array(4,7),
		'9'=>array(2,5,8),
		'10'=>array(3,6,9),
		'11'=>array(2,4,7,10),
		'12'=>array(2,5,8,11),
		'13'=>array(3,6,9,12),
		'14'=>array(2,5,7,10,13),
		'15'=>array(2,5,8,11,14),
		'16'=>array(2,5,8,9,12,15),
		'17'=>array(2,5,8,10,13,16),
		'18'=>array(3,6,9,11,14,17),
		'20'=>array(3,5,8,11,14,17,20),
		'23'=>array(2,4,7,10,13,16,19,23),
	);
	$exists = array();
	$houses = loadAssoc("SELECT id, floors FROM houses");
	$boxes = loadAssoc("SELECT id, house, entrance, floor FROM tv_boxes");
	$connections = loadAssoc("SELECT id, tv_box FROM tv_connections");
	foreach($connections as $con){
		$box = $boxes[$con['tv_box']];
		$exists[$box['house']] = 1;
	}
	foreach($houses as $hid=>$house){
		if($exists[$hid]){
			//$db->Execute("DELETE FROM tv_boxes WHERE house='$hid'");
			//generate_tv_boxes($hid);
		}
	}
}

//test_boxes();

//foreach(loadRecords("SELECT id FROM houses") as $house){
//	generate_tv_boxes($house['id']);
//}


function edit_entrances($table){
    global $db;
    $id = $table->current_record["id"];
	$actual_count = loadValue("SELECT count(*) FROM entrances WHERE house='".$id."'");
    if($table->current_record["entrances"] < $actual_count){
        $rez_val = $actual_count - $table->current_record["entrances"];
        $rezult = $db->Execute("SELECT * FROM entrances WHERE house =  '$id' ORDER BY number DESC LIMIT $rez_val");
        while($val = $db->Next($rezult)){
            $db->Execute("DELETE FROM entrances WHERE (id='".$val['id']."' )");
        }
    }elseif($table->current_record["entrances"] > $actual_count){
	    for($i = 1; $i <= $table->current_record["entrances"]; $i++){
			if(!loadRecord("SELECT id FROM entrances WHERE house='".$id."' AND number='".$i."'")){
				$db->Execute("INSERT INTO entrances (house, number) VALUES ('".$id."','".$i."')");
			}
	    }
	}
}

function format_percent($val){
	return $val.'%';
}

class FormatPercent {

function fromString(){}

function toString($val){
	return $val.'%';
}

}

$form_percent = new FormatPercent();

function getKpreos(){
	return loadByQuery("SELECT id, number as value FROM kpreos");
}

function getKoops(){
	return loadByQuery("SELECT id, name as value FROM koops");
}

$doc->start = '<div id="overlay" style="display:none;"></div>'.
	'<img id="pic_big" class="popup" style="border: 2px solid white; display:none; top: 50%; left:50%;">';
$doc->page->contents['js'] = "<script language='JavaScript'>
	var picViewer = new PicViewer(1024, 768);
	</script>";

$period = new PPeriod($nil, BOOT.'houses/period.php');

$filters = array();
if($period->active){
	if($from = $period->getFrom()){
		$filters['from'] = sprintf("s.created >= '%s'", $from);
	}
	if($to = $period->getTo()){
		$filters['to'] = sprintf("s.created <= '%s'", $to);
	}
}
$pwhere = empty($filters) ? "" : " AND ".implode(" AND ", $filters);

//echo $pwhere;

//$db->debug = 1;

$db->Execute("CREATE TEMPORARY TABLE population (
	house INT UNSIGNED NOT NULL primary key,
	amount INT
	) Engine=Memory");
insertSelectOverFile('population', "-- INSERT INTO population (house, amount)
SELECT c.house_id, count(*)
FROM clients c
LEFT JOIN connection_types ct ON ct.id=c.connection_type
LEFT JOIN stamps s ON s.id=c.stamp
WHERE ct.service_type&1=1
$pwhere
GROUP BY c.house_id");

$db->Execute("CREATE TEMPORARY TABLE population_tv (
	house INT UNSIGNED NOT NULL primary key,
	amount INT
	) Engine=Memory");
insertSelectOverFile('population_tv', "-- INSERT INTO population_tv (house, amount)
SELECT c.house_id, count(*)
FROM clients c
LEFT JOIN connection_types ct ON ct.id=c.connection_type
LEFT JOIN tv_types tt ON tt.id=c.tv_type
LEFT JOIN stamps s ON s.id=c.stamp
WHERE ct.service_type&2=2 AND c.tv_type IS NOT NULL AND tt.offline=0
$pwhere
GROUP BY c.house_id");

$db->Execute("CREATE TEMPORARY TABLE entrances_info (
	house INT UNSIGNED NOT NULL primary key,
	amount INT,
	type INT,
	tie INT
	) Engine=Memory");
insertSelectOverFile('entrances_info', "-- INSERT INTO entrances_info (house, amount, type, tie)
SELECT e.house, count(*) amount, sum(type) type, IF(sum(if(tie=2, 1,0)) > 0, 2, IF(sum(if(tie=1, 1,0)) > 0, 1, 3) ) tie
FROM entrances e
GROUP BY e.house");


$houses = new PTable($db,BOOT.'houses/table.php');
$houses->readonly = !$oper->system_access['houses'];
addCityPolicy($houses, 'h.city');

$doc->page->contents['houses'] = new PMyAccess($houses,array(
	'title'=>getResource('houses.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/streets.gif',
	'grid_boot'=>forceCity(BOOT.'houses/grid.php'),
	'form_boot'=>forceCity(BOOT.'houses/form.php'),
	'tool'=>$period,
));
if(!$doc->page->contents['houses']->brief){
ob_start();
?>
<script src="scripts/Ajaxer.js"></script>
<script src="scripts/house-tracker.js"></script>
<script src="scripts/dispatching.js"></script>
<script>
var tracker = new dispatching('hss');
tracker.track();

var form = document.forms["<?=$houses->nick?>"];
new ServedByTracker(form);

var f = $("form[name=<?=$houses->nick?>]");
$("[name=city]", f).change(function(){
	lookup_street.src = '?lookup=street&target=lookup_street&city=' + this.value;
	lookup_street.loaded = false;
	lookup_street.loadFirst();
	lookup_district.src = '?lookup=district&target=lookup_district&city=' + this.value;
	lookup_district.loaded = false;
	lookup_district.loadFirst();

	lookup_kpreo.src = '?lookup=kpreo&target=lookup_kpreo&city=' + this.value;
	lookup_kpreo.loaded = false;
	lookup_kpreo.loadFirst();
	lookup_kpreo1.src = '?lookup=kpreo&target=lookup_kpreo1&city=' + this.value;
	lookup_kpreo1.loaded = false;
	lookup_kpreo1.loadFirst();

	lookup_koop.src = '?lookup=koop&target=lookup_koop&city=' + this.value;
	lookup_koop.loaded = false;
	lookup_koop.loadFirst();
	lookup_koop1.src = '?lookup=koop&target=lookup_koop1&city=' + this.value;
	lookup_koop1.loaded = false;
	lookup_koop1.loadFirst();
}).change();

$("[name=internet]", f).change(function(){
	var v = this.value;
	$("[name=internet_reason]", f).closest("tr").toggle(v==0);
	$("[name=\"link_up_internet[year]\"]", f).closest("tr").toggle(v==1);
}).change();

$("[name=tv]", f).change(function(){
	var v = this.value;
	$("[name=tv_reason]", f).closest("tr").toggle(v==0);
	$("[name=\"link_up_tv[year]\"]", f).closest("tr").toggle(v==1);
}).change();


</script>
<?
$doc->page->contents['hjs'] .= ob_get_clean();
}

if($houses->active_record['id'] > ''){
	$hmenu = new PNamedMenu($nil,BOOT.'houses/menu.php');
	$doc->page->contents['hmenu'] = $hmenu;
	switch($hmenu->selected){
		case 'ent':
			$entrance = new PTable($db,BOOT.'houses/entrances/table.php');
			$entrance->readonly = !$oper->system_access['houses'];
			$doc->page->contents['entrance'] = new PMyAccess($entrance,array(
				'title'=>getResource('entrances.title'),
				'icon'=>HREF.'images/streets.gif',
				'grid_boot'=>BOOT.'houses/entrances/grid.php',
				'form_boot'=>BOOT.'houses/entrances/form.php',
			));
			if($entrance->isOn()){
				include_once('classes/cells/FileCellRenderer.php');
				loadStrings(BOOT.'houses/entrances/notes/strings.txt');
				$notes = new PTable($db,BOOT.'houses/entrances/notes/table.php');
				$notes->readonly = !$oper->system_access['houses'];
				$doc->page->contents['notes'] = new PMyAccess($notes,array(
					'title'=>getResource('entrances.notes.title'),
					'icon'=>HREF.'images/rules.gif',
					'grid_boot'=>BOOT.'houses/entrances/notes/grid.php',
					'form_boot'=>BOOT.'houses/entrances/notes/form.php',
				));
			}
			break;
		case 'tv':
			loadStrings(BOOT.'houses/tv_boxes/strings.txt');
			$tv_boxes = new PTable($db,BOOT.'houses/tv_boxes/table.php');
			$tv_boxes->readonly = !$oper->system_access['houses'];
			$doc->page->contents['tv_boxes'] = new PMyAccess($tv_boxes,array(
				'title'=>getResource('tv.boxes.title'),
				'icon'=>HREF.'images/storage.gif',
				'grid_boot'=>BOOT.'houses/tv_boxes/grid.php',
				'form_boot'=>BOOT.'houses/tv_boxes/form.php',
			));
			break;
		case 'foto':
			loadStrings(BOOT.'houses/fotos/strings.txt');
			$fotos = new PTable($db,BOOT.'houses/fotos/table.php');
			$fotos->readonly = !$oper->system_access['houses'];
			$doc->page->contents['fotos'] = new PMyAccess($fotos,array(
				'title'=>getResource('houses.foto.title'),
				'icon'=>HREF.'images/streets.gif',
				'grid_boot'=>BOOT.'houses/fotos/grid.php',
				'form_boot'=>BOOT.'houses/fotos/form.php',
			));
			break;
		case 'notes':
			loadStrings(BOOT.'houses/notes/strings.txt');
			$notes = new PTable($db,BOOT.'houses/notes/table.php');
			$notes->readonly = !$oper->system_access['houses'];
			$doc->page->contents['notes'] = new PMyAccess($notes,array(
				'title'=>getResource('houses.notes.title'),
				'icon'=>HREF.'images/rules.gif',
				'grid_boot'=>BOOT.'houses/notes/grid.php',
				'form_boot'=>BOOT.'houses/notes/form.php',
			));
			break;
		case 'hi':
			loadStrings(BOOT.'action_log/strings.txt');
			$action_log = new PTable($db, BOOT.'action_log/table.php');
			$action_log->filters['by_item'] = '(alo.name="houses" AND l.item_id="'.$houses->active_record['id'].'")';
			$doc->page->contents['history'] =  new PMyAccess($action_log, array(
				'title'=>getResource('action.log.title'),
				'icon'=>HREF.'images/log.gif',
				'grid_boot'=>BOOT.'action_log/grid_alt.php',
			));
			break;
		case 'map':
			$_SESSION['sent_houses'] = array();
			$house = $houses->active_record;
			$coords = explode(",", $house['coords']);
			if(count($coords)==2){
				ob_start();
				?>
				<div id="map_canvas" style="width:1200px; height: 800px;"></div>
				<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
				<script type="text/javascript" src="scripts/markerclusterer_packed.js"></script>
				<script type="text/javascript" src="scripts/map.js"></script>
				<script type="text/javascript">
					$(document).ready(function(){
						var center = new google.maps.LatLng(<?=$coords[1]?> + 0.000120, <?=$coords[0]?>);
						var map = new google.maps.Map(document.getElementById('map_canvas'), {zoom:16, center: center, mapTypeId: google.maps.MapTypeId.ROADMAP});
						limitMapZoom(map, 19);
						var marker = new google.maps.Marker({position: center, map: map, title:"<?=$house['street_name'].' '.$house['house']?>"});
						var markerSource = new AjaxMarkerSource('houses_in.php', {}, function(hid){
							window.location = '?id=' + hid + '&house_selected=map#house';
						});
						var controller = ClastererMapController(map, markerSource);
					});
				</script>
				<?
				$doc->page->contents['map'] = ob_get_clean();
			}
			break;
	}
}

echo $doc->Paint();
?>