<?
function getClientHosts(){
	global $resource_use;
	return loadByQuery(sprintf("SELECT id, ip as value FROM hosts WHERE client='%s' ORDER BY ip", $resource_use['client']));
}

function getIpUseIntervals(){
	$format = "%Y%m%d %H%:%i:%s";
	return loadByQuery(sprintf("SELECT id, 
		CONCAT(DATE_FORMAT(from_time, '%s'), ' - ', DATE_FORMAT(to_time, '%s')) as value
		FROM ip_use_intervals
		ORDER BY from_time DESC", $format, $format));
}

function getIpUses(){
	return loadByQuery("
		SELECT iu.id as id, concat('[', iu.label, '] ', r.name, ', ', ru.price/100) as value
		FROM ip_uses iu
		LEFT JOIN rules r ON r.id=iu.rule
		LEFT JOIN personal_period_resource_uses ppru ON ppru.id = iu.personal_period_resource_use
		LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
		WHERE iu.label IS NOT NULL
		ORDER BY iu.label");
}

class LogMoveForm extends PForm {
	function Process(){
		global $db, $ip_log, $ip_uses;
		$db->debug = 1;
		$db->Begin();
		$sel = $ip_log->current_record;
		if($this->fields['scope']->value > 0){
			$scope = " WHERE ".implode(" AND ", $ip_log->getScope());
		}else{
			$scope = sprintf(" WHERE l.ip_use='%s' AND l.ip_use_interval='%s'", $sel['ip_use'], $sel['ip_use_interval']);
		}
		$old_use = $ip_uses->current_record['id'];
		$new_use = $this->fields['ip_use']->value;
		$arr = $db->Next($db->Execute("SELECT sum(l.bytes) s FROM ".$ip_log->source.$scope));
		$sum = $arr['s'];
		$db->Execute("CREATE TEMPORARY TABLE tmp_move_log (ip_use int unsigned not null, ip_use_interval int unsigned not null, bytes bigint unsigned not null)  ENGINE=Memory
			SELECT l.ip_use, l.ip_use_interval, l.bytes FROM ".$ip_log->source.$scope);
		$db->Execute(sprintf("DELETE FROM ip_use_log WHERE ip_use='%s' AND ip_use_interval IN (SELECT ip_use_interval FROM tmp_move_log)", $old_use));
		$db->Execute(sprintf("UPDATE tmp_move_log t 
			LEFT JOIN ip_use_log l ON l.ip_use='%s' AND l.ip_use_interval=t.ip_use_interval 
			SET t.bytes=t.bytes + IFNULL(l.bytes,0)", $new_use));
		$db->Execute(sprintf("REPLACE INTO ip_use_log (ip_use, ip_use_interval, bytes) 
			SELECT '%s', ip_use_interval, bytes FROM tmp_move_log", $new_use));
		changeIpUse($old_use, -$sum);
		changeIpUse($new_use, $sum);
		if($db->hasErrors()){
			$db->Rollback();
		}else{
			$db->Commit();
		}
	}
}



$rumenu = new PNamedMenu($nil,BOOT.'resource_uses/menu.php');
$doc->page->contents['ru_menu'] = $rumenu;
switch($rumenu->selected){
	case 'ip':
		$ip_uses = new PTable($db,BOOT.'resource_ip_uses/table.php');
		$ip_uses->readonly = !$oper->system_access['resource_uses'];
		$doc->page->contents['ip_uses'] = new PMyAccess($ip_uses, array(
			'title'=>getResource('resource.uses.menu.ip'),
			'icon'=>HREF.'images/resource_uses.gif',
			'grid_boot'=>BOOT.'resource_ip_uses/grid.php',
			'form_boot'=>BOOT.'resource_ip_uses/form.php',
		));
		if($ip_uses->isOn()){
			$ip_log = new PTable($db,BOOT.'ip_uses_log/table.php');
			$ip_log->readonly = !$oper->system_access['resource_uses'];
			$doc->page->contents['ip_log'] = new PMyAccess($ip_log, array(
				'title'=>getResource('log.title'),
				'icon'=>HREF.'images/log.gif',
				'grid_boot'=>BOOT.'ip_uses_log/grid.php',
				'form_boot'=>BOOT.'ip_uses_log/form.php', 
			));
			$doc->page->contents['move_icon'] = '<img src="'.HREF.'/images/move_uses.gif" align="middle" vspace="6"><span class="access_head">'.getResource('log.move').'</span>';
			$doc->page->contents['move_form'] = new LogMoveForm($nil, BOOT.'ip_uses_log/form-move.php');
		}
		break;
}
?>