<?php
include_once('includes/global.php');
loadStrings(BOOT.'job_problem_types/strings.txt');

$doc->title .= ' :: '.getResource('jpt.title');

required_access('job_problem_types');

$menu = new PNamedMenu($nil,BOOT.'job_problem_types/menu.php');
$doc->page->contents['jpt_menu'] = $menu;
switch($menu->selected){
	case 'ty':
		$jpt = new PTable($db,BOOT.'job_problem_types/table.php');
		$jpt->readonly = !$oper->system_access['job_problem_types'];
		addCityPolicy($jpt, 'p.city');
		$doc->page->contents['jpt'] = new PMyAccess($jpt,array(
			'title'=>getResource('jpt.title'),
			'help'=>HELP_PATH.'//',
			'icon'=>HREF.'images/jobs.gif',
			'grid_boot'=>forceCity(BOOT.'job_problem_types/grid.php'),
			'form_boot'=>forceCity(BOOT.'job_problem_types/form.php'),
		));
		break;
	case 'st':
		include_once('classes/SwitchTool.php');
		include_once('classes/ComboTool.php');

		$service_type_tool = new SwitchTool('jptstt', array(
			'1'=>getResource('jpt.service.type.1'),
			'2'=>getResource('jpt.service.type.2'),
			//'3'=>getResource('jpt.service.type.3'),
		), '1', true);
		$group_by_tool = new SwitchTool('jptgt', array(
			'1'=>getResource('jpt.stats.grouper.1'),
			'2'=>getResource('jpt.stats.grouper.2'),
			'3'=>getResource('jpt.stats.grouper.3'),
			'4'=>getResource('jpt.stats.grouper.4'),
		), '3', true);
		$group_by_values = array(
			'1'=>'DATE_FORMAT(j.date, "%Y-%m-%d")',
			'2'=>'DATE_FORMAT(FROM_UNIXTIME(FLOOR((UNIX_TIMESTAMP(j.date) - 338400)/604800) * 604800 + 345600), "%Y-%m-%d+")',
			'3'=>'DATE_FORMAT(j.date, "%Y-%m")',
			'4'=>'DATE_FORMAT(j.date, "%Y")',
		);
		$grouper = $group_by_values[$group_by_tool->value];
		$service_type_filter = sprintf(" WHERE jt.type&%s", $service_type_tool->value + 0);

		$db->Execute("CREATE TEMPORARY TABLE jpt_stats (
				id INT UNSIGNED NOT NULL PRIMARY KEY,
				amount INT NOT NULL,
				city INT UNSIGNED,
				problem_type INT UNSIGNED,
				date VARCHAR(32),
				KEY(city),
				KEY(problem_type)
			) ENGINE=Memory
			SELECT
				MAX(jn.id) id,
				count(jn.id) as amount,
				j.city,
				jn.problem_type,
				$grouper as date
			FROM jobs_notes jn
			LEFT JOIN jobs j ON j.id=jn.job
			LEFT JOIN job_types jt ON jt.id=j.type
			$service_type_filter
			GROUP BY 3,4,5");
		$db->Execute("CREATE TEMPORARY TABLE jpt_totals (
				city INT UNSIGNED,
				date VARCHAR(32),
				amount INT NOT NULL,
				PRIMARY KEY(city, date)
			) ENGINE=Memory
			SELECT
				city,
				date,
				sum(amount) as amount
			FROM jpt_stats st
			GROUP BY 1,2");

		$stats = new PTable($db, BOOT.'job_problem_types/stats/table.php');
		addCityPolicy($stats, 'st.city');
		$doc->page->contents['stats'] = new PMyAccess($stats, array(
			'title'=>getResource('jpt.stats.title'),
			'icon'=>HREF.'images/calls.gif',
			'grid_boot'=>BOOT.'job_problem_types/stats/grid.php',
			'tool'=>new ComboTool(array(
				new ComboToolCell($group_by_tool),
				new ComboToolCell($service_type_tool),
			)),
		));
		$doc->page->contents['stats']->grid->columns['date']->title = getResource('jpt.stats.grouper.'.$group_by_tool->value);
		break;
}

echo $doc->Paint();
?>