<?php

/**
 * @author tregub
 * @copyright 2010
 */

include_once('includes/global.php');
loadStrings(BOOT.'jobs_types/strings.txt');

$doc->title .= ' :: '.getResource('jt.title');

required_access('jobs_types');

function getMaterialTypes(){
	return loadByQuery("SELECT t.id, t.name as value FROM expense_material_types t ORDER BY t.name");
}

function getJobTypeTvTypes(){
	global $jt;
	if($city = $jt->active_record['city']){
		$where = "WHERE city='$city' OR city IS NULL";
	}
	return loadByQuery("SELECT id, name AS value FROM tv_types $where ORDER BY name");
}

$jt = new PTable($db,BOOT.'jobs_types/table.php');
$jt->readonly = !$oper->system_access['jobs_types'];
addCityPolicy($jt, 'p.city');

$doc->page->contents['jt'] = new PMyAccess($jt,array(
	'title'=>getResource('jt.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/jobs.gif',
	'grid_boot'=>forceCity(BOOT.'jobs_types/grid.php'),
	'form_boot'=>forceCity(BOOT.'jobs_types/form.php'),
));
if($jt->isOn()){
	$menu = new PNamedMenu($nil,BOOT.'jobs_types/menu.php');
	$doc->page->contents['_menu'] = $menu;
	switch($menu->selected)	{
		case 'ct':
			loadStrings(BOOT.'jobs_types/connection_types/strings.txt');
			$connection_types = new PTable($db,BOOT.'jobs_types/connection_types/table.php');
			$connection_types->readonly = $jt->readonly;
			$doc->page->contents['connection_types'] = new PMyAccess($connection_types, array(
				'title'=>getResource('job.type.connection.types.title'),
				'icon'=>HREF.'images/hpro.gif',
				'grid_boot'=>BOOT.'jobs_types/connection_types/grid.php',
				'form_boot'=>BOOT.'jobs_types/connection_types/form.php',
			));
			break;
		case 'tt':
			loadStrings(BOOT.'jobs_types/tv_types/strings.txt');
			$tv_types = new PTable($db,BOOT.'jobs_types/tv_types/table.php');
			$tv_types->readonly = $jt->readonly;
			$doc->page->contents['tv_types'] = new PMyAccess($tv_types, array(
				'title'=>getResource('job.type.tv.types.title'),
				'icon'=>HREF.'images/hpro.gif',
				'grid_boot'=>BOOT.'jobs_types/tv_types/grid.php',
				'form_boot'=>BOOT.'jobs_types/tv_types/form.php',
			));
			break;
		case 'mt':
			loadStrings(BOOT.'jobs_types/material_types/strings.txt');
			$material_types = new PTable($db,BOOT.'jobs_types/material_types/table.php');
			$material_types->readonly = $jt->readonly;
			$doc->page->contents['material_types'] = new PMyAccess($material_types, array(
				'title'=>getResource('expense.material.job.types.title'),
				'icon'=>HREF.'images/hpro.gif',
				'grid_boot'=>BOOT.'jobs_types/material_types/grid.php',
				'form_boot'=>BOOT.'jobs_types/material_types/form.php',
			));
			break;
	}
}
echo $doc->Paint();
?>