<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:17 $
$Revision: 1.9 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('classes/ComboTool.php');
include_once('classes/FilterTool.php');
loadStrings(BOOT.'mail_messages/strings.txt');

$doc->title .= ' :: '.getResource('mail.messages.title');

required_access('support');

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'client':	lookup('client_contract');
}


//$db->debug = 1;

function apply_client($table){
	global $db;
	$new = $table->new_record;
	if(preg_match('|([a-z0-9])+([.\w-])*@([\w-])+(\.[\w-]+)+|i', $table->current_record['addr_from'], $m)){
		$query = sprintf("UPDATE mail_messages SET client=%s WHERE addr_from LIKE '%%%s%%'", $new['client'] ? $new['client'] : 'NULL', $m[0]);
		$db->Execute($query);
	}
}

function before_message_delete($table){
	$table->filesToDelete = loadRecords("SELECT file FROM mail_attachments WHERE message=".$table->active_record['id']);
}

function after_message_delete($table){
	global $db;
	$values = array();
	foreach($table->filesToDelete as $arr){
		$values[] = $arr['file'];
	}
	if(!empty($values)){
		$db->Execute("DELETE FROM billing_storage.files WHERE id IN (".implode(", ", $values).")");
	}
}

function addr_cell($val){
	return htmlspecialchars($val);
}

function in_reply_to($to, $data, $col){
	$msg = $col->owner->owner->active_record;
	$to = htmlspecialchars($to);
	if($msg['parent_id']){
		return '<a href="mail_messages.php?mams_brief=0&id='.$msg['parent_id'].'&mail_filter=all#mams">'.$to.'</a>';
	}else{
		return $to;
	}
}

function msg_body($body, $msg){
	$result = '<textarea id="msg_'.$msg['id'].'" rows="20" cols="120" WRAP="VIRTUAL">'.htmlspecialchars($body).'</textarea>';
	//$result = "<pre id='msg_".$msg['id']."'><code style='font-size: 9pt;'>".htmlspecialchars(wordwrap($body, 120))."</code></pre>";
	$result .= '<script language="JavaScript">
	var pre = document.getElementById("msg_'.$msg['id'].'");
	//pre.parentNode.style.backgroundColor = "white";
	pre.parentNode.style.width = "81em";
	</script>';
	return $result;
}

function msg_attachments(){
	global $messages;
	if($messages->isOn()){
		$files = loadRecords("SELECT f.* FROM mail_attachments ma
			LEFT JOIN billing_storage.files f ON f.id=ma.file
			WHERE ma.message='".$messages->active_record['id']."'");
		return listAttachments($files, 'mail');
	}
}

function answer_attachments(){
	global $answers;
	if($answers->isOn()){
		$files = loadRecords("SELECT f.* FROM mail_attachments ma
			LEFT JOIN billing_storage.files f ON f.id=ma.file
			WHERE ma.message='".$answers->active_record['id']."'");
		return listAttachments($files, 'mail');
	}
}


function before_answer_insert($table){
	global $messages, $oper;
	$msg = $messages->active_record;
	$table->new_record['in_reply_to'] = $msg['msg_id'];
	$table->new_record['type'] = 1;
	$table->new_record['answer_id'] = date("YmdHis").'-'.$oper->id;
	$table->new_record['date'] = date("Y-m-d H:i:s");
}

function after_answer_insert($table){
	global $db;
	$count = upload_attachment_files($table->new_record['id']);
	$db->Execute(sprintf("UPDATE mail_messages SET attachments=%s WHERE id=%s", $count, $table->new_record['id']));
	include_once 'classes/mail/MailSender.php';
	$sender = new MailSender();
	$sender->send($table->new_record['id']);
}

function upload_attachment_files($tid){
	global $db;
	$count = 0;
	foreach($_FILES as $info){
		clearstatcache();
		$info['time'] = filemtime($info['tmp_name']);
		if (is_uploaded_file($info['tmp_name'])) {
			$db->Execute(sprintf("INSERT INTO billing_storage.files (name, size, type, filedate)
				VALUES ('%s', '%s', '%s', '%s')", addslashes($info['name']), filesize($info['tmp_name']), addslashes($info['type']), date('Y-m-d H:i:s', $info['time'])));
			$fid = $db->getJustInserted('files', 'id');
			$fp = fopen($info['tmp_name'], "rb");
			while (!feof($fp)) {
				$binarydata = fread($fp, 65535);
				$db->Execute(sprintf("INSERT INTO billing_storage.file_chunks (file_id, chunk) VALUES ('%s', '%s')",
					$fid, addslashes($binarydata)));
			}
			fclose($fp);
			$db->Execute(sprintf("INSERT INTO mail_attachments (message, file) VALUES ('%s', '%s')", $tid, $fid));
			$count++;
		}
	}
	return $count;
}

class AnswersCellRenderer {
	function render($column, $record){
		$val = $record[$column->name];
		return sprintf("<td class='%s' align='right'>%s</td>", $val > 0 ? 'green_lighted' : 'red_lighted', $val);
	}
}
$answers_cell = new AnswersCellRenderer();

$filters = array();
foreach(array(
		'in'=>array(
			'title'=>'',
			'field'=>'m.addr_to',
			'prefix'=>'&nbsp;&nbsp;&nbsp;:&nbsp;',
		),
		'out'=>array(
			'title'=>'',
			'field'=>'m.addr_from',
			'prefix'=>'&nbsp;&nbsp;:&nbsp;',
		),
	) as $g=>$group){
	$group_filter = array();
	$signle_filter = array();
	foreach(array(
	'info'=>array('info@lanet.kiev.ua', 'info@lanet.ua'),
	'sale'=>array('sale@lanet.kiev.ua', 'sale@lanet.ua'),
	'support'=>array('support@lanet.kiev.ua', 'support@lanet.ua'),
	) as $name=>$emails){
		$f = array();
		foreach($emails as $email){
			$f[] = $group['field'].' LIKE "%'.$email.'%"';
		}
		$f = '('.implode(" OR ", $f).')';
		$group_filter[] = $f;
		$signle_filter[$g.'_'.$name] = array(
			'title'=>$group['prefix'].$name,
			'filter'=>$f,
		);
	}
	$filters[$g] = array(
		'title'=>$group['title'],
		'filter'=>"(".implode(" || ", $group_filter).")",
	);
	$filters = array_merge($filters, $signle_filter);
}
$filters['all'] = array(
	'title'=>'',
	'filter'=>'1',
);
$filters['all_good'] = array(
	'title'=>'&nbsp;&nbsp;&nbsp;',
	'filter'=>'('.$filters['in']['filter'].' || '.$filters['out']['filter'].')',
);
$filters['all_bad'] = array(
	'title'=>'&nbsp;&nbsp;&nbsp;',
	'filter'=>'NOT ('.$filters['in']['filter'].' || '.$filters['out']['filter'].')',
);

$mailFilter = new FilterTool('mail_filter', $filters);

include(BOOT.'period/form.php');
$obj['nick'] = 'mlmpr';
$obj['active'] = 0;
$period = new PPeriod($nil, $obj);
$period->commented = false;


/*
$db->Execute("CREATE TEMPORARY TABLE answers_count (in_reply_to varchar(255) primary key, cnt int)");
insertSelectOverFile('answers_count', "-- INSERT INTO answers_count
SELECT in_reply_to, count(id) FROM mail_messages GROUP BY in_reply_to");
*/

$messages = new PTable($db,BOOT.'mail_messages/table.php');
$messages->readonly = !$oper->system_access['support'];
$messages->filters['view'] = $mailFilter->getFilter();
if($period->active){
	if($from = $period->getFrom()){
		$messages->filters['from'] = sprintf("m.date >= '%s'", $from);
	}
	if($to = $period->getTo()){
		$messages->filters['to'] = sprintf("m.date <= '%s'", $to);
	}
}

$doc->page->contents['messages'] = new PMyAccess($messages,array(
	'title'=>getResource('mail.messages.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/question.gif',
	'tool'=>$mailFilter,
	'grid_boot'=>BOOT.'mail_messages/grid.php',
	'form_boot'=>BOOT.'mail_messages/form.php',
	'tool'=>new ComboTool(array(
		new ComboToolCell($mailFilter),
		new ComboToolCell($period),
	)),
));

if($messages->isOn()){
	$answers = new PTable($db,BOOT.'mail_answers/table.php');
	$answers->filters['is_reply'] = 'm.in_reply_to > ""';
	$answers->nick = 'mans';
	$answers->masters['clients'] = array(
		'table'=>$messages,
		'on'=>'msg_id',
		'by'=>'in_reply_to',
	);
	$answers->readonly = !$oper->system_access['support'];
	$doc->page->contents['answers'] = new PMyAccess($answers,array(
		'title'=>getResource('mail.answers.title'),
		'icon'=>HREF.'images/troubles.gif',
		'grid_boot'=>BOOT.'mail_answers/grid.php',
		'form_boot'=>BOOT.'mail_answers/form.php',
	));
	if(!$doc->page->contents['answers']->brief){
		$doc->page->contents['script'] = "
		<script>
		var m = new FileMultiplicator(document.forms['mans'].elements['file']);
		</script>
		";
	}
}
$p = array(
	'input-charset'=>'windows-1251',
	'output-charset'=>'windows-1251',
);

echo $doc->Paint();
?>