<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.16 $
*/
include_once('includes/global.php');
include_once('functions/host.php');
include_once('classes/tools/IpAddress.php');
include_once('classes/ModemsNest.php');
include_once('classes/cells/UpCellRenderer.php');
loadStrings(BOOT.'districts/strings.txt');
loadStrings(BOOT.'houses/strings.txt');
loadStrings(BOOT.'hosts/strings.txt');
loadStrings(BOOT.'modems/strings.txt');
loadStrings(BOOT.'exp_points/strings.txt');

$doc->title .= ' :: '.getResource('modems.title');

required_access('modems');

//$db->debug = 1;

include_once('includes/lookups.php');
switch($_GET['lookup']){
	case 'modem':	lookup('modem2');
	case 'modem_profile':	lookup('modem_profile');
	case 'domain':	lookup('domain');
	case 'street':	lookup('street', $_GET['city'] ? array('s.city='.addslashes($_GET['city'])) : array());
	case 'department':	lookup('department');
	case 'point': lookup('exp_point', $_GET['city'] ? array('p.city='.addslashes($_GET['city'])) : array());
}

function check_modem_city($table){
	$new = $table->new_record;
	$check = array(
		'street'=>'streets',
		'exp_point'=>'exp_points',
	);
	foreach($check as $field=>$table_name){
		$arr = loadRecord("SELECT city FROM $table_name WHERE id='".$new[$field]."'");
		if($arr && ($arr['city']!=$new['city'])){
			$table->error(getResource('modems.error.'.$field.'.city'));
		}
	}
}


$state_cell = new ModemStateCellRenderer();

class StateDateCellRenderer {
	function render($column, $record){
		if(!$record['state'] && $record['state_date'] && ($record['state_date'] < date("Y-m-d H:i:s", time() - 60*60*24))){
			$class = 'red_lighted';
		}else{
			$class = '';
		}
		return sprintf("<td class='%s' align='center'>%s</td>", $class, $record['state_date']);
	}
}
$state_date_cell = new StateDateCellRenderer();

$doc->page->contents['style'] = '
<style>
.vsign { font-family: "Courier New", Courier, monospace; color: #bbb; font-size: 7pt; }
.m_valid {background-color: #f0fff0;}
.m_invalid {background-color: #fff0f0;}
</style>
';

function after_point_post($table){
	global $db;
	
	$arr = upload_storage_files(1);
	if(isset($arr['file1'])){
		if($table->old_record['foto']){
			$db->Execute(sprintf("DELETE FROM billing_storage.files WHERE id='%s'", $table->old_record['foto']));
		}
		$db->Execute(sprintf("UPDATE modems_foto SET foto='%s' WHERE id='%s'", $arr['file1'], $table->current_record['id']));
	}
}

function show_photo(){
	global $fotos;
	if($fotos->isOn()){
		if($fotos->active_record['foto']){
			return '<img id="staff_img" 
				onclick="picViewer.open(this);stopEvent(event);"
				style="border: 1px solid white; max-height:300px; max-width:500px;"
				src="download.php?source=photo&id='.$fotos->active_record['foto'].'">';
		}
	}
}



class Foto
{
	function render($val, $rec)
	{
		return '<td align="center"><img style="border: 1px solid white; height:300px;" 
			onclick="picViewer.open(this);stopEvent(event);"
			src="download.php?source=photo&id='.$rec['foto'].'" ></td>';
	}
}

$foto = new Foto();

class ValidCellRenderer {
	function render($column, $record){
		$val = $record[$column->name];
		if(strpos($val,'+')){
			return sprintf('<td class="m_valid">%s</td>', str_replace('+', ' <span class="vsign">+</span>', $val));
		}
		if(strpos($val,'-')){
			return sprintf('<td class="m_invalid">%s</td>', str_replace('-', ' <span class="vsign">&ndash;</span>', $val));
		}
		return sprintf("<td>%s</td>", $val);
	}
}
$valid_cell = new ValidCellRenderer();

class PowerCellRenderer {
	function render($column, $record){
		$power = $record['power'];
//		$cls = $power==1 ? 'm_valid' : ($power==2 ? 'm_invalid' : '');
		$cls = $power==2 ? 'm_invalid' : 'm_valid';
		return sprintf('<td class="%s">%s</td>', $cls, $record['power_name']);
	}
}
$power_cell = new PowerCellRenderer();


function fmt_shadow_sign($val){
	return str_replace(
		array('+', '-'),
		array(
			'<span class="vsign">+</span>',
			'<span class="vsign">&ndash;</span>'
		),
		$val
	);
}

function getModemProfiles(){
	return loadByQuery("SELECT id, name AS value FROM modem_profiles WHERE hidden=0 ORDER BY name");
}

function before_trunk_modem_apply($table){
	if(($table->new_record['type']==2) && $table->new_record['ip_core_route']){
		$table->error(ValidateIp($table->new_record['ip_core_route']));
	}
	$table->trunk = array(
		'ip_core_route'=>$table->new_record['ip_core_route'],
		'real_ip_vlan'=>$table->new_record['real_ip_vlan'],
	);
	unset($table->new_record['ip_core_route']);
	unset($table->new_record['real_ip_vlan']);
}

function before_modem_apply($table){
	global $db;
//	$db->debug = 1;
	$new = $table->new_record;
	$old = $table->old_record;
	if($new['port']){
		if($new['modem']){
			$res = $db->Execute(sprintf("SELECT
				h.id, h.client, h.ip,
				CONCAT(c.last_name, ' ', c.first_name, ' (', c.login, ')') as client_name
				FROM hosts h
				LEFT JOIN clients c ON c.id=h.client
				WHERE h.modem='%s' AND h.port='%s'", $new['modem'], $new['port']));
			while($arr = $db->Next($res)){
				$table->error(sprintf(getResource('hosts.error.port.collision'), $new['port'], $arr['client_name'], $arr['ip']));
			}
			$modem_addr = $db->Next($db->Execute(sprintf("SELECT uplink FROM modems WHERE id='%s'", $new['modem'])));
			if($new['port']==$modem_addr['uplink']){
				$table->error(sprintf(getResource('hosts.error.port.collision.uplink'), $new['port']));
			}
			$res = $db->Execute(sprintf("SELECT id, name FROM modems
				WHERE modem='%s' AND port='%s' AND id!='%s'", $new['modem'], $new['port'], $old['id']));
			if($arr = $db->Next($res)){
				$table->error(sprintf(getResource('hosts.error.port.collision.modem'), $new['port'], $arr['name']));
			}
		}
	}
	if($new['uplink']){
		$res = $db->Execute(sprintf("SELECT
			h.id, h.client, h.ip,
			CONCAT(c.last_name, ' ', c.first_name, ' (', c.login, ')') as client_name
			FROM hosts h
			LEFT JOIN clients c ON c.id=h.client
			WHERE h.modem='%s' AND h.port='%s'", $old['id'], $new['uplink']));
		while($arr = $db->Next($res)){
			$table->error(sprintf(getResource('hosts.error.port.collision'), $new['uplink'], $arr['client_name'], $arr['ip']));
		}
		$res = $db->Execute(sprintf("SELECT id, name FROM modems
			WHERE modem='%s' AND port='%s'", $old['id'], $new['uplink']));
		if($arr = $db->Next($res)){
			$table->error(sprintf(getResource('hosts.error.port.collision.modem'), $new['uplink'], $arr['name']));
		}
	}
	if($new['address_space']){
		foreach(explode("\n", $new['address_space']) as $line){
			$str = trim($line);
			$arr = explode(":", $str);
			$ip = new SlashedIpAddress($arr[0]);
			if(strcmp($arr[0], $ip->toString())!=0 && strcmp($arr[0], $ip->toShortString())){
				$table->error(sprintf(getResource('modems.address.space.error'), $str));
			}
		}
	}
	before_host_apply($table);
	before_trunk_modem_apply($table);
}

function after_trunk_modem_apply($table){
	global $db;
	if($table->current_record['type']==2){
		$db->Execute(sprintf('REPLACE INTO trunk_modems (id, ip_core_route, real_ip_vlan) VALUES ("%s", "%s", "%s")', 
			$table->current_record['id'], addslashes($table->trunk['ip_core_route']), addslashes($table->trunk['real_ip_vlan'])));
	}else{
		$db->Execute("DELETE FROM trunk_modems WHERE id='".$table->current_record['id']."'");
	}
}

function after_modem_delete($table){
	global $modems_nest;
	after_host_delete($table);
	if($old['modem'] && $old['port']){
		$table->warning(RemakeModemProfile($old['modem']));
	}
	$modems_nest->recalc();
}

function after_modem_insert($table){
	global $modems_nest;
	after_host_post($table);
	if($table->isChanged('ip,mac,profile,name,domain,uplink,address_space')){
		$table->warning(RemakeModemProfileTask($table->new_record['id']));
	}
	$new =  $table->new_record;
	if($new['modem'] && $new['port']){
		$table->warning(RemakeModemProfileTask($new['modem']));
	}
	after_trunk_modem_apply($table);
	$modems_nest->recalc();
}

function after_modem_post($table){
	global $modems_nest;
	after_host_post($table);
	if($table->isChanged('ip,mac,profile,name,domain,uplink,address_space')){
		$table->warning(RemakeModemProfileTask($table->old_record['id'])); //   DOCSIS !!! (  IP  !)
		//$table->warning(RemakeChangedModemProfile($table->old_record['id'], $table->old_record));
	}
	$new = $table->new_record;
	$old = $table->old_record;
	if($table->isChanged('modem')){
		if($old['modem'] && $old['port']){
			$table->warning(RemakeModemProfileTask($old['modem']));
		}
		if($new['modem'] && $new['port']){
			$table->warning(RemakeModemProfileTask($new['modem']));
		}
	}elseif($table->isChanged('port')){
		if($new['modem']){
			$table->warning(RemakeModemProfileTask($new['modem']));
		}
	}
	after_trunk_modem_apply($table);
	$modems_nest->recalc();
}

class PActionForm extends PForm {
	function Process(){
		global $db;
		$modem = $this->fields['modem']->value;
		$action = $this->fields['action']->value;
		//load pattern
		$res = $db->Execute("SELECT * FROM modems_actions WHERE id='$action'");
		$act_arr = $db->Next($res);
		$executor = $act_arr['action_pattern'];
		//load modem
		$res = $db->Execute("SELECT * FROM modems WHERE id='$modem'");
		$mod_arr = $db->Next($res);
		//fill pattern by modem info
		$executor = str_replace(array("%id","%mac","%ip","%name"),array($mod_arr['id'],$mod_arr['mac'],$mod_arr['ip'],$mod_arr['name']),$executor);
		//execute
		$err = ExecuteScript($executor, 0, array($this, 'highlight'));
		if($err){
			PrintStrings("Modem Action", $executor);
		}
		return $err;
	}
	
	function highlight($out){
		return str_replace('FAILED', '<font color=red>FAILED</font>', $out);
	}
}

$modems_nest = new ModemsNest();

$doc->start = '<div id="overlay" style="display:none;"></div>'.
	'<img id="pic_big" class="popup" style="border: 2px solid white; display:none; top: 50%; left:50%;">';
$doc->page->contents['js'] = "<script language='JavaScript'>
	var picViewer = new PicViewer(1024, 768);
	</script>";

//$db->debug = 1;
//recalc_modems_clients();

$db->Execute("CREATE TEMPORARY TABLE modems_gigabit (modem INT UNSIGNED NOT NULL PRIMARY KEY, amount INT NOT NULL) ENGINE=Memory
SELECT h.modem, COUNT(DISTINCT h.client) amount
FROM hosts h
LEFT JOIN clients c ON c.id=h.client
LEFT JOIN connection_types ct ON ct.id=c.connection_type
WHERE ct.gigabit=1
GROUP BY h.modem");

$modems = new PTable($db,BOOT.'modems/table.php');
$modems->readonly = !$oper->system_access['modems'];
addCityPolicy($modems, 'm.city');

$doc->page->contents['modems'] = new PMyAccess($modems,array(
	'title'=>getResource('modems.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/modems.gif',
	'grid_boot'=>forceCity(BOOT.'modems/grid.php'),
	'form_boot'=>forceCity(BOOT.'modems/form.php'),
));

if(!$doc->page->contents['modems']->brief){
	if(!$modems->readonly){
		$doc->page->contents['modems']->form->fields['ip']->comment = createIpCandidates('ip', $modems, 3);
	}
	ob_start();
?>
<script>
	var f = $("form[name=<?=$modems->nick?>]");
	$("[name=city]", f).change(function(){
		lookup_point.src = '?lookup=point&target=lookup_point&city=' + this.value;
		lookup_point.loaded = false;
		lookup_point.loadFirst();
		lookup_street.src = '?lookup=street&target=lookup_street&city=' + this.value;
		lookup_street.loaded = false;
		lookup_street.loadFirst();
	}).change();
</script>
<?
	$doc->page->contents['mjs'] .= ob_get_clean();
}

if($modems->isOn() ){//&& !$modems->readonly){
	$mmenu = new PNamedMenu($nil,BOOT.'modems/menu.php');
	$doc->page->contents['modems_menu'] = $mmenu;
	switch($mmenu->selected){
		case 'ac':
			$doc->page->contents['actions_icon'] = '<br><div class="access_head"><img src="'.HREF.'images/mact.gif" vspace="2" hspace="2" style="vertical-align: middle;">'.getResource('modems.action').'</div>';
			$doc->page->contents['actions'] = new PActionForm($nil,BOOT.'modems/actions/form.php');
			break;
		case 'st':
			$modems_states = new PTable($db,BOOT.'modems/states/table.php');
			$doc->page->contents['modems_states'] = new PMyAccess($modems_states,array(
				'title'=>getResource('modems.states.title'),
				'icon'=>HREF.'images/log.gif',
				'grid_boot'=>BOOT.'modems/states/grid.php',
			));
			break;
		case 'po':
			$powers = new PTable($db,BOOT.'modems/powers/table.php');
			$doc->page->contents['powers'] = new PMyAccess($powers,array(
				'title'=>getResource('modems.power.history.title'),
				'icon'=>HREF.'images/log.gif',
				'grid_boot'=>BOOT.'modems/powers/grid.php',
			));
			break;
		case 'pe':
			$pids = array(0);
			$pid = $modems->active_record['modem'];

			while($pid){
				$pids[] = $pid;

				$res = $db->Execute(sprintf("SELECT modem FROM modems WHERE id='%s'", $pid));
				if($arr = $db->Next($res)){
					$pid = $arr['modem'];
				}else{
					$pid = '';
				}
			}
			$deep_selector = "CASE m.id ";
			foreach(array_reverse($pids) as $i=>$pid){
				$deep_selector .= " WHEN ".$pid." THEN ".$i;
			}
			$deep_selector .= " ELSE 0 END";
			//$db->debug = 1;
			$pedigree = new PTable($db,BOOT.'modems/pedigree/table.php');
			$pedigree->readonly = 1;
			$pedigree->filters['pids'] = "m.id IN (".implode(", ", $pids).")";
			$doc->page->contents['pedigree'] = new PMyAccess($pedigree,array(
				'title'=>getResource('modems.pedigree.title'),
				'icon'=>HREF.'images/modems.gif',
				'grid_boot'=>BOOT.'modems/pedigree/grid.php',
			));
			break;
			
		case 'foto':
			loadStrings(BOOT.'modems/fotos/strings.txt');
				//$db->debug = 1;
				if(!isset($oper->system_access['modems'])){
					$doc->page->contents['denied'] = getResource('access.denied');
					echo $doc->Paint();
					exit;
				}
				$fotos = new PTable($db,BOOT.'modems/fotos/table.php');
				$fotos->readonly = !$oper->system_access['modems'];
				
				$doc->page->contents['fotos'] = new PMyAccess($fotos,array(
					'title'=>getResource('modems.foto.title'),
					'icon'=>HREF.'images/streets.gif',
					'grid_boot'=>BOOT.'modems/fotos/grid.php',
					'form_boot'=>BOOT.'modems/fotos/form.php',
				));
			break;
	}
}

$ip = new SlashedIpAddress('10.100.100.0/24');

//print_r(findFreeIp($ip, 100));

//echo ip2long(long2ip($ip->getAddress() & $ip->getMask()));
//echo '<br>';
//echo ip2long(long2ip($ip->getAddress() | ~$ip->getMask()));

ob_start();
?>
<script type="text/javascript" src="scripts/Ajaxer.js"></script>
<script type="text/javascript" src="scripts/ip-tracker.js"></script>
<script type="text/javascript" src="scripts/modem-type-tracker.js"></script>
<script type="text/javascript" src="scripts/strict-input-tracker.js"></script>
<script type="text/javascript">
<?if(!$doc->page->contents['modems']->brief){?>
var ipTracker = new IpTracker('mds');
var typeTracker = new ModemTypeTracker(document.forms['mds']);
<?}?>
StrictInputTracker(document.forms['g_mds'].elements['mds_mac_filter'], /.*/, /[\-;\.]/g, ":");
StrictInputTracker(document.forms['mds'].elements['mac'], /.*/, /[\-;\.]/g, ":");
</script>
<?
$doc->page->contents['all'] = ob_get_clean();
echo $doc->Paint();
?>
