<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:39 $
$Revision: 1.13 $
*/
include_once(dirname(__FILE__).'/../boot.php');
include_once(dirname(__FILE__).'/field.php');

class PTable extends PBoot {

var $name;
var $nick;
var $fields = array();
var $active_record = array();
var $current_record = array();
var $sort_by;
var $sort_order;
var $group_by;
var $readonly;
var $filters = array();
var $masters = array();
var $cursor;
var $collections = array('fields'=>'PDBField');
var $errors = array();
var $warnings = array();

function Create($db,$data){
	parent::Create($db,$data);
	if(!is_object($db)){
		$this->Error('Invalid database');
	}
}

function Begin(){
	$this->owner->Begin();
}

function Commit(){
	$this->owner->Commit();
}

function Rollback(){
	$this->owner->Rollback();
}

function Execute($str){
	return $this->owner->Execute($str);
}

function Next($res){
	return $this->owner->Next($res);
}

function DecorateLinks(){
	$links = array();
	foreach($this->masters as $key=>$master){
		if(is_object($master['table'])){
			$links[] = $this->fields[$master['by']]->getSelector().'='.$this->owner->Pak($master['table']->active_record[$master['on']]);
		}else{
			$this->Error('Invalid master table ('.$key.')');
		}
	}
	return $links;
}

function getScope(){
	$scope = array();
	if(count($links = $this->DecorateLinks())){
		$scope = $links;
	}
	foreach($this->filters as $filter){
		$scope[] = $filter;
	}
	foreach($this->fields as $k=>$v){
		if($filter = $this->fields[$k]->getFilter()){
			$scope[] = $filter;
		}
	}
	if($this->deleted_mark){
		$scope[] = $this->name.'.'.$this->deleted_mark.'=0';
	}
	return $scope;
}

function getKeysSelector(){
	$keys = array();
	foreach($this->fields as $name=>$field){
		if($field->key){
			$keys[] = $this->fields[$name]->getSelector();
		}
	}
	return implode(",",$keys);
}

function getOrder(){
	$order = array();
	if(isset($this->fields[$this->sort_by])){
		$order[] = $this->fields[$this->sort_by]->getSortSelector().' '.$this->sort_order;
	}
	foreach($this->fields as $n=>$f){
		if($f->key && $n!=$this->sort_by && !$f->nosort){
			$order[] = $this->fields[$n]->getSelector();
		}
	}
	return count($order) ? 'ORDER BY '.implode(", ",$order):'';
}

function getSelector($cond=array(), $in_scope=true){
	$selectors = array();
	foreach($this->fields as $name=>$field){
		if($s = $field->getSelector()){
			$selectors[]= $s.' as '.$name;
			$ss = $field->getSortSelector();
			if($ss != $s){
				$selectors[] = $ss.' as '.$name.'_sort_selector';
			}
		}
	}
	$selectors = count($selectors)?implode(', ',$selectors):'*';
	$tables = $this->source;
	if($in_scope){
		$cond = array_merge($cond,$this->getScope());
	}
	$cond = count($cond)?'WHERE '.implode(' AND ',$cond):'';
	$group = $this->group_by?'GROUP BY '.$this->group_by:'';
	$order = $this->getOrder();
	$query = "SELECT $selectors FROM $tables $cond $group $order"; // SQL_CALC_FOUND_ROWS
	return $query;
}

function getFoundRows(){
    $res = $this->owner->Execute("SELECT FOUND_ROWS() cnt");
    $arr = $this->owner->Next($res);
    return $arr['cnt'];
}

function Open(){
	$this->cursor = $this->owner->Execute($this->getSelector());
	$this->num_rows = $this->owner->NumRows($this->cursor);
	//$this->_count = $this->getFoundRows();
	return $this->cursor;
}

function OpenRange($from,$count){
	$query = $this->owner->LimitQuery($this->getSelector(),$from,$count);
	$this->cursor = $this->owner->Execute($query);
	$this->num_rows = $this->owner->NumRows($this->cursor);
	//$this->_count = $this->getFoundRows();
	return $this->cursor;
}

function NextRow(){
	return $this->ReadRecord($this->owner->Next($this->cursor));
}

function ReadRecord($row){
	if($row){
		$this->current_record = $row;
	}else{
		$this->current_record = array();
	}
	return $row;
}

function DecoratePointer($pointer){
	$result = array();
	foreach($pointer as $key=>$val){
		$result[$this->fields[$key]->getSelector()]=$val;
	}
	return $result;
}

function Locate($pointer=array(), $in_scope=true){
//	$this->old_record = $this->active_record;
	$pointer = $this->DecoratePointer($pointer);
	$query = $this->getSelector(_Pair($pointer,array($this->owner,'Pak')), $in_scope);
	$res = $this->owner->Execute($query);
	if($this->ReadRecord($this->owner->Next($res))){
		$this->active_record = $this->current_record;
	}else{
		$this->active_record = array();
	}
	return count($this->active_record)>0?1:0;
}

function getPosition(){
	if(!$this->isOn()){
		return 0;
	}
	$scope = $this->getScope();
	if(isset($this->fields[$this->sort_by])){
		$s = $this->fields[$this->sort_by]->getSortSelector();
		if(isset($this->active_record[$this->sort_by.'_sort_selector'])){
			$val = $this->active_record[$this->sort_by.'_sort_selector'];
		}else{
			$val = $this->active_record[$this->sort_by];
		}
		$sub_scope = $s.($this->sort_order=='desc'?'>':'<').$this->owner->Pak($val);
		$sub_scope .= ' OR ('.$s.'='.$this->owner->Pak($val);
		foreach($this->fields as $n=>$f){
			if($f->key && $n!=$this->sort_by){
				$sub_scope .= ' AND '.$this->fields[$n]->getBinSelector().'<'.$this->owner->Pak($this->active_record[$n]);
			}
		}
		$sub_scope .= ')';
		$scope[] = '('.$sub_scope.')';
	}else{
		foreach($this->fields as $n=>$f){
			if($f->key){
				$scope[] = $this->fields[$n]->getBinSelector().'<'.$this->owner->Pak($this->active_record[$n]);
			}
		}
	}
	if($scope){
		$scope = " WHERE ".implode(" AND ",$scope);
	}else{
		$scope = '';
	}
	$res = $this->owner->Execute('SELECT COUNT(*) as cnt FROM '.$this->source.$scope.($this->group_by?" GROUP BY ".$this->group_by:""));
	$arr = $this->owner->Next($res);
	return $arr['cnt']+1;
}

function getCount(){
	return $this->getAggregate("_cnt");
	//return $this->_count;
}

function getAggregate($column){
	if(!isset($this->aggregates)){
		$query = "SELECT ";
		foreach($this->fields as $name=>$field){
			if($field->aggregate){
				if(strstr($field->aggregate, '(')){
					$query .= $field->aggregate." as $name,";
				}else{
					$query .= $field->aggregate."(".$this->fields[$name]->getSelector().") as $name,";
				}
			}
		}
		$query .= " count(*) as _cnt FROM ".$this->source;
		if($scope = $this->getScope()){
			$query .= " WHERE ".implode(" AND ",$scope);
		}
		$res = $this->Execute($query);
		$this->aggregates = $this->owner->Next($res);
	}
	return $this->aggregates[$column];
}

function _getCount(){
	static $cache = array();
	if($scope = $this->getScope()){
		$scope = " WHERE ".implode(" AND ",$scope);
	}else{
		$scope = '';
	}
	if(!isset($cache[$scope])){
		$res = $this->owner->Execute('SELECT COUNT(*) as cnt FROM '.$this->source.$scope.($this->group_by?" GROUP BY ".$this->group_by:""));
		$arr = $this->owner->Next($res);
		$cache[$scope] = $arr['cnt'];
	}
	return $cache[$scope];
}

function _Aggregate($name,$func){
	if($func=='count'){
		return $this->getCount();
	}else{
		if($scope = $this->getScope()){
			$scope = " WHERE ".implode(" AND ",$scope);
		}else{
			$scope = '';
		}
		$res = $this->owner->Execute("SELECT $func(".$this->fields[$name]->getSelector().") as aggr FROM ".$this->source.$scope);
		$arr = $this->owner->Next($res);
		return $arr['aggr'];
	}
}

function getPointer($row=array()){
	$pointer = array();
	if(empty($row)){
		$row = $this->active_record;
	}
	foreach($this->fields as $name=>$field){
		if($field->key){
			$pointer[$name] = $row[$name];
		}
	}
	return $pointer;
}

function SetMasterFields($record){
	foreach($this->masters as $master){
		if(is_object($master['table'])){
			$record[$master['by']] = $master['table']->active_record[$master['on']];
		}
	}
	return $record;
}

function hasErrors(){
	return !empty($this->errors);
}

function hasWarnings(){
	return !empty($this->warnings);
}

function errors(){
	$this->errors = array_merge($this->errors, $this->owner->errors);
}

function error($msg){
	if($msg){
		$this->errors[] = $msg;
	}
}

function warning($msg){
	if($msg){
		$this->warnings[] = $msg;
	}
}

function report(){
	if(!empty($this->errors) || !empty($this->warnings)){
		return implode("<br>", array_merge($this->errors, $this->warnings));
	}
}

function skipUnknown($record){
	foreach($record as $key=>$val){
		if(!isset($this->fields[$key])){
			unset($record[$key]);
		}
	}
	return $record;
}

function Insert($record){
	$this->data = $record;
	$record = $this->skipUnknown($record);
	$this->errors = array();
	$this->warnings = array();
	if($this->readonly || !is_array($record)){
		return;
	}
	$this->old_record = array();
	$this->new_record = $record;
	foreach($this->fields as $name=>$field){
		if(isset($field->auto_insert)){
			$this->new_record[$name] = $field->auto_insert;
		}
	}
	$this->new_record = $this->SetMasterFields($this->new_record);
	$log_arr = $this->new_record;
	$this->Begin();
	$this->Notify('BeforeInsert');
	if(!$this->abort){
		if(empty($this->errors)){
			$values = array();
			foreach($this->new_record as $k=>$v){
				if(strlen(trim($v))==0 && $this->fields[$k]->nullable){
					$val = 'NULL';
				}else{
					$val = $this->owner->Pak($v);
				}
				$values[$k] = $val;
			}
			if($this->owner->Execute('INSERT INTO '.$this->name.' ('.implode(',',array_keys($this->new_record)).')
				VALUES ('.implode(',',$values).')')){
				$pointer = array();
				foreach($this->fields as $name=>$field){
					if($field->key){
						if(isset($this->new_record[$name])){
							$pointer[$name] = $this->new_record[$name];
						}else{
							$pointer[$name] = $this->owner->getJustInserted($this->name,$name);
							$this->new_record[$name] = $pointer[$name];
						}
					}
				}
				$this->Locate($pointer, false);
				$this->Notify('AfterInsert');
			}else{
				$this->errors();
			}
		}
	}
	if(!empty($this->errors)){
		$this->Rollback();
	}else{
		$this->Commit();
	}
	return $this->report();
}

function Delete(){
	$this->errors = array();
	$this->warnings = array();
	if($this->readonly || !count($this->active_record)){
		return;
	}
	$pointer = $this->SetMasterFields($this->getPointer());
	$this->Begin();
	$this->Notify('BeforeDelete');
	if(empty($this->errors)){
		if($this->deleted_mark){
			$query = 'UPDATE '.$this->source.' SET '.$this->deleted_mark.'=1 WHERE '.implode(' AND ',_Pair($this->make_selector($pointer),array($this->owner,'Pak')));
		}else{
			$query = 'DELETE FROM '.$this->name.' WHERE '.implode(' AND ',_Pair($pointer,array($this->owner,'Pak')));
		}
		if($this->owner->Execute($query)){
			$this->old_record = $this->active_record;
			$this->Notify('AfterDelete');
		}else{
			$this->errors();
		}
	}
	if(!empty($this->errors)){
		$this->Rollback();
	}else{
		$this->Commit();
	}
	return $this->report();
}

function make_selector($record){
	$result = array();
	foreach($record as $k=>$v){
		$result[$this->fields[$k]->getSelector()] = $v;
	}
	return $result;
}

function Post($record){
	$this->data = $record;
	$record = $this->skipUnknown($record);
	$this->errors = array();
	$this->warnings = array();
	if($this->readonly || !count($this->active_record)){
		return;
	}
	$pointer = $this->getPointer();
	$pointer = $this->SetMasterFields($pointer);
	$this->old_record = $this->active_record;
	$this->new_record = $this->SetMasterFields($record);
	foreach($this->fields as $name=>$field){
		if(isset($field->auto_post)){
			$this->new_record[$name] = $field->auto_post;
		}
	}
	$this->Begin();
	$this->Notify('BeforePost');
	if(!$this->abort){
		if(empty($this->errors)){
			$values = array();
			foreach($this->new_record as $k=>$v){
				if(strlen(trim($v))==0 && $this->fields[$k]->nullable){
					$val = 'NULL';
				}else{
					$val = $this->owner->Pak($v);
				}
				$values[$k] = $val;
			}
			if($this->owner->Execute('UPDATE '.$this->name.
				' SET '.implode(', ',_Pair($values)).
				' WHERE '.implode(' AND ',_Pair($pointer, array($this->owner,'Pak'))))){
				foreach($pointer as $k=>$v){
					if(isset($this->new_record[$k])){
						$pointer[$k]=$this->new_record[$k];
					}
				}
				$this->Locate($pointer, false);
				$err = $this->Notify('AfterPost');
			}else{
				$this->errors();
			}
		}
	}
	if(!empty($this->errors)){
		$this->Rollback();
	}else{
		$this->Commit();
	}
	return $this->report();
}

function isChanged($prop){
	if(!is_array($prop)){
		$prop = explode(",", $prop);
	}
	foreach($prop as $p){
		$p = trim($p);
		if($this->new_record[$p] != $this->old_record[$p]){
			return true;
		}
	}
	return false;
}

function isOn(){
	return count($this->active_record)?1:0;
}
}
?>