<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/08/04 07:53:23 $
$Revision: 1.18 $
*/

function compareByLength($s1, $s2){
	$l1 = strlen($s1);
	$l2 = strlen($s2);
	if ($l1 == $l2) return 0;
	return ($l1 > $l2) ? 1 : -1;
}

function getLocalizedFilename($filename){
	$languages = explode(",", $_SERVER['HTTP_ACCEPT_LANGUAGE']);
	usort($languages, 'compareByLength');
	$languages = array_reverse($languages);
	foreach($languages as $lang){
		$file = str_replace("*","_$lang", $filename);
		if(file_exists( $file )){
			return $file;
		}
	}
	$file = str_replace("*","", $filename);
	if(file_exists( $file )){
		return $file;
	}
}

function getResource($key){
	$obj = $GLOBALS['pe6yc_resources'];
	if(!is_object($obj)){
		$e = new Exception();
		file_put_contents(TMP_DIR.'/exception', $e->getTraceAsString()."\n\n".count($GLOBALS));
		$arr = explode(".", $key);
		return count($arr) ? $arr[count($arr) - 1] : $key;
	}else{
		return $obj->get($key);
	}
}

function loadStrings($filename){
	$obj = $GLOBALS['pe6yc_resources'];
	$obj->loadStrings($filename);
}

function getResource_($key){
	return isset($GLOBALS['messages'][$key]) ? $GLOBALS['messages'][$key] : $key;
}

define('_STRIP', get_magic_quotes_gpc());

function unslash($str){
	return _STRIP ? stripslashes($str) : $str;
}

function deep_unslash($val){
	if(_STRIP){
		return is_array($val) ? array_map('deep_unslash', $val) : unslash($val);
	}else{
		return $val;
	}
}

function _get_relative_path($file){
	return str_replace($_SERVER['DOCUMENT_ROOT'],'',str_replace('\\','/',dirname($file).'/'));
}

function _get_params($exclude_array=array()){
	if(!is_array($exclude_array)) $exclude_array = explode(",",$exclude_array);
	$params = '';
	if(is_array($_GET)){
		foreach(deep_unslash($_GET) as $key=>$value){
			if ((!in_array($key, $exclude_array))) 
				$params .= $key .'='.rawurlencode($value).'&';
		}
	}
	return $params;
}

function _URI($exclude_array=array()){
	return $_SERVER['PHP_SELF'].'?'._get_params($exclude_array);
}

function _href_change($change=array()){
	return _URI(array_keys($change)).implode('&',_Pair($change));
}

function _DBPak($str){
	return "'".addslashes(ltrim($str))."'";
}

function _LikePak($str){
	return "'%".addslashes(ltrim($str))."%'";
}

function _Pair($arr,$userfunc='',$operator='='){
	$result=array();
	foreach($arr as $key=>$val){
		if($userfunc)
			$val = call_user_func($userfunc,$val);
		$result[] = "$key$operator$val";
	}
	return $result;
}

function _Clone($arr){
	$result=array();
	foreach($arr as $key=>$val){
		$result[$key] = $val;
	}
	return $result;
}

function _LookUp($base,$haystack){
	$result = array();
	foreach($base as $key=>$val){
		$result[$key]=$haystack[$val];
	}
	return $result;
}

function _Load($base,$haystack){
	$result = array();
	foreach($base as $key=>$val){
		$result[$key]=$haystack[$key];
	}
	return $result;
}


function _Walk($arr,$userfunc){
	$result = array();
	foreach($arr as $key=>$val){
		$result[$key] = call_user_func($userfunc,$val);
	}
	return $result;
}

function _Extract($arr,$key){
	$result = array();
	foreach($arr as $k=>$v){
		$result[$k]=$v[$key];
	}
	return $result;
}

function _Aggregate($arr,$func){
	switch(strtolower($func)){
		case 'max':
			return max($arr);
		case 'min':
			return min($arr);
		case 'count':
			return count($arr);
		case 'sum':
			return array_sum($arr);
		case 'avg':
			return array_sum($arr)/count($arr);
	}
}

function _Float($str){
	$locale_info = localeconv();
	$decimal_point = $locale_info["decimal_point"];
	$result = str_replace(".", $decimal_point, $str);
	$result = str_replace(",", $decimal_point, $result);
	return doubleval($result);
}

function _prec_0($str){
	return number_format(round(_Float($str)),0);
}

function _prec_1($str){
	return number_format(round(_Float($str),1),1);
}

function _prec_2($str){
	return number_format(round(_Float($str),2),2);
}

function _prec_3($str){
	return number_format(round(_Float($str),3),3);
}

function _prec_4($str){
	return number_format(round(_Float($str),4),4);
}

function _prec_6($str){
	return number_format(round(_Float($str),6),6);
}

function _parse_datetime($datetime){
	$year=substr($datetime,0,4);
	$month=substr($datetime,5,2);
	$day=(integer)substr($datetime,8,2);
	$hour=substr($datetime,11,2);
	$minute=substr($datetime,14,2);
	$second=substr($datetime,17,2);
	return mktime($hour,$minute,$second,$month,$day,$year);
}

function _format_datetime($datetime,$dtf){
    if($datetime>0){
	  	if(strlen($datetime)<=10)
			$datetime = date("Y-m-d H:i:s",$datetime);
		$date_time = strftime($dtf, _parse_datetime($datetime));
		return $date_time;
	}else
		return "undefined";
}


function _format_datetime_short($datetime){
	return _format_datetime($datetime,"%d/%m/%y %H:%M");
}

function _extension($filename){
	return substr($filename,-strpos(strrev($filename),'.'));
}

function _upload($name,$dir,$new_file=''){
	if($_FILES[$name]['tmp_name']){
		if(is_dir($dir)){
			if(substr($dir,-1,1)!='/'){
				$dir .= '/';
			}
			if(!$new_file){
				$ext = _extension($_FILES[$name]['name']);
				list($msec, $sec) = explode(" ",microtime());
				$new_file = date("Ymd_His").'_'.str_replace(array('.',','),'',$msec).'.'.$ext;
			}
		 	if(move_uploaded_file($_FILES[$name]['tmp_name'],$dir.$new_file)){
				chmod($dir.$new_file,0660);
				return $new_file;
			}
		}
	}
}

function _random_string($length){
	$str = '';
	$source = array( array(48,57), array(65,90), array(97,122) );
	mt_srand ((double) microtime() * 1000000);
	while(strlen($str) < $length){
		$s = mt_rand(0,2);
		$str .= chr( mt_rand($source[$s][0],$source[$s][1]) );
	}
	return($str);
}

function _InRange($val,$from,$to){
	$val = min(intval($val),$to);
	return max($val,$from);
}

function _ValidYear($year){
	if(!$year+=0){
		$year = date("Y");
	}
	if($year<100)
		$year+=2000;
	return $year;
}

function _ValidMonth($month){
	return sprintf("%02d",_InRange($month,1,12));
}

function _ValidDay($day){
	return sprintf("%02d",_InRange($day,1,31));
}

function _ValidTime($time){
	$parts = explode(':',$time);
	$result = array();
	$result[0] = sprintf("%02d",_InRange($parts[0],0,23));
	if(isset($parts[1])){
		$result[1] = sprintf("%02d",_InRange($parts[1],0,59));
	}else{
		$result[1] = '00';
	}
	if(isset($parts[2])){
		$result[2] = sprintf("%02d",_InRange($parts[2],0,59));
	}else{
		$result[2] = '00';
	}
	return implode(':',$result);
}

?>