<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/08/04 07:53:23 $
$Revision: 1.4 $
*/
include_once(dirname(__FILE__).'/boot.php');

class PGraph extends PBoot {

var $area_width;
var $area_height;

var $left;
var $top;
var $width;
var $height;

var $trans_color;
var $bg_color;
var $face_color;
var $graph_color;
var $grid_color;
var $border_color;

var $grid_x_step = 1;
var $grid_y_step = 1;

var $img;

function ParseColor($str){
	$str = str_replace('#','',$str);
	$rgb = array(
		'r'=>hexdec('0x'.substr($str,0,2)),
		'g'=>hexdec('0x'.substr($str,2,2)),
		'b'=>hexdec('0x'.substr($str,4,2)),
	);
	return $rgb;
}

function AllocateHexColor($color){
	$arr = $this->ParseColor($color);
	return ImageColorAllocate($this->img,$arr['r'],$arr['g'],$arr['b']);
}

function AllocateColors(){
	$this->c_bg = $this->AllocateHexColor($this->bg_color);
	$this->c_face = $this->AllocateHexColor($this->face_color);
	$this->c_graph = $this->AllocateHexColor($this->graph_color);
	$this->c_border = $this->AllocateHexColor($this->border_color);
	$this->c_grid = $this->AllocateHexColor($this->grid_color);
	ImageSetStyle($this->img, array(IMG_COLOR_TRANSPARENT, IMG_COLOR_TRANSPARENT, $this->c_border));
}

function DrawArea(){
	if($this->bg_trans){
		ImageColorTransparent($this->img,$this->c_bg);
	}
	ImageFilledRectangle(
		$this->img,
		$this->left,
		$this->top,
		$this->left + $this->width,
		$this->top + $this->height,
		$this->c_face
	);
}

function DrawBorder(){
	ImageRectangle(
		$this->img,
		$this->left,
		$this->top,
		$this->left + $this->width,
		$this->top + $this->height,
		$this->c_border
	);
}

function DrawGrid(){
	$this->DrawHGrid($this->c_grid);
	$this->DrawVGrid($this->c_grid);
}

function getHMarkText($y){
	return $y;
}

function getVMarkText($x){
	return $x;
}

function DrawHMark($y){
	ImageLine(
		$this->img,
		$this->left - $this->mark_out,
		$this->ReductionY($y),
		$this->left - $this->mark_out + $this->mark_size,
		$this->ReductionY($y),
		$this->c_border
	);
	if($str = $this->getHMarkText($y)){
		ImageString(
			$this->img,2,
			$this->left + $this->mark_h_x,
			$this->ReductionY($y) + $this->mark_h_y,
			$str,
			$this->c_border
		);
	}
}

function DrawVMark($x){
	ImageLine(
		$this->img,
		$this->ReductionX($x),
		($this->top + $this->height) + $this->mark_out,
		$this->ReductionX($x),
		($this->top + $this->height) + $this->mark_out - $this->mark_size,
		$this->c_border
	);
	if($str = $this->getVMarkText($x)){
		ImageString(
			$this->img,2,
			$this->ReductionX($x) + $this->mark_v_x,
			($this->top + $this->height) + $this->mark_v_y,
			$str,
			$this->c_border
		);
	}
}

function getNextGridY($y){
	return $y + $this->grid_y_step;
}

function DrawHGrid(){
	for($y=$this->min_y; $y<$this->max_y; $y=$this->getNextGridY($y)){
		ImageLine(
			$this->img,
			$this->ReductionX($this->min_x),
			$this->ReductionY($y),
			$this->ReductionX($this->max_x),
			$this->ReductionY($y),
			IMG_COLOR_STYLED
		);
		$this->DrawHMark($y);
	}
}

function getNextGridX($x){
	return $x + $this->grid_x_step;
}

function DrawVGrid(){
	for($x=$this->min_x; $x<$this->max_x; $x=$this->getNextGridX($x)){
		ImageLine(
			$this->img,
			$this->ReductionX($x),
			$this->ReductionY($this->min_y),
			$this->ReductionX($x),
			$this->ReductionY($this->max_y),
			IMG_COLOR_STYLED
		);
		$this->DrawVMark($x);
	}
}

function ReductionX($x){
	return $this->left + $this->width * ($x - $this->min_x)/($this->max_x - $this->min_x);
}

function ReductionY($y){
	return ($this->top + $this->height) - ($this->height * ($y - $this->min_y)/($this->max_y - $this->min_y));
}

function MoveLine($x,$y){
	if($this->prev_x || $this->prev_y){
		ImageLine(
			$this->img,
			$this->ReductionX($this->prev_x),
			$this->ReductionY($this->prev_y),
			$this->ReductionX($x),
			$this->ReductionY($y),
			$this->c_graph
		);
	}
	$this->prev_x = $x;
	$this->prev_y = $y;
}

function MoveFill($x,$y){
	ImageLine(
		$this->img,
		$this->ReductionX($x),
		$this->ReductionY($this->min_y),
		$this->ReductionX($x),
		$this->ReductionY($y),
		$this->c_graph
	);
}

function Move($x,$y){
	switch($this->style){
		case 'fill':
			$this->MoveFill($x,$y);
			break;
		default:
			$this->MoveLine($x,$y);
	}
}

function DrawGraph(){
	$this->prev_x = 0;
	$this->prev_y = 0;
}

function Draw($format='png'){
	$this->img = ImageCreate($this->area_width,$this->area_height);
	$this->AllocateColors();
	$this->DrawArea();
	$this->DrawGraph();
	$this->DrawBorder();
	$this->DrawGrid();
	switch($format){
		case 'png':
			header("content-type: image/png");
			ImagePNG($this->img);
	}
	ImageDestroy($this->img);
}

}
?>