<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/08/04 07:53:23 $
$Revision: 1.8 $
*/
include_once(dirname(__FILE__).'/permanent.php');

class PMenu extends PPermanent {
	var $class = 'menu';
	var $collections = array('items');
	var $items = array();
	var $title;
	var $mode = 'v';
	var $anchor = true;
	var $available = true;

	function Create($owner,$data){
		$this->collections = array('items'=>get_class($this));
		parent::Create($owner,$data);
	}

	function isActive(){
	}

	function isAvailable(){
		return $this->available;
	}

	function DressItem($name){
		if(!$this->items[$name]->isActive()){
			return "<a ".($this->items[$name]->external?"class=\"cross\"":"")." href=\"".$this->items[$name]->path."\">".$this->items[$name]->title."</a>";
		}else{
			return "<span>".$this->items[$name]->title."</span>";
		}
	}

	function DressVItems(){
		$result = '';
		foreach($this->items as $name=>$item){
			if($item->isAvailable()){
				$result .= "	<tr class=\"menu_item\" ".
				' id="'.$this->Pedigree($name).'" '.
				'onmouseover="change_class(\''.$this->Pedigree($name).'\',\'menu_item_shine\')" '.
				'onmouseout="change_class(\''.$this->Pedigree($name).'\',\'menu_item\')" '.
				'onclick="window.location=\''.$this->items[$name]->path.'\'"'.
				">\n";
				$result .= "		<td>";
				$result .= 	$this->DressItem($name);
				$result .="</td>\n";
				$result .= "	</tr>\n";
			}
		}
		return $result;
	}

	function DressHItems(){
		$result = "	<tr>\n";
		$result .= "		<td>";
		$ic=0;
		foreach($this->items as $name=>$item){
			if($item->isAvailable()){
				if($ic++){
					$result .= 	" | ";
				}
				$result .= 	$this->DressItem($name);
			}
		}
		$result .="</td>\n";
		$result .= "	</tr>\n";
		return $result;
	}

	function DressHCLItems(){
		$result = "	<tr>\n";
		$result .= "		<td>";
		$ic=0;
		foreach($this->items as $name=>$item){
			if($item->isAvailable()){
				$result .= 	$this->DressItem($name);
			}
		}
		$result .="</td>\n";
		$result .= "	</tr>\n";
		return $result;
	}

	function Dress(){
		$result = "";
		if($this->anchor && $this->pedi_name){
			$result .= "<a name=\"".$this->pedi_name."\"></a>\n";
		}
		$result .= "<table width=\"100%\" class=\"menu_".$this->mode."\" cellpadding=0 cellspacing=0>\n";
		if($this->mode=='h'){
			$result .= $this->DressHItems();
		}elseif($this->mode=='hcl'){
			$result .= $this->DressHCLItems();
		}else{
			$result .= $this->DressVItems();
		}
		$result .= "</table>\n";
		return $result;
	}

}

class PFileMenu extends PMenu {
	var $path;
	var $base;

	function Create($owner,$data){
		$this->base = PROTOCOL.$_SERVER['SERVER_NAME'];
		parent::Create($owner,$data);
	}

	function isActive(){
		return strstr($_SERVER['REQUEST_URI'], $this->path) ? 1 : 0;
	}

}

class PNamedMenu extends PMenu {
	var $selected;
	var $listen = array('selected');
	var $select_first;
	var $empty;

	function Create($owner,$data){
		parent::Create($owner,$data);
		if(is_object($this->owner) && !$this->path){
			$this->path = $this->owner->SafeHrefChange('selected',$this->name);
		}
		if(!is_object($this->owner)){
			$first_available = '';
			foreach($this->items as $name=>$item){
				if($item->isAvailable()){
					if(!$first_available){
						$first_available = $name;
					}
				}else{
					if($name==$this->selected){
						$this->selected = '';
					}
				}
			}
			if(!$this->selected && $this->select_first){
				$this->selected = $first_available;
			}
			$this->empty = !$first_available;
		}
	}

	function isActive(){
		if(is_object($this->owner) && $this->owner->selected==$this->name){
			return 1;
		}
	}
	
	function getSelected(){
		if(isset($this->items[$this->selected])){
			$item = $this->items[$this->selected];
			if($item->isAvailable()){
				return $this->selected;
			}
		}
		return '';
	}

}
?>