<?
include_once "classes/log/StdoutAppender.php";
include_once "classes/log/FileAppender.php";
include_once "classes/log/StreamAppender.php";
include_once "classes/log/DefaultLogger.php";
include_once "classes/tools/IpAddress.php";
include("includes/environment.php");
include("functions/accounts.php");

class PrivateCashPayer {

var $account;
var $company = 1;
var $logger;

function PrivateCashPayer($logger){
	global $db;
	$this->logger = $logger;
	if($arr = $db->Next($db->Execute("SELECT account FROM system_accounts WHERE code='PAY_PRIVATB'"))){
		$this->account = $arr['account'];
	}
}

function process(){
	global $db;
	if(!$this->account){
		return $this->response($this->fill_error(99, 'service unavailable'));
	}
	if($access_zone = getTrimOption('PRIVATE_CASH_ACCESS_ZONE')){
		$valid = false;
		$ip = new SlashedIpAddress($_SERVER["REMOTE_ADDR"]);
		foreach(preg_split("|[\s,;]+|", $access_zone, -1, PREG_SPLIT_NO_EMPTY) as $ip_str){
			$zone = new SlashedIpAddress($ip_str);
			if($zone->contains($ip)){
				$valid = true;
				break;
			}
		}
		if(!$valid){
			return $this->response($this->fill_error(5, '   IP  '));
		}
	}
	switch($_GET['action']){
		case 'bill_search': return $this->response($this->bill_search());
		case 'bill_input': return $this->response($this->bill_input());
		default: return $this->response($this->fill_error(1, '  '));
	}
}

function bill_search(){
	$this->logger->info("bill_search request: %s", $_SERVER['QUERY_STRING']);
	$contract = $_GET['bill_identifier'];
	if($client = $this->getClientByContract($contract)){
		$this->logger->debug("bill_search contract %s found: %s", $contract, $client['login']);
		return $this->fill_answer($client, 100, chr(178).'');
	}else{
		$this->logger->debug("bill_search contract %s not found", $contract);
		return $this->fill_error(2, '  ');
	}
}

function bill_input(){
	global $db;
	$this->logger->info("bill_input request: %s", $_SERVER['QUERY_STRING']);
	$service = new StdClass();
	array_walk(explode(';',trim($_GET['service'], "{}")), array($this, 'unpair'), $service);
	$this->logger->debug(print_r($service, 1));
	$this->logger->debug(print_r($_GET['date'], 1));
	$contract = $_GET['bill_identifier'];
	$pkey = $_GET['pkey'];
	if(preg_match("|[^\d.]|", $service->sum)){
		$this->logger->warning("invalid sum: %s", $service->sum);
		return $this->fill_error(3, '    ');
	}
	$iamount = intval(strval($service->sum * 100));
	if($client = $this->getClientByContract($contract)){
		if($pay = loadRecord(sprintf("SELECT movement FROM privatb WHERE pkey='%s'", addslashes($pkey)))){
			$this->logger->warning("pay %s already exists", $pkey);
			return $this->fill_success($pay['movement']);
		}else{
			$success = false;
			$mid = '';
			for($i=0; $i<3; $i++){
				$db->Begin();
				$mid = move($this->account, $client['account'], $iamount);
				$db->Execute(sprintf("INSERT INTO privatb (client, movement, pkey, amount, date)
						VALUES ('%s', '%s', '%s', '%s', '%s')",
						$client['id'], $mid, addslashes($pkey), $iamount, addslashes($_GET['date'])));
				if($db->hasErrors()){
					$this->logger->warning(implode("\n", $db->errors));
					$db->Rollback();
					sleep(3);
				}else{
					$db->Commit();
					$success = true;
					break;
				}
			}
			if($success){
				$this->logger->info('pay %s is ok', $pkey);
				return $this->fill_success($mid);
			}else{
				$this->logger->error('pay %s cant be moved', $txn_id);
				return $this->fill_error(99, ' ');
			}
		}
	}else{
		$this->logger->debug("bill_input contract %s not found", $contract);
		return $this->fill_error(2, '  ');
	}
}

function getClientByContract($contract){
	if($arr = loadRecord(sprintf("SELECT c.id, c.login, c.phone, c.contract, c.account, c.connection_type, c.first_name, c.last_name, c.patronymic,
		ci.name as city_name, s.name as street_name, h.house, c.apartment,
		(ifnull(cas.state_end,0) - ifnull(cs.incomplete,0))/100 as deposit
		FROM clients c
		LEFT JOIN cities ci ON ci.id=c.city
		LEFT JOIN houses h ON h.id=c.house_id
		LEFT JOIN streets s ON s.id=h.street
		LEFT JOIN calendar_account_states cas on cas.account=c.account AND cas.calendar_period=(SELECT id FROM calendar_periods WHERE marker=1)
		LEFT JOIN clients_states cs ON cs.client=c.id
		WHERE c.contract='%s'", addslashes($contract)))){
		$arr['fio'] = trim($arr['last_name'].' '.$arr['first_name'].' '.$arr['patronymic']);
		$arr['address'] = $arr['city_name'].', '.$arr['street_name'].' '.$arr['house'].', .'.$arr['apartment'];
		return $arr;
	}
}

function response($body){
	$body = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'.$body;
	header('Content-Type: text/xml; charset=utf-8');
	header('Content-Length: '.strlen($body));
	echo $body;
}

function fill_answer($client, $service_code, $service_name){
	$client = array_map(array($this, 'wrap'), $client);
	extract($client);
	return '<ResponseDebt>
	<debtPayPack phone="'.$phone.'" fio="'.$fio.'" bill_period="'.date("Ym").'" bill_identifier="'.$contract.'"  address="'.$address.'">
	<service>
	<ks company_code="'.$this->company.'" service_code="'.$service_code.'" service="'.$this->wrap($service_name).'"/>
	<debt amount_to_pay="'.$deposit.'"/>
	<payer ls="'.$contract.'"/>
	</service>
	<message>'.$this->wrap('        !').'</message>
	</debtPayPack>
	</ResponseDebt>';
}

function fill_error($code, $message){
	return '<ResponseDebt>
	<errorResponse>
	<code>'.$code.'</code>
	<message>'.$this->wrap($message).'</message>
	</errorResponse>
	</ResponseDebt>';
}

function fill_success($id){
	return '<ResponseExtInputPay>
	<extInputPay>
	<inner_ref>'.$id.'</inner_ref>
	</extInputPay>
	</ResponseExtInputPay>';
}

function wrap($str){
	return iconv('windows-1251', 'utf-8', htmlspecialchars($str));
}

function escape($str){
	return str_replace(array("\t", "\n", "\r", "\0"), array('\t', '\n','\r','\0'), $str);
}

function unpair($str, $i, $obj){
	if(trim($str)){
		list($k, $v) = explode("=", $str);
		$k = trim($k);
		$v = trim($v);
		$obj->$k = $v;
	}
}

}

if(isset($_GET['test'])){
	$url = "http".($_SERVER['HTTPS'] == "on" ? 's' : '')."://". $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
	$test_queries = array(
		'action=bill_search&bill_identifier=333221',
		'action=bill_input&bill_identifier=333221&pkey=1&service='.urlencode("{service_code=100;sum=10.50;}")."&date=".date("Y-m-d").'T'.date("H:i:s"),
	);
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url.'?'.$test_queries[$_GET['test']]);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$result = curl_exec($ch);
	curl_close($ch);
	header('Content-Type: text/xml; charset=utf-8');
	header('Content-Length: '.strlen($result));
	echo $result;
}else{
	$appender = new FileAppender('/var/log/private-cash.log');
	$logger = new DefaultLogger();
	$logger->setAppender($appender);
	$logger->setName('private.cash');
	$payer = new PrivateCashPayer($logger);
	$payer->process();
}
?>