<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/11/06 12:46:17 $
$Revision: 1.9 $
*/
include_once('includes/global.php');
loadStrings(BOOT.'snapshots/strings.txt');

$doc->title .= ' :: '.getResource('snapshots.title');

required_access('snapshots');

//$db->debug = 1;

$smenu = new PNamedMenu($nil,BOOT.'snapshots/menu.php');
$doc->page->contents['smenu'] = $smenu;
switch($smenu->selected){
	case 'm':
		//$db->debug = 1;
		$db->Execute("CREATE TEMPORARY TABLE snapshots_m ENGINE=Memory
			SELECT max(id) id,
				sum(payed) payed, sum(int_payed) int_payed, sum(tv_payed) tv_payed, sum(both_payed) both_payed,
				avg(arpu) arpu, avg(int_arpu) int_arpu, avg(tv_arpu) tv_arpu, avg(both_arpu) both_arpu,
				sum(int_clients_diff) int_clients_diff, sum(int_new) int_new, sum(int_return) int_return,
				sum(tv_clients_diff) tv_clients_diff, sum(tv_new) tv_new, sum(tv_return) tv_return,
				sum(both_clients_diff) both_clients_diff, sum(both_new) both_new, sum(both_return) both_return,
				sum(cover_tv_diff) cover_tv_diff, sum(cover_int_diff)cover_int_diff 
			FROM snapshots
			GROUP BY city, date_format(SUBDATE(date, INTERVAL 1 HOUR), '%Y%m')");
		$db->Execute("ALTER TABLE snapshots_m ADD KEY(id)");
		$snapshots_m = new PTable($db,BOOT.'snapshots/month/table.php');
		$snapshots_m->readonly = 1;
		addCityPolicy($snapshots_m, 'ss.city');
		$doc->page->contents['snapshots_m'] = new PMyAccess($snapshots_m,array(
			'title'=>getResource('snapshots.title').': '.getResource('snapshots.month.title'),
			'help'=>HELP_PATH.'//',
			'icon'=>HREF.'images/clients.gif',
			'grid_boot'=>forceCity(BOOT.'snapshots/month/grid.php'),
		));
		$n = $snapshots_m->nick;
		$doc->page->contents["${n}_chart"] = "
		<div id=\"${n}_chart\" class=\"chart\"></div>
		<script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>
		<script type=\"text/javascript\" src=\"scripts/charts.js\"></script>
		<script>
			GridColumnChart(document.getElementById('${n}_chart'), document.getElementById('${n}_grid'), '${n}_date_f');
		</script>";
		if($snapshots_m->isOn()){
			$shot = $snapshots_m->active_record;
			$db->Execute("CREATE TEMPORARY TABLE snapshots_w ENGINE=Memory
				SELECT max(id) id,
					sum(payed) payed, sum(int_payed) int_payed, sum(tv_payed) tv_payed, sum(both_payed) both_payed,
					avg(arpu) arpu, avg(int_arpu) int_arpu, avg(tv_arpu) tv_arpu, avg(both_arpu) both_arpu,
					sum(int_clients_diff) int_clients_diff, sum(int_new) int_new, sum(int_return) int_return,
					sum(tv_clients_diff) tv_clients_diff, sum(tv_new) tv_new, sum(tv_return) tv_return,
					sum(both_clients_diff) both_clients_diff, sum(both_new) both_new, sum(both_return) both_return,
					sum(cover_tv_diff) cover_tv_diff, sum(cover_int_diff)cover_int_diff 
				FROM snapshots
				GROUP BY city, date_format(SUBDATE(date, INTERVAL 1 HOUR), '%Y%u')");
			$db->Execute("ALTER TABLE snapshots_w ADD KEY(id)");
			$snapshots_w = new PTable($db,BOOT.'snapshots/week/table.php');
			$snapshots_w->readonly = 1;
			addCityPolicy($snapshots_w, 'ss.city');
			$snapshots_w->filters['by_month'] = "date_format(SUBDATE(ss.date, INTERVAL 1 HOUR), '%Y%m')=date_format(SUBDATE('".$shot['date']."', INTERVAL 1 HOUR), '%Y%m')";
			$snapshots_w->filters['by_city'] = "ss.city ".($shot['city'] ? '='.$shot['city'] : 'IS NULL');
			$doc->page->contents['snapshots_w'] = new PMyAccess($snapshots_w,array(
				'title'=>getResource('snapshots.title').': '.getResource('snapshots.week.title'),
				'icon'=>HREF.'images/clients.gif',
				'grid_boot'=>forceCity(BOOT.'snapshots/week/grid.php'),
			));
			if($snapshots_w->isOn()){
				$shot = $snapshots_w->active_record;
				$snapshots_d = new PTable($db,BOOT.'snapshots/day/table.php');
				$snapshots_d->readonly = 1;
				addCityPolicy($snapshots_d, 's.city');
				$snapshots_d->filters['by_week'] = "date_format(SUBDATE(s.date, INTERVAL 1 HOUR), '%Y%u')=date_format(SUBDATE('".$shot['date']."', INTERVAL 1 HOUR), '%Y%u')";
				$snapshots_d->filters['by_city'] = "s.city ".($shot['city'] ? '='.$shot['city'] : 'IS NULL');
				$doc->page->contents['snapshots_d'] = new PMyAccess($snapshots_d,array(
					'title'=>getResource('snapshots.title').': '.getResource('snapshots.day.title'),
					'help'=>HELP_PATH.'//',
					'icon'=>HREF.'images/clients.gif',
					'grid_boot'=>forceCity(BOOT.'snapshots/day/grid.php'),
				));
			}
		}
		break;
	case 'w':
		//$db->debug = 1;
		$db->Execute("CREATE TEMPORARY TABLE snapshots_w ENGINE=Memory
			SELECT max(id) id,
				sum(payed) payed, sum(int_payed) int_payed, sum(tv_payed) tv_payed, sum(both_payed) both_payed,
				avg(arpu) arpu, avg(int_arpu) int_arpu, avg(tv_arpu) tv_arpu, avg(both_arpu) both_arpu,
				sum(int_clients_diff) int_clients_diff, sum(int_new) int_new, sum(int_return) int_return,
				sum(tv_clients_diff) tv_clients_diff, sum(tv_new) tv_new, sum(tv_return) tv_return,
				sum(both_clients_diff) both_clients_diff, sum(both_new) both_new, sum(both_return) both_return,
				sum(cover_tv_diff) cover_tv_diff, sum(cover_int_diff)cover_int_diff 
			FROM snapshots
			GROUP BY city, date_format(SUBDATE(date, INTERVAL 1 HOUR), '%Y%u')");
		$db->Execute("ALTER TABLE snapshots_w ADD KEY(id)");
		$snapshots_w = new PTable($db,BOOT.'snapshots/week/table.php');
		$snapshots_w->readonly = 1;
		addCityPolicy($snapshots_w, 'ss.city');
		$doc->page->contents['snapshots_w'] = new PMyAccess($snapshots_w,array(
			'title'=>getResource('snapshots.title').': '.getResource('snapshots.week.title'),
			'icon'=>HREF.'images/clients.gif',
			'grid_boot'=>forceCity(BOOT.'snapshots/week/grid.php'),
		));
		$n = $snapshots_w->nick;
		$doc->page->contents["${n}_chart"] = "
		<div id=\"${n}_chart\" class=\"chart\"></div>
		<script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>
		<script type=\"text/javascript\" src=\"scripts/charts.js\"></script>
		<script>
			GridColumnChart(document.getElementById('${n}_chart'), document.getElementById('${n}_grid'), '${n}_date_f');
		</script>";
		if($snapshots_w->isOn()){
			$shot = $snapshots_w->active_record;
			$snapshots_d = new PTable($db,BOOT.'snapshots/day/table.php');
			$snapshots_d->readonly = 1;
			addCityPolicy($snapshots_d, 's.city');
			$snapshots_d->filters['by_week'] = "date_format(SUBDATE(s.date, INTERVAL 1 HOUR), '%Y%u')=date_format(SUBDATE('".$shot['date']."', INTERVAL 1 HOUR), '%Y%u')";
			$snapshots_d->filters['by_city'] = "s.city ".($shot['city'] ? '='.$shot['city'] : 'IS NULL');
			$doc->page->contents['snapshots_d'] = new PMyAccess($snapshots_d,array(
				'title'=>getResource('snapshots.title').': '.getResource('snapshots.day.title'),
				'help'=>HELP_PATH.'//',
				'icon'=>HREF.'images/clients.gif',
				'grid_boot'=>forceCity(BOOT.'snapshots/day/grid.php'),
			));
		}
		break;
	case 'd':
		$snapshots_d = new PTable($db,BOOT.'snapshots/day/table.php');
		$snapshots_d->readonly = 1;
		addCityPolicy($snapshots_d, 's.city');
		$doc->page->contents['snapshots_d'] = new PMyAccess($snapshots_d,array(
			'title'=>getResource('snapshots.title').': '.getResource('snapshots.day.title'),
			'help'=>HELP_PATH.'//',
			'icon'=>HREF.'images/clients.gif',
			'grid_boot'=>forceCity(BOOT.'snapshots/day/grid.php'),
		));
		$n = $snapshots_d->nick;
		$doc->page->contents["${n}_chart"] = "
		<div id=\"${n}_chart\" class=\"chart\"></div>
		<script type=\"text/javascript\" src=\"https://www.google.com/jsapi\"></script>
		<script type=\"text/javascript\" src=\"scripts/charts.js\"></script>
		<script>
			GridColumnChart(document.getElementById('${n}_chart'), document.getElementById('${n}_grid'), '${n}_date_f');
		</script>";
		break;
}
echo $doc->Paint();
?> 