<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2003/12/23 09:08:50 $
$Revision: 1.23 $
*/
include_once('includes/global.php');
include_once('classes/period.php');
include_once('functions/uses.php');

$doc->title .= ' :: '.getResource('stat.clients.title');

required_access('clients');

$period = new PPeriod($nil,BOOT.'period/form.php');
//$db->debug = 1;
prepare_ip_use_data($period);

$db->Execute("CREATE TEMPORARY TABLE stats_resource_uses (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");

insertSelectOverFile('stats_resource_uses', 
	"-- INSERT INTO stats_resource_uses (id, bytes, cost)
	SELECT ru.id, sum(l.bytes) bytes, floor(sum(l.bytes) * IF(ru.dst IS NULL, 0, ru.price) / ru.unit_size) cost
	FROM ip_use_data l
	LEFT JOIN ip_uses iu ON iu.id=l.ip_use
	LEFT JOIN personal_period_resource_uses ppru ON ppru.id=iu.personal_period_resource_use
	LEFT JOIN resource_uses ru ON ru.id=ppru.resource_use
	LEFT JOIN clients c ON c.account=ru.src
	".($oper->city_mode ? "WHERE c.city IN (SELECT city FROM operators_cities WHERE operator='$oper->id' )" : "")."
	GROUP BY ru.id");

$db->Execute("CREATE TEMPORARY TABLE stats_clients (
	id		INT UNSIGNED NOT NULL PRIMARY KEY,
	bytes	BIGINT UNSIGNED NOT NULL,
	cost	BIGINT UNSIGNED NOT NULL) ENGINE=Memory");
insertSelectOverFile('stats_clients', "-- INSERT INTO stats_clients (id, bytes, cost)
	SELECT ru.client,  sum(x.bytes), sum(x.cost)
	FROM stats_resource_uses x
	LEFT JOIN resource_uses ru ON ru.id=x.id
	GROUP BY ru.client");

$p_filters = array();
if($period->active){
	if($from = $period->getFrom()){
		$p_filters['from'] = sprintf("(m.date >= '%s')", $from);
	}
	if($to = $period->getTo()){
		$p_filters['to'] = sprintf("(m.date <= '%s')", $to);
	}
}
if($oper->city_mode){
	$p_filters['city'] = "c.city IN (SELECT city FROM operators_cities WHERE operator='$oper->id')";
}
$p_filters['pays'] = "sa.code LIKE '%PAY%'";
$db->Execute(sprintf("CREATE TEMPORARY TABLE stats_pays (client INT UNSIGNED NOT NULL PRIMARY KEY, amount BIGINT UNSIGNED NOT NULL) ENGINE=Memory
SELECT c.id as client, sum(m.amount) as amount
FROM movements m 
INNER JOIN clients c ON c.account=m.dst
INNER JOIN system_accounts sa ON sa.account=m.src
WHERE %s
GROUP BY m.dst", implode(" AND ", $p_filters)));

$stats_clients = new PTable($db,BOOT.'stats_clients/table.php');
addCityPolicy($stats_clients, 'c.city');

$doc->page->contents['stats_clients'] = new PMyAccess($stats_clients,array(
	'title'=>getResource('stat.clients.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/clients.gif',
	'grid_boot'=>BOOT.'stats_clients/grid.php',
	'tool'=>$period,
));
if($stats_clients->isOn()){
	$doc->page->contents['hosts'] = '';
}

if($stats_clients->isOn()){
	$id = $stats_clients->active_record['id'];
	$cmenu = new PNamedMenu($nil,BOOT.'stats_clients/menu.php');
	$doc->page->contents['client_menu'] = $cmenu;
	switch($cmenu->selected){
		case 'in':
			$doc->page->contents['graph'] = "
			<div align='center'>
			<br><br>".getResource('stat.graph.day')."<br>
			<img src='".HREF."graph/client.php?id=$id&period=day'>
			<br><br>".getResource('stat.graph.month')."<br>
			<img src='".HREF."graph/client.php?id=$id&period=month'>
			<br><br>".getResource('stat.graph.year')."<br>
			<img src='".HREF."graph/client.php?id=$id&period=year'><br>
			</div>";
			break;
		case 'rs':
			$db->Execute("CREATE TEMPORARY TABLE stats_resources (
				resource_type	INT UNSIGNED NOT NULL,
				price			BIGINT UNSIGNED NOT NULL,
				unit_size		BIGINT UNSIGNED NOT NULL,
				bytes			BIGINT UNSIGNED NOT NULL,
				cost			BIGINT UNSIGNED NOT NULL,
				PRIMARY KEY (resource_type, price, unit_size)) ENGINE=Memory");
			insertSelectOverFile('stats_resources' ,"-- INSERT INTO stats_resources (resource_type, price, unit_size, bytes, cost)
				SELECT ru.resource_type, ru.price, ru.unit_size, sum(s.bytes), sum(cost)
				FROM stats_resource_uses s
				LEFT JOIN resource_uses ru ON ru.id=s.id
				WHERE ru.client='$id' GROUP BY ru.resource_type, ru.price, ru.unit_size");
			$stats_resources = new PTable($db,BOOT.'stats_resources/table.php');
			$doc->page->contents['stats_resources'] = new PMyAccess($stats_resources, array(
				'title'=>getResource('stat.resources.title'),
				'icon'=>HREF.'images/resource_uses.gif',
				'grid_boot'=>BOOT.'stats_resources/grid.php',
			));
			break;
	}
}
echo $doc->Paint();
?>