<?php

/**
 * @author tregub
 * @copyright 2010
 */

include_once('includes/global.php');
loadStrings(BOOT.'tech_zones/strings.txt');
include_once('includes/lookups.php');
$doc->title .= ' :: ' . getResource('workgraph.title');


required_access('jobs');

function getZoneJobTypes(){
	global $zone, $oper;
	$filters = array();
	if($oper->city_mode){
		$filters[] = "(oc.city IS NOT NULL)";
	}
	if($zone['city']){
		$filters[] = "jt.city='".$zone['city']."'";
	}
	$where = empty($filters) ? "" : " WHERE ".implode(" AND ", $filters);
	return loadByQuery ( "SELECT jt.id, jt.name as value 
		FROM job_types jt
		LEFT JOIN operators_cities oc ON oc.city=jt.city AND oc.operator='$oper->id'
		$where ORDER BY jt.number, jt.name");
}

function getZoneDistricts() {
	global $zone, $oper;
	$filters = array();
	if($oper->city_mode){
		$filters[] = "(oc.city IS NOT NULL)";
	}
	if($zone['city']){
		$filters[] = "d.city='".$zone['city']."'";
	}
	$where = empty($filters) ? "" : " WHERE ".implode(" AND ", $filters);
	return loadByQuery ( "SELECT d.id, d.name as value 
		FROM districts d
		LEFT JOIN operators_cities oc ON oc.city=d.city AND oc.operator='$oper->id'
		$where ORDER BY d.name" );
}

$works = new PTable($db,BOOT.'tech_zones/table.php');
$works->readonly = !$oper->system_access['jobs'];
addCityPolicy($works, 'tz.city');

$doc->page->contents['workgraph'] = new PMyAccess($works,array(
	'title'=>getResource('workgraph.title'),
	'help'=>HELP_PATH.'//',
	'icon'=>HREF.'images/streets.gif',
	'grid_boot'=>forceCity(BOOT.'tech_zones/grid.php'),
	'form_boot'=>forceCity(BOOT.'tech_zones/form.php'),
));
if($works->isOn()){
	$zone = $works->active_record;
	$menu = new PNamedMenu($nil,BOOT.'tech_zones/menu.php');
	$doc->page->contents['_menu'] = $menu;
	
	switch($menu->selected)	{
		case 'distr':
			$district = new PTable($db,BOOT.'tech_zones/distr/table.php');
			$district->readonly = !$oper->system_access['jobs'];
			$doc->page->contents['workgraph2'] = new PMyAccess($district,array(
				'title'=>getResource('workgraph.title2'),
				'icon'=>HREF.'images/streets.gif',
				'grid_boot'=>BOOT.'tech_zones/distr/grid.php',
				'form_boot'=>BOOT.'tech_zones/distr/form.php',
			));
			
			break;
		case 'times':
			$times = new PTable($db,BOOT.'tech_zones/times/table.php');
			$times->readonly = !$oper->system_access['jobs'];
				$doc->page->contents['workgraph3'] = new PMyAccess($times,array(
					'title'=>getResource('workgraph.title3'),
					'icon'=>HREF.'images/streets.gif',
					'grid_boot'=>BOOT.'tech_zones/times/grid.php',
					'form_boot'=>BOOT.'tech_zones/times/form.php',
				));
			break;
		case 'types':
			loadStrings(BOOT.'tech_zones/job_types/strings.txt');
			loadStrings(BOOT.'jobs/strings.txt');
			$types = new PTable($db,BOOT.'tech_zones/job_types/table.php');
			$types->readonly = !$oper->system_access['jobs'];
				$doc->page->contents['workgraph3'] = new PMyAccess($types,array(
					'title'=>getResource('tech.zone.job.types.title'),
					'icon'=>HREF.'images/streets.gif',
					'grid_boot'=>BOOT.'tech_zones/job_types/grid.php',
					'form_boot'=>BOOT.'tech_zones/job_types/form.php',
				));
			break;
	}
}	
echo $doc->Paint();


?>