#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$db = $beanFactory->getBean('connection');

$modems = array();
$sel = $db->select("SELECT id, name FROM modems");
while($arr = $sel->next()){
	$modems[$arr['name']] = $arr['id'];
	$cmd = sprintf("/var/www/cacti/cli/add_device.php --description=%s --ip=%s.lanet --template=9 --avail=snmp --version=2 --quiet",
		$arr['name'], $arr['name']);
	exec($cmd);
}

$cmd = "/var/www/cacti/cli/add_graphs.php --list-hosts";
if($p = popen($cmd, "r")){
	while (!feof($p)) {
        $line = trim(fgets($p, 64));
		if($line){
			$arr = preg_split("|\s+|", $line);
			if(isset($modems[$arr[3]])){
				//printf("%s: %s\n", $arr[3], $arr[0]);
				$db->update("UPDATE modems SET cacti_id=%s WHERE id=%s", $arr[0], $modems[$arr[3]]);
				$cmd = sprintf('/var/www/cacti/cli/add_graphs.php --graph-type=ds --graph-template-id=35 --host-id=%s --snmp-query-id=1 --snmp-query-type-id=23 --snmp-field=ifType --snmp-value="ethernetCsmacd(6)" --quiet',
					$arr[0]);
				exec($cmd);
			}
		}
    }
	pclose($p);
}
?>