#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
 */
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.acl3');

$logger->info("BEGIN");

$tftp_server = '194.50.85.2'; //ip2long(implode('.', array_reverse(explode('.', '194.50.85.1'))));

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
);

$options = array(
	'destination' => '/var/lib/tftpboot/',
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
	'http-timeout' => '10',
	'http-user' => 'security',
	'http-password' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

function _snmpset($oid, $type, $value){
	global $options, $modem;
	$result = snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
	if(!$result){
		echo "failed snmpset: ".$modem['ip']." ".$oid." ".$type." ".$value."\n";
	}
	return $result;
}

function countLevel($id){
	global $modems;
	$modem = $modems[$id];
	if($parent = $modem['modem']){
		return countLevel($parent) + 1;
	}else{
		return 0;
	}
}

function compareByLevelDesc($m1, $m2){
	return $m2['level'] - $m1['level'];
}

// rich+

$debug = false;
$verbose = true;

$tftp_server_ip = '10.0.0.2';

$addon_script = '/var/www/html/stat/tools/modems-fix-acl3.sh';
$tmp_file_name='sw-tmp-DONT-REMOVE.txt';
$backdir='/var/lib/tftpboot/back';

function execInBackground($cmd) {
	exec($cmd . " > /dev/null &");  
}
// rich-

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');

$it = $dao->iterator();

$modems = array();
while($modem = $it->next()){
	$modems[$modem['id']] = $modem;
}
foreach($modems as $id=>$modem){
	$modems[$id]['level'] = countLevel($id);
}
usort($modems, 'compareByLevelDesc');

$modemN=0;
foreach($modems as $modem){
	if($modem['model']=='ES3528M' || $modem['model']=='ES3552M'){
	//if($modem['ip']=='10.0.0.4'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
				$oid = array(
					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.1.7.0',
					'config_src'=>$model_oid.".1.24.1.1.0",
					'config_dst'=>$model_oid.".1.24.1.3.0",
					'config_dst_name'=>$model_oid.".1.24.1.4.0",
					'config_action'=>$model_oid.".1.24.1.8.0"
				);

				$cfg_name = $modem['name'].'-confg';

				$success = true;
				$modemN+=1;

				/*
				 * CLI analog of 'copy running-config tftp'
				 */

				
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.1.0', 'i', 2); // runningCfg
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.3.0', 'i', 4); // tftp
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.4.0', 's', $tmp_file_name); // filename
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.6.0', 'a', $tftp_server_ip); // tftp server
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.8.0', 'i', 2); // copy

				if (!$success){
					$logger->error("edge %s ($modemN): copying runnung-config to $tftp_server_ip failed", $modem['name'].".lanet");
					continue;
				}

				// Wait for notCopying(1) status
				while ( 1 != @snmpget($modem['ip'], $options['snmp-reader'], "ES3528MO-MIB::fileCopyMgt.8.0", $options['snmp-timeout'], $options['snmp-retries'])){
					sleep(1);
				}				
				sleep(2);

				$client_vlans='';
				foreach (split("\r",$modem['address_space']) as $i){
					$client_vlans.=substr(strstr($i,':'),1).',';
				}
				$client_vlans=substr($client_vlans,0,-1);
				exec("/bin/cp /var/lib/tftpboot/".$tmp_file_name." ".$backdir."/".$cfg_name);

				/*
				 * Do necessary changes
				 */
				
				$addon_str=$addon_script.' /var/lib/tftpboot/'.$tmp_file_name.' /var/lib/tftpboot/'.$cfg_name." ".$client_vlans;
				exec($addon_str);

				/*
				 * CLI analog of 'copy tftp startup-config'
				 */

				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.1.0', 'i', 4); // from tftp
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.2.0', 's', $cfg_name); // filename
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.3.0', 'i', 3); // to startup-config
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.4.0', 's', $cfg_name); // filename
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.6.0', 'a', $tftp_server_ip); // tftp server
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.8.0', 'i', 2); // copy

				if (!$success){
					$logger->error("edge %s ($modemN): copying config from $tftp_server_ip to startup-config failed", $modem['name'].".lanet");
					continue;
				}

				// Wait for notCopying(1) status
				while ( 1 != @snmpget($modem['ip'], $options['snmp-reader'], "ES3528MO-MIB::fileCopyMgt.8.0", $options['snmp-timeout'], $options['snmp-retries'])){
					sleep(1);
				}

				$sw=$modem['ip'];
				execInBackground("/var/www/html/stat/tools/modems-fix-acl3-reload.sh $sw");

				/*sleep(10);

				/*
				 * CLI analog of 'copy startup-config running-config'
				 */
/*
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.1.0', 'i', 3); // from startUpCfg
				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.3.0', 'i', 2); // to runningCfg
 				$success &= _snmpset('ES3528MO-MIB::fileCopyMgt.8.0', 'i', 2); // copy
 */
				// Reboot
/*
				$success &= _snmpset('ES3528MO-MIB::restartControl.0', 'i', 2);
				 */
				if (!$success){
					$logger->error("edge %s ($modemN): copying starup-config to runnung-config failed", $modem['name'].".lanet");
					continue;
				}

				if ($success){
					$logger->info("edge %s ($modemN): OK", $modem['name'].".lanet");
				}
				//break;
			}
		}else {
			$logger->error("edge %s ($modemN): no answer", $modem['name']);
		}
	}
}
$logger->info("END");

?>
