#!/bin/bash

line_separator='?'
config_addons_file='/var/www/html/stat/tools/modems-fix-acl-confg'

working_file1='/tmp/sw-working1'
working_file2='/tmp/sw-working2'
search_pattern1='/tmp/sw-working3'
search_pattern2='/tmp/sw-working4'

# CHECKING FOR CORRECT INPUT VALUE
src_file=$1
dest_file=$2
client_vlans=$3

if [ -z $src_file ] || [ -z $dest_file ] || [ -z $client_vlans ]; then
	echo "Not enough actual parameters"
	echo "This script should be running only from modems-fix-acl3.php"
	exit
fi

PATH=$PATH:/bin:/sbin:/usr/sbin:/sur/sbin
export PATH

function GET_CLIENT_VLANS {
  for i in `echo $client_vlans|tr ',' ' '`; do
	  echo "match vlan ${i}\\"
	done
}

#function STRIP_ALL {
#	cat $1|tr '\n' $line_separator > $2
#	sed "s/\s\s\+/ /g" -i $2
#}
#
#function CREATE_SED {
#	for((i=0; i < ${#ADD[*]}; ++i)); do
#		echo ----------------------1------------
#		echo sed -n \'
#		if [ "$i" == 0 ]; then
#			echo "/${ADD[$i]}/ {"
#		else
#			if [ "$i" == ${#ADD[*]} ]; then
#				echo "/\n\s*${ADD[$i]}/ d"
#			else
#				echo "/\n\s*${ADD[$i]}/ {"
#			fi
#		fi
#	done
#}
#
#. $config_addons_file
#
#cfg=/tmp/sw-blg-5-2-confg

#STRIP_ALL $cfg $working_file1
#STRIP_ALL $cfg $working_file2

#for((i=0; i < ${#REMOVE[*]}; ++i)); do
#	echo ${REMOVE[$i]} > $search_pattern1
#	STRIP_ALL:
#	sed_r_cmd="s/${REMOVE[$i]}/!/g"
#	STRIP_ALL 
#	sed_a_cmd="s/${ADD[$i]}/!/g"
#
#	sed -e "$sed_r_cmd" -i $working_file1
#	sed -e "$sed_a_cmd" -i $working_file2
	#cfg_a=`cat $working_file1|sed -e "$sed_a_cmd"`
	#echo $cfg_r
	#echo $cfg_a
	#sed_cmd="s/${REMOVE[$i]}/!/g"
	#sed $sed_cmd -i $working_file1
#done
#  diff $working_file1 $working_file2

#cat $working_file1|tr $line_separator '\n'

#Convert all EoF symbols to $line_separator
cat $src_file|tr '\n' $line_separator > $working_file1

# Remove unnecessary lines
sed 's/queue\s*mode[^!]*!/!/g' -i $working_file1
sed 's/access-list ip[^!]*!/!/g' -i $working_file1
sed 's/class-map[^!]*!/!/g' -i $working_file1
sed 's/policy-map[^!]*!/!/g' -i $working_file1

# Remove empty lines and return EoL symbols
sed "s/\(!$line_separator\)\+/!$line_separator/g" -i $working_file1
sed "s/\($line_separator\)/\n/g" -i $working_file1

# Insert config
confg=`cat $config_addons_file`
sed "/^hostname.*/a\
$confg" -i $working_file1

confg='!\
queue mode strict\
!'
sed "/^snmp-server contact.*/a\
$confg" -i $working_file1

# Insert correct client vlans
client_vlans=`GET_CLIENT_VLANS`
if [ "$client_vlans" == "" ]; then
	client_vlans='match vlan 11'
fi
sed "/__GET_CLIENT_VLANS__/c\
$client_vlans" -i $working_file1
sed 's/^match vlan/ &/;s/\\//g' -i $working_file1

cp $working_file1 $dest_file 
#&& rm $working_file1
#rm $working_file2
