#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
 */
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.acl2');

$logger->info("BEGIN");

$tftp_server = '194.50.85.2'; //ip2long(implode('.', array_reverse(explode('.', '194.50.85.1'))));

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
);

$options = array(
	'destination' => '/var/lib/tftpboot/',
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
	'http-timeout' => '10',
	'http-user' => 'security',
	'http-password' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

function _snmpset($oid, $type, $value){
	global $options, $modem;
	$result = snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
	if(!$result){
		echo "failed snmpset: ".$modem['ip']." ".$oid." ".$type." ".$value."\n";
	}
	return $result;
}

function countLevel($id){
	global $modems;
	$modem = $modems[$id];
	if($parent = $modem['modem']){
		return countLevel($parent) + 1;
	}else{
		return 0;
	}
}

function compareByLevelDesc($m1, $m2){
	return $m2['level'] - $m1['level'];
}

// rich+

/*************************
* Used MIB variables
* **********************/

$base_oid = ".1.3.6.1.4.1.259.6.10.94";
$acl_oid = $base_oid.".1.16.4.15.1"; // ES3528MO-MIB::diffServAclEntry
$ipace_oid = $base_oid.".1.16.4.17.1"; // ES3528MO-MIB::diffServIpAceEntry
$macace_oid = $base_oid.".1.16.4.18.1"; // ES3528MO-MIB::DiffServMacAceEntry
$classmap_oid = $base_oid.".1.16.4.13.1"; // ES3528MO-MIB::diffServClassMapEntry
$policymap_oid = $base_oid.".1.16.4.10.1"; // ES3528MO-MIB::diffServPolicyMapEntry
$dsrv_action_oid = $base_oid.".1.16.4.19.1"; // ES3528MO-MIB::diffServActionEntry
$dsrv_meter_oid = $base_oid.".1.16.4.20.1"; // ES3528MO-MIB::diffServMeterEntry
$policy_element_oid = $base_oid.".1.16.4.12.1"; // diffServPolicyMapElementEntry


function getRecordsCount($OIDbranch){
	extract($GLOBALS);

	return count (snmpwalkoid($modem['ip'], "security", $OIDbranch));
}

// rich -

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');

$it = $dao->iterator();

$modems = array();
while($modem = $it->next()){
	$modems[$modem['id']] = $modem;
}
foreach($modems as $id=>$modem){
	$modems[$id]['level'] = countLevel($id);
}
usort($modems, 'compareByLevelDesc');

foreach($modems as $modem){
	if($modem['model']=='ES3528M' || $modem['model']=='ES3552M'){
	//if($modem['ip']=='194.50.85.64'){
	//if($modem['ip']=='10.0.10.127'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
				$oid = array(
					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.1.7.0',
					'config_src'=>$model_oid.".1.24.1.1.0",
					'config_dst'=>$model_oid.".1.24.1.3.0",
					'config_dst_name'=>$model_oid.".1.24.1.4.0",
					'config_action'=>$model_oid.".1.24.1.8.0"
				);
				$cfg_name = $modem['name'].'-confg';

				$success = true;


				// Delete Ip SourceGuard entries for vlan 11
				$a = snmpwalkoid($modem['ip'], "security", "ES3528MO-MIB::ipSrcGuardBindingsStatus.11");
				foreach (array_keys($a,'1') as $i)
				{
					$success &= _snmpset($i, 'i', 6);					
				}

				continue

				// DELETING vlan 11
				$oidvalue = @snmpget($modem['ip'], $options['snmp-reader'], "Q-BRIDGE-MIB::dot1qVlanStaticRowStatus.11", $options['snmp-timeout'], $options['snmp-retries']);
				if ( $oidvalue != '' )
				{
					echo $modem['name']."lanet processing\n";
					$success &= _snmpset("Q-BRIDGE-MIB::dot1qVlanStaticRowStatus.11", 'i', 6);
				}
				continue

				// Get Vlan11 ungatted ports
				$oidvalue = @snmpget($modem['ip'], $options['snmp-reader'], "Q-BRIDGE-MIB::dot1qVlanStaticUntaggedPorts.11", $options['snmp-timeout'], $options['snmp-retries']);
				$untagged_vlan11=unpack("H*",$oidvalue); $untagged_vlan11=$untagged_vlan11[1];

				if ($untagged_vlan11 == '0000000000000000' or $untagged_vlan11 == ''){
					continue;
				}
				
				echo $modem['name']." processing\n";
				$oidvalue = @snmpget($modem['ip'], $options['snmp-reader'], "Q-BRIDGE-MIB::dot1qVlanStaticUntaggedPorts.2", $options['snmp-timeout'], $options['snmp-retries']);
				$untagged_vlan2=unpack("H*",$oidvalue); $untagged_vlan2=$untagged_vlan2[1];

				$new_vlan2 = '';
				$a1 = str_split($untagged_vlan11,2);
				$a2 = str_split($untagged_vlan2,2);

				for ($i = 0; $i < 8; $i++) {
//					echo $a1[$i]."\n";
	//				echo $a2[$i]."\n";
					$new_vlan2.=str_pad(dechex((hexdec($a1[$i])) | (hexdec($a2[$i]))),2,'0',STR_PAD_LEFT);
		//			echo $new_vlan2."\n\n";
				}

//				echo $new_vlan2;

				// Set old vlan11 ports to vlan 2
				$success &= _snmpset("Q-BRIDGE-MIB::dot1qVlanStaticUntaggedPorts.2", 'x', $new_vlan2);

				// If port PVID is equal to 11, set it to 2
				$a = snmpwalkoid($modem['ip'], "security", "Q-BRIDGE-MIB::dot1qPvid");
				foreach (array_keys($a,'11') as $i) {
					$success &= _snmpset($i, 'u', 2);
				}
				
				// Remove untagged 11 Vlan from interfaces and replace it with vlan 2


				// Unset all vlan11 ports
//			$success &= _snmpset("Q-BRIDGE-MIB::dot1qVlanStaticUntaggedPorts.11", 'x', '0000000000000000');
				$success &= _snmpset("Q-BRIDGE-MIB::dot1qVlanStaticEgressPorts.11", 'x', '0000000000000000');

	
//				$oidvalue = @snmpget($modem['ip'], $options['snmp-reader'], "Q-BRIDGE-MIB::dot1qVlanStaticUntaggedPorts.11", $options['snmp-timeout'], $options['snmp-retries']);
//				$untagged_ports=unpack("H*",$oidvalue); $untagged_ports=$untagged_ports[1];
//
//				$portOctet=1;
//				$portBin = '';
//				foreach (str_split($untagged_ports,2) as $i) {
//					$portBin = base_convert($i,16,2);
//					$portBin = str_pad($portBin, 8, "0", STR_PAD_LEFT); 
//					for ($j = 0; $j < strlen($portBin); $j++){
//						if ($portBin[$j] == 1){
//							$portN = $j+($portOctet);
//
//						}
//					}
//					$portOctet=$portOctet + 8;
//				};

//				continue
				continue;

				// Look for diffServMacAceMinVid == 11
				$a = snmpwalkoid($modem['ip'], "security", "ES3528MO-MIB::diffServMacAceEntry.9");
				$vlan11_id = substr(array_search('11', $a),39);
				echo $vlan11_id." - ".$modem['name']."\n";
				continue;


				$a = snmpwalkoid($modem['ip'], "security", "ES3528MO-MIB::diffServClassMapEntry.2");
				$classmap_id = substr(array_search('CLIENT_VLANS', $a), 39);

				if ($classmap_id != '' && $vlan11_id != '') {
					echo $modem['name']." in work\n";

					$success &= _snmpset('ES3528MO-MIB::diffServClassMapAttachCtl.1.0', 'i', $classmap_id);
					$success &= _snmpset('ES3528MO-MIB::diffServClassMapAttachCtl.2.0', 'i', 1);
					$success &= _snmpset('ES3528MO-MIB::diffServClassMapAttachCtl.3.0', 'i', $vlan11_id);
					$success &= _snmpset('ES3528MO-MIB::diffServClassMapAttachCtl.4.0', 'i', 3);

					// ATTACH VLANS FROM $modem['address_space'] to VLAN CLASSMAP CLIENTS_VLAN (3)

					$last_ace_id = getRecordsCount("ES3528MO-MIB::diffServMacAceStatus")+getRecordsCount("ES3528MO-MIB::diffServIpAceStatus")+1;

					foreach (split("\r",$modem['address_space']) as $i){
						$vlan_id = substr(strstr($i,':'),1);

						$success &= _snmpset($macace_oid.'.16.'.$last_ace_id, 'i', 5);
						$success &= _snmpset($macace_oid.'.2.'.$last_ace_id, 'i', 1);
						$success &= _snmpset($macace_oid.'.3.'.$last_ace_id, 'i', 1);
						$success &= _snmpset($macace_oid.'.8.'.$last_ace_id, 'i', 2);
						$success &= _snmpset($macace_oid.'.9.'.$last_ace_id, 'i', $vlan_id); //Vlan id
						$success &= _snmpset($macace_oid.'.16.'.$last_ace_id, 'i', 1);

						$success &= _snmpset('ES3528MO-MIB::diffServClassMapAttachCtl.1.0', 'i', $classmap_id);
						$success &= _snmpset('ES3528MO-MIB::diffServClassMapAttachCtl.2.0', 'i', 1);
						$success &= _snmpset('ES3528MO-MIB::diffServClassMapAttachCtl.3.0', 'i', $last_ace_id);
						$success &= _snmpset('ES3528MO-MIB::diffServClassMapAttachCtl.4.0', 'i', 2);

						$last_ace_id+=1;
					}
				}

				//break;
			}
		}else {
			$logger->error("edge %s: no answer", $modem['name']);
		}
	}
}
$logger->info("END");

?>
