#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;

error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');

include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));

$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.fix.oid');

$logger->info("BEGIN");

$tftp_server = '10.0.0.2';

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.10.1.27.101'=>'ES3510-28T',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
    '.1.3.6.1.4.1.259.10.1.27'=>'ES3510-28T',

);

$options = array(
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

function _snmpset($oid, $type, $value){
	global $options, $modem;
	return snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
}

function countLevel($id){
	global $modems;
	$modem = $modems[$id];
	if($parent = $modem['modem']){
		return countLevel($parent) + 1;
	}else{
		return 0;
	}
}

function compareByLevelDesc($m1, $m2){
	return $m2['level'] - $m1['level'];
}

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');

$it = $dao->iterator();

$modems = array();

while($modem = $it->next()){
	$modems[$modem['id']] = $modem;
}
foreach($modems as $id=>$modem){
	$modems[$id]['level'] = countLevel($id);
}

usort($modems, 'compareByLevelDesc');

foreach($modems as $modem){
	if($modem['model']=='ES3528M' || $modem['model']=='ES3552M'){
//	if(($modem['model']=='ES3528M' || $modem['model']=='ES3552M') && $modem['firmware']=='1.3.7.1'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
				$oid = array(
					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.1.7.0',
					'config_src'=>$model_oid.".1.24.1.1.0",
					'config_dst'=>$model_oid.".1.24.1.3.0",
					'config_dst_name'=>$model_oid.".1.24.1.4.0",
					'config_action'=>$model_oid.".1.24.1.8.0"
				);
				$cfg_name = $modem['name'].'-confg';
				$success = true;
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.1.7.0', 'i', 2);														// disable jumbo frames
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.10.2.0', 'a', '10.0.0.241');												// set default gateway
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.19.1.0', 'i', 2);														// disable syslog
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.19.6.1.0', 'i', 2);														// disable remote syslog
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.19.7.1.0', 'i', 2);														// disable sendmail log
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.1.1.0', 'i', 1);														// enabled sntp
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.1.3.0', 'i', 16384);													// set sntp sync period
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.1.4.1.2.1', 'a', '10.0.0.2');												// set sntp sync period
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.5.1.0', 'i', 2);														// disable ntp
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.6.0', 'i', 22004);													// set Kiev timezone
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.1.0', 'i', 4);														// set src tftp
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.2.0', 's', 'ES3528_52M_loader_1.0.2.0.bin');										// set src filename
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.3.0', 'i', 1);														// set dst file
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.4.0', 's', 'ES3528_52M_loader_1.0.2.0.bin');										// set dst filename
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.5.0', 'i', 5);														// set dst type opcode
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.6.0', 'a', '10.0.0.2');												// set src tftp address
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.8.0', 'i', 2);														// start copy
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.4.0.69.83.51.53.50.56.95.53.50.77.95.49.46.51.46.55.46.49.46.98.105.120', 'i', 1);					// set startup ES3528_52M_1.3.7.1.bix
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.4.0.69.83.51.53.50.56.95.53.50.77.95.100.105.97.103.95.49.46.50.46.48.46.49.46.98.105.120', 'i', 1);		// set startup ES3528_52M_diag_1.2.0.1.bix
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.111.112.49.46.98.105.120', 'i', 2);										// delete op1.bix
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.69.83.51.53.50.56.95.53.50.77.95.49.46.49.46.51.46.56.46.98.105.120', 'i', 2);					// delete ES3528_52M_1.1.3.8.bix
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.69.83.51.53.50.56.95.53.50.77.95.49.46.51.46.52.46.50.46.98.105.120', 'i', 2);					// delete ES3528_52M_1.3.4.2.bix
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.69.83.51.53.50.56.95.53.50.77.95.111.112.99.111.100.101.95.86.49.46.49.46.51.46.52.46.98.105.120', 'i', 2);	// delete ES3528_52M_opcode_V1.1.3.4.bix
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.69.83.51.53.50.56.95.53.50.77.95.100.105.97.103.95.86.49.46.48.46.48.46.56.46.98.105.120', 'i', 2);		// delete ES3528_52M_diag_V1.0.0.8.bix
				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.47.1.0', 'i', 2);														// disable cluster

//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.7.3.0', 'i', 3);														// hard reboot

//				$success &= _snmpset('1.3.6.1.2.1.17.7.1.4.3.1.5.4093', 'i', 6);															// delete vlan 4093

/*				if($modem['uplink']){
//					$inutil = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::enterprises.259.6.10.94.1.2.6.1.2.".$modem['uplink'], $options['snmp-timeout'], $options['snmp-retries']);	// Collisions
//					$collisions = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::mib-2.16.1.1.1.13.".$modem['uplink'], $options['snmp-timeout'], $options['snmp-retries']);		// Collisions
//					$cpu = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::enterprises.259.6.10.94.1.39.2.3.0", $options['snmp-timeout'], $options['snmp-retries']);			// CPU utilisation
				}
*/
				if(
					$success
//					&& $inutil
//					&& $collisions
//					&& $cpu

//					&& _snmpset($oid['set'], 'i', 1)
					&& _snmpset($oid['config_src'], 'i', 2)
					&& _snmpset($oid['config_dst'], 'i', 3)
					&& _snmpset($oid['config_dst_name'], 's', $cfg_name)
					&& _snmpset($oid['config_action'], 'i', 2)
				){
//					echo "./add_device.php --description=".$modem['name']." --ip=".$modem['name'].".lanet --template=9 --avail=snmp --version=2\n";
					$logger->info("edge %s: ok (level %d)", $modem['name'], $modem['level']);
//					$logger->info("edge %s: uplink port %d utilisation: %d", $modem['name'], $modem['uplink'], $inutil);
//					$logger->info("edge %s: uplink port %d collisions: %d", $modem['name'], $modem['uplink'], $collisions);
//					$logger->info("edge %s: CPU utilisation: %d", $modem['name'], $cpu);
				}else{
					$logger->error("edge %s: failed", $modem['name']);
				}
			}
		}else{
			$logger->error("edge %s: no answer", $modem['name']);
		}
	}
/*
   if($modem['model']=='ES3510-28T'){
// if(($modem['model']=='ES3528M' || $modem['model']=='ES3552M') && $modem['firmware']=='1.3.7.1'){
       $model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
       if($model_oid){
           if(isset($edgecore_models[$model_oid])){
               $oid = array(
                   'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.1.7.0',
                  'config_src'=>$model_oid.".1.24.1.1.0",
                   'config_dst'=>$model_oid.".1.24.1.3.0",
                   'config_dst_name'=>$model_oid.".1.24.1.4.0",
                   'config_action'=>$model_oid.".1.24.1.8.0"
               );
               $cfg_name = $modem['name'].'-confg';
               $success = true;
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.1.7.0', 'i', 2);                                                        // disable jumbo frames
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.10.2.0', 'a', '10.0.0.241');                                                // set default gateway
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.19.1.0', 'i', 2);                                                       // disable syslog
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.19.6.1.0', 'i', 2);                                                     // disable remote syslog
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.19.7.1.0', 'i', 2);                                                     // disable sendmail log
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.1.1.0', 'i', 1);                                                     // enabled sntp
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.1.3.0', 'i', 16384);                                                 // set sntp sync period
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.1.4.1.2.1', 'a', '10.0.0.2');                                                // set sntp sync period
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.5.1.0', 'i', 2);                                                     // disable ntp
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.23.6.0', 'i', 22004);                                                   // set Kiev timezone
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.1.0', 'i', 4);                                                     // set src tftp
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.2.0', 's', 'ES3528_52M_loader_1.0.2.0.bin');                                       // set src filename
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.3.0', 'i', 1);                                                     // set dst file
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.4.0', 's', 'ES3528_52M_loader_1.0.2.0.bin');                                       // set dst filename
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.5.0', 'i', 5);                                                     // set dst type opcode
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.6.0', 'a', '10.0.0.2');                                                // set src tftp address
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.1.8.0', 'i', 2);                                                     // start copy
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.4.0.69.83.51.53.50.56.95.53.50.77.95.49.46.51.46.55.46.49.46.98.105.120', 'i', 1);                 // set startup ES3528_52M_1.3.7.1.bix
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.4.0.69.83.51.53.50.56.95.53.50.77.95.100.105.97.103.95.49.46.50.46.48.46.49.46.98.105.120', 'i', 1);       // set startup ES3528_52M_diag_1.2.0.1.bix
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.111.112.49.46.98.105.120', 'i', 2);                                        // delete op1.bix
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.69.83.51.53.50.56.95.53.50.77.95.49.46.49.46.51.46.56.46.98.105.120', 'i', 2);                 // delete ES3528_52M_1.1.3.8.bix
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.69.83.51.53.50.56.95.53.50.77.95.49.46.51.46.52.46.50.46.98.105.120', 'i', 2);                 // delete ES3528_52M_1.3.4.2.bix
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.69.83.51.53.50.56.95.53.50.77.95.111.112.99.111.100.101.95.86.49.46.49.46.51.46.52.46.98.105.120', 'i', 2);    // delete ES3528_52M_opcode_V1.1.3.4.
//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.24.2.1.1.7.0.69.83.51.53.50.56.95.53.50.77.95.100.105.97.103.95.86.49.46.48.46.48.46.56.46.98.105.120', 'i', 2);        // delete ES3528_52M_diag_V1.0.0.8.bix
               $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.47.1.0', 'i', 2);                                                       // disable cluster

//             $success &= _snmpset('SNMPv2-SMI::enterprises.259.6.10.94.1.7.3.0', 'i', 3);                                                        // hard reboot

//             $success &= _snmpset('1.3.6.1.2.1.17.7.1.4.3.1.5.4093', 'i', 6);                                                            // delete vlan 4093
*/

/*             if($modem['uplink']){
//                 $inutil = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::enterprises.259.6.10.94.1.2.6.1.2.".$modem['uplink'], $options['snmp-timeout'], $options['snmp-retries']);   // Collisions
//                 $collisions = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::mib-2.16.1.1.1.13.".$modem['uplink'], $options['snmp-timeout'], $options['snmp-retries']);       // Collisions
//                 $cpu = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::enterprises.259.6.10.94.1.39.2.3.0", $options['snmp-timeout'], $options['snmp-retries']);           // CPU utilisation
               }
*/
/*
               if(
                   $success
//                 && $inutil
//                 && $collisions
//                 && $cpu

//                 && _snmpset($oid['set'], 'i', 1)
                   && _snmpset($oid['config_src'], 'i', 2)
                   && _snmpset($oid['config_dst'], 'i', 3)
                   && _snmpset($oid['config_dst_name'], 's', $cfg_name)
                   && _snmpset($oid['config_action'], 'i', 2)
               ){
//                 echo "./add_device.php --description=".$modem['name']." --ip=".$modem['name'].".lanet --template=9 --avail=snmp --version=2\n";
                   $logger->info("edge %s: ok (level %d)", $modem['name'], $modem['level']);
//                 $logger->info("edge %s: uplink port %d utilisation: %d", $modem['name'], $modem['uplink'], $inutil);
//                 $logger->info("edge %s: uplink port %d collisions: %d", $modem['name'], $modem['uplink'], $collisions);
//                 $logger->info("edge %s: CPU utilisation: %d", $modem['name'], $cpu);
               }else{
                   $logger->error("edge %s: failed", $modem['name']);
               }
           }
       }else{
           $logger->error("edge %s: no answer", $modem['name']);
       }
   }

*/



	if($modem['model']=='ES3510' && $modem['firmware']='1.1.0.26'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
				$oid = array(
					'set'=>'SNMPv2-SMI::enterprises.259.8.1.5.1.1.7.0',
					'config_src'=>$model_oid.".1.24.1.1.0",
					'config_dst'=>$model_oid.".1.24.1.3.0",
					'config_dst_name'=>$model_oid.".1.24.1.4.0",
					'config_action'=>$model_oid.".1.24.1.8.0"
				);
				$cfg_name = $modem['name'].'-confg';
				$success = true;
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.7.3.0', 'i', 3);														// hard reboot

//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.10.2.0', 'a', '10.0.0.241');													// set default gateway

//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.23.1.1.0', 'i', 1);														// enabled sntp
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.23.1.3.0', 'i', 16384);													// set sntp sync period
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.23.1.4.1.2.1', 'a', '10.0.0.2');												// set sntp sync period
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.23.5.1.0', 'i', 2);														// disable ntp

//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.24.1.1.0', 'i', 4);														// set src tftp
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.24.1.2.0', 's', 'ES3510_26XA-2_1.1.0.26.bix');										// set src filename
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.24.1.3.0', 'i', 1);														// set dst file
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.24.1.4.0', 's', 'ES3510_26XA-2_1.1.0.26.bix');										// set dst filename
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.24.1.5.0', 'i', 1);														// set dst type opcode
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.24.1.6.0', 'a', '10.0.0.2');													// set src tftp address
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.24.1.8.0', 'i', 2);														// start copy
//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.24.2.1.1.4.0.69.83.51.53.49.48.95.50.54.88.65.45.50.95.49.46.49.46.48.46.50.54.46.98.105.120', 'i', 1);			// set startup ES3510_26XA-2_1.1.0.26.bix

//				$success &= _snmpset('SNMPv2-SMI::enterprises.259.8.1.5.1.47.1.0', 'i', 2);														// disable cluster
				if(
					$success
//					&& _snmpset($oid['set'], 'i', 1)
//					&& _snmpset($oid['config_src'], 'i', 2)
//					&& _snmpset($oid['config_dst'], 'i', 3)
//					&& _snmpset($oid['config_dst_name'], 's', $cfg_name)
//					&& _snmpset($oid['config_action'], 'i', 2)
				){
					$logger->info("edge %s: ok", $modem['name']);
				}else{
					$logger->error("edge %s: failed", $modem['name']);
				}
			}
		}else{
			$logger->error("edge %s: no answer", $modem['name']);
		}
	}
}
$logger->info("END");

?>
