#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
 */
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.del.acl');

$logger->info("BEGIN");

$tftp_server = '194.50.85.2'; //ip2long(implode('.', array_reverse(explode('.', '194.50.85.1'))));

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
);

$options = array(
	'destination' => '/var/lib/tftpboot/',
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
	'http-timeout' => '10',
	'http-user' => 'security',
	'http-password' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

function _snmpset($oid, $type, $value){
	global $options, $modem;
	$result = snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
	if(!$result){
	    echo "failed snmpset: ".$modem['ip']." ".$oid." ".$type." ".$value."\n";
	}
	return $result;
}

function countLevel($id){
	global $modems;
	$modem = $modems[$id];
	if($parent = $modem['modem']){
		return countLevel($parent) + 1;
	}else{
		return 0;
	}
}

function compareByLevelDesc($m1, $m2){
	return $m2['level'] - $m1['level'];
}

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');

$it = $dao->iterator();

$modems = array();
while($modem = $it->next()){
	$modems[$modem['id']] = $modem;
}
foreach($modems as $id=>$modem){
	$modems[$id]['level'] = countLevel($id);
}
usort($modems, 'compareByLevelDesc');

foreach($modems as $modem){
	if($modem['model']=='ES3528M' || $modem['model']=='ES3552M'){
	//if($modem['ip']=='10.0.0.4'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
				$oid = array(
					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.1.7.0',
					'config_src'=>$model_oid.".1.24.1.1.0",
					'config_dst'=>$model_oid.".1.24.1.3.0",
					'config_dst_name'=>$model_oid.".1.24.1.4.0",
					'config_action'=>$model_oid.".1.24.1.8.0"
				);
				$cfg_name = $modem['name'].'-confg';

				$base_oid = ".1.3.6.1.4.1.259.6.10.94";
				$subvlan_oid = $base_oid.".1.12.13.1"; // ES3528MO-MIB::subnetVlanEntry

				$success = true;
				$debug = true;

				/*************************
				 * CLEARING SubnetVlan Table
				 * ***********************/

				if ( $debug ) { print "SubnetVlan clearing\n";}
				$success &= _snmpset('.1.3.6.1.4.1.259.6.10.94.1.12.14.0', 'i', 2);

				/*************************
				 * SUBNETVLAN TABLE CREATING
				 * ( raise error when IP/mask pair is not reasonable )
				 *************************/

				// Entry 1
				/*
				$subip_list = array('192.168.0.0/255.255.255.0:77', '100.100.0.0/255.255.255.0:33');

				foreach ($subip_list as $i) {
					if ( $debug ) { print "Entry $i\n";}
					$subip = substr($i,0,strpos($i,'/'));	$subvlan = substr(strstr($i,':'),1);
					$submask = substr(strstr($i,'/'),1); $submask = substr($submask,0,strpos($submask,$subvlan)-1);
					
					$success &= _snmpset($subvlan_oid.".5.".$submask.".".$subip, 'i', 1);
					$success &= _snmpset($subvlan_oid.'.3.'.$submask.'.'.$subip, 'i', $subvlan);
				}

				if( $success ){
					$logger->info("edge %s: ok", $modem['name'].'.lanet');
				}else{
					$logger->error("edge %s: failed", $modem['name'].'.lanet');
				}
				 */
				//break;
			}
		}else {
			$logger->error("edge %s: no answer", $modem['name']);
		}
	}
}
$logger->info("END");

?>
