#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.fix.cable');

$logger->info("BEGIN");

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
);

$options = array(
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

function _snmpset($oid, $type, $value){
	global $options, $modem;
	return snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
}

function countLevel($id){
	global $modems;
	$modem = $modems[$id];
	if($parent = $modem['modem']){
		return countLevel($parent) + 1;
	}else{
		return 0;
	}
}

function compareByLevelDesc($m1, $m2){
	return $m2['level'] - $m1['level'];
}

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');
$hostsDao = $beanFactory->getBean('hostsDAO');

$it = $dao->iterator();

$modems = array();
while($modem = $it->next()){
	$modems[$modem['id']] = $modem;
}
foreach($modems as $id=>$modem){
	$modems[$id]['level'] = countLevel($id);
}
usort($modems, 'compareByLevelDesc');

foreach($modems as $modem){
	if($modem['model']=='ES3528M' || $modem['model']=='ES3552M'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
				$name = true;
				$number = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::enterprises.259.6.10.94.1.1.3.1.7.1", $options['snmp-timeout'], $options['snmp-retries']);			// get port number
				for($index = $number-3; $index <= $number; $index++){
					$status = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.2.2.1.8.".$index, $options['snmp-timeout'], $options['snmp-retries']);					// get port operstatus
					if($status == 1){
						$type = @snmpget($modem['ip'], $options['snmp-reader'], "SNMPv2-SMI::enterprises.259.6.10.94.1.2.1.1.3.".$index, $options['snmp-timeout'], $options['snmp-retries']);	// get port type
						if($name && $type != 8){
							echo $modem['name']."\t".$modem['ip']."\t".$index;
							$name = false;
						}elseif($type != 8){
							echo " ".$index;
						}
					}
				}
				if(!$name){
					echo "\n";
				}
			}
		}else{
			$logger->error("edge %s: no answer", $modem['name']);
		}
	}
}
$logger->info("END");
?>
