#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
 */
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.acl2');

$logger->info("BEGIN");

$tftp_server = '194.50.85.2'; //ip2long(implode('.', array_reverse(explode('.', '194.50.85.1'))));

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
);

$options = array(
	'destination' => '/var/lib/tftpboot/',
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
	'http-timeout' => '10',
	'http-user' => 'security',
	'http-password' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

function _snmpset($oid, $type, $value){
	global $options, $modem;
	$result = snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
	if(!$result){
		echo "failed snmpset: ".$modem['ip']." ".$oid." ".$type." ".$value."\n";
	}
	return $result;
}

function countLevel($id){
	global $modems;
	$modem = $modems[$id];
	if($parent = $modem['modem']){
		return countLevel($parent) + 1;
	}else{
		return 0;
	}
}

function compareByLevelDesc($m1, $m2){
	return $m2['level'] - $m1['level'];
}

// rich+

function getChanPorts($multicastIP)
{
  extract($GLOBALS);

	$baseOID="ES3528MO-MIB::igmpSnoopMulticastCurrentPorts.33."; // oid + vlanID
	$oidvalue = @snmpget($modem['ip'], $options['snmp-reader'], $baseOID.$multicastIP, $options['snmp-timeout'], $options['snmp-retries']);
	$ports=unpack("H*",$oidvalue); $ports=$ports[1];

	$portOctet=1;
	$portBin = '';
	$reciversCnt = 0;
	if (strlen($ports) == 0 ) return;
	foreach (str_split($ports,2) as $i) {
		$portBin = base_convert($i,16,2);
		$portBin = str_pad($portBin, 8, "0", STR_PAD_LEFT);
		for ($j = 0; $j < strlen($portBin); $j++){
			if ($portBin[$j] == 1){
				$portN = $j+($portOctet);
				if ($modem['uplink'] != $portN){
					//print $modem['ip'].' '.$multicastIP.' '.$portN."\n";
					$reciversCnt += 1;
				}
			}
		}
		$portOctet=$portOctet + 8;
	};
	
	$link = mysql_connect('localhost', 'iptv', 'iptv') or die("Could not connect to db");
	mysql_select_db('iptv_channes',$link) or die("Could not select database");	

	$values = mysql_fetch_assoc(mysql_query(sprintf('select count from channels where check_time="%s" and chan_ip = "%s"',$check_time,$multicastIP)));
	if (!$values) {
		$cnt = $reciversCnt;
		mysql_query(sprintf('insert into channels (check_time, chan_ip, count) values ("%s","%s",%s);',$check_time,$multicastIP,$cnt));
	}
	else
	{
		//print_r ($values);
		$cnt = $values['count']	+ $reciversCnt;
		//echo $values['count'].' '.$cnt.' '.$reciversCnt."\n";
		//mysql_query(sprintf('replace into channels (check_time, chan_ip, count) values ("%s","%s",%s);',$check_time,$multicastIP,$cnt));
		mysql_query(sprintf('update channels set count = %s where check_time = "%s" and chan_ip = "%s";',$cnt, $check_time,$multicastIP));
	}


	
	mysql_close($link);
}
// //rich-

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');

$it = $dao->iterator();

$modems = array();
while($modem = $it->next()){
	$modems[$modem['id']] = $modem;
}
foreach($modems as $id=>$modem){
	$modems[$id]['level'] = countLevel($id);
}
usort($modems, 'compareByLevelDesc');

$check_time = date('o-m-d G:i');
foreach($modems as $modem){
	if($modem['model']=='ES3528M' || $modem['model']=='ES3552M'){
	//if($modem['ip']=='10.0.14.29'){
		$model_oid = @snmpget($modem['ip'], $options['snmp-reader'], ".1.3.6.1.2.1.1.2.0", $options['snmp-timeout'], $options['snmp-retries']);
		if($model_oid){
			if(isset($edgecore_models[$model_oid])){
				$oid = array(
					'set'=>'SNMPv2-SMI::enterprises.259.6.10.94.1.1.7.0',
					'config_src'=>$model_oid.".1.24.1.1.0",
					'config_dst'=>$model_oid.".1.24.1.3.0",
					'config_dst_name'=>$model_oid.".1.24.1.4.0",
					'config_action'=>$model_oid.".1.24.1.8.0"
				);
				$cfg_name = $modem['name'].'-confg';

				$success = true;

				getChanPorts('239.0.1.11');
				getChanPorts('239.0.1.12');
				getChanPorts('239.0.1.13');
				getChanPorts('239.0.1.21');
				getChanPorts('239.0.1.31');
				getChanPorts('239.0.1.32');
				getChanPorts('239.0.1.33');
				getChanPorts('239.0.1.34');
				getChanPorts('239.0.1.41');
				getChanPorts('239.0.1.42');
				getChanPorts('239.0.1.43');
				getChanPorts('239.0.1.44');
				getChanPorts('239.0.1.45');
				getChanPorts('239.0.1.51');
				getChanPorts('239.0.1.54');
				getChanPorts('239.0.1.55');
				getChanPorts('239.0.1.57');
				getChanPorts('239.0.1.61');
				getChanPorts('239.0.1.63');
				getChanPorts('239.0.1.64');
				getChanPorts('239.0.1.66');
				getChanPorts('239.0.1.71');
				getChanPorts('239.0.1.72');
				getChanPorts('239.0.1.73');
				getChanPorts('239.0.1.74');
				getChanPorts('239.0.1.75');
				getChanPorts('239.0.1.76');
				getChanPorts('239.0.1.91');
				getChanPorts('239.0.1.92');
				getChanPorts('239.0.1.93');
				getChanPorts('239.0.1.94');
				getChanPorts('239.0.1.101');
				getChanPorts('239.0.1.102');
				getChanPorts('239.0.1.103');
				getChanPorts('239.0.1.104');
				getChanPorts('239.0.1.105');
				getChanPorts('239.0.1.106');
				getChanPorts('239.0.1.111');
				getChanPorts('239.0.1.112');
				getChanPorts('239.0.1.113');
				getChanPorts('239.0.1.114');
				getChanPorts('239.0.1.121');
				getChanPorts('239.0.1.161');
				getChanPorts('239.0.1.164');
				getChanPorts('239.0.1.165');
				getChanPorts('239.0.1.168');
				getChanPorts('239.0.1.169');
				getChanPorts('239.0.1.201');
				getChanPorts('239.0.1.202');
				getChanPorts('239.0.1.203');
				getChanPorts('239.0.1.204');
				getChanPorts('239.0.1.205');

				//				mysql_query(sprintf('replace into channels (check_time, chan_ip, count) values ("%s","%s",%s);',$check_time,'',));


				//break;
			}
		}else {
			$logger->error("edge %s: no answer", $modem['name']);
		}
	}
}
$logger->info("END");

?>
