#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.reboot');

$logger->info("BEGIN");

$tftp_server = '194.50.85.2'; //ip2long(implode('.', array_reverse(explode('.', '194.50.85.1'))));

$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
);

$options = array(
	'destination' => '/var/lib/tftpboot/',
	'snmp-timeout' => 2000000,
	'snmp-retries' => 2,
	'snmp-reader' => 'public',
	'snmp-writer' => 'security',
	'http-timeout' => '10',
	'http-user' => 'security',
	'http-password' => 'security',
);

snmp_set_oid_numeric_print(1);
snmp_set_quick_print(1);
snmp_set_valueretrieval(SNMP_VALUE_PLAIN);

function _snmpset($oid, $type, $value){
	global $options, $modem;
	return snmpset($modem['ip'], $options['snmp-writer'], $oid, $type, $value, $options['snmp-timeout'], $options['snmp-retries']);
}

function countLevel($id){
	global $modems;
	$modem = $modems[$id];
	if($parent = $modem['modem']){
		return countLevel($parent) + 1;
	}else{
		return 0;
	}
}

function isChildOf($id, $ip_arr){
	global $modems;
	$modem = $modems[$id];
	if($modem['modem']){
		$parent = $modems[$modem['modem']];
		if(in_array($parent['ip'], $ip_arr)){
			return true;
		}else{
			return isChildOf($parent['id'], $ip_arr);
		}
	}else{
		return false;
	}
}


function compareByLevelDesc($m1, $m2){
	return $m2['level'] - $m1['level'];
}

$dao = $beanFactory->getBean('modemsDAO');
$db = $beanFactory->getBean('connection');

$it = $dao->iterator();

$modems = array();
while($modem = $it->next()){
	$modems[$modem['id']] = $modem;
}
$root = array('10.0.8.30', '10.0.8.10');
foreach($modems as $id=>$modem){
	$modems[$id]['level'] = countLevel($id);
	$modems[$id]['matched'] = in_array($modem['ip'], $root) || isChildOf($id, $root);
}
usort($modems, 'compareByLevelDesc');

$reboot = array(
	'ES3528M'=> array('.1.3.6.1.4.1.259.6.10.94.1.7.3.0', 'i', '3'),
	'ES3552M'=> array('.1.3.6.1.4.1.259.6.10.94.1.7.3.0', 'i', '3'),
	'ES4612'=>  array('.1.3.6.1.4.1.259.6.10.57.1.7.3.0', 'i', '3'),
	'ES3510'=>  array('.1.3.6.1.4.1.259.8.1.5.1.7.3.0', 'i', '3'),
);

foreach($modems as $modem){
	if($modem['matched']){
		if(isset($reboot[$modem['model']])){
			$r = $reboot[$modem['model']];
//			echo $modem['ip'].' - '.$modem['model']."\n";
			$result = snmpset($modem['ip'], $options['snmp-writer'], $r[0], $r[1], $r[2], $options['snmp-timeout'], $options['snmp-retries']);
			$logger->info('reboot %s: %s', $modem['name'], $result ? 'ok' : 'failed');
		}else{
			$logger->error('unsupported model %s: %s', $modem['name'], $modem['model']);
		}
	}
}
$logger->info("END");

?>
