#!/usr/bin/php -q
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.19 $
*/

error_reporting(E_ALL);

define('OPERATOR', 96);

if(isset($_SERVER['SERVER_NAME'])){
	// run through http-request, deny
	exit;
}

if(count($_SERVER['argv']) < 3){
	usage();
	exit;
}
$timeout = $_SERVER['argv'][1] * 1000;
$retries = $_SERVER['argv'][2] + 0;
$with_lock = isset($_SERVER['argv'][3]);

ini_set('include_path', DIRNAME(__FILE__). '/../');
include("includes/options.php");
include("classes/context/include.php");
$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/log.php'),
	new ArrayBeanFactory('boot/caban/tools.php'),
	new ArrayBeanFactory('boot/caban/dao.php'),
	new ArrayBeanFactory('boot/caban/service.php'),
	new ArrayBeanFactory('boot/caban/service-2.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('switch.ping');
$delayedTasksManager = $beanFactory->getBean('delayedTasksManager');

$link = mysql_connect(DB_HOST, DB_USER, DB_PASS) or die("Could not connect to ".DB_HOST." as ".DB_USER." with".(DB_PASS ? "":"out")." password specified");
mysql_select_db(DB_BASE, $link) or die("Could not select database ".DB_BASE." at ".DB_HOST);

mysql_query("set names ".DB_CHARSET);

if($with_lock){
	$res = mysql_query("SELECT GET_LOCK('snmp_ping', 0) as success");
	if($arr = mysql_fetch_assoc($res)){
		if(!$arr['success']){
			$logger->info('locked');
			exit;
		}
	}else{
		$logger->info('locked');
		exit;
	}
}

$celan_models = array(
	'.1.3.6.1.4.1.655.5.3'=>'2402Fi-EA',
	'.1.3.6.1.4.1.655.5.11'=>'8F00i-EA',
	'.1.3.6.1.4.1.655.5.15'=>'0800i-EA',
	'.1.3.6.1.4.1.655.5.16'=>'1601Fi-EA',
	'.1.3.6.1.4.1.655.5.21'=>'0701Fi-EA',
	'.1.3.6.1.4.1.655.9.3'=>'2402FGi-EA',
	'.1.3.6.1.4.1.655.9.8'=>'8F02Gi-EA',
);
$edgecore_models = array(
	'.1.3.6.1.4.1.259.6.10.57'=>'ES4612',
	'.1.3.6.1.4.1.259.6.10.74'=>'ES3526XA-1',
	'.1.3.6.1.4.1.259.6.10.94'=>'ES3552M',
	'.1.3.6.1.4.1.259.10.1.27.101'=>'ES3510-28T',
	'.1.3.6.1.4.1.259.8.1.5'=>'ES3526XA-2',
	'.1.3.6.1.4.1.259.8.1.6'=>'ES3510',
	'.1.3.6.1.4.1.259.8.1.11'=>'ES3510MA',
	//'.1.3.6.1.4.1.6339.1.1.2.14'=>'FS4626SFP',
	'.1.3.6.1.4.1.259.8.1.3'=>'ES4626SFP',
	'.1.3.6.1.4.1.259.10.1.27'=>'ES3510-28T',
	'.1.3.6.1.4.1.259.10.1.27.102'=>'ES3510-52T',
	
);
$cisco_models = array(
	'.1.3.6.1.4.1.9.1.516'=>'CATALYST',
	'.1.3.6.1.4.1.9.1.703'=>'CATALYST',
);

function setModemState($mid, $state, $state_date, $loss_in, $loss_in_prev, $loss_out, $loss_out_prev){
	global $time, $parents;
	$prev = 'NULL';
	if(isset($parents[$mid]) ){
		if($parents[$mid]['state_id']){
			$prev = $parents[$mid]['state_id'];
		}
	}
	$arr_all = mysql_fetch_assoc(mysql_query(sprintf("SELECT SUM(UNIX_TIMESTAMP(s.date) - UNIX_TIMESTAMP(p.date)) as amount
		FROM modems_states s
		LEFT JOIN modems_states p ON p.id=s.prev
		WHERE s.modem='%s' AND p.state=0 AND p.id IS NOT NULL
		GROUP BY s.modem", $mid)));
	$arr_month = mysql_fetch_assoc(mysql_query(sprintf("SELECT SUM(UNIX_TIMESTAMP(s.date) - UNIX_TIMESTAMP(p.date)) as amount
		FROM modems_states s
		LEFT JOIN modems_states p ON p.id=s.prev
		WHERE s.modem='%s' AND p.state=0 AND p.id IS NOT NULL AND p.date > SUBDATE(now(), INTERVAL 1 MONTH)", $mid)));
	mysql_query(sprintf("INSERT INTO modems_states (modem, state, loss_in, loss_in_prev, loss_out, loss_out_prev, date, prev) VALUES (%s, %s, %s, %s, %s, %s, FROM_UNIXTIME(%s), %s)", 
		$mid, $state, 
		$loss_in ? $loss_in : 0,
		$loss_in_prev ? $loss_in_prev : 0,
		$loss_out ? $loss_out : 0,
		$loss_out_prev ? $loss_out_prev : 0,
		$state_date,
		$prev
		));
	$arr = mysql_fetch_assoc(mysql_query("SELECT LAST_INSERT_ID() as id"));
	mysql_query(sprintf("UPDATE modems SET state_id=%s, off_all='%s', off_month='%s' WHERE id=%s", $arr['id'], $arr_all['amount'], $arr_month['amount'], $mid));
	$time = time();
}

$time = time();

function touchConnection(){
	global $time, $logger;
	$t = time();
	if($time + 60 < $t){
		$logger->info('touch MySql connection');
		mysql_query("SELECT 1");
		$time = $t;
	}
}

function macToBillFormat($mac){
	$mac = strtolower(preg_replace('|[^0-9a-f]|i', '', $mac));
	return $mac ? substr($mac, 0, 2).':'.
		substr($mac, 2, 2).':'.
		substr($mac, 4, 2).':'.
		substr($mac, 6, 2).':'.
		substr($mac, 8, 2).':'.
		substr($mac, 10, 2) : '';
}

$mac_fix = array();

set_error_handler(create_function('$x, $y', 'throw new Exception($y, $x);'), E_ALL & ~E_NOTICE);

$logger->info('BEGIN');

$bad = 0;

$modems = array();
$parents = array();
$ping_input = '';
$res = mysql_query("SELECT m.id, m.ip, m.mac, m.name, s.name as street_name, m.house, m.entrance, m.floor, m.stamp, m.uplink, m.modem, m.port,
    UNIX_TIMESTAMP(m.up_since) up_since, m.model, m.firmware, m.loader, m.diag, m.power, m.check_power,
    x.state, x.id as state_id, UNIX_TIMESTAMP(x.date) as date,
    x.loss_in as prev_loss_in, x.loss_in_prev as prev_loss_in_prev,
    x.loss_out as prev_loss_out, x.loss_out_prev as prev_loss_out_prev
    FROM modems m
    LEFT JOIN modems_states x ON x.id=m.state_id
    LEFT JOIN streets s ON s.id=m.street
    LEFT JOIN modem_profiles mp ON mp.id=m.profile
    WHERE m.audit=1 AND mp.name LIKE '%edge%'");
/*
$res = mysql_query("SELECT m.id, m.ip, m.mac, m.name, s.name as street_name, m.house, m.entrance, m.floor, m.stamp, m.uplink, m.modem, m.port,
	UNIX_TIMESTAMP(m.up_since) up_since, m.model, m.firmware, m.loader, m.diag, m.power, m.check_power,
	x.state, x.id as state_id, UNIX_TIMESTAMP(x.date) as date,
	x.loss_in as prev_loss_in, x.loss_in_prev as prev_loss_in_prev,
	x.loss_out as prev_loss_out, x.loss_out_prev as prev_loss_out_prev
	FROM modems m
	LEFT JOIN modems_states x ON x.id=m.state_id
	LEFT JOIN streets s ON s.id=m.street
	WHERE m.audit=1");
*/
while($arr = mysql_fetch_assoc($res)){
	$arr['loss'] = '';
	$modems[$arr['ip']] = $arr;
	$parents[$arr['id']] = $arr;
//	$ping_input .= $arr['ip']."\n";
}
/*
$logger->info('begin parallel ping %s hosts', count($modems));
if($proc = popen('xargs -n 1 -P 64 ping -c 100 -i 0.01 -q -W 1 -n | egrep "(packet loss)|(statistics)" > '.TMP_DIR.'/caban/ping.out', "w")){
	fwrite($proc, $ping_input);
	pclose($proc);
	$ip = '';
	$lines = file(TMP_DIR.'/caban/ping.out');
	foreach($lines as $line){
		if(@preg_match('|--- (\d+\.\d+\.\d+\.\d+) ping statistics ---|', $line, $m)){
			$ip = $m[1];
			continue;
		}
		if($ip && @preg_match('|(\d+)% packet loss|', $line, $m)){
			$modems[$ip]['loss'] = $m[1];
		}
	}
}
$logger->info('end parallel ping');
*/

foreach($modems as $arr){
	touchConnection();
	snmp_set_oid_numeric_print(1);
	snmp_set_quick_print(1);
	snmp_set_valueretrieval(SNMP_VALUE_PLAIN);
//	ping -c 100 -f -q -W 1 10.101.104.18 |grep loss |cut -d" " -f 6 | sed -e s/\%//g
	/*
	$loss_changed = false;
	if($arr['loss']!=$arr['prev_loss']){
		if(	$arr['loss']==0 ||
			$arr['loss']==100 ||
			$arr['prev_loss']=='' ||
			$arr['prev_loss']==0 ||
			$arr['prev_loss']==100 ||
			abs($arr['prev_loss'] - $arr['loss']) > 5
		){
			$loss_changed = true;
		}
	}
	*/
	$state_date = time();
	$model_oid = '';
	$state = 1;
	try{
		$model_oid = snmpget($arr['ip'], "public", ".1.3.6.1.2.1.1.2.0", $timeout, $retries);
	}catch(Exception $ex){
		$state = 0;
		$bad++;
		$logger->info('%s unavailable: %s', $arr['ip'], $ex->getMessage());
	}
	$loss_in = $arr['prev_loss_in'];
	if($model_oid && $arr['uplink']){
		try{
			$loss_in = snmpget($arr['ip'], "public", ".1.3.6.1.2.1.2.2.1.14.".$arr['uplink'], $timeout, $retries);
		}catch(Exception $ex){
			$logger->info('cant read loss_in from %s: %s', $arr['ip'], $ex->getMessage());
		}
	}
	$loss_out = $arr['prev_loss_out'];
	if(isset($parents[$arr['modem']]) && $arr['port']){
		$parent = $parents[$arr['modem']];
		try{
			$loss_out = snmpget($parent['ip'], "public", ".1.3.6.1.2.1.2.2.1.14.".$arr['port'], $timeout, $retries);
		}catch(Exception $ex){
			$logger->info('cant read loss_out from: %s for: %s, msg: %s', $parent['ip'], $arr['ip'], $ex->getMessage());
		}
	}
	if($model_oid){
		try{
			snmp_set_valueretrieval(SNMP_VALUE_LIBRARY);
			$mac = macToBillFormat(snmpget($arr['ip'], "public", ".1.3.6.1.2.1.17.1.1.0", $timeout, $retries));
			if($mac && (strcasecmp($arr['mac'], $mac)!=0)){
				$arr['mac'] = $mac;
				$mac_fix[$arr['id']] = $arr;
			}
			snmp_set_valueretrieval(SNMP_VALUE_PLAIN);
			$uptime = snmpget($arr['ip'], "public", ".1.3.6.1.2.1.1.3.0", $timeout, $retries);
			$up_since = time() - intval($uptime/100);
			if($up_since > ($state_date - 60 * 5)){ //     5 
				$logger->info('modified state date from %s to %s', date("Y-m-d H:i:s", $state_date), date("Y-m-d H:i:s", $up_since));
				$state_date = $up_since;
			}
			$model = '';
			$power = 0;
			if(isset($celan_models[$model_oid])){
				$model = $celan_models[$model_oid];
				$firmware = @snmpget($arr['ip'], "public", $model_oid.".1.1.2.0", $timeout, $retries);
				if($pos = strpos($firmware," ")){
					$firmware = substr($firmware, 0, $pos);
				}
			}
			$is_edge = false;
			if(isset($edgecore_models[$model_oid])){
				$is_edge = true;
				$model = $edgecore_models[$model_oid];
				if($model=="ES3510"){
					$model_oid = ".1.3.6.1.4.1.259.8.1.5";
				}
				if($model=='ES3552M'){
					$model = snmpget($arr['ip'], "public", ".1.3.6.1.4.1.259.6.10.94.1.1.5.1.0", $timeout, $retries);
				}
//				if($model=='ES3510-28T'){
//     			    $model = snmpget($arr['ip'], "public", ".1.3.6.1.4.1.259.10.1.27.1.1.5.1.0", $timeout, $retries);
//     			    $model_oid=".1.3.6.1.4.1.259.10.1.27";
//     			    $firmware = snmpget($arr['ip'], "public", $model_oid.".1.1.3.1.6.1", $timeout, $retries);
//     			    $loader =   snmpget($arr['ip'], "public", $model_oid.".1.1.3.1.4.1", $timeout, $retries);
//                    $diag =     snmpget($arr['ip'], "public", $model_oid.".1.1.3.1.5.1", $timeout, $retries);
//     			                                            
//     			    
//				}
				  
              if($model=='ES3510-28T'){
                  $model_oid=".1.3.6.1.4.1.259.10.1.27";
              }
				
              if($model=='ES3510-52T'){
                   $model_oid=".1.3.6.1.4.1.259.10.1.27";
               }
				                                                                                  
				if($model=='ES3526XA-2'){
					$model = snmpget($arr['ip'], "public", ".1.3.6.1.4.1.259.8.1.5.1.1.5.1.0", $timeout, $retries);
				}
				if($model=='ES4626SFP'){
					$model    = snmpget($arr['ip'], "public", ".1.3.6.1.4.1.259.8.1.3.100.25.1.1.1.0", $timeout, $retries);
					$firmware = snmpget($arr['ip'], "public", ".1.3.6.1.4.1.259.8.1.3.100.25.1.1.2.0", $timeout, $retries);
					$loader = '';
					$diag = '';
				}else{
					$firmware = snmpget($arr['ip'], "public", $model_oid.".1.1.3.1.6.1", $timeout, $retries);
					$loader =   snmpget($arr['ip'], "public", $model_oid.".1.1.3.1.4.1", $timeout, $retries);
					$diag =     snmpget($arr['ip'], "public", $model_oid.".1.1.3.1.5.1", $timeout, $retries);
				}
				if($arr['check_power']){
					$power =    snmpget($arr['ip'], "public", $model_oid.".1.1.3.1.8.1", $timeout, $retries);
				}
			}
			if(isset($cisco_models[$model_oid])){
				$model = snmpget($arr['ip'], "public", ".1.3.6.1.4.1.9.5.1.3.1.1.17.1", $timeout, $retries);
				$firmware = snmpget($arr['ip'], "public", ".1.3.6.1.4.1.9.5.1.3.1.1.19.1", $timeout, $retries);
			}
			$update = array();
			if(abs($up_since - $arr['up_since']) > 20){
				$update[] = sprintf("up_since=FROM_UNIXTIME(%s)", $up_since);
				if($is_edge){
					$logger->info('up_since changed, scheduling profile rebuild: %s', $arr['ip']);
					$delayedTasksManager->appendOffline('3', 'task.build.profile '.$arr['id'], 1, 1);
					//mysql_query(sprintf("INSERT IGNORE INTO access_tracker_queue (modem, added) VALUES (%s, now())", $arr['id']));
				}
			}
			if($arr['model']!=$model){
				$update[] = sprintf("model='%s'", addslashes($model)) ;
			}
			if($arr['firmware']!=$firmware){
				$update[] = sprintf("firmware='%s'", addslashes($firmware));
			}
			if($arr['loader']!=$loader){
				$update[] = sprintf("loader='%s'", addslashes($loader));
			}
			if($arr['diag']!=$diag){
				$update[] = sprintf("diag='%s'", addslashes($diag));
			}
			if($arr['check_power']){
				if($arr['power']!=$power){
					$update[] = sprintf("power='%s'", addslashes($power));
					mysql_query(sprintf("INSERT INTO modems_power_history (modem, power, date) VALUES ('%s', '%s', now())",
						$arr['id'], addslashes($power)));
				}
			}
			if(!empty($update)){
				mysql_query("UPDATE modems SET ".implode(", ", $update)." WHERE id=".$arr['id']."\n");
				$time = time();
			}
		}catch(Exception $ex){
			$logger->error('cant read additional info from %s: %s', $arr['ip'], $ex->getMessage());
		}
	}
	if(!$arr['state_id'] || $arr['state']!=$state ||
		($arr['prev_loss_in']!=$loss_in) || ($arr['prev_loss_in']!=$arr['prev_loss_in_prev']) ||
		($arr['prev_loss_out']!=$loss_out) || ($arr['prev_loss_out']!=$arr['prev_loss_out_prev'])
	){
		setModemState($arr['id'], $state, $state_date, $loss_in, $arr['prev_loss_in'], $loss_out, $arr['prev_loss_out']);
		$logger->info("change %s state to [%s], loss_in: %s, loss_out: %s", 
			$arr['ip'], $state ? 'up':'down', $loss_in - $arr['prev_loss_in'], $loss_out - $arr['prev_loss_out']);
	}
}
/*
foreach($mac_fix as $id=>$marr){
	$logger->info('fixing MAC %s => %s', $marr['ip'], $marr['mac']);
	$res = mysql_query(sprintf("SELECT id, ip FROM modems WHERE mac='%s'", $marr['mac']));
	if($arr = mysql_fetch_assoc($res)){
		$logger->info('clearing wrong MAC %s = %s', $arr['ip'], $marr['mac']);
		mysql_query(sprintf("UPDATE modems SET mac=NULL WHERE id='%s'", $arr['id']));
	}
	if($marr['stamp']){
		mysql_query(sprintf("UPDATE stamps SET modified=now(), modified_by='%d' WHERE id='%d'", OPERATOR, $marr['stamp']));
		mysql_query(sprintf("UPDATE modems SET mac='%s' WHERE id='%s'", $marr['mac'], $id));
	}else{
		mysql_query(sprintf("INSERT INTO stamps (modified, modified_by) VALUES (now(), '%d')", OPERATOR));
		$stamp = mysql_fetch_assoc(mysql_query("SELECT LAST_INSERT_ID() as id"));
		mysql_query(sprintf("UPDATE modems SET mac='%s', stamp='%s' WHERE id='%s'", $marr['mac'], $stamp['id'], $id));
	}
}
*/
$logger->info('END: %s modems bad', $bad);

function usage(){
?>

Requests modems/commutators by snmp to detect their accessibility.

author: Ponomarev Denis <ponomarev@gmail.com>

usage:
<?=basename($_SERVER['argv'][0])?> <timeout> <retries>

	timeout - how long wait for answer in milliseconds
	retries - how many attempts must be made before reporting about a failure

<?
}
?>