#!/usr/bin/php

<?php
//#!/usr/bin/php -q

if(count($_SERVER['argv']) < 3){
        die("Request incomplete");
}
$host = $_SERVER['argv'][1];
$cfg = $_SERVER['argv'][2];
$LOGDEST=$_SERVER['argv'][3];
/* Включаем логи
 Переменная определяет куда писать лог
	print - на экран
	syslog - в syslog
	none - не писать
 */

$LOGSTRINGAR = array (
	LOG_INFO => "INFO:",
	LOG_WARNING => "WARNING:",
	LOG_ERR => "ERROR:",
	);
function hex2dec($mac)
/* Переводит MAC адрес из шестнадцатиричной формы в десятичную
*/
{
    $hmac = explode(":", $mac);
    $dmac = array();
    foreach($hmac as $key => $value){
	$dmac[] = hexdec($value); 
    }
    return implode(".", $dmac);
}

function dec2hex(&$str)
/* Переводит MAC адрес из десятичной формы в шестнадцатиричную
*/
{
    $str = sprintf("%02s", dechex($str));
}


function syslog_safe ($loglevel,$message)
/*Выводит лог туда, куда указывает переменная LOGDEST
*/
{
	global $LOGDEST;
	global $LOGSTRINGAR;
	
	switch ($LOGDEST) {
    case "print":
        print( $LOGSTRINGAR[$loglevel] . $message . "\n");
		break;
    case "syslog" :
        syslog($loglevel,$message);
		break;
    case "none" :
        break;
	}
}


function port_enable( $hextring, $port)
/* формирует HEX-STRING для ВКЛючения порта
Входные параметры  аналогично port_handle
*/
{
 return (port_handle( $hextring, $port,1));
}
function port_disable( $hextring, $port)
/* Формирует HEX-STRING для ВЫКЛючения порта
  Входные параметры  аналогично port_handle
*/
{ 
	return (port_handle( $hextring, $port,0));
}

function port_handle( $hextring, $port, $enable )
/* Формирует HEX-STRING для включения или выключения конкретного порта.
 * Биты в строке соответствуют: самый левый - порт 1, самый правый - последний порт.
 * @param string $hextring Исходное значение HEX-STRING.
 * @param int $port Номер порта, к которому привязывать запись.
 * @param int $enable Флаг: если 1 - включить, если 0 - вылючить.
 * @return string $hextrout Новое значение HEX-STRING.
 */
{
 $hexbin = array (
    "0" => "0000", "1" => "0001", "2" => "0010","3" => "0011",
    "4" => "0100", "5" => "0101", "6" => "0110","7" => "0111",
    "8" => "1000", "9" => "1001", "a" => "1010","b" => "1011",
    "c" => "1100", "d" => "1101", "e" => "1110","f" => "1111"
    );
 $binhex = array (
    "0000" => "0", "0001" => "1", "0010" => "2", "0011" => "3",
    "0100" => "4", "0101" => "5", "0110" => "6", "0111" => "7",
    "1000" => "8", "1001" => "9", "1010" => "a", "1011" => "b",
    "1100" => "c", "1101" => "d", "1110" => "e", "1111" => "f"
    );
	
 // Очищаем входную строку от незначащих символов и пробелов.
 $hextring = strtolower( preg_replace("/[^0-9a-fA-F]/","", $hextring) );
 
 //Проверка входных параметров
 $port = intval( $port );
 if ( $port < 1 || $port > strlen($hextring)*4 )  return $hexsring;
 
 // Превращаем строку HEX в массив HEX и cтроим строку BIN
 $hextringar=str_split($hextring);
 $binstring="";
 foreach ($hextringar as $hexdigit) {
 $binstring=$binstring . $hexbin[$hexdigit];
  }

 // Включаем, или выключаем порт в бинарной строке
  if ($enable == 1) { $binstring[$port-1]='1';}
  else { $binstring[$port-1]='0';}

// Превращаем строку обратно в массив по 4 бита и строим строку HEX
 $binstringar=str_split($binstring,4);
 $hextrout="";
 $hexflag=0;
 foreach ($binstringar as $bin4bit) {
 if (!$hexflag) { $hextrout=$hextrout . $binhex[$bin4bit];$hexflag=1; }
  else {$hextrout=$hextrout . $binhex[$bin4bit] . " "; $hexflag=0;}
}
 return $hextrout;
}

 
function snmpset_safe ($action,$exitflag, $host,$community,$oid,$type, $value) 
/* Исполняет SNMPSET действие с логгированием и проверкой результата.
 action - словесное описание того что делаем
 exitflag - прервать или нет исполнение кода в случае ошибки
 host,community,oid,type,value - стандартные snmpset параметры
 */ 
{
    if ( snmpset($host, $community, $oid, $type,$value) )
	{
	syslog_safe(LOG_INFO, sprintf("SNMPSET SUCCESS: Action:[%s] on host: [%s] communty: [%s] oid: [%s] type: [%s] value:[%s]",$action, $host,$community,$oid,$type,$value));
	}
	else
	{ 
		if ($exitflag){
		syslog_safe(LOG_ERR, sprintf("SNMPSET FATAL ERROR: Action:[%s] on host: [%s] communty: [%s] oid: [%s] type: [%s] value:[%s]",$action, $host,$community,$oid,$type,$value));
		exit(5);
		} else {
		syslog_safe(LOG_WARNING, sprintf("SNMPSET WARNING ERROR: Action:[%s] on host: [%s] communty: [%s] oid: [%s] type: [%s] value:[%s]",$action, $host,$community,$oid,$type,$value));
		}
		
	};

}

function snmpset_fast($action,$exitflag,$oid,$type,$value) 
/* Исполняет snmpset_safe. на актуальных значениях $host и $option['writecom']
*/
{
 global $host;
 global $option;
	return snmpset_safe($action,$exitflag,$host,$option['writecom'],$oid,$type, $value);
 }

function snmpget_safe ($action,$exitflag, $host,$community,$oid) 
/* Исполняет SNMPGET действие с логгированием и проверкой результата.
 action - словесное описание того что делаем
 exitflag - прервать или нет исполнение кода в случае ошибки
 host,community,oid,type,value - стандартные snmpset параметры
 возвращает полученное значение
 */{
	$snmpresult= snmpget($host, $community, $oid);

    if ($snmpresult != FALSE)
	{
	syslog_safe(LOG_INFO, sprintf("SNMPGET SUCCESS: Action:[%s] on host: [%s] communty:[%s] oid:[%s] result:[%s]",$action, $host,$community,$oid,$snmpresult));
	}
	else
	{ 
		if ($exitflag){
		syslog_safe(LOG_ERR, sprintf("SNMPGET FATAL ERROR: Action:[%s] on host: [%s] communty: [%s] oid: [%s]",$action, $host,$community,$oid));
		exit(5);
		} else {
		syslog_safe(LOG_WARNING, sprintf("SNMPGET WARNING ERROR : Action:[%s] on host: [%s] communty: [%s] oid: [%s]",$action, $host,$community,$oid));
		}
		
	};
	return $snmpresult;
}

function snmpget_fast ($action,$exitflag,$oid) 
/* Исполняет snmpget_safe на актуальных значениях $host и $option['readcom']
 action - словесное описание того что делаем
 exitflag - прервать или нет исполнение кода в случае ошибки
 host,community,oid,type,value - стандартные snmpset параметры
 возвращает полученное значение
 */{
global $host;
global $option;
	return snmpget_safe($action,$exitflag,$host,$option['readcom'],$oid);
}
 
 function oid_gen ($basic_oid)
/* Формирует массив OID на основе BASIC_OID
*/{
$oid= array(
//PORT
	'port_name'=>$basic_oid . ".1.2.1.1.2.",

//MAC
	'mac_hextring'=>".1.3.6.1.2.1.17.7.1.3.1.1.3.",
	// hextring
	//dot1qStaticUnicastAllowedToGoTo!@#.iso.org.dod.internet.mgmt.mib-2.dot1dBridge.qBridgeMIB.qBridgeMIBObjects.dot1qStatic.dot1qStaticUnicastTable.dot1qStaticUnicastEntry.dot1qStaticUnicastAllowedToGoTo
	'mac_type'=>".1.3.6.1.2.1.17.7.1.3.1.1.4.",
	'mac_type_walk'=>".1.3.6.1.2.1.17.7.1.3.1.1.4",
	// 3-permanenet
	//dot1qStaticUnicastStatus	!@#.iso.org.dod.internet.mgmt.mib-2.dot1dBridge.qBridgeMIB.qBridgeMIBObjects.dot1qStatic.dot1qStaticUnicastTable.dot1qStaticUnicastEntry.dot1qStaticUnicastStatus
	
//VLAN
	'vlan_native' => ".1.3.6.1.2.1.17.7.1.4.5.1.1", 
	//snmpset -c private -v 2c 192.168.1.137 1.3.6.1.2.1.17.7.1.4.5.1.1.3 u 30 (port 3 vlan 30)	
	//dot1qPvid		!@#.iso.org.dod.internet.mgmt.mib-2.dot1dBridge.qBridgeMIB.qBridgeMIBObjects.dot1qVlan.dot1qPortVlanTable.dot1qPortVlanEntry.dot1qPvid
	
	'vlan_untag' => ".1.3.6.1.2.1.17.7.1.4.3.1.4", 
	//snmpset -c private 192.168.1.137 1.3.6.1.2.1.17.7.1.4.3.1.4.30 x "f0 00 00 00" (allow vlan untagged 30 on port 1-4)
	//dot1qVlanStaticUntaggedPorts		!@#.iso.org.dod.internet.mgmt.mib-2.dot1dBridge.qBridgeMIB.qBridgeMIBObjects.dot1qVlan.dot1qVlanStaticTable.dot1qVlanStaticEntry.dot1qVlanStaticUntaggedPorts

	'vlan_tag' => ".1.3.6.1.2.1.17.7.1.4.3.1.2",
	//snmpset -c private -v 2c 192.168.1.137 1.3.6.1.2.1.17.7.1.4.3.1.4.30 x "f0 00 00 00"
	//dot1qVlanStaticEgressPorts		!@#.iso.org.dod.internet.mgmt.mib-2.dot1dBridge.qBridgeMIB.qBridgeMIBObjects.dot1qVlan.dot1qVlanStaticTable.dot1qVlanStaticEntry.dot1qVlanStaticEgressPorts
	
// IPSG port	
	'ipsg_port_enable' =>  $basic_oid.".1.48.1.1.2", 
	// snmpset -c private 192.168.1.135 1.3.6.1.4.1.259.8.1.5.(basic_oid) 1.48.1.1.2.1 i 2 (enable source guard on port 1)
	// ipSrcGuardMode		!@#.iso.org.dod.internet.private.enterprises.accton.snmpMgt.cheetahSwitchMgt.es3528moMIB.es3528moMIBObjects.ipSrcGuardMgt.ipSrcGuardConfigTable.ipSrcGuardConfigEntry.ipSrcGuardMode

// IPSG record
	'ipsg_status' => $basic_oid.".1.48.2.1.8", 
	'ipsg_iptype' => $basic_oid.".1.48.2.1.3",
	'ipsg_ip' => $basic_oid.".1.48.2.1.5",
	'ipsg_port' => $basic_oid.".1.48.2.1.6",

// ADMIN PORT STATUS
	'port_status' => ".1.3.6.1.2.1.2.2.1.7",

// CONFIG FILE HANDLE
	'config_src' => $basic_oid.".1.24.1.1.0",
	'config_dst' => $basic_oid.".1.24.1.3.0",
	'config_name' => $basic_oid.".1.24.1.4.0",
	'config_action' => $basic_oid.".1.24.1.8.0",

	// режим ipsec на порту
	'port_security'=>$basic_oid . ".1.17.2.1.1.2",
	'port_security_action'=>$basic_oid . ".1.17.2.1.1.3",
	'port_security_count'=>$basic_oid . ".1.17.2.1.1.4",
);

//	if ($basic_oid==".1.3.6.1.4.1.259.8.1.5") {
//	$oid[port_name]=".1.3.6.1.4.1.259.8.1.5.1.2.1.1.2";
//	}
return $oid;

}

function vlan_replace ($vlan_name,$vlan_old,$vlan_new,$vlan_port)
/* Заменяет на порту PVID с vlan_old на vlan_new
*/{
global $oid;
global $option;
global $host;

//Добавляем untagged NEW на указанный порт
	$vlan_oid=$oid['vlan_untag'].".".$vlan_new;
	$vlan_state=snmpget_safe("Obtaining status NEW VLAN". $vlan_name ,TRUE,$host,$option['readcom'],$vlan_oid);
	$vlan_hextring=port_enable($vlan_state,$vlan_port);
	snmpset_safe(sprintf("Add untagged NEW VLAN[%s]: ID:[%s] to port [%s] ",$vlan_name,$vlan_new,$vlan_port),\
	TRUE, $host ,$option['writecom'], $vlan_oid ,'x',$vlan_hextring);

//Меняем PVID на NEW
	snmpset_safe(sprintf("Enable [%s] PVID:[%s] at port [%s]",$vlan_name,$vlan_new,$vlan_port),\
	TRUE, $host, $option['writecom'], $oid['vlan_native'].".".$vlan_port, 'u', $vlan_new);

// Удаляем untagged OLD  с указанного порта
	$vlan_oid=$oid['vlan_untag'].".".$vlan_old;
	$vlan_status=snmpget_safe( sprintf("Obtain status untagg OLD VLAN: [%s] ",$vlan_old), TRUE, $host, $option['readcom'],$vlan_oid);
	$vlan_hextring=port_disable($vlan_status,$vlan_port);
		snmpset_safe(sprintf("Remove OLD VLAN: [%s] on port [%s] ",$vlan_old,$vlan_port),\
	TRUE, $host, $option['writecom'], $vlan_oid ,'x',$vlan_hextring);
	
//Удаляем остатки tagged OLD
	$vlan_oid=$oid['vlan_tag'].".".$vlan_old;
	$vlan_state=snmpget_safe("Obtaining status tagg OLD VLAN.",TRUE,$host,$option['readcom'],$vlan_oid);
	$vlan_hextring=port_disable($vlan_state,$vlan_port);
	snmpset_safe(sprintf("Remove tagged OLD vlan: [%s] to port [%s] ",$vlan_old,$vlan_port),\
	TRUE, $host ,$option['writecom'], $vlan_oid ,'x',$vlan_hextring);
}

function mac_add ($action,$mac,$hextring,$vlan)
/* Добавляет статическую запись MAC
*/{
global $oid;
	$macdec=hex2dec($mac);
	$oid_mac_type = $oid['mac_type'] . $vlan .".". $macdec ."." ."0";
	$oid_mac_hextring = $oid['mac_hextring'] . $vlan .".". $macdec .".". "0";
	//Создаем запись статическую (3)
	snmpset_fast($action,FALSE, $oid_mac_type,'i',3);
	// Задаем на каком порту она действует
	snmpset_fast($action,FALSE, $oid_mac_hextring, 'x' ,$hextring);
}

function mac_del ($action,$mac,$vlan)
/* Удаляет статическую запись MAC
*/ {
global $oid;
	$oid_mac_type = $oid['mac_type'] . $vlan .".". hex2dec($mac)."." ."0";
	//Если статическая запись существует
	if (snmpget_fast($action . " obtain STATUS", FALSE, $oid_mac_type)) 
		{
		//Удаляем эту статическую запись (2)
		snmpset_fast($action,FALSE, $oid_mac_type,'i',2);		
		}	
}

/* Преобразует MAC из десятичной формы 1.2.3.4.5.6 в шестнадцатиричную aa:bb:cc:dd:ee:ff */
function mac2hex ($macdec){		
		$mac_ar = explode(".", $macdec);
		foreach ($mac_ar as $value){
			$mac_hex=$mac_hex .":". sprintf("%02s", dechex($value));
			}
	    $mac_hex[0]=" ";
		return trim($mac_hex);
}

/* Глобальные системные переменные
*/
$clientsar = array(); // список пользователей упорядоченый по порту
$ipsg_swar = array(); //список записей IPSG в коммутаторе
$ipsg_bilar = array(); // список записей IPSG в биллинге

$mac_swar=array(); //список записей MAC в коммутаторе
$mac_bilar=array(); // список записей MAC в биллинге


$options = array();
$oid= array();

/*	Включаем системное логгирование
*/
	openlog("bill-sw-ec-snmp", LOG_PID,LOG_LOCAL6);
	syslog_safe(LOG_INFO, sprintf("SW_START: Profiling host IP:%s using FILE:%s", $host, $cfg));

/* Задаем дефолтные значения для опций*/

	
/*	Читаем конфигурационный файл
 Комментарии начинаются с #
 формат строк конфигурационного файла
 Строка опции Имя=Опция
 обязательно требуются
 readcomm
 writecomm
 stubvlan
*/
$comment_pattern = 	"|^.*\#(.+)$|ix";
// $record_pattern = 	"|^(\d+)\s+(\w\w\:\w\w\:\w\w\:\w\w\:\w\w\:\w\w)\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+)|ix";
$record_pattern = 	"|^(\d+)\s+(\w\w\:\w\w\:\w\w\:\w\w\:\w\w\:\w\w)\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+)\s+(.*)|ix";
$option_pattern = 	"|^(\w+)\s*\=\s*(.+)|ix";
if($bill_cfg = file($cfg)){
	foreach($bill_cfg as $key=>$value){
	// Comment line
		if(preg_match($comment_pattern, $value, $line)){
			syslog_safe(LOG_INFO, sprintf("Loaded COMMENT from cfg:[%s] line:[%s]",$cfg, $line[0]));
			continue;
		} 
	// RECORD line
		if(preg_match($record_pattern, $value, $line)){
			list($all, $vlan, $mac, $ip, $port, $client) = $line;
			// заполняем массивы записей ipsg,mac и описаний портов
			$ipsg_bilar[] = compact('vlan', 'mac', 'ip', 'port');

			$hextring="" . port_enable("00 00 00 00 00 00 00 00",$port);

			$mac_bilar[] = compact('mac','vlan','hextring');
			$hextring="" . port_enable("00 00 00 00 00 00",$port);
			$mac_bilar_shex[] = compact('mac','vlan','hextring');
			
			$clientsar[$port]= substr($client. "&" . $clientsar[$port],0,31);
			syslog_safe(LOG_INFO, sprintf("Loaded from file IPSG RECORD:%s",$line[0]));
			continue;
		} 

	// OPTION line
		if(preg_match($option_pattern, $value, $line)) {
			$option[$line[1]] = $line[2];
			syslog_safe(LOG_INFO, sprintf("Loaded OPTION from cfg:[%s] option:[%s] value:[%s]",$cfg,$line[1],$line[2]));
		}
	}
    syslog_safe(LOG_INFO, sprintf("OK:Successfully loaded config file:%s.",$cfg ));
} else {
    syslog_safe(LOG_ERR, sprintf("Fatal Error: Loading config file:%s.Exiting.", $cfg));
    exit(2);
}

//Флаг если были изменения - нужно пересохранить конфигурацию.
$switch_rebuild=FALSE;
//SNMP community readonly
$read = $option["readcom"];
//$comm_read=$read;

//SNMP community fullaccess
$write = $option["writecom"];
//$comm_write = $write;

/* Задаем режим работы SNMP билииотеки
*/
snmp_set_quick_print(1);
snmp_set_oid_output_format(SNMP_OID_OUTPUT_NUMERIC);

/* Определяем модель коммутатора и его BASIC_OID
*/

$sw_model = snmpget_fast("Detecting switch model.", TRUE,".1.3.6.1.2.1.1.1.0" );
$sw_basic_oid = snmpget_fast("Obtaining basic oid.", TRUE,".1.3.6.1.2.1.1.2.0" ) ;

if ($sw_model == "Layer2+ Fast Ethernet Standalone Switch ES3526XA") {
	$mac_bilar=$mac_bilar_shex;
}

/* Формируем на основе BASIC_OID массив SNMP OIDов для конкретной модели
*/
$oid = oid_gen($sw_basic_oid);

/* Читаем IP SOURCE GUARD записи из коммутатора 
*/
syslog_safe(LOG_INFO, sprintf("START: Read IPSG records from IP:[%s] community:[%s] oid:[%s]",$host,$option["readcom"],$oid['ipsg_status']));            
$res=snmprealwalk($host,$option[readcom],$oid[ipsg_status]);
if(isset($res)){
    foreach($res as $key=>$value){
	if($value == 1){
	    $tmp = str_replace($oid[ipsg_status].".", "", $key);
    	$tmp_arr = explode(".", $tmp);

	    $a = array();
	    $a['vlan'] = $tmp_arr[0];
	    unset($tmp_arr[0]);
	    array_walk($tmp_arr, 'dec2hex');

	    $a['mac'] = implode(":", $tmp_arr);
	    $a['ip'] = snmpget_fast("IPSG READ: IP:", TRUE,$oid[ipsg_ip].".".$tmp);
	    $a['port'] = snmpget_fast("IPSG READ: PORT",TRUE,$oid[ipsg_port].".".$tmp);
	    $ipsg_swar[] = $a;	

        syslog_safe(LOG_INFO, sprintf("Obtained IPSG record mac:%s ip:%s port:%s vlan:%s",$a['mac'],$a['ip'],$a['port'],$a['vlan']));            

	}
    }
    syslog_safe(LOG_INFO, sprintf("SUCCESS: Switch IPSG table read from IP:[%s].",$host));            
	} else {
    syslog_safe(LOG_ERR, sprintf("Can't read switch IPSG table"));
    exit(3);            
}

/* Читаем IP MAC записи из  коммутатора 
*/
syslog_safe(LOG_INFO, "START: Read MAC records from IP:[" . $host. "] oid:[" . $oid[mac_type_walk] . "]" );            
$mac_walkar=snmprealwalk($host,$option[readcom],$oid[mac_type_walk]);
if(isset($mac_walkar)){
    foreach($mac_walkar as $key=>$value){
	if($value == 3){
	$rec=explode(".",str_replace($oid[mac_type],"", $key));
	$hexoid=str_replace($oid[mac_type],$oid[mac_hextring], $key);

	$vlan=$rec[0];
	$mac=mac2hex($rec[1] .".". $rec[2] .".". $rec[3] .".". $rec[4] .".". $rec[5] .".". $rec[6]);
	
	$hextring=str_replace('"',"",snmpget_fast("Read hextring record MAC",TRUE,$hexoid));
	$mac_swar[] = compact('mac','vlan','hextring');
		}
  
	}
	syslog_safe(LOG_INFO, sprintf("SUCCESS: Switch MAC table read from IP:[%s].",$host));            
	} else {
    syslog_safe(LOG_ERR, sprintf("Can't read switch MAC table"));
    exit(3);            

}





/* формируем массив для удаления и добавления записей MAC
*/
$mac_delar = $mac_swar; // delar - эти записи будуем удалять из коммутатора
$mac_addar = $mac_bilar; // addar - эти записи будем добавять в коммутатор
foreach($mac_swar as $sw_key => $sw_val){
		$s = implode("", $sw_val);
			foreach($mac_bilar as $bill_key => $bill_val){
				$b = implode("", $bill_val);
				if($s==$b){
				unset($mac_delar[$sw_key]);
				unset($mac_addar[$bill_key]);
				}
			}
}

//print_r($mac_swar);
//print_r($mac_bilar);
//exit(3);

/* формируем массив для удаления и добавления записей IPSG
*/
$ipsg_delar = $ipsg_swar; // st - эти записи будуем удалять из коммутатора
$ipsg_addar = $ipsg_bilar; // bt - эти записи будем добавять в коммутатор
foreach($ipsg_swar as $sw_key => $sw_val){
		$s = implode("", $sw_val);
			foreach($ipsg_bilar as $bill_key => $bill_val){
				$b = implode("", $bill_val);
				if($s==$b){
				unset($ipsg_delar[$sw_key]);
				unset($ipsg_addar[$bill_key]);
				}
			}
}




/* Удаляем из коммутатора IPSG записи и связанные с ними привязки VLAN
*/
foreach($ipsg_delar as $key => $value){
	//Флаг-были изменения - нужно пересохранить конфигурацию.
	$switch_rebuild=TRUE;

	//удаление из коммутатора записи IPSG, которых нет в конфиге из биллинга
	snmpset_fast("Removing IPSG record.",TRUE,$oid[ipsg_status].".".$value['vlan'].".".hex2dec($value['mac']), 'i', 6);

	//Отключение IPSG на порту
   	snmpset_fast("IPSG on port: Disable",TRUE,$oid['ipsg_port_enable'].".".$value['port'], 'i', 0);
	snmpset_fast("Port security: Disable",TRUE,$oid['port_security'].".".$value['port'],'i', 2);

	// Устанавливаем на порту native vlan заглушку
	vlan_replace(" STUB ",$value['vlan'],$option['stubvlan'],$value['port']);
		
	// Очищаем имя на порту
	if (isset($clientsar[$value['port']]))
		{
			snmpset_fast("Port name: Clear to user",TRUE,$oid[port_name].$value[port],'s',$clientsar[$value['port']]);
		} else {
			snmpset_fast("Port name: Clear to user empty",TRUE,$oid[port_name].$value[port],'s',"");
		}
}

/* Удаляем из коммутатора MAC записи
*/
foreach($mac_delar as $key => $value){
	//Флаг-были изменения - нужно пересохранить конфигурацию.
	$switch_rebuild=TRUE;
	mac_del("MACstatic: DEL",$value['mac'],$value['vlan']);
}



/*Добавляем в коммутатор IPSG записи и связанные с ними привязки VLAN
*/
foreach($ipsg_addar as $key => $value){
	//
	//Флаг-были изменения - нужно пересохранить конфигурацию.
	$switch_rebuild=TRUE;
	
 $index = ".".$value['vlan'].".".hex2dec($value['mac']);

	// Очищаем место перед созданием записи
	snmpset($host, $write, $oid[ipsg_status].$index, 'i', 5);
	snmpset($host, $write, $oid[ipsg_iptype].$index, 'i', 1);
	snmpset($host, $write, $oid[ipsg_ip].$index, 'a', $value['ip']);
	snmpset($host, $write, $oid[ipsg_port].$index, 'i', $value['port'] );
    snmpset($host, $write, $oid[ipsg_port_enable].".".$value['port'], 'i', 2);
    snmpset($host, $write, $oid[ipsg_status].$index, 'i', 1);
    snmpset($host, $write, $oid[ipsg_status].$index, 'i', 6);
    snmpset($host, $write, $oid[ipsg_port_enable].".".$value['port'], 'i', 0);

// Создаем запись в таблице IPSG
	snmpset_fast("Add IPSG record: Create",TRUE,$oid[ipsg_status].$index,'i',5);
	snmpset_fast("Add IPSG record: Set IP addr type",TRUE,$oid[ipsg_iptype].$index,'i',1);
	snmpset_fast("Add IPSG record: Set IP addr",TRUE,$oid[ipsg_ip].$index, 'a', $value['ip']);
	snmpset_fast("Add IPSG record: Set port",TRUE,$oid[ipsg_port].$index, 'i', $value['port']);
	snmpset_fast("Add IPSG record: Set IPSG mode",TRUE,$oid[ipsg_port_enable].".".$value['port'], 'i', 2);
	snmpset_fast("Add IPSG record: Enable",TRUE,$oid[ipsg_status].$index,'i',1);

// Включаем port security на порту
	snmpset_fast("Port security: Enable",TRUE,$oid['port_security'].".".$value['port'],'i',1);
	snmpset_fast("Port security: Action ",TRUE,$oid['port_security_action'].".".$value['port'],'i',1);
	snmpset_fast("Port security: Volume ",TRUE,$oid['port_security_count'].".".$value['port'],'i',0);
    
// Заменяем PVID заглушки на требуемый PVID
	vlan_replace(" CUSTOMER ",$option['stubvlan'],$value['vlan'],$value['port']);
	
// Добавляем статические записи MAC
//	mac_add("MAC static: ADD",$value['mac'],$value['port'],$value['vlan']);
// Устанавливаем имя на порту
	snmpset_fast("Port name: SET",TRUE,$oid[port_name].$value[port],'s',$clientsar[$value[port]]);	
}

/*Добавляем в коммутатор MAC записи и связанные с ними привязки VLAN
*/
foreach($mac_addar as $key => $value){
	//Флаг-были изменения - нужно пересохранить конфигурацию.
	$switch_rebuild=TRUE;
	// Добавляем статические записи MAC
	mac_add("MAC static: ADD",$value['mac'],$value['hextring'],$value['vlan']);
}


/* Если были изменения - сохраняем конфигурацию в startup file.
*/
 if ($switch_rebuild) {
    snmpset_fast("SOURCE file: Running config", TRUE, $oid[config_src], 'i', 2);
    snmpset_fast("DESTINATION file: Startup config", TRUE, $oid[config_dst], 'i', 3);
    snmpset_fast("FILE NAME:". $option['startup_config'], TRUE, $oid[config_name], 's', $option["startup_config"]);
    snmpset_fast("START COPY:",TRUE, $oid[config_action], 'i',2);
 }


syslog_safe(LOG_INFO, "SW_FINISHED: Profiling host IP:". $host ." using FILE:" . $cfg);

?>