#!/usr/bin/php
<?php
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.34 $
*/
!isset($_SERVER['SERVER_NAME']) || exit;
error_reporting(E_ALL);
//$debug = 1;

exit;

setlocale(LC_CTYPE, 'ru_RU');

ini_set('include_path', '../');
include_once("includes/options.php");
include_once("classes/context/include.php");

$beanFactory = new CompositBeanFactory(array(
	new ArrayBeanFactory('boot/caban/tools.php'),
	new ArrayBeanFactory('boot/caban/upgrade-log.php'),
	new ArrayBeanFactory('boot/caban/upgrade-dao.php'),
));
$loggerFactory = $beanFactory->getBean('loggerFactory');
$logger = $loggerFactory->getLogger('upgrade');
$src = $beanFactory->getBean('src_connection');
$dst = $beanFactory->getBean('dst_connection');

$opt = array(
//	'keep_profiles' => array('64k-64k', '!5Mb', '!10Mb', '!20Mb', '!30Mb', '!38Mb', '!100Mb'),
	'now' => date("Y-m-d H:i:s"),
	'calendar_period' => 1,
	'rt_charge_type' => 18,
	'rt_traffic' => 1,
	'ac_pay_card' => 3,
	'ac_charge_type' => 218098,
	'ac_deposit_rest_src' => 13,
	'ac_deposit_dolg_dst' => 14,
	'ac_prepay_rest_src'=>15,
	'city' => 1,
	'district' => 1,
);

$dst->query("BEGIN");

// move_config();
// move_rules();
// move_tariffs();
// move_shapers();
// move_networks();
// move_domains();
// move_departments();
// move_modems_actions(); 
// move_mailbox_types();
// move_charge_types();
// move_modems_profiles();
// move_queries();
// move_connection_types();
// move_operators();


move_streets();
move_modems();
move_clients();
move_mail_lists();
/*
move_cards();
*/

$dst->query("COMMIT");

exit;

function stamp($row){
	global $dst;
	extract($row);
	return $dst->insert_auto("INSERT INTO stamps (created, created_by, modified, modified_by) VALUES (%s, %s, %s, %s)",
		$created, $created_by?:'', $modified, $modified_by?:'');
}

function move_connection_types(){
	global $src, $dst, $logger;
	$logger->info("moving connection_types");
	$res = $src->select("SELECT * FROM connection_types WHERE name LIKE '%%'");
	while( $row = $res->Next() ) {
		$dst->insert("INSERT IGNORE INTO connection_types (id, city, name) VALUES (%s, %s, %s)", $row['id'], $opt['city'], $row['name']);
	}
}

function move_departments(){
	global $src, $dst, $logger;
	$logger->info("moving departments");
	$res = $src->select("SELECT * FROM departments");
	while( $row = $res->Next() ) {
		$dst->insert("INSERT INTO departments (id, name) VALUES (%s, %s)", $row['id'], $row['name']);
	}
}

function move_operators(){
	global $src, $dst, $logger, $opt;
	$logger->info("moving operators & operators_access");
	$dst->update("DELETE FROM operators");
	$res = $src->select("SELECT * FROM operators");
	while($row = $res->Next()) {
		extract($row);
		$person = $dst->insert_auto("INSERT INTO staff (city, name, stamp) VALUES (%s, %s, %s)", $opt['city'], $name, stamp($row));
		$dst->insert("INSERT INTO operators (id, department, person, login, pass, city_mode, stamp) VALUES (%s, %s, %s, %s, %s, %s, %s)",
			$id, $department?:'', $person, $login, $pass, 1, stamp($row));
		$dst->insert("INSERT INTO operators_cities (operator, city) VALUES (%s, %s)", $id, $opt['city']);
		move_operators_access($id);
		//move_operators_logins($id);
	}
}

function move_operators_access($operator){
	global $src, $dst, $logger;
	$res = $src->select("SELECT * FROM operators_access WHERE entity not in(14,24) AND operator=%s", $operator);
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT IGNORE INTO operators_access (operator, entity, access) VALUES (%s, %s, %s)", $operator, $entity, $access);
	}
}

function move_operators_logins($operator){
	global $src, $dst, $logger;
	$res = $src->select("SELECT * FROM operators_logins WHERE operator=%s", $operator);
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO operators_logins (operator, loged, ip) VALUES (%s, %s, %s)", $operator, $loged, $ip);
	}
}

function move_streets(){
	global $src, $dst, $logger, $opt;
	$logger->info("moving streets");
	$res = $src->select("SELECT * FROM streets");
	while($row = $res->Next()) {
		extract($row);
		$dst->insert("INSERT INTO streets (id, city, name, stamp) VALUES (%s, %s, %s, %s)",  $id, $opt['city'], $name, stamp($row));
	}
}

function move_tariffs(){
	global $src, $dst, $logger;
	$logger->info("moving tariffs");
	$res = $src->select("SELECT * FROM tarifs");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO tariffs (id, name, description, function, unit_size, stamp) VALUES (%s, %s, %s, %s, %s, %s)",
			$id, $name, $description, $function, 1048576, stamp($row));
	}
}


function move_rules(){
	global $src, $dst, $logger;
	$logger->info("moving rules");
	$dst->update("delete from rules");
	$res = $src->select("SELECT * FROM rules");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO rules (id, name, for_client, chain) VALUES (%s, %s, %s, %s)",
			$id, $name, $name, 'none.accounting.driver.'.$id);
	}
}

function move_networks(){
	global $src, $dst, $logger;
	$logger->info("moving networks");
	$res = $src->select("SELECT * FROM networks");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO networks (id, ip, local, filename, template, host_template, version, stamp) VALUES (%s, %s, %s, %s, %s, %s, %s, %s)",
			$id, $ip, $local, $filename, $template, $host_template, 0, stamp($row));
	}
}

function move_domains(){
	global $src, $dst, $logger;
	$logger->info("moving domains");
	$res = $src->select("SELECT * FROM domains");
	while($row = $res->Next()){
		extract($row);
		$dst->insert("INSERT INTO domains (id, name, template, host_template, version, stamp) VALUES (%s, %s, %s, %s, %s, %s)",
			$id, $name, $template, $host_template, $version, stamp($row));
	}
}

function move_shapers(){
	global $src, $dst, $logger;
	$logger->info("moving shapers");
	$res = $src->select("SELECT * FROM restrictors");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO shapers (id, name, pattern, stamp) VALUES (%s, %s, %s, %s)",
			$id, $name, $restrictor_pattern, stamp($row));
	}
}

function move_modems_actions(){
	global $src, $dst, $logger;
	$logger->info("moving modems_actions");
	$res = $src->select("SELECT * FROM modems_actions");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO modems_actions (id, name, action_pattern, stamp) VALUES (%s, %s, %s, %s)",
			$id, $name, $action_pattern, stamp($row));
	}
}

function move_modems_profiles(){
	global $src, $dst, $logger, $opt;
	$logger->info("moving modem_profiles");
	$res = $src->select("SELECT * FROM modems_profiles");
	while( $row = $res->Next() ) {
		extract($row);
		if(!isset($opt['keep_profiles']) || in_array($name, $opt['keep_profiles'])){
			$hp = str_replace(
				array("%ip","%mac", "%port", "%index","%++"),
				array("<?=\$host['ip']?>","<?=\$host['mac']?>", "<?=\$host['port']?>",'<?=$index;?>','<?$index++;?>'),
				$host_pattern
			);
			$mp = str_replace(
				array("%ip","%mac","%hosts","%count"),
				array(
					"<?=\$modem['ip']?>","<?=\$modem['mac']?>", 
					sprintf("<?foreach(\$modem['hosts'] as \$host){?>\n\n%s\n\n<?}?>\n", $hp), 
					"<?=max(1,count(\$modem['hosts']))?>"
				),
				$modem_pattern
			);
			$ex = str_replace(
				array("%ip", "%mac", "%old_mac", "%old_ip", "%dir%name","%dir", "%name"),
				array("<?=\$modem['ip']?>","<?=\$modem['mac']?>", "<?=\$old_modem['ip']?>","<?=\$old_modem['mac']?>", "<?=\$filename?>", "<?=dirname(\$filename)?>", "<?=basename(\$filename)?>"),
				$executor
			);
			$ex = str_replace("?>\n", "?> \n", $ex);
			$mp = preg_replace("'%index\s*=\s*(\d+)\D'",'<?$index=\1;?>',$mp);
			$dst->insert("INSERT INTO modem_profiles (id, name, template, executor, stamp) VALUES (%s, %s, %s, %s, %s)",
				$id, $name, $mp, $ex, stamp($row));
		}
	}
}

function move_queries(){
	global $src, $dst, $logger;
	$logger->info("moving queries"); 
	$res = $src->select("SELECT * FROM queries");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO queries (id, name, body, stamp) VALUES (%s, %s, %s, %s)",
			$id, $name, $body, stamp($row));
	}
}

function move_mailbox_types(){
	global $src, $dst, $logger;
	$logger->info("moving mailbox_types"); 
	$res = $src->select("SELECT * FROM mailbox_types");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO mailbox_types (id, name, domain, boxsize, mailsize, stamp) VALUES (%s, %s, %s, %s, %s, %s)",
			$id, $name, $domain, $boxsize, $mailsize, stamp($row));
	}
}

function move_mail_lists(){
	global $src, $dst, $logger;
	$logger->info("moving mail_lists"); 
	$res = $src->select("SELECT * FROM mail_lists");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO mail_lists (id, name, file, list_pattern, element_pattern, query, stamp) VALUES (%s, %s, %s, %s, %s, %s, %s)",
			$id, $name, $file, $list_pattern, $element_pattern, $query, stamp($row));
		move_mail_lists_clients($id);
	}
}

function move_mail_lists_clients($mail_list){
	global $src, $dst, $logger;
	$res = $src->select("SELECT * FROM mail_lists_clients");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO mail_lists_clients (id, mail_list, client, stamp) VALUES (%s, %s, %s, %s)",
			$id, $mail_list, $client, stamp($row));
	}
}

function move_config(){
	global $src, $dst, $logger;
	$logger->info("moving config"); 
	$res = $src->select("SELECT * FROM config");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->update("UPDATE config SET value=%s, actual=%s WHERE id=%s",
			$value, $actual, $id);
	}
}

function move_modems(){
	global $src, $dst, $logger, $opt;
	$logger->info("moving modems");
	$res = $src->select("SELECT * FROM modems");
	while($row = $res->Next()) {
		extract($row);
		$dst->insert("INSERT INTO modems (id, city, department, name, domain, ip, mac, profile, notes, street, house, entrance, floor, stamp)
			VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)",
			$id, $opt['city'], 1, $name, $domain, $ip, $mac, $profile, '', $street?:'', $house, $entrance, $floor, stamp($row));
	}
}

function move_charge_types(){
	global $src, $dst, $logger, $opt;
	$logger->info("moving charge_types");
	$res = $src->select("SELECT * FROM charge_types");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO charge_types (id, name, price, unit_size, account, resource_type, stamp)
			VALUES (%s, %s, %s, %s, %s, %s, %s)",
			$id, $name, intval($price*100), 1, $opt['ac_charge_type'], $opt['rt_charge_type'], stamp($row));
	}
}

function move_cards(){
	global $src, $dst, $logger, $opt;
	$logger->info("moving cards");
	$res = $src->select("SELECT * FROM cards WHERE pay=0 AND expire > now()");
	while( $row = $res->Next() ) {
		extract($row);
		$dst->insert("INSERT INTO cards (id, code_public, code_private, amount, account, expire, stamp)
			VALUES (%s, %s, %s, %s, %s, %s, %s)",
			$id, $code_public, $code_private, intval($sum * 100), $opt['ac_pay_card'], $expire, stamp($row));
	}
}

function getHouse($house, $street){
	global $src, $dst, $logger, $opt;
	static $houses;
	if(!isset($houses[$street][$house])){
		$houses[$street][$house] = $dst->insert_auto("INSERT INTO houses (city, street, house, district) VALUES (%s, %s, %s, %s)",
			$opt['city'], $street, $house, $opt['district']);
	}
	return $houses[$street][$house];
}


//     ,   
function getConnectionType($name){
	global $src, $dst, $logger, $opt;
	static $con_types;
	if(!isset($con_types[$name])){
		$sel = $dst->select("SELECT id FROM connection_types WHERE name=%s", $name);
		if($arr = $sel->next()){
			$con_types[$name] = $arr['id'];
		}else{
			$con_types[$name] = 1;
		}
	}
	return $con_types[$name];
}

function move_clients(){
	global $src, $dst, $logger, $opt;
	
	$bad_contracts = array();
	$res = $src->select("select contract from clients where contract > '' group by contract having count(*) > 1");
	while( $row = $res->Next() ) {
	    $bad_contracts[$row['contract']] = 1;
	}
	
	$logger->info("moving clients & hosts & deposit");
	$res = $src->select("SELECT c.*, ct.name as ct_name 
		FROM clients c 
		LEFT JOIN connection_types ct ON ct.id=c.connection_type
		WHERE first_name!=''
		");
	while( $row = $res->Next() ) {
		extract($row);
		if(isset($bad_contracts[$contract])){
		    $notes = trim($notes."\nnon-unique contract: ".$contract);
		    $contract = '';
		}
		if(strlen(trim($letter)) > 0){
			$notes = trim($notes."\n:".$letter);
		}
		if($building && ($house!=$building) && !strstr($house, '/'.$building)){
//		    $house = $house.'/'.$building;
		}
/*
		$letter = strtolower($letter);
		if($letter=='a'){
		    $letter = chr(224);
		}
		if($letter==1){
		    $letter = '';
		}
		$house = $house.($letter?:'');
*/
		$bank_account = trim($row['account']);
		$alarm = intval($alarm *100);
		$block = intval($block *100);
		$deposit = vround($deposit);
		$acc_name = addslashes($last_name.' '.$first_name.' ('.$login.')');
		$account = $dst->insert_auto("INSERT INTO accounts (type, name) VALUES (%s, %s)", 'D', $acc_name);
		$connection_type = getConnectionType($ct_name);
		$house_id = getHouse($house, $street);
		$dst->insert("INSERT INTO clients (id, account, department, connection_type, first_name, last_name, patronymic,
				city, street, house, house_id, building, letter, entrance, floor, apartment, surveyor, phone,
				contract, login, pass, email, bank_account, notice, alarm, block, reduction, blockable, notes, stamp)
				VALUES (%s, %s, %s, %s, %s, %s, %s,
					%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s,
					%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)",
				$id, $account, $department, $connection_type, $first_name, $last_name, $patronymic,
				$opt['city'], $street, $house, $house_id, $building, $letter, $entrance, $floor, $apartment, $surveyor, $phone,
				$contract, $login , $pass, $email, $bank_account, $notice, $alarm, $block, 0, $blockable, $notes, stamp($row));
		move_hosts($id);
		move_client_mailboxes($id);
		move_charge_subscriptions($id);
		if($pp_id = move_personal_preiod($id, $account)){
			$dst->update("UPDATE clients SET personal_period=%s WHERE id=%s", $pp_id, $id);
		}
		//  
		$rest = $deposit;
		if($connection_type==1){
			$rest = 0;
		}
		if($rest > 0) {
			$dst->insert("INSERT INTO movements (calendar_period, src, dst, amount, date) VALUES (%s, %s, %s, %s, %s)",
				$opt['calendar_period'], $opt['ac_deposit_rest_src'], $account, $rest, $opt['now']);
		} elseif($rest < 0){
			$dst->insert("INSERT INTO movements (calendar_period, src, dst, amount, date) VALUES (%s, %s, %s, %s, %s)",
				$opt['calendar_period'], $account, $opt['ac_deposit_dolg_dst'], -$rest, $opt['now']);
		}
		// 
		if($dead){
			$dst->insert("INSERT into blocks (client) VALUES (%s)", $id);
		}
		move_access_tracker($id, !$dead, $connection_type);
	}
}

function move_access_tracker($client, $state, $connection_type){
	global $src, $dst, $logger, $opt;
	$dst->insert("INSERT INTO access_tracker (client, state, connection_type) VALUES (%s, %s, %s)",
		$client, $state?1:0, $connection_type);
}

function move_personal_preiod($client, $account){
	global $src, $dst, $logger, $opt;
	$res = $src->select("SELECT p.*, ct.name as ct_name
		FROM prepays p
		LEFT JOIN connection_types ct ON ct.id=p.connection_type
		WHERE p.client=%s AND p.period_end > NOW()
		ORDER BY id DESC LIMIT 1", $client);
	if($row = $res->Next()){
		extract($row);
		$connection_type = getConnectionType($ct_name);
		$dst->insert("INSERT INTO personal_periods (id, client, connection_type, period_begin, period_end, marker, state)
			VALUES (%s, %s, %s, %s, %s, %s, %s)",
			$id, $client, $connection_type, $period_begin, $period_end, 1, 1);
		$rest = vround($rest);
		if($rest > 0){
			$dst->insert("INSERT INTO movements (calendar_period, src, dst, amount, date) VALUES (%s, %s, %s, %s, %s)",
				$opt['calendar_period'], $opt['ac_prepay_rest_src'], $account, $rest, $opt['now']);
			$dst->insert("INSERT INTO personal_period_plans (personal_period, resource_type, use_plan) VALUES (%s, %s, %s)",
				$id, $opt['rt_traffic'], $rest);
		}
		return $id;
	}
}

function move_hosts($client){
	global $src, $dst, $logger, $opt;
	$res = $src->select("SELECT * FROM hosts WHERE client=%s", $client);
	while( $row = $res->Next()){
		extract($row);
		$dst->insert("INSERT INTO hosts (id, client, ip, mac, name, domain, modem, port, countable, stamp)
			VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s)",
			$id, $client, $ip, $mac, $name, $domain?:'', $modem, $port, $countable, stamp($row));
	}
}

function move_client_mailboxes($client){
	global $src, $dst, $logger, $opt;
	$res = $src->select("SELECT * FROM client_mailboxes WHERE client=%s", $client);
	while( $row = $res->Next()){
		extract($row);
		$dst->insert("INSERT INTO client_mailboxes (id, client, type, login, password, active, stamp)
			VALUES (%s, %s, %s, %s, %s, %s, %s)",
			$id, $client, $type, $login, $password, $active, stamp($row));
	}
}

function move_charge_subscriptions($client){
	global $src, $dst, $logger, $opt;
	$res = $src->select("SELECT * FROM charge_subscriptions WHERE client=%s", $client);
	while( $row = $res->Next()){
		extract($row);
		$dst->insert("INSERT INTO charge_subscriptions (id, client, type, amount, stamp)
			VALUES (%s, %s, %s, %s, %s)",
			$id, $client, $type, 1, stamp($row));
	}
}

function vround( $x, $p = 100.0 ) {
	$r = 0.5 + 0.000000000000001 * $p;
	if( $x < 0 ) {
		$s = -1;
		$y = 0.0 - $x;
	} else {
		$s = 1;
		$y = 0.0 + $x;
	}
	$z = intval( $p * $y + $r ) * $s;
	return( $z );
}

function fix_houses(){
    global $src, $dst, $logger, $opt;
    $logger->info("fix houses");
    $res = $dst->select("SELECT id, house_id FROM clients");
    while($row = $res->Next()){
	extract($row);
	$res1 = $src->select("SELECT house, street, building, letter FROM clients WHERE id=%s", $id);
	if($row1 = $res1->next()){
	    extract($row1);
    	    if($building && ($house!=$building) && !strstr($house, '/'.$building)){
    		$house = $house.'/'.$building;
	    }
	    $letter = strtolower($letter);
    	    if($letter=='a'){
		$letter = chr(224);
	    }
	    if($letter==1){
		$letter = '';
	    }
	    $house = $house.($letter?:'');
	    $fixed_id = getDstHouse($house, $street);
	    $dst->update("UPDATE clients SET house_id=%s, house=%s WHERE id=%s", $fixed_id, $house, $id);
	}
    }
}

function getDstHouse($house, $street){ // used by fix_houses()
	global $dst, $logger, $opt;
	static $houses;
	if(!isset($houses)){
	    $houses = array();
	    $res = $dst->select("SELECT id, street, house FROM houses");
	    while($row = $res->next()){
		$houses[$row['street']][$row['house']] = $row['id'];
	    }
	}
	if(!isset($houses[$street][$house])){
		$houses[$street][$house] = $dst->insert_auto("INSERT INTO houses (city, street, house, district) VALUES (%s, %s, %s, %s)",
			$opt['city'], $street, $house, $opt['district']);
	}
	return $houses[$street][$house];
}

?>