<?
/*
author: Ponomarev Denis <ponomarev@gmail.com>
$Date: 2004/04/27 08:37:36 $
$Revision: 1.16 $
*/
include_once('includes/global.php');
include_once('classes/tools/PhpTemplate.php');
loadStrings(BOOT.'tv_nodes/strings.txt');
loadStrings(BOOT.'exp_points/strings.txt');

$doc->title .= ' :: '.getResource('tv.struct.title');

required_access('netstruct');ob_start();
?>

<script type="text/javascript" src="scripts/tv_nodes.js"></script>

<?
$kids = array();
$nodes = array();
$root = array();
$bad = array();

$res = $db->Execute('SELECT n.id, n.name, s.name as street_name, h.house, p.entrance, n.audit,
	n.power_in,
	t.power_out,
	tw.input_power,
	tw.output_power,
	tw.available,
	case p.floor
		when -1 then "'.getResource('exp.points.floor.1').'"
		when -2 then "'.getResource('exp.points.floor.2').'"
		when -3 then "'.getResource('exp.points.floor.3').'"
		when -4 then "'.getResource('exp.points.floor.4').'"
		else IFNULL(p.floor,"") end as floor,
	n.parent, t.name as model, 0 as state,
	IF(oc.city IS NULL, 0, 1) allow
	FROM tv_nodes n
	LEFT JOIN tv_node_types t ON t.id=n.type
	LEFT JOIN tv_nodes_power tw ON tw.tv_node=n.id
	LEFT JOIN operators_cities oc ON oc.city=n.city AND oc.operator="'.$oper->id.'"
	LEFT JOIN exp_points p ON p.id=n.point
	LEFT JOIN houses h ON h.id=p.house
	LEFT JOIN streets s ON s.id=h.street ORDER BY n.name');
while($arr = $db->Next($res)){
	$nodes[$arr['id']] = $arr;
	if($arr['parent']){
		$kids[$arr['parent']][$arr['id']] = 1;
	}else{
		$root[] = $arr['id'];
	}
}

function checkAccess($mid){
	global $nodes, $kids;
	$allow = false;
	if(isset($kids[$mid])){
		foreach($kids[$mid] as $kid=>$x){
			if(checkAccess($kid)){
				$allow = true;
			}
		}
	}
	$allow |= $nodes[$mid]['allow'];
	if(!$allow){
		$node = $nodes[$mid];
		unset($nodes[$mid]);
		if($node['parent']){
			unset($kids[$node['parent']][$mid]);
		}
	}
	return $allow;
}

if($oper->city_mode){
	foreach($root as $rid){
		checkAccess($rid);
	}
}

function checkCircle($mid, &$check_errors, $trace=array()){
	global $nodes;
	$node = $nodes[$mid];
	if(in_array($mid, $trace)){
		if(!isset($check_errors[$mid])){
			$pos = array_search($mid, $trace);
			$check_errors[$mid] = array_slice($trace, $pos);
		}
		return false;
	}
	if(!$node['parent']){
		return true;
	}else{
		$trace[] = $node['id'];
		return checkCircle($node['parent'], $check_errors, $trace);
	}
}

$check_errors = array();
foreach($nodes as $node){
	checkCircle($node['id'], $check_errors);
}
foreach($check_errors as $trace){
	echo "Cyclic error :";
	foreach($trace as $id){
		echo '<a href="tv_nodes.php?id='.$id.'">'.$nodes[$id]['name'].'</a> => ';
	}
	echo $nodes[$trace[0]]['name'].'<br>';
}
?>

<script type="text/javascript"><!--

var icons = {
	node		: 'img/modem.gif',
	node_state	: {
		1 : 'img/modem_warn.gif',
		2 : 'img/modem_warn.gif',
		3 : 'img/modem_bad.gif',
	},
	empty		: 'img/empty.gif',
	line		: 'img/line.gif',
	join		: 'img/join.gif',
	joinBottom	: 'img/joinbottom.gif',
	plus		: 'img/plus.gif',
	plusBottom	: 'img/plusbottom.gif',
	minus		: 'img/minus.gif',
	minusBottom	: 'img/minusbottom.gif',
	nlPlus		: 'img/nolines_plus.gif',
	nlMinus		: 'img/nolines_minus.gif'
};

var mTree = new TvTree('mTree', icons);

<?

function sortByPort($id1, $id2){
	global $nodes;
	return $nodes[$id1]['port'] - $nodes[$id2]['port'];
}

function calc_state($node){
	if(!$node['audit']) return 0;
	if(strlen($node['input_power']) > 0){
		$in_warning = (abs($node['power_in'] - $node['input_power']) >= 200) ? 1 : 0;
		$in_error = ($node['input_power'] < 0) ? 3 : 0;
	}else{
		$in_warning = $in_error = 0;
	}
	if(strlen($node['output_power']) > 0){
		$out_warning = ($node['output_power'] < $node['power_out']) ? 2 : 0;
		$out_error = ($node['output_power'] <= ($node['power_out'] - 200)) ? 3 : 0;
	}else{
		$out_warning = $out_error = 0;
	}
	return max($in_warning, $out_warning, $in_error, $out_error);
}

function addNode($mid, $pid, $parent_state=0){
	global $nodes, $kids;
	$node = $nodes[$mid];
	$node_state = $parent_state==3 ? 3 : calc_state($node);
	$nodes[$mid]['state'] = $node_state;
	printf("mTree.add(new TvNode(%s, %s, '%s', '%s', '%s', '%s', '%s', '%s', '%s'));\n",
		$pid,
		$node['id'],
		htmlspecialchars($node['name'], ENT_QUOTES),
		$node['model'],
		htmlspecialchars($node['street_name'], ENT_QUOTES),
		$node['house'],
		$node['entrance'],
		$node['floor'],
		$node_state);
	if(isset($kids[$mid])){
		uksort($kids[$mid], 'sortByPort');
		foreach($kids[$mid] as $id=>$x){
			addNode($id, $mid, $node_state);
		}
	}
}

foreach($root as $rid){
	addNode($rid,-1);
}
?>

//-->
</script>

<style>
.nodes {width:100%; border:1px solid #fff;}
.nodes table {border-collapse: collapse; width:100%; }
.nodes .selected {background-color:#ffffdd;}
.nodes td {padding:1px 4px; border-bottom:1px solid #fff;}
.nodes td img {margin:0; border:none;}
.nodes td.indent, .nodes td.icon  {
	width:18px;
	text-align: center;
	padding: 0px;
}
.nodes .Over {background-color: #f8f8f8;}
.nodes .au0 {background-color: #dfd;}

.nodes .st0 {background-color: inherit;}
.nodes .st1 {background-color: #cdf;}
.nodes .st2 {background-color: #fcf;}
.nodes .st3 {background-color: #fbb;}

.nodes .st0Over {background-color: #f8f8f8;}
.nodes .st1Over {background-color: #def;}
.nodes .st2Over {background-color: #fdf;}
.nodes .st3Over {background-color: #fdd;}

.nodes td.name {}
.nodes td.name a {color: black;}
.nodes td.name a:hover {text-decoration: underline;}
.nodes td.model {width: 20em;}
.nodes td.street {width: 30em;}
.nodes td.house {width: 3em; text-align: right;}
.nodes td.entrance {width: 5em; text-align: right;}
.nodes td.floor {width: 9em; text-align: right;}
.nodes td.off {width: 7em; text-align: right;}
.nodes td.port {width: 5em; text-align: right;}
.nodes td.toCatalog {width:0.6em; text-align: center;}
.nodes .kids {padding:0; margin-top:-1px;width:100%;}
.nodes .kids_in {padding:0; margin-top:0px;width:100%;}

</style>

<div class="nodes">
<table>
	<tr>
		<td class="indent"><a href="javascript:mTree.toggleAll()"><img src="img/base.gif" height=18 width=19></a></td>
		<td class="indent"><img src="img/empty.gif" height=18 width=18></td>
		<td class="name"></td>
		<td class="model"></td>
		<td class="street"></td>
		<td class="entrance"></td>
		<td class="floor"></td>
		<td class="toCatalog"></td>
	</tr>
</table><div class="kids"></div><script type="text/javascript"><!--
document.write(mTree.draw());

<?if($_GET['id']){?>
mTree.select(<?=$_GET['id']?>);
<?}else{
	foreach($nodes as $node){
		if($node['state'] > 0 && $node['parent']){
			printf("mTree.openTo(%s);\n", $node['parent']);
		}
	}
}?>

mTree.registerHighLight("Over");
//-->
</script>
</div>
<?
$doc->page->contents['a'] = ob_get_clean();
echo $doc->Paint();
?>