<?
function IpMatch($network, $mask, $ip) {
   $n = ip2long($network);
   $i = ip2long($ip);
   if (is_numeric($mask)) {// 10.10.10.0/24
       $m = ~((1<< (32-$mask))-1);
   }else{// 10.10.10.0/255.255.255.0
       $m = ip2long($mask); 
   }
   return !(($n & $m)-($i & $m));
}

function isIp($ip){
	return !(ip2long($ip)===FALSE || ip2long($ip)==-1);
}

function sortByDate($arr1, $arr2){
	return $arr2['date'] - $arr1['date'];
}

function isIpFrom($filename, $ip){
	$match = false;
	$file = @fopen($filename, "r");
	if ($file) {
	    while (!feof($file) && !$match) {
	        if($line = trim(fgets($file, 128))){
				@list($net_ip, $net_mask) = explode("/", $line);
				if($net_ip){
					if($net_mask){
						$match = IpMatch($net_ip, $net_mask, $ip);
					}else{
						$match = $ip = $net_ip;
					}
				}
			}
	    }
	    fclose($file);
	}
	return $match;
}

session_start();
$history = isset($_SESSION['history']) ? $_SESSION['history'] : array();

$ip = trim($_GET['ip']);
if($ip){
	if(!isIp($ip)){
		$name = $ip;
		if(preg_match("/^(((https:)|(http:)|(ftp:))\/\/)?([^\/]+)/i",  $name, $matches)){
			$name = $matches[6];
			@list($name, $port) = explode(":", $name);
		}
		$ip = gethostbyname($name);
		if(isIp($ip)){
			$valid = true;
		}else{
			$valid = false;
		}
	}else{
		$name = gethostbyaddr($ip);
		$valid = true;
	}
	if($valid){
		if(isIpFrom("local-list.txt", $ip)){
			$zone = 3;
		}elseif(isIpFrom("ua-list.txt", $ip)){
			$zone = 2;
		}else{
			$zone = 1;
		}
		$host = array(
			'ip'=>$ip,
			'name'=>$name,
			'date'=>mktime(),
			'resolved'=>$ip!=$name,
			'zone'=>$zone,
		);
		$history[$name] = $host;
		uasort($history, 'sortByDate');
		$_SESSION['history'] = $history;
	}
}
header("Content-Type: text/html; charset=cp1251");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<head>
<title>  </title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
<style>
	body {font-size: 8pt; font-family: Tahoma;}
	.intro {padding-bottom: 4px;} 
	.form {background-color: #f0f0f0;}
	.form td {padding:10px 12px;}
	.ipinput {width: 250; font-size: 8pt; font-family: Tahoma;}
	.button {font-size: 8pt; font-family: Tahoma;}
	.local  {color: #000000;}
	.uaix  {color: blue;}
	.notuaix {color: red;}
	.error {color: red; font-family: Monospace; padding: 8px;}
	.history {font-size: 8pt; font-family: Tahoma;}
	.history td {padding:3px;}
	.last {font-weight:bold;}
	.row0 {background-color: #f0f0f0;}
	.row1 {background-color: #f6f6f6;}
	.a {text-decoration: none;}
	.a:hover {text-decoration: underline;}
</style>
</head>
<body>
<center><b><a class=a href="http://ua.lanet.kiev.ua/ua-list.txt">  UA-IX</a> </b>||<b> <a class=a href="http://ua.lanet.kiev.ua/local-list.txt">  Lanet</a></b></center><br>
<form>
<table align=center cellpadding=0>
<tr class=form><td align=center>
<input class=ipinput name="ip" value="<?=$_GET['ip']?>" title=" IP-,    ">
<input class=button type="submit" value="">
</td></tr>
<?if($_GET['ip'] && !$valid){?>
<tr><td align=center>
	<div class=error>'<?=$_GET['ip']?>' -  !</div>
</td></tr>
<?}?>
<?if(!empty($history)){$i=0;?>
<tr><td>
<table class=history width="100%" cellspacing=1>
	<?foreach($history as $host){$last = $i++==0;?>	<tr class=<?if($last){?>last<?}else{?>row<?=($i%2)?><?}?>>
		<td width=10%><?=$host['ip']?></td>
		<td><?if($host['resolved']){?><a class=a href="http://<?=$host['name']?>"><?=$host['name']?></a><?}?></td>
		<?if($host['zone']==3){?><td align=center class=local width=10% nowrap>LOCAL</td></tr>
		<?}elseif($host['zone']==2){?><td align=center class=uaix width=10% nowrap>UA-IX</td></tr>
		<?}elseif($host['zone']==1){?><td align=center class=notuaix width=10% nowrap>NOT UA-IX</td></tr>
		<?}else{?><td></td></tr>
		<?}?>
	<?}?></table>
</td></tr>
<?}?>
</table>
</form>
</body>
