<?
include_once "includes/environment.php";
include_once "functions/accounts.php";
include_once "classes/log/FileAppender.php";
include_once "classes/log/DefaultLogger.php";
include_once "classes/nusoap/nusoap.php";

$appender = new FileAppender('/var/log/ukrcard.log');
$logger = new DefaultLogger();
$logger->setAppender($appender);
$logger->setName('ukrcard');
//$logger->setLevel(2);

function test_method($client, $method, $args){
	$result = $client->call($method, $args);
	print_r($result);
	echo $client->getError();
	echo '<h2>request</h2>';
	echo '<pre>' . htmlspecialchars(str_replace("><", ">\n<", $client->request), ENT_QUOTES) . '</pre>';
	echo '<h2>response</h2>';
	echo '<pre>' . htmlspecialchars(str_replace("><", ">\n<", $client->response), ENT_QUOTES) . '</pre>';
}

function test_get($client){
	return test_method($client, 'getPaymentInfo', array(
		'tranid' => 'test123',
		'paysysid' => 'UKRC',
		'serviceid' => 'INET',
		'payercode' => '333221',
		'barcode' => '',
	));
}

function test_put($client){
	return test_method($client, 'putPayment', array(
		'tranid' => 'test123',
		'paysysid' => 'UKRC',
		'serviceid' => 'INET',
		'paymentinfo' => array(
			'payercode' => '333221',
			'payername' => utf(''),
			'paydate' => '2012-01-03 12:00:00',
			'summa' => '10.29',
		),
	));
}

function test_reg($client){
	return test_method($client, 'putregister', array(
		'paysysid' =>		'UKRC',
		'Mfo' =>			'123123123',
		'registerid' =>		'126',
		'registerdate' =>	'2012-01-11',
		'orderno' =>		'234234',
		'orderdate' =>		'2012-01-10',
		'ordersum' =>		'10.29',
		'allcount' =>		'2',
		'allsumma' =>		'10.29',
		'tranlist' =>		array(
			'transaction'=>array(
				array(
					'Rownum' => 		1,
					'serviceid' => 		'INET',
					'paymentinfo' => 	array(
						'payercode' =>	'333222',
						'payername' =>	'zvezda',
						'paydate' =>	'2012-01-03 12:00:00',
						'summa' =>		'10.29',
						'paymentid' =>	7,
						'regdate' =>	'2012-01-01',
						'paymenstat' =>	0,
						'paymenstatname' => 'poh',
					),
				),
				/*array(
					'Rownum' => 		1,
					'serviceid' => 		'INET',
					'paymentinfo' => 	array(
						'payercode' =>	'333222',
						'payername' =>	'zvezda',
						'paydate' =>	'2012-01-03 12:00:00',
						'summa' =>		'10.29',
						'paymentid' =>	1,
						'regdate' =>	'2012-01-01',
						'paymenstat' =>	0,
						'paymenstatname' => 'poh',
					),
				),*/
			),
		),
	));
}

if(isset($_GET['test'])){
	header("Content-Type: text/html; charset=utf-8");
	$wsdl = "http".($_SERVER['HTTPS'] == "on" ? 's' : '')."://". $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'].'?wsdl'; 
	$client = new soapclient($wsdl, 'wsdl');
	$client->http_encoding='UTF-8';
	$client->soap_defencoding = 'UTF-8'; 
	$client->decode_utf8 = false;
//	test_get($client);
//	test_put($client);
//	test_reg($client);
	exit;
}

function utf($str){
	return iconv('cp1251', 'utf8', $str);
}

function cp1251($str){
	return iconv('utf8', 'cp1251', $str);
}

function getPsaName($paysysid){
	$psa_list = parse_ini_string(getTrimOption('UKRCARD_PSA_LIST'));
	return $psa_list[$paysysid];
}

function getServiceName($serviceid){
	$service_list = parse_ini_string(getTrimOption('UKRCARD_SERVICE_LIST'));
	return $service_list[$serviceid];
}

function getPaymentInfo($tranid, $paysysid, $serviceid, $payercode, $barcode){
	global $db, $logger;
	$logger->info('getPaymentInfo: tranid=%s, paysysid=%s, serviceid=%s, payercode=%s, barcode=%s', $tranid, $paysysid, $serviceid, $payercode, $barcode);
	$paysysname = $servicename = $payername = $payeraddress = $respmessage = ''; $respcode = 0;
	$db->Begin();
	if(loadValue("SELECT account FROM system_accounts WHERE code='PAY_UKRCARD'")){
		if($paysysname = getPsaName($paysysid)){
			if($servicename = getServiceName($serviceid)){
				if($client = loadRecord(sprintf("SELECT c.id, c.last_name, c.first_name, c.apartment, s.name as street_name, h.house
					FROM clients c
					LEFT JOIN houses h ON h.id=c.house_id
					LEFT JOIN streets s ON s.id=h.street
					WHERE c.contract='%s'", addslashes($payercode)))){
					$payername = $client['last_name'].' '.$client['first_name'];
					$payeraddress = $client['street_name'].' '.$client['house'].', '.$client['apartment'];
					$respcode = 0;
					$respmessage = 'Ok';
				}else{
					$respcode = 2;
					$respmessage = 'unknown payercode';
				}
			}else{
				$respcode = 3;
				$respmessage = 'no such service';
			}
		}else{
			$respcode = 1;
			$respmessage = 'unknown payment system';
		}
	}else{
		$respcode = 8;
		$respmessage = 'system error';
	}
	if(!$db->End()){
		$respcode = 8;
		$respmessage = 'system error';
	}
	return array(
		'tranid' => $tranid,
		'paysysid' => $paysysid,
		'paysysname' => utf($paysysname),
		'serviceid' => $serviceid,
		'servicename' => utf($servicename),
		'payercode' => $payercode,
		'payername' => utf($payername),
		'payeraddress' => utf($payeraddress),
		'respcode' => $respcode,
		'respmessage' => utf($respmessage),
	);
}

function putPayment($tranid, $paysysid, $serviceid, $paymentinfo){
	global $db, $logger;
	$logger->info('putPayment: tranid=%s, paysysid=%s, serviceid=%s, paymentinfo=%s', $tranid, $paysysid, $serviceid, print_r($paymentinfo, true));
	$paysysname = $servicename = $payername = $payeraddress = $respmessage = ''; $respcode = 0;
	$db->Begin();
	if($account = loadValue("SELECT account FROM system_accounts WHERE code='PAY_UKRCARD'")){
		if($paysysname = getPsaName($paysysid)){
			if($servicename = getServiceName($serviceid)){
				if($client = loadRecord(sprintf("SELECT c.id, c.account FROM clients c WHERE c.contract='%s'", addslashes($paymentinfo['payercode'])))){
					$amount =  intval(strval($paymentinfo['summa'] * 100));
					if($amount > 0){
						$regdate = date("c");
						$mid = move($account, $client['account'], $amount, '', $regdate);
						$db->Execute(sprintf("INSERT INTO ukrcard_pays (tranid, paysysid, serviceid, payercode, paydate, amount, client, movement, state)
							VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')",
							addslashes($tranid), addslashes($paysysid), addslashes($serviceid), addslashes($paymentinfo['payercode']), addslashes($paymentinfo['paydate']), $amount,
							$client['id'], $mid, 0
						));
						$pid = $db->getJustInserted('ukrcard_pays', 'id');
						$paymentinfo['paymentid'] = $pid;
						$paymentinfo['regdate'] = $regdate;
						$paymentinfo['paymenstat'] = 2;
						$paymentinfo['paymenstatname'] = utf('   ');
						$respcode = 0;
						$respmessage = 'Ok';
					}else{
						$respcode = 4;
						$respmessage = 'zero or negative amount';
					}
				}else{
					$respcode = 2;
					$respmessage = 'unknown payercode';
				}
			}else{
				$respcode = 3;
				$respmessage = 'no such service';
			}
		}else{
			$respcode = 1;
			$respmessage = 'unknown payment system';
		}
	}else{
		$respcode = 8;
		$respmessage = 'system error';
	}
	if(!$db->End()){
		$respcode = 8;
		$respmessage = 'system error';
		$paymentinfo['paymentid'] = 0;
		$paymentinfo['paymenstat'] = 0;
		$paymentinfo['paymenstatname'] = utf("  ");
	}
	return array(
		'tranid' => $tranid,
		'paysysid' => $paysysid,
		'serviceid' => $serviceid,
		'respcode' => $respcode,
		'respmessage' => utf($respmessage),
		'paymentinfo' => $paymentinfo,

	);
}

function putregister($paysysid, $Mfo, $registerid, $registerdate, $orderno, $orderdate, $ordersum, $allcount, $allsumma, $tranlist){
	global $db, $logger;
	$logger->info('putregister: paysysid=%s, Mfo=%s, registerid=%s, registerdate=%s, orderno=%s, orderdate=%s, ordersum=%s, allcount=%s, allsumma=%s, tranlist=%s',
		$paysysid, $Mfo, $registerid, $registerdate, $orderno, $orderdate, $ordersum, $allcount, $allsumma, print_r($tranlist, true));
	$sum = 0; $respcode = 0; $respmessage = 'ok';
	$osum = intval(strval($ordersum * 100));
	$asum = intval(strval($allsumma * 100));
	$db->Begin();
	if(!loadRecord("SELECT id FROM ukrcard_pays_regs WHERE paysysid='".addslashes($paysysid)."' AND registerid='".addslashes($registerid)."'")){
		$db->Execute(sprintf("INSERT INTO ukrcard_pays_regs (paysysid, Mfo, registerid, registerdate, orderno, orderdate, ordersum, allcount, allsumma)
			VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')",
			addslashes($paysysid), addslashes($Mfo), addslashes($registerid), addslashes($registerdate), addslashes($orderno), addslashes($orderdate),
			$osum, addslashes($allcount), $asum
		));
		$rid = $db->getJustInserted('ukrcard_pays_regs', 'id');
		
		foreach($tranlist as $tran){
			$info = $tran['paymentinfo'];
			$pid = addslashes($info['paymentid']);
			$pay = loadRecord("SELECT id, amount, client, movement, state, reg FROM ukrcard_pays WHERE id='".$pid."'");
			if($pay){
				$amount =  intval(strval($info['summa'] * 100));
				if($amount != $pay['amount']){
					$respcode = 1;
					$respmessage = sprintf('payment %s sum not match, %s!=%s', $pid, $amount, $pay['amount']);
					break;
				}
				$db->Execute("UPDATE ukrcard_pays SET reg='".$rid."' WHERE id='".$pid."'");
				$sum += $amount;
			}else{
				$respcode = 1;
				$respmessage = sprintf('payment %s not found', $pid);
				break;
			}
		};
		if($respcode==0 && ($sum!=$osum)){
			$respcode = 1;
			$respmessage = sprintf('ordersum not match, %s!=%s', $sum, $osum);
		}
	}else{
		$respcode = 1;
		$respmessage = sprintf('registry %s:%s already exists', $paysysid, $registerid);
	}
	if($respcode > 0){
		$db->Rollback();
	}else{
		if(!$db->End()){
			$logger->error(implode("\n", $db->errors));
			$respcode = 2;
			$respmessage = 'system error';
		}
	}
	$logger->info($respmessage);
	return array(
		'paysysid' =>		$paysysid,
		'Mfo' =>			$Mfo,
		'registerid' =>		$registerid,
		'orderno' =>		$orderno,
		'orderdate' =>		$orderdate,
		'ordersum' =>		$ordersum,
		'allcount' =>		$allcount,
		'allsumma' =>		$allsumma,
		'respcode' =>		$respcode,
		'respmessage' =>	$respmessage,
	);
}

$server = new soap_server();
$server->soap_defencoding = 'UTF-8'; 
$server->decode_utf8 = false;
$server->configureWSDL('WSLANETPlat');


$server->wsdl->addComplexType('paymentinfo', 'complexType', 'struct', 'sequence', '',
	array(
		'payercode' =>	array('name' => 'payercode',	'type' => 'xsd:string'),
		'payername' =>	array('name' => 'payername',	'type' => 'xsd:string'),
		'paydate' =>	array('name' => 'paydate',		'type' => 'xsd:dateTime'),
		'summa' =>		array('name' => 'summa',		'type' => 'xsd:double'),
		'paymentid' => 		array('name' => 'paymentid',		'type' => 'xsd:long'),
		'regdate' => 		array('name' => 'regdate',			'type' => 'xsd:dateTime'),
		'paymenstat' => 	array('name' => 'paymenstat',		'type' => 'xsd:long'),
		'paymenstatname' => array('name' => 'paymenstatname',	'type' => 'xsd:string'),
	)
);

$server->wsdl->addComplexType('transaction', 'complexType', 'struct', 'sequence', '',
	array(
		'Rownum' => 		array('name' => 'Rownum',			'type' => 'xsd:int'),
		'serviceid' => 		array('name' => 'serviceid',		'type' => 'xsd:string'),
		'paymentinfo' => 	array('name' => 'paymentinfo',		'type' => 'tns:paymentinfo'),
	)
);

$server->wsdl->addComplexType('tranlist', 'complexType', 'array', 'sequence', '',
	array(
		'transaction' => array(
			'name' => 'transaction',
			'type' => 'tns:transaction',
			'minOccurs' => '0',
			'maxOccurs' => 'unbounded',
		)
	)
);

$server->register('getPaymentInfo',
	array(
		'tranid' =>			'xsd:string',
		'paysysid' =>		'xsd:string',
		'serviceid' =>		'xsd:string',
		'payercode' =>		'xsd:string',
		'barcode' =>		'xsd:string',
	),
	array(
		'tranid' =>			'xsd:string',
		'paysysid' =>		'xsd:string',
		'paysysname' =>		'xsd:string',
		'serviceid' =>		'xsd:string',
		'servicename' =>	'xsd:string',
		'payercode' =>		'xsd:string',
		'payername' =>		'xsd:string',
		'payeraddress' =>	'xsd:string',
		'respcode' =>		'xsd:long',
		'respmessage' =>	'xsd:string',
	)
);

$server->register('putPayment',
	array(
		'tranid' =>			'xsd:string',
		'paysysid' =>		'xsd:string',
		'serviceid' =>		'xsd:string',
		'paymentinfo' =>	'tns:paymentinfo',
	),
	array(
		'tranid' =>			'xsd:string',
		'paysysid' =>		'xsd:string',
		'serviceid' =>		'xsd:string',
		'respcode' =>		'xsd:long',
		'respmessage' =>	'xsd:string',
		'paymentinfo' =>	'tns:paymentinfo',
	)
);

$server->register('putregister',
	array(
		'paysysid' =>		'xsd:string',
		'Mfo' =>			'xsd:string',
		'registerid' =>		'xsd:string',
		'registerdate' =>	'xsd:dateTime',
		'orderno' =>		'xsd:string',
		'orderdate' =>		'xsd:dateTime',
		'ordersum' =>		'xsd:double',
		'allcount' =>		'xsd:int',
		'allsumma' =>		'xsd:double',
		'tranlist' =>		'tns:tranlist',
	),
	array(
		'paysysid' =>		'xsd:string',
		'Mfo' =>			'xsd:string',
		'registerid' =>		'xsd:string',
		'orderno' =>		'xsd:string',
		'orderdate' =>		'xsd:dateTime',
		'ordersum' =>		'xsd:double',
		'allcount' =>		'xsd:int',
		'allsumma' =>		'xsd:double',
		'respcode' =>		'xsd:long',
		'respmessage' =>	'xsd:string',
	)
);

function fine($xml){
	return str_replace("><", ">\n<", cp1251($xml));
}

$server->service($HTTP_RAW_POST_DATA);

if(strlen($HTTP_RAW_POST_DATA) > 0){
	$logger->info("REQUEST: %s", fine($server->request));
	$logger->info("RESPONSE: %s", fine($server->response));
}
?>
